/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 705:
/***/ (function(module) {


/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
// eslint-disable-next-line func-names

module.exports = function (cssWithMappingToString) {
  var list = []; // return the list of modules as css string

  list.toString = function toString() {
    return this.map(function (item) {
      var content = cssWithMappingToString(item);

      if (item[2]) {
        return "@media ".concat(item[2], " {").concat(content, "}");
      }

      return content;
    }).join("");
  }; // import a list of modules into the list
  // eslint-disable-next-line func-names


  list.i = function (modules, mediaQuery, dedupe) {
    if (typeof modules === "string") {
      // eslint-disable-next-line no-param-reassign
      modules = [[null, modules, ""]];
    }

    var alreadyImportedModules = {};

    if (dedupe) {
      for (var i = 0; i < this.length; i++) {
        // eslint-disable-next-line prefer-destructuring
        var id = this[i][0];

        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }

    for (var _i = 0; _i < modules.length; _i++) {
      var item = [].concat(modules[_i]);

      if (dedupe && alreadyImportedModules[item[0]]) {
        // eslint-disable-next-line no-continue
        continue;
      }

      if (mediaQuery) {
        if (!item[2]) {
          item[2] = mediaQuery;
        } else {
          item[2] = "".concat(mediaQuery, " and ").concat(item[2]);
        }
      }

      list.push(item);
    }
  };

  return list;
};

/***/ }),

/***/ 868:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(705);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__);
// Imports

var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default()(function(i){return i[1]});
// Module
___CSS_LOADER_EXPORT___.push([module.id, ".coord{background:rgba(42,42,42,.8);border-radius:4px;padding:5px;color:#edffff;font-size:15px}.coord .triangle{display:block;height:15px;width:15px;background-color:inherit;border:inherit;position:absolute;bottom:-7px;left:calc(50% - 10px);clip-path:polygon(0% 0%, 100% 100%, 0% 100%);transform:rotate(-45deg)}", ""]);
// Exports
/* harmony default export */ __webpack_exports__["Z"] = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ 854:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(705);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__);
// Imports

var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default()(function(i){return i[1]});
// Module
___CSS_LOADER_EXPORT___.push([module.id, ".cesium-viewer-bottom{right:0px !important;display:flex;justify-content:center}.cesium-viewer-bottom .cesium-viewer-statusContainer{bottom:16px !important;font-size:14px;right:unset}", ""]);
// Exports
/* harmony default export */ __webpack_exports__["Z"] = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ 379:
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {



var isOldIE = function isOldIE() {
  var memo;
  return function memorize() {
    if (typeof memo === 'undefined') {
      // Test for IE <= 9 as proposed by Browserhacks
      // @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
      // Tests for existence of standard globals is to allow style-loader
      // to operate correctly into non-standard environments
      // @see https://github.com/webpack-contrib/style-loader/issues/177
      memo = Boolean(window && document && document.all && !window.atob);
    }

    return memo;
  };
}();

var getTarget = function getTarget() {
  var memo = {};
  return function memorize(target) {
    if (typeof memo[target] === 'undefined') {
      var styleTarget = document.querySelector(target); // Special case to return head of iframe instead of iframe itself

      if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
        try {
          // This will throw an exception if access to iframe is blocked
          // due to cross-origin restrictions
          styleTarget = styleTarget.contentDocument.head;
        } catch (e) {
          // istanbul ignore next
          styleTarget = null;
        }
      }

      memo[target] = styleTarget;
    }

    return memo[target];
  };
}();

var stylesInDom = [];

function getIndexByIdentifier(identifier) {
  var result = -1;

  for (var i = 0; i < stylesInDom.length; i++) {
    if (stylesInDom[i].identifier === identifier) {
      result = i;
      break;
    }
  }

  return result;
}

function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var index = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3]
    };

    if (index !== -1) {
      stylesInDom[index].references++;
      stylesInDom[index].updater(obj);
    } else {
      stylesInDom.push({
        identifier: identifier,
        updater: addStyle(obj, options),
        references: 1
      });
    }

    identifiers.push(identifier);
  }

  return identifiers;
}

function insertStyleElement(options) {
  var style = document.createElement('style');
  var attributes = options.attributes || {};

  if (typeof attributes.nonce === 'undefined') {
    var nonce =  true ? __webpack_require__.nc : 0;

    if (nonce) {
      attributes.nonce = nonce;
    }
  }

  Object.keys(attributes).forEach(function (key) {
    style.setAttribute(key, attributes[key]);
  });

  if (typeof options.insert === 'function') {
    options.insert(style);
  } else {
    var target = getTarget(options.insert || 'head');

    if (!target) {
      throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
    }

    target.appendChild(style);
  }

  return style;
}

function removeStyleElement(style) {
  // istanbul ignore if
  if (style.parentNode === null) {
    return false;
  }

  style.parentNode.removeChild(style);
}
/* istanbul ignore next  */


var replaceText = function replaceText() {
  var textStore = [];
  return function replace(index, replacement) {
    textStore[index] = replacement;
    return textStore.filter(Boolean).join('\n');
  };
}();

function applyToSingletonTag(style, index, remove, obj) {
  var css = remove ? '' : obj.media ? "@media ".concat(obj.media, " {").concat(obj.css, "}") : obj.css; // For old IE

  /* istanbul ignore if  */

  if (style.styleSheet) {
    style.styleSheet.cssText = replaceText(index, css);
  } else {
    var cssNode = document.createTextNode(css);
    var childNodes = style.childNodes;

    if (childNodes[index]) {
      style.removeChild(childNodes[index]);
    }

    if (childNodes.length) {
      style.insertBefore(cssNode, childNodes[index]);
    } else {
      style.appendChild(cssNode);
    }
  }
}

function applyToTag(style, options, obj) {
  var css = obj.css;
  var media = obj.media;
  var sourceMap = obj.sourceMap;

  if (media) {
    style.setAttribute('media', media);
  } else {
    style.removeAttribute('media');
  }

  if (sourceMap && typeof btoa !== 'undefined') {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  } // For old IE

  /* istanbul ignore if  */


  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    while (style.firstChild) {
      style.removeChild(style.firstChild);
    }

    style.appendChild(document.createTextNode(css));
  }
}

var singleton = null;
var singletonCounter = 0;

function addStyle(obj, options) {
  var style;
  var update;
  var remove;

  if (options.singleton) {
    var styleIndex = singletonCounter++;
    style = singleton || (singleton = insertStyleElement(options));
    update = applyToSingletonTag.bind(null, style, styleIndex, false);
    remove = applyToSingletonTag.bind(null, style, styleIndex, true);
  } else {
    style = insertStyleElement(options);
    update = applyToTag.bind(null, style, options);

    remove = function remove() {
      removeStyleElement(style);
    };
  }

  update(obj);
  return function updateStyle(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) {
        return;
      }

      update(obj = newObj);
    } else {
      remove();
    }
  };
}

module.exports = function (list, options) {
  options = options || {}; // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
  // tags it will allow on a page

  if (!options.singleton && typeof options.singleton !== 'boolean') {
    options.singleton = isOldIE();
  }

  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];

    if (Object.prototype.toString.call(newList) !== '[object Array]') {
      return;
    }

    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDom[index].references--;
    }

    var newLastIdentifiers = modulesToDom(newList, options);

    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];

      var _index = getIndexByIdentifier(_identifier);

      if (stylesInDom[_index].references === 0) {
        stylesInDom[_index].updater();

        stylesInDom.splice(_index, 1);
      }
    }

    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/nonce */
/******/ 	!function() {
/******/ 		__webpack_require__.nc = undefined;
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "Kq3dAddData": function() { return /* reexport */ AddData; },
  "Kq3dAddDataViewModel": function() { return /* reexport */ AddDataViewModel; },
  "Kq3dAspectAnalysis": function() { return /* reexport */ AspectAnalysis; },
  "Kq3dAspectAnalysisViewModel": function() { return /* reexport */ AspectAnalysisViewModel; },
  "Kq3dBaseterrainGallery": function() { return /* reexport */ BaseterrainGallery; },
  "Kq3dBaseterrainGalleryViewModel": function() { return /* reexport */ BaseterrainGalleryViewModel; },
  "Kq3dBoxClip": function() { return /* reexport */ BoxClip; },
  "Kq3dBoxClipViewModel": function() { return /* reexport */ BoxClipViewModel; },
  "Kq3dClientPrint": function() { return /* reexport */ ClientPrint; },
  "Kq3dCompareMap": function() { return /* reexport */ CompareMap; },
  "Kq3dCompareMapViewModel": function() { return /* reexport */ CompareMapViewModel; },
  "Kq3dCompass": function() { return /* reexport */ Compass; },
  "Kq3dCompassViewModel": function() { return /* reexport */ CompassViewModel; },
  "Kq3dExcavateFillAnalysis": function() { return /* reexport */ ExcavateFillAnalysis; },
  "Kq3dExcavateFillAnalysisViewModel": function() { return /* reexport */ ExcavateFillAnalysisViewModel; },
  "Kq3dFixedZoomin": function() { return /* reexport */ FixedZoomin; },
  "Kq3dFixedZoominViewModel": function() { return /* reexport */ FixedZoomin3dViewModel; },
  "Kq3dFixedZoomout": function() { return /* reexport */ FixedZoomout; },
  "Kq3dFixedZoomoutViewModel": function() { return /* reexport */ FixedZoomout3dViewModel; },
  "Kq3dFlight": function() { return /* reexport */ Flight; },
  "Kq3dFlightViewModel": function() { return /* reexport */ FlightViewModel; },
  "Kq3dFloodAnalysis": function() { return /* reexport */ FloodAnalysis; },
  "Kq3dFloodAnalysisViewModel": function() { return /* reexport */ FloodAnalysisViewModel; },
  "Kq3dGPUSpatialQuery": function() { return /* reexport */ GPUSpatialQuery; },
  "Kq3dGPUSpatialQueryViewModel": function() { return /* reexport */ GPUSpatialQueryViewModel; },
  "Kq3dHawkeye": function() { return /* reexport */ Hawkeye; },
  "Kq3dHawkeyeViewModel": function() { return /* reexport */ HawkeyeViewModel; },
  "Kq3dIsolineAnalysis": function() { return /* reexport */ IsolineAnalysis; },
  "Kq3dIsolineAnalysisViewModel": function() { return /* reexport */ IsolineAnalysisViewModel; },
  "Kq3dMeasure": function() { return /* reexport */ Measure; },
  "Kq3dMeasureViewModel": function() { return /* reexport */ MeasureViewModel; },
  "Kq3dModelSelect": function() { return /* reexport */ ModelSelect; },
  "Kq3dModelSelectViewModel": function() { return /* reexport */ ModelSelectViewModel; },
  "Kq3dParticleEffect": function() { return /* reexport */ ParticleEffect; },
  "Kq3dParticleEffectViewModel": function() { return /* reexport */ ParticleEffectViewModel; },
  "Kq3dPlaneClip": function() { return /* reexport */ PlaneClip; },
  "Kq3dPlaneClipViewModel": function() { return /* reexport */ PlaneClipViewModel; },
  "Kq3dProfileAnalysis": function() { return /* reexport */ ProfileAnalysis; },
  "Kq3dProfileAnalysisViewModel": function() { return /* reexport */ ProfileAnalysisViewModel; },
  "Kq3dResetView": function() { return /* reexport */ ResetView; },
  "Kq3dResetViewViewModel": function() { return /* reexport */ ResetViewViewModel; },
  "Kq3dRoller": function() { return /* reexport */ Roller; },
  "Kq3dRollerViewModel": function() { return /* reexport */ RollerViewModel; },
  "Kq3dScreenShot": function() { return /* reexport */ Screenshot; },
  "Kq3dScreenshotViewModel": function() { return /* reexport */ ScreenshotViewModel; },
  "Kq3dShadowAnalysis": function() { return /* reexport */ ShadowAnalysis; },
  "Kq3dShadowAnalysisViewModel": function() { return /* reexport */ ShadowAnalysisViewModel; },
  "Kq3dSightlineAnalysis": function() { return /* reexport */ SightlineAnalysis; },
  "Kq3dSightlineAnalysisViewModel": function() { return /* reexport */ SightlineAnalysisViewModel; },
  "Kq3dSkylineAnalysis": function() { return /* reexport */ SkylineAnalysis; },
  "Kq3dSkylineAnalysisViewModel": function() { return /* reexport */ SkylineAnalysisViewModel; },
  "Kq3dSlopeAnalysis": function() { return /* reexport */ SlopeAnalysis; },
  "Kq3dSlopeAnalysisViewModel": function() { return /* reexport */ SlopeAnalysisViewModel; },
  "Kq3dStatusBar": function() { return /* reexport */ StatusBar; },
  "Kq3dStatusBarViewModel": function() { return /* reexport */ StatusBarViewModel; },
  "Kq3dTerrainOperation": function() { return /* reexport */ TerrainOperation; },
  "Kq3dTerrainOperationViewModel": function() { return /* reexport */ TerrainOperationViewModel; },
  "Kq3dUnderground": function() { return /* reexport */ Underground; },
  "Kq3dUndergroundViewModel": function() { return /* reexport */ UndergroundViewModel; },
  "Kq3dViewshedAnalysis": function() { return /* reexport */ ViewshedAnalysis; },
  "Kq3dViewshedAnalysisViewModel": function() { return /* reexport */ ViewshedAnalysisViewModel; },
  "Kq3dWeatherEffect": function() { return /* reexport */ WeatherEffect; },
  "Kq3dWeatherEffectViewModel": function() { return /* reexport */ WeatherEffectViewModel; },
  "KqScenceView": function() { return /* reexport */ ScenceView; },
  "KqScenceViewViewModel": function() { return /* reexport */ ScenceViewViewModel; },
  "default": function() { return /* binding */ webgl; },
  "webglComponents": function() { return /* reexport */ webglComponents; }
});

;// CONCATENATED MODULE: external {"root":"Vue","commonjs":"vue","commonjs2":"vue","amd":"vue"}
var external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject = require("vue");
;// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/defineProperty.js
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_utils/mitt"
var mitt_namespaceObject = require("@kq_npm/client_common_vue/_utils/mitt");
var mitt_default = /*#__PURE__*/__webpack_require__.n(mitt_namespaceObject);
;// CONCATENATED MODULE: external "core-js/modules/web.dom-exception.stack.js"
var web_dom_exception_stack_js_namespaceObject = require("core-js/modules/web.dom-exception.stack.js");
;// CONCATENATED MODULE: external "core-js/modules/es.array.includes.js"
var es_array_includes_js_namespaceObject = require("core-js/modules/es.array.includes.js");
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_utils/const-image"
var const_image_namespaceObject = require("@kq_npm/client_common_vue/_utils/const-image");
;// CONCATENATED MODULE: ./src/webgl/scenceview/DrawManager.js



 //绘制操作类

class DrawManager {
  // 图层分组
  // 地理编码绘制点图标点击事件
  // 地理编码绘制点图层分组
  // 默认绘制样式提供给绘图组件绑定
  // 默认绘制样式
  constructor(viewer, language) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_drawHandler", null);

    _defineProperty(this, "_drawLayer", null);

    _defineProperty(this, "_layerGroup", []);

    _defineProperty(this, "_handler", null);

    _defineProperty(this, "_pointGroup", []);

    _defineProperty(this, "_defaultStyle", {
      color: "#ff0000",
      fillColor: "#1E90FF",
      weight: 2,
      fillOpacity: 0.3,
      dashArray: "0"
    });

    _defineProperty(this, "drawFinishedEvent", null);

    _defineProperty(this, "editSelectedEvent", null);

    _defineProperty(this, "_drawStyle", {
      //文本样式
      text: {
        text: "文字标注",
        //文字内容
        fontSize: 25,
        //文字大小
        fontFamily: 'Microsoft YaHei',
        color: "#ff0000" //文字颜色
        // opacity: 0.5, //文字颜色透明度
        // clampToGround: false //是否贴地

      },
      //点-图标样式
      marker: {
        image: const_image_namespaceObject.MARKER_URL,
        //图标路径
        width: 32,
        //图标宽度
        height: 32,
        //图标高度
        clampToGround: true,
        //是否贴地
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      },
      //折线样式
      polyline: {
        width: 2,
        //线宽
        color: "#ff0000",
        //线颜色
        opacity: 1,
        //线颜色透明度
        arcType: 1,
        clampToGround: true //是否贴地

      },
      //多边形样式
      polygon: {
        fill: true,
        //是否填充颜色
        fillColor: "#1E90FF",
        //填充颜色
        fillOpacity: 0.3,
        //填充颜色透明度
        width: 2,
        //边框宽度
        color: "#ff0000",
        //边框颜色
        opacity: 1,
        //边框颜色透明度
        clampToGround: true //是否贴地

      }
    });

    _defineProperty(this, "_geojsonStyle", {
      label: {
        style: Cesium.LabelStyle.FILL_AND_OUTLINE,
        outlineWidth: 2,
        fillColor: "#ff0000",
        opacity: 1,
        pixelOffset: [0, -16],
        express: "name",
        font: "25px 微软雅黑"
      },
      billboard: {
        image: const_image_namespaceObject.MARKER_URL,
        width: 32,
        height: 32
      },
      polyline: {
        color: "#ff0000",
        opacity: 1.0,
        width: 2,
        dash: false
      },
      polygon: {
        color: "#0000ff",
        opacity: 0.3,
        outline: true,
        outlineColor: "#ff0000",
        outlineWidth: 1,
        outlineDash: false,
        fill: true,
        fillStyle: null
      }
    });

    this._viewer = viewer;
    if (language) this._drawStyle.text.text = language.text;
    this._drawHandler = Cesium.Kq3dPlotHandler; // 创建绘制图形图层

    this._drawLayer = this._drawHandler.createShapeLayer({
      name: "Drawing"
    }); // 添加绘制图形图层到场景

    this._viewer.scene.primitives.add(this._drawLayer); // 初始化绘制函数集对象


    this._drawHandler.initialize(this._viewer.scene, this._drawLayer); // 默认禁用编辑操作


    this.enableEdit(false); // 绘制结束事件

    this.drawFinishedEvent = this._drawHandler.drawHandler.drawFinished; // 编辑拾取事件

    this.editSelectedEvent = this._drawHandler.editHandler.editSelected; // 关闭双击旋转交互

    if (this._viewer.roadingHandler) {
      this._viewer.roadingHandler.cameraRotatePointer.enableMouseAutoStart = false;
    } //复制样式


    this._drawStyle.freehandline = this._drawStyle.polyline; //手绘线

    this._drawStyle.concentricCircle = this._drawStyle.polyline; //同心圆

    this._drawStyle.circle = this._drawStyle.polygon; //圆

    this._drawStyle.ellipse = this._drawStyle.polygon; //椭圆

    this._drawStyle.freehandpolygon = this._drawStyle.polygon; //手绘面

    this._drawStyle.rectangle = this._drawStyle.polygon; //矩形
  } // 获取三维填充样式


  getFillStyle(fillStyle) {
    let lineColor = fillStyle.lineColor || "rgba(0, 0, 255, 1)";
    let lineWidth = fillStyle.lineWidth || "2px";
    let style = "stroke-linecap: square;stroke-linejoin: miter;overflow: inherit;stroke: " + lineColor + ";stroke-width: " + lineWidth + ";";
    let width = 10;
    let height = 10;
    let lineType = "left";

    if (fillStyle.lineSpacing !== undefined) {
      width = height = fillStyle.lineSpacing;
    }

    if (fillStyle.lineType !== undefined) {
      lineType = fillStyle.lineType;
    }

    let svgLine = "";

    if (lineType === "left") {
      svgLine = '<line x1="' + width / 2 + '" y1="' + 0 + '" x2="' + width / 2 + '" y2="' + height + '" style="' + style + '"></line>';
    } else if (lineType === "right") {
      svgLine = '<line x1="' + 0 + '" y1="' + height / 2 + '" x2="' + width + '" y2="' + height / 2 + '" style="' + style + '"></line>';
    } else {
      svgLine = '<line x1="' + width / 2 + '" y1="' + 0 + '" x2="' + width / 2 + '" y2="' + height + '" style="' + style + '"></line>';
      svgLine += '<line x1="' + 0 + '" y1="' + height / 2 + '" x2="' + width + '" y2="' + height / 2 + '" style="' + style + '"></line>';
    }

    let svgStr = '<svg xmlns:svg="http://www.w3.org/2000/svg" xmlns="http://www.w3.org/2000/svg" width="' + width + '" height="' + height + '" style="overflow: inherit;">' + svgLine + "</svg>";
    let imgUrl = "data:image/svg+xml;base64," + window.btoa(svgStr) + "";
    var myImage = new Image(width, height);
    myImage.src = imgUrl;
    let material = new Cesium.ImageMaterialProperty({
      image: myImage,
      repeat: new Cesium.Cartesian2(15, 15),
      transparent: true
    });
    return material;
  }

  getImageWithColor(imgUrl, color, width = 32, height = 32) {
    if (color) {
      var svgStr = window.atob(imgUrl.split(',')[1]);
      var regex = /#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})/g; // 修改svg颜色

      svgStr = svgStr.replace(regex, color); // 修改svg大小

      svgStr = svgStr.replace('width="16"', 'width="' + width + '"').replace('height="16"', 'height="' + height + '"');
      imgUrl = "data:image/svg+xml;base64," + window.btoa(svgStr);
    }

    return imgUrl;
  } //开始绘制


  startDraw(type, options, callback, groupName) {
    if (!options) options = {};

    if (type === "point") {
      type = "marker";
    }

    if (type === "coloricon") {
      type = "marker";
      options.iconSize = [32, 32];
      options.iconUrl = const_image_namespaceObject.LABEL_SVG_ICONS[0];
      options.image = this.getImageWithColor(const_image_namespaceObject.LABEL_SVG_ICONS[0], options.color);
    }

    if (type === "text") {
      this._viewer.scene.globe.depthTestAgainstTerrain = false;
    } else {
      this._viewer.scene.globe.depthTestAgainstTerrain = true;
    }

    var unionOptions = { ...this._drawStyle[type],
      ...options
    };

    if (type === "polyline") {
      //标记组件使用
      options.opacity = 1;
    }

    if (type === "text") {
      //标记组件使用
      options.fontSize = this._drawStyle.text.fontSize;
      options.fontFamily = this._drawStyle.text.fontFamily;
      options.content = this._drawStyle.text.text;
      options.is3D = true;
    }

    if (type !== "marker" && type !== "text") {
      //标记组件使用
      if (unionOptions.hasOwnProperty("weight")) {
        unionOptions.width = unionOptions.weight;
      }
    }

    if (unionOptions.hasOwnProperty("color")) {
      unionOptions.color = Cesium.Color.fromCssColorString(unionOptions.color).withAlpha(unionOptions.opacity);
    }

    if (unionOptions.hasOwnProperty("fillColor")) {
      unionOptions.fillColor = Cesium.Color.fromCssColorString(unionOptions.fillColor).withAlpha(unionOptions.fillOpacity);
    }

    this._drawHandler.startDraw(type, type, unionOptions);

    var that = this;
    var removeEventListener = this.drawFinishedEvent.addEventListener(shape => {
      if (groupName) shape.groupName = groupName;

      if (shape.type === "text") {
        setTimeout(() => {
          shape._label.disableDepthTestDistance = Number.POSITIVE_INFINITY;
        }, 200);
      }

      shape.options = options;

      if (callback) {
        var feature = that.shapeToGeoFeature(shape);
        callback(feature.geometry, {
          layer: shape.guid
        });
      }

      removeEventListener();
    });
  }

  stopDraw() {
    this._drawHandler.stopDraw();
  } //是否启用连续绘制


  enableMultiDraw(isEnable) {
    this._drawHandler.drawHandler.enableMultiDraw = isEnable;
  } //是否启用编辑


  enableEdit(isEnable) {
    if (isEnable) {
      this._drawHandler.editHandler.activate();
    } else {
      this._drawHandler.editHandler.deactivate();
    }
  } //清除绘图分组


  clearDrawGroup(groupName) {
    let primitives = this._drawLayer._primitives;

    if (primitives && primitives.length > 0) {
      for (let i = primitives.length - 1; i >= 0; i--) {
        if (primitives[i].groupName === groupName) {
          this._drawLayer.removeById(primitives[i].guid);
        }
      }
    }
  } //清除全部手动绘图


  clear() {
    this._drawLayer && this._drawLayer.removeAll();
  } //销毁


  destroy() {
    this._viewer = null;
    this._drawHandler = null;
    this.clear();
  } //笛卡尔坐标转经纬度


  transformPosition(position) {
    // 转坐标
    if (position) {
      if (position instanceof Array && position.length === 3) {
        position = Cesium.Cartesian3.fromDegrees(position[0], position[1], position[2]);
      }

      let ellipsoid = this._viewer.scene.globe.ellipsoid;
      let cartographic = ellipsoid.cartesianToCartographic(position);
      let lon = Cesium.Math.toDegrees(cartographic.longitude);
      let lat = Cesium.Math.toDegrees(cartographic.latitude);
      let lonLat = [lon, lat];
      return lonLat;
    }
  } //绘制返回结果转换为GeoFeature


  shapeToGeoFeature(shape) {
    var geoFeature = null;
    var that = this;

    if (shape) {
      if (shape.controlPoints && shape.controlPoints.length === 0) return shape;

      if (shape.type === that._drawHandler.ShapeTypes.MARKER.type || shape.type === that._drawHandler.ShapeTypes.TEXT.type) {
        let position = that.transformPosition(shape._position);
        geoFeature = window.turf.point(position);
      } else if (shape.type === that._drawHandler.ShapeTypes.CIRCLE.type) {
        let center = that.transformPosition(shape.center);
        geoFeature = window.turf.circle(center, shape.radius, {
          steps: 64,
          units: "meters"
        });
        geoFeature.geometry.radius = shape.radius;
        geoFeature.geometry.center = center;
      } else if (shape.type === that._drawHandler.ShapeTypes.POLYLINE.type) {
        let position = [[]];
        shape.controlPoints.forEach(function (val) {
          position[0].push(that.transformPosition(val));
        });
        geoFeature = window.turf.lineStrings(position).features[0];
      } else if (shape.type === that._drawHandler.ShapeTypes.RECTANGLE.type) {
        if (shape.rectangle) {
          let minX = shape.rectangle.west / Math.PI * 180;
          let maxX = shape.rectangle.east / Math.PI * 180;
          let minY = shape.rectangle.south / Math.PI * 180;
          let maxY = shape.rectangle.north / Math.PI * 180;
          let positions1 = [[[minX, minY], [minX, maxY], [maxX, maxY], [maxX, minY], [minX, minY]]];
          geoFeature = window.turf.polygon(positions1);
        }
      } else if (shape.type === that._drawHandler.ShapeTypes.POLYGON.type) {
        let positions = [[]];
        let posi;
        shape.controlPoints.forEach(function (val, dex) {
          // 存坐标
          positions[0].push(that.transformPosition(val)); // 闭合坐标

          if (dex === 0) {
            posi = that.transformPosition(val);
          }

          if (dex === shape.controlPoints.length - 1) {
            positions[0].push(posi);
          }
        });
        geoFeature = window.turf.polygon(positions);
      }
    }

    return geoFeature || shape;
  } //通过geojson进行绘制，支持定位


  drawFromGeojson(geojsonData, idCustom = "result", callFun, geojsonStyle, isLocation) {
    if (!geojsonStyle) geojsonStyle = {};
    let style = JSON.parse(JSON.stringify(this._geojsonStyle));

    for (var type in geojsonStyle) {
      if (style.hasOwnProperty(type)) {
        for (var key in geojsonStyle[type]) {
          style[type][key] = geojsonStyle[type][key];
        }
      } else {
        style[type] = geojsonStyle[type];
      }
    }

    for (var type in style) {
      if (style[type].hasOwnProperty("color")) {
        if (!style[type].material) style[type].material = Cesium.Color.fromCssColorString(style[type].color).withAlpha(style[type].opacity);
      }

      if (style[type].hasOwnProperty("fillColor")) {
        style[type].fillColor = Cesium.Color.fromCssColorString(style[type].fillColor).withAlpha(style[type].opacity);
      }

      if (style[type].hasOwnProperty("outlineColor")) {
        style[type].outlineColor = Cesium.Color.fromCssColorString(style[type].outlineColor);
      }

      if (style[type].hasOwnProperty("pixelOffset")) {
        style[type].pixelOffset = new Cesium.Cartesian2(style[type].pixelOffset[0], style[type].pixelOffset[1]);
      }

      if (type === "polyline" && style.polyline.dash) {
        style.polyline.material = new Cesium.PolylineDashMaterialProperty({
          color: style.polyline.material
        });
      }

      if (type === "polygon" && style.polygon.fillStyle) {
        style.polygon.material = this.getFillStyle(style.polygon.fillStyle);
      }
    }

    if (style.point) {
      style.point.color = style.point.material;
      delete style.billboard;
    }

    this._viewer.scene.globe.depthTestAgainstTerrain = false;

    let geojsonDs = this._viewer.dataSources.getByName(idCustom);

    if (geojsonDs.length === 0) {
      geojsonDs = new Cesium.Kq3dGeoJsonDataSource(idCustom);

      this._viewer.dataSources.add(geojsonDs);
    } else {
      geojsonDs = geojsonDs[0];
    }

    let that = this;
    geojsonDs.load(geojsonData, style).then(ds => {
      if (style.polygon.outline) {
        ds.entities.values.forEach(entity => {
          if (entity.polygon && !entity.polyline) {
            entity.polygon.outline = false;
            entity.polyline = {
              positions: entity.polygon.hierarchy._value.positions,
              width: style.polygon.outlineWidth,
              material: style.polygon.outlineDash ? new Cesium.PolylineDashMaterialProperty({
                color: style.polygon.outlineColor
              }) : style.polygon.outlineColor
            };
          }
        });
      }

      if (!that._layerGroup.includes(idCustom)) {
        that._layerGroup.push(idCustom);
      }

      if (isLocation) {
        that._viewer.flyTo(ds, {
          duration: 1.5
        });
      }

      callFun && callFun(that._viewer);
    });
  } //删除指定绘图分组的所有图形


  removeGeojsonByIdCustom(idCustom) {
    let dsList = this._viewer.dataSources.getByName(idCustom);

    if (dsList.length <= 0) {
      this.clear();
      return;
    }

    for (let i = 0; i < dsList.length; i++) {
      this._viewer.dataSources.remove(dsList[i], true);
    }

    let index = this._layerGroup.indexOf(idCustom);

    if (index > -1) {
      this._layerGroup.splice(index, 1);
    }
  }

  getGeometry(idCustom) {
    let dsList = this._viewer.dataSources.getByName(idCustom);

    if (dsList.length <= 0) {
      return "";
    }

    return dsList;
  } //删除所有geojson绘图


  removeAll() {
    let that = this;

    this._layerGroup.forEach(group => {
      let dsList = that._viewer.dataSources.getByName(group);

      for (let i = 0; i < dsList.length; i++) {
        that._viewer.dataSources.remove(dsList[i], true);
      }
    });

    this._layerGroup = [];
  } //清除所有，包含手动绘图和geojson绘图


  clearAll() {
    this.clear();
    this.removeAll();
  } //ShapeLayer的绘制要素转换为GeoFeature (普通点线面绘制接口使用)


  drawToGeoFeature(shape) {
    var geoFeature = null;
    var that = this;

    if (shape) {
      if (shape.type === that._drawHandler.ShapeTypes.MARKER.type) {
        geoFeature = window.turf.point(shape.latlng);
        geoFeature.properties = {
          image: shape.image,
          width: shape.width,
          height: shape.height
        };
      } else if (shape.type === that._drawHandler.ShapeTypes.CIRCLE.type) {
        let center = that.transformPosition(shape.controlPoints[0]);
        let point1 = Cesium.Cartesian3.fromDegrees(shape.controlPoints[0][0], shape.controlPoints[0][1], shape.controlPoints[0][2]);
        let point2 = Cesium.Cartesian3.fromDegrees(shape.controlPoints[1][0], shape.controlPoints[1][1], shape.controlPoints[1][2]);
        let radius = Cesium.Cartesian3.distance(point1, point2);
        geoFeature = window.turf.circle(center, radius, {
          steps: 64,
          units: "meters"
        });
      } else if (shape.type === that._drawHandler.ShapeTypes.POLYLINE.type) {
        let position = [[]];
        shape.controlPoints.forEach(function (val) {
          position[0].push(that.transformPosition(val));
        });
        geoFeature = window.turf.lineStrings(position).features[0];
      } else if (shape.type === that._drawHandler.ShapeTypes.RECTANGLE.type) {
        let point1 = that.transformPosition(shape.controlPoints[0]);
        let point2 = that.transformPosition(shape.controlPoints[1]);
        let minX = point1[0];
        let maxX = point2[0];
        let minY = point1[1];
        let maxY = point2[1];
        let positions1 = [[[minX, minY], [minX, maxY], [maxX, maxY], [maxX, minY], [minX, minY]]];
        geoFeature = window.turf.polygon(positions1);
      } else if (shape.type === that._drawHandler.ShapeTypes.POLYGON.type) {
        let positions = [[]];
        let posi;
        shape.controlPoints.forEach(function (val, dex) {
          // 存坐标
          positions[0].push(that.transformPosition(val)); // 闭合坐标

          if (dex === 0) {
            posi = that.transformPosition(val);
          }

          if (dex === shape.controlPoints.length - 1) {
            positions[0].push(posi);
          }
        });
        geoFeature = window.turf.polygon(positions);
      }
    }

    return geoFeature;
  } // 获取所有绘制图层, geojson数据格式 (普通点线面绘制接口使用)


  getAllGeometry() {
    let features = [];

    let shapes = this._drawLayer.toJSON();

    if (shapes && shapes.draws && shapes.draws.length > 0) {
      shapes.draws.forEach(shape => {
        let feature = this.drawToGeoFeature(shape);
        if (feature) features.push(feature);
      }, this);
    }

    let geojson = {
      type: "FeatureCollection",
      features: features
    };
    return geojson;
  } // 设置交互绘制样式, 只设置最后一个图形样式, 绘图组件使用


  setDrawStyleById(id, style) {
    let primitive = this._drawLayer.getById(id);

    if (!primitive) return;
    let type = primitive._geoType;

    if (primitive.type === 'text') {
      primitive.fontSize = style.fontSize;
      primitive.fontFamily = style.fontFamily;
      primitive.text = style.content;
      primitive.fillColor = Cesium.Color.fromCssColorString(style.color);
    } else if (type === 'point') {
      primitive.image = this.getImageWithColor(style.iconUrl, style.color, style.iconSize[0], style.iconSize[1]);
      primitive.width = style.iconSize[0];
      primitive.height = style.iconSize[1];
    } else if (type === 'polyline' || type === 'polygon') {
      if (style.weight) primitive.width = style.weight;
      if (style.color) primitive.color = Cesium.Color.fromCssColorString(style.color);
      if (style.dashArray) primitive.dashArray = style.dashArray;
      if (style.opacity) primitive.color = primitive.color.withAlpha(style.opacity);
    }

    if (type === 'polygon') {
      primitive.fill = style.fill === undefined ? true : style.fill;

      if (primitive.fill) {
        let opacity = style.fillOpacity || this._drawStyle.polygon.fillOpacity;
        if (style.fillColor) primitive.fillColor = Cesium.Color.fromCssColorString(style.fillColor).withAlpha(opacity);
      }
    } // 存储绘图样式, 标记组件使用


    primitive.options = style;
  }

  getShapeTypeById(id) {
    let type = '';

    let primitive = this._drawLayer.getById(id);

    if (primitive) {
      type = primitive.type;
      if (type == 'marker') type = 'Marker';
      if (type == 'polyline') type = 'Line';
      if (type == 'polygon') type = 'Polygon';
      if (type == 'rectangle') type = 'Rectangle';
      if (type == 'circle') type = 'Circle';
      if (type == 'text') type = 'Text';
    }

    return type;
  }

  getShapeStyle(id) {
    let primitive = this._drawLayer.getById(id);

    if (primitive) {
      return primitive.options;
    }
  }

  getShapeInfo(id) {
    let primitive = this._drawLayer.getById(id);

    if (!primitive) return;
    let type = this.getShapeTypeById(id);
    let info = null;
    let options = primitive.options;

    if (type == "Marker") {
      info = {
        coordinate: primitive.position,
        style: {
          iconSize: options.iconSize,
          iconUrl: options.iconUrl,
          color: options.color
        }
      };
    } else if (type == "Line") {
      info = {
        coordinate: primitive.controlPoints,
        style: {
          opacity: options.opacity,
          color: options.color,
          weight: options.weight,
          dashArray: options.dashArray
        }
      };
    } else if (type == "Polygon" || type == "Rectangle" || type == "Circle") {
      info = {
        coordinate: primitive.controlPoints,
        style: {
          fillColor: options.fillColor,
          fillOpacity: options.fillOpacity,
          color: options.color,
          weight: options.weight
        }
      };
    } else if (type == "Text") {
      info = {
        coordinate: primitive.position,
        style: {
          fontSize: options.fontSize,
          fontFamily: options.fontFamily,
          color: options.color,
          content: options.content,
          is3D: true
        }
      };
    }

    return info;
  }

  getJsonByLayerList(layerList) {
    let items = [];

    for (let i = 0; i < layerList.length; i++) {
      const layer = layerList[i];
      const name = layer.name || "";
      const info = this.getShapeInfo(layer.layer);
      items.push({
        name: name,
        info: info,
        shape: layer.shape
      });
    }

    return JSON.stringify(items);
  }

  createShapeByInfo(info, type) {
    let shape = null;

    if (type == "Marker") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.MARKER.type, '', {
        position: info.coordinate,
        disableDepthTestDistance: Number.POSITIVE_INFINITY,
        width: info.style.iconSize[0],
        height: info.style.iconSize[1],
        image: this.getImageWithColor(info.style.iconUrl, info.style.color, info.style.iconSize[0], info.style.iconSize[1])
      });
    } else if (type == "Line") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.POLYLINE.type, '', {
        controlPoints: info.coordinate,
        color: Cesium.Color.fromCssColorString(info.style.color).withAlpha(info.style.opacity),
        width: info.style.weight,
        dashArray: info.style.dashArray,
        clampToGround: true
      });
    } else if (type == "Polygon") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.POLYGON.type, '', {
        controlPoints: info.coordinate,
        color: Cesium.Color.fromCssColorString(info.style.color),
        width: info.style.weight,
        fillColor: Cesium.Color.fromCssColorString(info.style.fillColor).withAlpha(info.style.fillOpacity),
        fill: true,
        clampToGround: true
      });
    } else if (type == "Rectangle") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.RECTANGLE.type, '', {
        controlPoints: info.coordinate,
        color: Cesium.Color.fromCssColorString(info.style.color),
        width: info.style.weight,
        fillColor: Cesium.Color.fromCssColorString(info.style.fillColor).withAlpha(info.style.fillOpacity),
        fill: true,
        clampToGround: true
      });
    } else if (type == "Circle") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.CIRCLE.type, '', {
        controlPoints: info.coordinate,
        color: Cesium.Color.fromCssColorString(info.style.color),
        width: info.style.weight,
        fillColor: Cesium.Color.fromCssColorString(info.style.fillColor).withAlpha(info.style.fillOpacity),
        fill: true,
        clampToGround: true
      });
    } else if (type == "Text") {
      shape = this._drawHandler.createShape(this._drawHandler.ShapeTypes.TEXT.type, '', {
        latlng: info.coordinate,
        text: info.style.content,
        fontSize: info.style.fontSize,
        fontFamily: info.style.fontFamily,
        color: Cesium.Color.fromCssColorString(info.style.color)
      });
      setTimeout(() => {
        shape._label.disableDepthTestDistance = Number.POSITIVE_INFINITY;
      }, 200);
    }

    return shape;
  }

  createLayerListByJson(items) {
    let layerList = [];

    for (let i = 0; i < items.length; i++) {
      const item = items[i];
      const type = item.shape;
      let shape = this.createShapeByInfo(item.info, type);

      if (shape) {
        shape.options = item.info.style;

        this._drawLayer.add(shape);

        layerList.push({
          name: item.name,
          shape: type,
          layer: shape.id
        });
      }
    }

    return layerList;
  }

  removeGeometryById(id) {
    this._drawLayer.removeById(id);
  }
  /********** 地理编码通用组件使用 start ************/
  // 绘制点图标自带点击弹出气泡, 地理编码通用组件使用


  drawPointWithPoup(data, idCustom = "geocode") {
    if (!this._handler) {
      // 注册点击事件
      let scene = this._viewer.scene;
      this._handler = new Cesium.ScreenSpaceEventHandler(scene.canvas);
      let that = this;

      this._handler.setInputAction(function (movement) {
        var pickedObject = scene.pick(movement.position);

        if (pickedObject && pickedObject.id && pickedObject.id instanceof Cesium.Entity) {
          let entity = pickedObject.id;
          that.createPointPoup(entity);
        }
      }, Cesium.ScreenSpaceEventType.LEFT_CLICK);

      this._handler.setInputAction(function (movement) {
        // that.closePointPoup();
        that.openPointPoup('1002', 'AAA'); //  that.removePointAll();
        //that.clearPointByIdCustom();
      }, Cesium.ScreenSpaceEventType.RIGHT_CLICK);
    }

    let pointDs = this._viewer.dataSources.getByName(idCustom);

    if (pointDs.length === 0) {
      pointDs = new Cesium.CustomDataSource(idCustom);

      this._viewer.dataSources.add(pointDs);

      this._pointGroup.push(idCustom);
    } else {
      pointDs = pointDs[0];
    }

    let position = Cesium.Cartesian3.fromDegrees(data.lat, data.lon);
    pointDs.entities.add({
      position: position,
      billboard: {
        image: data.image,
        width: data.width,
        height: data.height,
        verticalOrigin: Cesium.VerticalOrigin.BOTTOM
      } // properties: data

    });
  } // 通过entity创建关联气泡


  createPointPoup(entity) {
    if (this._htmlTag) this._htmlTag.destroy();
    this._htmlTag = new Cesium.Kq3dHtmlTag(this._viewer, {
      html: '<div>' + entity.properties.id._value + '</div>',
      position: entity.position,
      anchor: [0, -entity.properties.height._value],
      alignmentMode: 7
    });
  } // 通过id打开地理编码图标气泡


  openPointPoup(id, idCustom = "geocode") {
    if (id) {
      let pointDs = this._viewer.dataSources.getByName(idCustom);

      if (pointDs.length > 0) {
        let entities = pointDs[0].entities.values;

        for (let i = 0; i < entities.length; i++) {
          if (entities[i].properties.id && entities[i].properties.id._value === id) {
            this.createPointPoup(entities[i]);
            break;
          }
        }
      }
    }
  } // 关闭地理编码图标点击气泡


  closePointPoup() {
    if (this._htmlTag) this._htmlTag.destroy();
  } // 清除地理编码指定分组的所有图标


  clearPointByIdCustom(idCustom = "geocode") {
    let pointDs = this._viewer.dataSources.getByName(idCustom);

    if (pointDs.length > 0) {
      for (let i = 0; i < pointDs.length; i++) {
        pointDs[i].entities.removeAll();
      }
    }
  } // 删除所有地理编码图标, 包含分组图层


  removePointAll() {
    let that = this;

    this._pointGroup.forEach(group => {
      let dsList = that._viewer.dataSources.getByName(group);

      for (let i = 0; i < dsList.length; i++) {
        that._viewer.dataSources.remove(dsList[i], true);
      }
    });

    this._pointGroup = [];
  }
  /********** 地理编码通用组件使用 end ************/


}
;// CONCATENATED MODULE: external "element-plus/es"
var es_namespaceObject = require("element-plus/es");
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/init.js"
var init_js_namespaceObject = require("@kq_npm/client_common_vue/init.js");
var init_js_default = /*#__PURE__*/__webpack_require__.n(init_js_namespaceObject);
;// CONCATENATED MODULE: ./src/common/_ui/message/index.js



es_namespaceObject.ElMessage.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component("KqMessage", es_namespaceObject.ElMessage);
};

/* harmony default export */ var message = (es_namespaceObject.ElMessage);
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_utils/webmapservice"
var webmapservice_namespaceObject = require("@kq_npm/client_common_vue/_utils/webmapservice");
var webmapservice_default = /*#__PURE__*/__webpack_require__.n(webmapservice_namespaceObject);
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_utils/util"
var util_namespaceObject = require("@kq_npm/client_common_vue/_utils/util");
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_types/global-event"
var global_event_namespaceObject = require("@kq_npm/client_common_vue/_types/global-event");
var global_event_default = /*#__PURE__*/__webpack_require__.n(global_event_namespaceObject);
;// CONCATENATED MODULE: ./src/webgl/scenceview/LayerManager.js





 //图层管理类

class LayerManager {
  //图层树数据
  //图层列表数据（不包含文件夹节点,不包含融合子图层），特殊图层数据（BaseLayer、OnLineLayer）除外
  //图层原数据列表（包含文件夹节点，融合子图层）
  //置顶图层guid
  //记录置顶图层index
  //数据流服务图层集合
  //地形集合
  //加载geojson数据样式
  constructor(scenceView) {
    _defineProperty(this, "_scenceView", null);

    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_layerTreeData", []);

    _defineProperty(this, "_layerListData", []);

    _defineProperty(this, "_layerListData_old", []);

    _defineProperty(this, "_frontLayerGuid", null);

    _defineProperty(this, "_frontLayerIndex", null);

    _defineProperty(this, "_emptyTerrainProvider", new Cesium.EllipsoidTerrainProvider({}));

    _defineProperty(this, "_dataFlowLayerList", []);

    _defineProperty(this, "_terrainProviders", []);

    _defineProperty(this, "_geojsonStyle", {
      label: {
        express: "name",
        // font: "25px 微软雅黑",
        font: "28px sans-serif",
        fontSize: 28,
        fillColor: Cesium.Color.WHITE,
        scale: 0.6,
        outlineColor: Cesium.Color.BLACK,
        outlineWidth: 5,
        style: Cesium.LabelStyle.FILL_AND_OUTLINE,
        eyeOffset: Cesium.Cartesian3.ZERO,
        pixelOffset: new Cesium.Cartesian2(0, -8),
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      },
      billboard: {
        image: const_image_namespaceObject.BILLBOARD_IMAGE_URL,
        width: 12,
        height: 12,
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      },
      polyline: {
        width: 2.0,
        material: Cesium.Color.RED,
        clampToGround: true
      },
      polygon: {
        material: Cesium.Color.BLUE.withAlpha(0.3),
        outline: true,
        outlineWidth: 1,
        outlineColor: Cesium.Color.YELLOW,
        perPositionHeight: false
      }
    });

    this._scenceView = scenceView;
    this._viewer = scenceView._viewer;
    this._scenceShowLayers = scenceView._props.defaultShowLayerNames;

    this._initData(scenceView._props);
  } //加载初始数据


  _initData(props) {
    if (props.scenceInfo) {
      this.addScenceInfo(props.scenceInfo);
    } else {
      this.addServiceData(props.service);
    }
  } //添加场景数据


  addScenceInfo(scenceInfo) {
    if (scenceInfo.rectangle && scenceInfo.rectangle.length === 4) {
      this._viewer.camera.flyTo({
        destination: Cesium.Rectangle.fromDegrees(scenceInfo.rectangle[0], scenceInfo.rectangle[1], scenceInfo.rectangle[2], scenceInfo.rectangle[3])
      });
    }

    let layer = scenceInfo.layer;

    if (layer && layer.sources && layer.layerTreeData) {
      //首先处理sources里kqserver类型的数据
      var sourcePromises = [];
      layer.sources.forEach(source => {
        if (source.serverType === "kqserver") {
          //使用二维方式解析服务
          var url = source.url;
          var serverName = url.split("services/")[1].split("/")[0];
          var serverUrl = url.split("services/")[0] + "services/";
          var token;

          if (url.indexOf("ua_token") != -1) {
            token = url.split("ua_token=")[1].split("&")[0];
          }

          token = token || source.token;
          var webMapService = new (webmapservice_default())(serverName, {
            token: token,
            serviceUrl: serverUrl
          });
          var sourcePromise = webMapService.getMapInfo().then(mapInfo => {
            if (mapInfo.resultcode === "error") {
              message({
                message: mapInfo.message,
                type: "error"
              });
              return;
            }

            source.mapServerInfo = (0,util_namespaceObject.formatKQMapInfo)(mapInfo.result, serverUrl, serverName, token, null, true);
            source.mapServerInfo.layers_old.forEach(layer_old => {
              layer_old.guid = source.name + "@@@" + layer_old.id;
              layer_old.sourceName = source.name;

              this._layerListData_old.push(layer_old);
            }, this);
          }, error => {
            console.log(error);
          }).catch(error => {
            console.error(error);
          });
          sourcePromises.push(sourcePromise);
        }
      });
      this._promises = [];
      Promise.all(sourcePromises).then(() => {
        // layer.layerTreeData.forEach(data => {
        //   this.setLayerInfo(data, layer.sources);
        // }, this);
        //倒序加载图层
        for (let i = layer.layerTreeData.length - 1; i >= 0; i--) {
          this.setLayerInfo(layer.layerTreeData[i], layer.sources);
        }

        Promise.all(this._promises).then(() => {
          this._layerTreeData = layer.layerTreeData;

          this._scenceView.fire("resetLayerDatas"); //重置Imagerylayer图层顺序，wms和wmts异步加载导致图层顺序错乱


          this._layerListData.forEach(layerData => {
            if (layerData.serverType === "imagerylayer") {
              var imagerylayer = this.getLayerByGuid(layerData.guid, 'imagerylayer');

              if (imagerylayer) {
                this._viewer.imageryLayers.raiseToTop(imagerylayer);
              }
            }
          }, this);
        });
      });
    }
  } //设置图层属性


  setLayerInfo(layerData, sources) {
    if (layerData.children) {
      layerData.guid = Cesium.createGuid(); // layerData.children.forEach(child => {
      //   this.setLayerInfo(child, sources);
      // }, this);
      //倒序加载子图层

      for (let i = layerData.children.length - 1; i >= 0; i--) {
        this.setLayerInfo(layerData.children[i], sources);
      }
    } else {
      if (layerData.sourceName) {
        var source = sources.find(item => {
          return item.name === layerData.sourceName;
        });

        if (source) {
          layerData.sourceType = source.serverType;
          layerData.renderType = source.renderType;
          layerData.url = source.url;
          layerData.guid = layerData.sourceName + "@@@" + (layerData.id || Math.random() * 10);
          var type = layerData.renderType;

          if (layerData.sourceType === "kqserver") {
            if (!layerData.renderType || layerData.renderType === "rest") {
              type = "kqgismapserver";
              layerData.token = source.token;
            } else {
              layerData.url += "/" + layerData.renderType;

              if (source.token) {
                layerData.url += "?ua_token=" + source.token;
              }
            } //记录数据源里所有图层信息


            layerData.sourceLayers = source.mapServerInfo.layers_show;
          } else if (layerData.sourceType === "arcserver") {
            if (!layerData.renderType || layerData.renderType === "rest") {
              type = "arcgismapserver";
            } else {
              layerData.url += "/" + layerData.renderType;
            }
          } else if (layerData.sourceType === "kqimageserver") {
            type = "kqgisimageserver";
          } else if (layerData.sourceType === "kq3dserver") {
            type = "kqgis3dserver";
          } else if (layerData.sourceType === "mvt") {
            type = "mvt";
          } else if (layerData.sourceType === "kqdataflowserver") {
            type = "kqgisdataflowserver";
          }

          layerData.addType = type;

          this._layerListData.push(layerData); //是否添加图层


          let isAdd = !this._scenceShowLayers || this._scenceShowLayers.indexOf(layerData.name) > -1;
          var promise = this.addLayerData(layerData, isAdd);

          if (promise) {
            this._promises.push(promise);
          }
        }
      }
    }
  } //添加图层数据


  addLayerData(layerData, isAdd = true) {
    var type = layerData.addType;
    let url = layerData.url;
    type = type || "";
    type = type.toLowerCase();
    let name = layerData.name;

    if (url) {
      if (!name || name === "") {
        let ext;

        if (url.lastIndexOf(".") > url.lastIndexOf("/")) {
          ext = url.substring(url.lastIndexOf(".") + 1);
          ext = ext.toLowerCase();
        }

        if (["kml", "kmz", "czml", "geojson", "json", "topojson"].indexOf(ext) > -1) {
          name = url.substring(url.lastIndexOf("/") + 1);
        } else {
          if (type !== "kqgismapserver" && type !== "wms" && type !== "wmts") {
            name = url.substring(0, url.lastIndexOf("/"));
            name = name.substring(name.lastIndexOf("/") + 1);
          }
        }
      }
    } else {
      if (!name || name === "") {
        name = layerData.layerType;
      }
    }

    layerData.name = name;
    let params = layerData.params || {};
    let layer, promise;

    switch (type) {
      case 'kq3dimageryfile':
        //影像瓦片文件
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dFileImageryProvider({
            name: name,
            url: url,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case 'obterrain':
        //ob地形瓦片文件
        layerData.visible = isAdd;
        layerData.serverType = "terrainprovider";

        if (isAdd) {
          layer = new Cesium.Kq3dFileTerrainProvider({
            name: name,
            url: url,
            ...params
          });
          layer.guid = layerData.guid;
          this._viewer.terrainProvider = layer;

          this._terrainProviders.push(layer);
        }

        break;

      case 'stkterrain':
        //stk地形瓦片文件
        layerData.visible = isAdd;
        layerData.serverType = "terrainprovider";

        if (isAdd) {
          layer = new Cesium.CesiumTerrainProvider({
            name: name,
            url: url,
            requestVertexNormals: true,
            requestWaterMask: false,
            ...params
          });
          layer.guid = layerData.guid;
          this._viewer.terrainProvider = layer;

          this._terrainProviders.push(layer);
        }

        break;

      case "3dtiles":
        layerData.visible = isAdd;
        layerData.serverType = "3dtiles";

        if (isAdd) {
          layer = this._viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
            name: name,
            url: url,
            ...params
          }));
          if (layerData.style && layer) layer.style = layerData.style;
          if (layerData.shader && layer) layer.kq3dCustomShader = layerData.shader;
          layer._guid = layerData.guid;
        }

        break;

      case "kqgis3dserver":
        var that = this;
        layerData.visible = isAdd;
        promise = this._viewer.addKq3dServerLayerGroupExt(url).then(group => {
          var layers = group._addedLayers || group._layers;

          if (layers && layers.length > 0) {
            layer = layers[0];
            var serverType = "";

            if (layer instanceof Cesium.Cesium3DTileset) {
              serverType = "3dtiles";
              layer.show = isAdd;
            } else if (layer instanceof Cesium.ImageryLayer) {
              serverType = "imagerylayer";
              layer.show = isAdd;
            } else if (layer instanceof Cesium.Kq3dFileTerrainProvider || layer instanceof Cesium.CesiumTerrainProvider) {
              serverType = "terrainprovider";
              layer.guid = layerData.guid;

              that._terrainProviders.push(layer);

              if (!isAdd) {
                layer.readyPromise.then(() => {
                  that._viewer.terrainProvider = that._emptyTerrainProvider;
                });
              }
            } else if (layer instanceof Cesium.Kq3dGeoJsonDataSource) {
              serverType = "datasource";
              layer.show = isAdd;
              layerData.shapeType = that.getShapeType(layer);
            }

            layer._guid = layerData.guid;
            layerData.serverType = serverType;
          }
        });
        break;

      case "kqgisimageserver":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";
        layerData.type = "Image"; // 图层树显示图标使用

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dKQGISServerImageryProviderExt({
            name: name,
            url: url,
            layerName: layerData.layerName,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "kqgismapserver":
        if (layerData.sourceLayers) {
          var layerInfo = layerData.sourceLayers.find(item => {
            return item.id + "" == layerData.id + "";
          });

          if (layerInfo) {
            for (var key in layerInfo) {
              if (!layerData[key]) {
                layerData[key] = layerInfo[key];
              }
            }
          }
        }

        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          var imageryProvider = new Cesium.Kq3dKQGISMapServerImageryProviderExt({
            url: url,
            ua_token: layerData.token,
            layers: layerData.id + "",
            ...params
          });
          layer = new Cesium.ImageryLayer(imageryProvider);

          this._viewer.imageryLayers.add(layer);

          layer._guid = layerData.guid;
        }

        break;

      case "arcgismapserver":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dArcGISMapServerImageryProvider({
            name: name,
            url: url,
            layers: layerData.id + "",
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "mvt":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";
        layerData.renderType = "vectortile"; // 图层树显示图标使用

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dMvtImageryProviderExt({
            name: name,
            style: url,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "kqgisdataflowserver":
        layerData.visible = isAdd;
        layerData.serverType = "dataflowlayer";

        if (isAdd) {
          layer = new Cesium.Kq3dDataFlowLayer(this._viewer, {
            url: url,
            style: {
              image: const_image_namespaceObject.CAR_URL,
              width: 30,
              height: 30
            },
            ...params
          });
          layer.init();
          layer.guid = layerData.guid;

          this._dataFlowLayerList.push(layer);
        }

        break;

      case "wms":
        //配置id时只能是单个图层
        if (layerData.rect84) {
          layerData.visible = isAdd;
          layerData.serverType = "imagerylayer";

          if (isAdd) {
            var options = {
              url: url,
              layers: layerData.id + "",
              tilingScheme: layerData.epsg == 3857 ? new Cesium.WebMercatorTilingScheme() : new Cesium.GeographicTilingScheme(),
              rectangle: Cesium.Rectangle.fromDegrees(layerData.rect84[0], layerData.rect84[1], layerData.rect84[2], layerData.rect84[3]),
              parameters: {
                transparent: 'true',
                format: 'image/png'
              },
              ...params
            };
            if (layerData.styles) options.parameters.styles = layerData.styles;
            layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.WebMapServiceImageryProvider(options));
            layer._guid = layerData.guid;
          }
        } else {
          //如果是kqserver类型，记录服务返回的图层信息
          if (layerData.sourceLayers) {
            var layerInfo = layerData.sourceLayers.find(item => {
              return item.id + "" == layerData.id + "";
            });

            if (layerInfo) {
              for (var key in layerInfo) {
                if (!layerData[key]) {
                  layerData[key] = layerInfo[key];
                }
              }
            }
          }

          layerData.visible = isAdd;
          layerData.serverType = "imagerylayer";

          if (isAdd) {
            promise = this._viewer.addWMSLayerGroup(url, {
              layers: layerData.id + ""
            }).then(group => {
              var layers = group._addedLayers || group._layers;

              if (layers && layers.length > 0) {
                layers[0]._guid = layerData.guid;
              }
            });
          }
        }

        break;

      case "wmts":
      case "kqgistileserver":
        //如果是kqserver类型，记录服务返回的图层信息
        if (layerData.sourceLayers) {
          var layerInfo = layerData.sourceLayers.find(item => {
            return item.id + "" == layerData.id + "";
          });

          if (layerInfo) {
            for (var key in layerInfo) {
              if (!layerData[key]) {
                layerData[key] = layerInfo[key];
              }
            }
          }
        }

        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer"; //配置id时只能是单个图层

        if (isAdd) {
          promise = this._viewer.addWMTSLayerGroup(url, {
            layers: layerData.id + ""
          }).then(group => {
            var layers = group._addedLayers || group._layers;

            if (layers && layers.length > 0) {
              layers[0]._guid = layerData.guid;
            }
          });
        }

        break;
      // case "wfs":
      //   var wfsProvider = new Cesium.Kq3dWebFeatureServiceProvider({
      //     url: url,
      //     typeName: name
      //   });
      //   var that = this;
      //   wfsProvider.load().then(function (data) {
      //     var ds = new Cesium.Kq3dGeoJsonDataSource(name);
      //     ds.load(data, that._geojsonStyle).then(ds => {
      //       that._viewer.dataSources.add(ds);
      //       ds.autoAvoid(that._viewer);
      //       layerData.guid = ds.guid;
      //       layerData.visible = true;
      //       layerData.serverType = "datasource";
      //     });
      //   });
      //   break;

      case "geojson":
        layerData.visible = isAdd;
        layerData.serverType = "datasource";

        if (isAdd) {
          var ds = new Cesium.Kq3dGeoJsonDataSource(name);
          var geojsonStyle = layerData.geojsonStyle || this._geojsonStyle;
          promise = ds.load(url, geojsonStyle).then(ds => {
            ds.entities.values.forEach(entity => {
              if (entity.polygon) {
                entity.polyline = {
                  positions: entity.polygon.hierarchy._value.positions,
                  width: geojsonStyle.polygon.outlineWidth,
                  material: geojsonStyle.polygon.outlineColor
                };
              }
            }, this);

            this._viewer.dataSources.add(ds);

            ds.autoAvoid(this._viewer);
            ds._guid = layerData.guid;
            layerData.shapeType = this.getShapeType(ds);
          });
        }

        break;

      case "arcjson":
        layerData.visible = isAdd;
        layerData.serverType = "datasource";

        if (isAdd) {
          var ds = new Cesium.Kq3dEsriGeoJsonDataSource(name);
          var geojsonStyle = layerData.geojsonStyle || this._geojsonStyle;
          promise = ds.load(url, geojsonStyle).then(ds => {
            ds.entities.values.forEach(entity => {
              if (entity.polygon) {
                entity.polyline = {
                  positions: entity.polygon.hierarchy._value.positions,
                  width: geojsonStyle.polygon.outlineWidth,
                  material: geojsonStyle.polygon.outlineColor
                };
              }
            }, this);

            this._viewer.dataSources.add(ds);

            ds._guid = layerData.guid;
            layerData.shapeType = this.getShapeType(ds);
          });
        }

        break;

      case "kml":
        layerData.visible = isAdd;
        layerData.serverType = "datasource";

        if (isAdd) {
          var ds = new Cesium.KmlDataSource({
            name: name,
            camera: this._viewer.camera,
            canvas: this._viewer.scene.canvas,
            ...params
          });
          promise = ds.load(url).then(ds => {
            this._viewer.dataSources.add(ds);

            ds._guid = layerData.guid;
          });
        }

        break;

      case "czml":
        layerData.visible = isAdd;
        layerData.serverType = "datasource";

        if (isAdd) {
          var ds = new Cesium.CzmlDataSource(name);
          promise = ds.load(url).then(ds => {
            this._viewer.dataSources.add(ds);

            ds._guid = layerData.guid;
          });
        }

        break;

      case "tianditu":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dTiandituImageryProvider({
            name: name,
            mapStyle: layerData.layerType + "_c",
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "baidu":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dBaiduMapsImageryProvider({
            name: name,
            mapStyle: layerData.layerType,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "gaode":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dAMapsImageryProvider({
            name: name,
            mapStyle: layerData.layerType,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "tencent":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dQQMapsImageryProvider({
            name: name,
            mapStyle: layerData.layerType,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      case "tile":
        layerData.visible = isAdd;
        layerData.serverType = "imagerylayer";

        if (isAdd) {
          layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.UrlTemplateImageryProvider({
            name: name,
            url: url,
            ...params
          }));
          layer._guid = layerData.guid;
        }

        break;

      default:
        break;
    }

    return promise;
  } // 获取geojson数据类型


  getShapeType(ds) {
    let shapeType = "";

    if (ds.entities.values.length > 0) {
      let entity = ds.entities.values[0];

      if (entity.polygon) {
        shapeType = 'polygon';
      } else if (entity.polyline) {
        shapeType = 'polyline';
      } else if (entity.billboard || entity.point) {
        shapeType = 'point';
      }
    }

    return shapeType;
  } //添加服务数据


  addServiceData(service) {
    if (service && service.name && service.url && service.type) {
      var that = this;

      if (service.type === "kqmapserver") {
        //KQGIS地图服务
        service.serviceUrl = service.url;
        let webMapService = new (webmapservice_default())(service.name, service);
        let serviceUrl = webMapService.handleServerUrl(service.url);
        webMapService.getMapInfo().then(mapInfo => {
          mapInfo = mapInfo.result || mapInfo; // 存储地图的名称以及描述等信息，返回给用户

          let mapServerInfo = (0,util_namespaceObject.formatKQMapInfo)(mapInfo, serviceUrl, service.name, service.token, service.defaultShowLayerNames, service.isShowAllLayers === undefined ? true : service.isShowAllLayers);
          mapServerInfo.layerTreeData.forEach(node => {
            that._layerTreeData.push(node);
          });
          mapServerInfo.layers_old.forEach(layer => {
            that._layerListData_old.push(layer);
          });
          let showLayers = [];
          showLayers = showLayers.concat(mapServerInfo.layers_show);
          showLayers.reverse(); //获取图层筛选类型时用

          showLayers.forEach(layer => {
            layer.sourceType = 'kqserver';
          });
          that._layerListData = that._layerListData.concat(showLayers); // console.log(that._layerTreeData);
          // console.log(that._layerListData);
          // console.log(that._layerListData_old);

          that.addMapServerLayers(showLayers, mapInfo.rect84);
        }, error => {
          throw error;
        }).catch(error => {
          console.error(error);
        });
      } else if (service.type === "kq3dserver") {//KQGIS三维服务
      } else if (service.type === "3dtiles") {
        //3dtiles
        that.add3DTilesData(service.name, service.url);
      }
    }
  } //添加KQGIS服务图层


  addMapServerLayers(layers, rect) {
    var that = this;
    layers.forEach(layer => {
      //不显示的图层不加载
      if (layer.visible) {
        var imageryProvider = new Cesium.Kq3dKQGISMapServerImageryProviderExt({
          url: layer.url,
          ua_token: layer.accessToken,
          layers: layer.id + ""
        });
        var imageryLayer = new Cesium.ImageryLayer(imageryProvider);
        imageryLayer._guid = layer.guid;

        that._viewer.imageryLayers.add(imageryLayer);
      }
    });

    if (rect) {
      if (rect instanceof Array) {
        that._viewer.camera.flyTo({
          destination: Cesium.Rectangle.fromDegrees(rect[0], rect[1], rect[2], rect[3])
        });
      } else {
        that._viewer.camera.flyTo({
          destination: Cesium.Rectangle.fromDegrees(rect.minx, rect.miny, rect.maxx, rect.maxy)
        });
      }
    }

    that._scenceView.fire("resetLayerDatas");
  } //添加3dtiles数据


  add3DTilesData(name, url) {
    let that = this;

    let tileset = that._viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
      name: name,
      url: url
    }));

    tileset.readyPromise.then(function (tileset) {
      that._viewer.zoomTo(tileset); //that._viewer.zoomTo(tileset, new Cesium.HeadingPitchRange(0.5, -0.6, tileset.boundingSphere.radius));

    });

    this._layerTreeData.push({
      guid: tileset.guid,
      name: name,
      visible: true,
      serverType: "3dtiles",
      shapeType: "model"
    });

    this._layerListData.push({
      guid: tileset.guid,
      name: name,
      visible: true,
      serverType: "3dtiles"
    });
  }
  /**
   * 设置多个图层的显示与隐藏 且控制树的勾选
   * @param ids 图层的GUID数组
   * @param visible true, false
   * @param eventTarget 触发方法的对象。该方法有执行其他监听事件，为防止方法死循环，该参数会传给监听事件
   */


  setLayerVisibleStateByIds(ids, visible, eventTarget = null) {
    if (!(ids && ids.length > 0)) return;
    let layer;

    for (let z = 0; z < ids.length; z++) {
      for (let i = 0; i < this._layerListData.length; i++) {
        if (this._layerListData[i].guid === ids[z]) {
          this._layerListData[i].visible = visible;
          layer = this.getLayerByGuid(ids[z], this._layerListData[i].serverType);

          if (layer) {
            if (this._layerListData[i].serverType === "terrainprovider") {
              if (visible) {
                this.setTerrain(layer);
              } else {
                this._viewer.terrainProvider = this._emptyTerrainProvider;
              }
            } else {
              layer.show = visible;
            }
          } else if (visible) {
            //如果不存在该图层则添加
            if (this._layerListData[i].serverType === "kqserver") {
              var imageryProvider = new Cesium.Kq3dKQGISMapServerImageryProviderExt({
                url: this._layerListData[i].url,
                ua_token: this._layerListData[i].accessToken,
                layers: this._layerListData[i].id + ""
              });
              var imageryLayer = new Cesium.ImageryLayer(imageryProvider);
              imageryLayer._guid = this._layerListData[i].guid;
              var addIndex = this.getImageryLayerAddIndex(ids[z]);

              if (addIndex > -1) {
                this._viewer.imageryLayers.add(imageryLayer, addIndex);
              } else {
                this._viewer.imageryLayers.add(imageryLayer);
              }
            } else if (this._layerListData[i].sourceType) {
              var promise = this.addLayerData(this._layerListData[i]);

              if (promise) {
                promise.then(() => {
                  adjustLayerIndex(this._layerListData[i], this);
                });
              } else {
                adjustLayerIndex(this._layerListData[i], this);
              }

              function adjustLayerIndex(layerData, that) {
                if (layerData.serverType === "imagerylayer") {
                  var addIndex = that.getImageryLayerAddIndex(layerData.guid);
                  if (addIndex === -1) return;
                  layer = that.getLayerByGuid(layerData.guid, layerData.serverType);

                  if (layer) {
                    var count = layer._layerIndex - addIndex;

                    for (var i = 0; i < count; i++) {
                      that._viewer.imageryLayers.lower(layer);
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    this._scenceView.fire("resetLayerDatas", {
      eventTarget
    });
  } //通过guid获取ImageryLayer图层添加的index


  getImageryLayerAddIndex(guid) {
    let layers = [];
    let layerIndex = -1;
    let layerAddIndex = -1; //从_layerListData中找出所有ImageryLayer图层

    this._layerListData.forEach(layer => {
      if (layer.serverType === "kqserver" || layer.serverType === "imagerylayer") {
        layers.push(layer);

        if (layer.guid === guid) {
          layerIndex = layers.length - 1;
        }
      }
    });

    if (layerIndex > -1) {
      var isLeftShow = false;
      var adjacentLayerShowIndex = -1; //搜索左边相邻显示的图层

      for (var i = layerIndex - 1; i >= 0; i--) {
        if (layers[i].visible) {
          adjacentLayerShowIndex = i;
          isLeftShow = true;
          break;
        }
      }

      if (adjacentLayerShowIndex === -1) {
        //搜索右边相邻显示的图层
        for (var j = layerIndex + 1; j < layers.length; j++) {
          if (layers[j].visible) {
            adjacentLayerShowIndex = j;
            break;
          }
        }
      }

      if (adjacentLayerShowIndex > -1) {
        var adjacentLayer = this.getLayerByGuid(layers[adjacentLayerShowIndex].guid);

        if (adjacentLayer) {
          var adjacentLayerIndex = adjacentLayer._layerIndex;

          if (isLeftShow) {
            layerAddIndex = adjacentLayerIndex + 1;
          } else {
            if (this.getBaseLayerIndex() === adjacentLayerIndex) {
              layerAddIndex = adjacentLayerIndex;
            } else {
              layerAddIndex = adjacentLayerIndex - 1;
            }
          }
        }
      }
    }

    return layerAddIndex;
  } //通过guid获取图层对象


  getLayerByGuid(guid, type) {
    if (!type) {
      type = this.getLayerTypeByGuid(guid);
    }

    if (type === "kqserver" || type === "imagerylayer") {
      let imageryLayers = this._viewer.imageryLayers._layers;
      let layer = imageryLayers.find(item => {
        return item.guid === guid;
      });
      return layer;
    } else if (type === "terrainprovider") {
      let layer = this._terrainProviders.find(item => {
        return item.guid === guid;
      });

      return layer;
    } else if (type === "3dtiles") {
      let primitives = this._viewer.scene.primitives._primitives;
      let layer = primitives.find(item => {
        return item.guid === guid && item instanceof Cesium.Cesium3DTileset;
      });
      return layer;
    } else if (type === "datasource") {
      let dataSources = this._viewer.dataSources._dataSources;
      let layer = dataSources.find(item => {
        return item.guid === guid;
      });
      return layer;
    } else if (type === "dataflowlayer") {
      let layer = this._dataFlowLayerList.find(item => {
        return item.guid === guid;
      });

      return layer;
    }
  } //通过guid获取图层类型


  getLayerTypeByGuid(guid) {
    let listLayer = this._layerListData.find(item => {
      return item.guid === guid;
    });

    if (listLayer) {
      return listLayer.serverType;
    }
  } // 获取所有图层原数据（包括adddata组件的临时图层数据，不包括底图baselayer）


  getLayerData(serverType) {
    let layerData = [];

    this._layerListData.forEach(layer => {
      if (this._isContainValue(serverType, layer.sourceType)) {
        layerData.push(layer);
      }
    }, this);

    return layerData;
  } // 获取所有图层的key（包括adddata组件的临时图层数据，不包括底图baselayer）


  getLayerDataKey(serverType) {
    let keys = [];

    this._layerListData.forEach(layer => {
      if (this._isContainValue(serverType, layer.sourceType)) {
        keys.push(layer.guid);
      }
    }, this);

    return keys;
  } //获取所有图层的树形结构数据


  getLayerTreeData() {
    return [...this._layerTreeData];
  } //是否包含值


  _isContainValue(target, value) {
    let contain = false;

    if (target) {
      if (typeof target === "string") {
        contain = target === value;
      } else if (target instanceof Array) {
        target.forEach(item => {
          if (item === value) {
            contain = true;
          }
        });
      }
    } else {
      contain = true;
    }

    return contain;
  } //获取选中或未选中图层集合


  getLayerCheckedList(serverType) {
    let checkedLayers = [];

    this._layerListData.forEach(layer => {
      if (layer.visible && this._isContainValue(serverType, layer.sourceType)) {
        checkedLayers.push(layer);
      }
    }, this);

    return checkedLayers;
  } //获取选中图层key集合


  getLayerCheckedListKey(isCheck = true, serverType) {
    let checkedKeys = [];

    this._layerListData.forEach(layer => {
      if (layer.visible === isCheck && this._isContainValue(serverType, layer.sourceType)) {
        checkedKeys.push(layer.guid);
      }
    }, this);

    return checkedKeys;
  }
  /**
   * 获取勾选图层的图层数据，如果是有融合图层，则只返回融合图层的子图层
   */


  getLayerDataByLayerChecked(serverType) {
    let layerData = [];
    const layers_checked = this.getLayerCheckedList(serverType);
    const layers_old = this._layerListData_old;

    for (let i = 0; i < layers_checked.length; i++) {
      if (layers_checked[i].combined) {
        getChildren(layers_checked[i]);
      } else {
        layerData.push(layers_checked[i]);
      }
    }

    return layerData;

    function getChildren(parent) {
      for (let z = 0; z < layers_old.length; z++) {
        if (layers_old[z].parentLayerId === parent.id && layers_old[z].sourceName === parent.sourceName) {
          // 分组节点
          if (layers_old[z].groupLayer) {
            getChildren(layers_old[z]);
          } else {
            layerData.push(layers_old[z]);
          }
        }
      }
    }
  } //缩放至图层


  flyToBounds(bounds) {
    let viewer = this._viewer;

    if (bounds instanceof Array && bounds.length === 4) {
      let rect = Cesium.Rectangle.fromDegrees(bounds[0], bounds[1], bounds[2], bounds[3]);
      viewer.camera.flyTo({
        destination: rect
      });
      return;
    }

    let guid = bounds;
    let layer = this.getLayerByGuid(guid);

    if (layer instanceof Cesium.ImageryLayer) {
      layer.getViewableRectangle().then(function (rectangle) {
        viewer.camera.flyTo({
          destination: rectangle
        });
      });
    } else if (layer instanceof Cesium.Cesium3DTileset) {
      viewer.zoomTo(layer);
    } else if (layer instanceof Cesium.GeoJsonDataSource || layer instanceof Cesium.Kq3dGeoJsonDataSource || layer instanceof Cesium.KmlDataSource || layer instanceof Cesium.CzmlDataSource) {
      viewer.flyTo(layer);
    } else if (layer instanceof Cesium.Kq3dKQGISServerTerrainProvider || layer instanceof Cesium.Kq3dFileTerrainProvider || layer instanceof Cesium.CesiumTerrainProvider) {
      layer.getViewableRectangle().then(function (rectangle) {
        if (layer.ExtentSource) {
          var rectangle = Cesium.Rectangle.fromDegrees(layer.ExtentSource.left, layer.ExtentSource.bottom, layer.ExtentSource.right, layer.ExtentSource.top);
          viewer.camera.flyTo({
            destination: rectangle
          });
        } else if (rectangle) {
          viewer.camera.flyTo({
            destination: rectangle
          });
        }
      });
    } else if (layer instanceof Cesium.Kq3dDataFlowLayer) {
      layer.flyToBounds();
    }
  } //获取底图图层Index


  getBaseLayerIndex() {
    let index = 1;

    this._viewer.imageryLayers._layers.forEach(layer => {
      if (layer.target === "online") {
        index++;
      }
    });

    return index;
  } //设置图层置顶或取消置顶


  setLayerBringToFrontById(guid, isFront) {
    let layer = this.getLayerByGuid(guid);

    if (layer) {
      if (isFront) {
        //置顶
        if (this._frontLayerGuid === guid) return;

        if (this._frontLayerGuid) {
          // 如果已经有置顶图层 先把已经置顶的图层还原 再继续操作
          let frontLayer = this.getLayerByGuid(this._frontLayerGuid);

          if (this._frontLayerIndex !== null) {
            var length = frontLayer._layerIndex - this._frontLayerIndex;

            for (let i = 0; i < length; i++) {
              if (frontLayer instanceof Cesium.ImageryLayer) {
                this._viewer.imageryLayers.lower(frontLayer);
              }
            }
          }
        }

        if (layer instanceof Cesium.ImageryLayer) {
          this._frontLayerGuid = guid;
          this._frontLayerIndex = layer._layerIndex;

          this._viewer.imageryLayers.raiseToTop(layer);
        }
      } else {
        //取消置顶
        if (this._frontLayerGuid !== guid) return;

        if (this._frontLayerIndex !== null) {
          let length = layer._layerIndex - this._frontLayerIndex;

          for (let j = 0; j < length; j++) {
            if (layer instanceof Cesium.ImageryLayer) {
              this._viewer.imageryLayers.lower(layer);
            }
          }
        }

        this._frontLayerGuid = null;
        this._frontLayerIndex = null;
      }
    }
  } //图层上移


  raiseLayerById(guid) {
    let layer = this.getLayerByGuid(guid);

    if (layer instanceof Cesium.ImageryLayer) {
      this._viewer.imageryLayers.raise(layer);
    }
  } //图层下移


  lowerLayerById(guid) {
    let layer = this.getLayerByGuid(guid);

    if (layer instanceof Cesium.ImageryLayer) {
      let baseIndex = this.getBaseLayerIndex(); //防止图层下移到底图下面

      if (layer._layerIndex > baseIndex) {
        this._viewer.imageryLayers.lower(layer);
      }
    }
  }
  /**
   * 根据传入的guid数组 给imageryLayer图层重新排序
   * 图层树拖动树节点功能需求实现
   * @param {array} guids guid数组
   */


  sortLayerZIndexByGuids(guids) {
    let layerListDataNew = [];

    for (let i = guids.length - 1; i >= 0; i--) {
      let layer = this.getLayerByGuid(guids[i]);

      if (layer && layer instanceof Cesium.ImageryLayer) {
        this._viewer.imageryLayers.raiseToTop(layer);
      }

      var layerData = this._layerListData.find(item => {
        return item.guid === guids[i];
      });

      if (layerData) layerListDataNew.push(layerData);
    }

    this._layerListData = layerListDataNew;
  } //重置图层顺序


  resetLayerIndex() {
    this._layerListData.forEach(layer => {
      if (layer.serverType === "kqserver" || layer.serverType === "imagerylayer") {
        var imageryLayer = this.getLayerByGuid(layer.guid);

        if (imageryLayer) {
          if (imageryLayer._layerIndex > imageryLayer._originIndex) {
            var length = imageryLayer._layerIndex - imageryLayer._originIndex;

            for (var i = 0; i < length; i++) {
              this._viewer.imageryLayers.lower(imageryLayer);
            }
          } else if (imageryLayer._layerIndex < imageryLayer._originIndex) {
            var length = imageryLayer._originIndex - imageryLayer._layerIndex;

            for (var j = 0; j < length; j++) {
              this._viewer.imageryLayers.raise(imageryLayer);
            }
          }
        }
      }
    }, this);

    this._frontLayerGuid = null;
    this._frontLayerIndex = null;
  } //设置图层透明度


  setLayerOpacityById(guid, opacity) {
    let layer = this.getLayerByGuid(guid);

    if (layer instanceof Cesium.ImageryLayer) {
      layer.alpha = opacity;
    } else if (layer instanceof Cesium.Cesium3DTileset) {
      layer.style = new Cesium.Cesium3DTileStyle({
        color: "color('rgba(255,255,255," + opacity + ")')"
      });
    }
  } //添加临时图层树节点


  addTempLayerNode(layer, type = 0) {
    let tempLayer = null;

    for (let i = 0; i < this._layerTreeData.length; i++) {
      if (this._layerTreeData[i].guid === "134f6h768tha23_3d") {
        tempLayer = this._layerTreeData[i];
        break;
      }
    }

    if (!tempLayer) {
      tempLayer = {
        guid: "134f6h768tha23_3d",
        name: "临时图层",
        children: []
      };

      this._layerTreeData.push(tempLayer);
    }

    tempLayer.children.push(layer);

    if (type === 0) {
      if (layer.children) {
        layer.children.forEach(child => {
          this._layerListData.push(child);
        }, this);
      } else {
        this._layerListData.push(layer);
      }
    }

    this._scenceView.fire("resetLayerDatas");
  } //设置地形


  setTerrain(terrainProvider) {
    if (this._viewer.terrainProvider) {
      let guid = this._viewer.terrainProvider.guid;

      if (guid) {
        //取消树节点勾选
        function uncheckNode(node, id) {
          if (node.children) {
            node.children.forEach(child => {
              uncheckNode(child, id);
            });
          } else {
            if (node.guid === id) {
              node.visible = false;
            }
          }
        }

        this._layerTreeData.forEach(item => {
          uncheckNode(item, guid);
        }); //this._scenceView.fire("resetLayerDatas");


        global_event_default().fire("setTreeChecked", {
          keys: [guid],
          show: false
        });
      }
    }

    this._viewer.terrainProvider = terrainProvider;
  }
  /**
   * 删除临时添加数据
   * 移除渲染图层
   * 删除 _layerTreeData的临时图层数据
   * 删除 _layerListData的临时图层数据
   * @param guid
   */


  delTempData(guid) {
    if (guid) {
      let guids = []; //获取需要删除的图层guid集合

      getChildrenByGuid(this._layerTreeData, guid, guids); //删除_layerTreeData数据

      delTreeDataByGuid(this._layerTreeData, guid);
      guids.forEach(id => {
        //移除渲染图层
        this.removeLayerByGuid(id); //删除_layerListData数据

        for (var i = 0; i < this._layerListData.length; i++) {
          if (id === this._layerListData[i].guid) {
            this._layerListData.splice(i, 1);

            break;
          }
        }
      }, this);
    }
  } //通过guid移除图层


  removeLayerByGuid(guid) {
    let type = this.getLayerTypeByGuid(guid);
    let layer = this.getLayerByGuid(guid, type);

    if (layer) {
      switch (type) {
        case "kqserver":
        case "imagerylayer":
          this._viewer.imageryLayers.remove(layer);

          break;

        case "terrainprovider":
          //删除地形集合数据
          for (let i = 0; i < this._terrainProviders.length; i++) {
            if (this._terrainProviders[i].guid === guid) {
              this._terrainProviders.splice(i, 1);

              break;
            }
          }

          this._viewer.terrainProvider = this._emptyTerrainProvider;
          break;

        case "3dtiles":
          this._viewer.scene.primitives.remove(layer);

          break;

        case "datasource":
          this._viewer.dataSources.remove(layer);

          break;

        case "dataflowlayer":
          layer.destroy(); //删除_dataFlowLayerList数据

          for (var i = 0; i < this._dataFlowLayerList.length; i++) {
            if (guid === this._dataFlowLayerList[i].guid) {
              this._dataFlowLayerList.splice(i, 1);

              break;
            }
          }

          break;

        default:
          break;
      }
    }
  } //通过guid刷新图层


  refreshLayerByGuid(guid) {
    let layer = this.getLayerByGuid(guid);

    if (layer) {
      if (layer.imageryProvider && layer.imageryProvider._reload) {
        layer.imageryProvider._reload();
      }
    }
  } // 设置海图显示物标


  reLoadHaiTu(encparam) {
    for (var i = 0; i < this._layerListData.length; i++) {
      var layerData = this._layerListData[i];

      if (layerData.layerType === 10) {
        var layer = this.getLayerByGuid(layerData.guid);

        if (layer) {
          layer.imageryProvider.encparam = encparam;
        }
      }
    }
  } //销毁


  destroy() {
    this._viewer = null;
    this._scenceView = null;
  }

}
/**
 * 根据guid获取子节点guid集合
 * @param data
 * @param guid
 */

function getChildrenByGuid(data, guid, guids, addChildren = false) {
  for (let i = 0; i < data.length; i++) {
    if (data[i].children) {
      if (data[i].guid === guid || addChildren) {
        getChildrenByGuid(data[i].children, guid, guids, true);
      } else {
        getChildrenByGuid(data[i].children, guid, guids);
      }
    } else {
      if (data[i].guid === guid || addChildren) {
        guids.push(data[i].guid);
      }
    }
  }
}
/**
 * 根据guid删除树节点数据，包含子节点也删除
 * @param data
 * @param guid
 */


function delTreeDataByGuid(data, guid) {
  var hasGuid = false;

  for (var i = 0; i < data.length; i++) {
    if (data[i].guid === guid) {
      data.splice(i, 1);
      hasGuid = true;
      break;
    }
  }

  if (!hasGuid) {
    for (var i = 0; i < data.length; i++) {
      if (data[i].children) {
        delTreeDataByGuid(data[i].children, guid);
      }
    }
  }
}
;// CONCATENATED MODULE: ./src/webgl/scenceview/ScenceViewViewModel.js

//ScenceView逻辑类




class ScenceViewViewModel extends (mitt_default()) {
  // 三维球div id
  // 三维viewer对象
  // 语言
  //绘制管理对象
  //图层管理对象
  //底图集合
  constructor(props, lang) {
    super();

    _defineProperty(this, "_viewerId", "");

    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_lang", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_layerManager", null);

    _defineProperty(this, "_props", null);

    _defineProperty(this, "_removeEventListener", null);

    _defineProperty(this, "_baseLayers", {});

    this._viewerId = props.target;
    this._props = props;
    this._lang = lang;
    this._language = lang.language;
  } //初始化三维球


  initViewer() {
    var defaultOptions = {
      imageryProvider: new Cesium.SingleTileImageryProvider({
        url: Cesium.buildModuleUrl("Assets/Textures/earth_color_low_4096.jpg")
      }),
      animation: false,
      timeline: false,
      baseLayerPicker: false,
      geocoder: false,
      homeButton: false,
      fullscreenButton: false,
      selectionIndicator: false,
      navigation: false,
      sceneModePicker: false,
      infoBox: false,
      languageStyle: this._lang.type == 'zh' ? 'zh-CN' : 'en',
      navigationHelpButton: false
    };

    for (var key in this._props.options) {
      if (this._props.options.hasOwnProperty(key)) {
        defaultOptions[key] = this._props.options[key];
      }
    }

    this._viewer = new Cesium.Viewer(this._viewerId, defaultOptions); //隐藏地图状态栏

    this._viewer.statusBar.show = false;

    if (!this._props.showLogo) {
      //隐藏logo
      this._viewer.bottomContainer.children[0].style.display = "none";
    } // this._viewer.scene.globe.depthTestAgainstTerrain = true;


    this.initManagerClass(); // 添加模型淹没分析对象, 淹没分析组件使用

    this._floodModelAnalysis = new Cesium.Kq3dFloodModelAnalysis({
      viewer: this._viewer
    });
    global_event_default().setWebMap(this._viewerId, "cesium", this);
    global_event_default().fire("load-viewer", {
      eventMapTarget: this._viewerId
    });
    global_event_default().off("load-viewer");
    this.fire("mounted", {
      eventMapTarget: this
    });
  } //初始化操作类


  initManagerClass() {
    if (this._viewer) {
      this._drawManager = new DrawManager(this._viewer, this._lang.language);
      this._layerManager = new LayerManager(this);
    }
  } //销毁


  destroy() {// if (this._removeEventListener) {
    //   this._removeEventListener();
    //   this._removeEventListener = null;
    // }
    // this._viewer = null;
    // this._drawManager = null;
    // this._layerManager = null;
  } //创建底图


  _createBaseLayer(layerConfig) {
    let layer = null;
    let index = 1;
    let layerType = layerConfig.serverType;
    if (layerType) layerType = layerType.toLowerCase();

    switch (layerType) {
      case "kqserver":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dKQGISMapServerImageryProviderExt({
          url: layerConfig.url,
          ua_token: layerConfig.accessToken
        }), index);
        break;

      case "wmts":
        var options = {
          url: layerConfig.url,
          layer: layerConfig.id,
          tileMatrixSetID: layerConfig.tilematrixSet || "default028mm",
          tileMatrixLabels: layerConfig.tileMatrixLabels,
          style: layerConfig.style || "default",
          format: layerConfig.format || "image/png",
          minimumLevel: layerConfig.minZoom,
          maximumLevel: layerConfig.maxZoom,
          subdomains: layerConfig.subdomains,
          tilingScheme: layerConfig.epsg === "3857" ? new Cesium.WebMercatorTilingScheme() : new Cesium.GeographicTilingScheme()
        };
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.WebMapTileServiceImageryProvider(options), index);
        break;

      case "wms":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.WebMapServiceImageryProvider({
          url: layerConfig.url,
          layers: layerConfig.id,
          parameters: {
            transparent: "true",
            format: "image/png"
          }
        }), index);
        break;

      case "tianditu":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dTiandituImageryProvider({
          mapStyle: layerConfig.layerType + "_c"
        }), index);
        break;

      case "baidu":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dBaiduMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "gaode":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dAMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "tencent":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dQQMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "bing":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.BingMapsImageryProvider({
          url: layerConfig.url || "https://dev.virtualearth.net",
          key: layerConfig.key || "AmXdbd8UeUJtaRSn7yVwyXgQlBBUqliLbHpgn2c76DfuHwAXfRrgS5qwfHU6Rhm8",
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "arcgisonline":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dArcGISMapServerImageryProvider({
          url: layerConfig.url
        }), index);
        break;

      case "mapbox":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.MapboxImageryProvider({
          mapId: "mapbox." + layerConfig.layerType,
          accessToken: layerConfig.key || "pk.eyJ1IjoiZXhhbXBsZXMiLCJhIjoiY2p1dHRybDR5MGJuZjQzcGhrZ2doeGgwNyJ9.a-vxW4UaxOoUMWUTGnEArw"
        }), index);
        break;

      case "osm":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.createOpenStreetMapImageryProvider({
          url: layerConfig.url
        }), index);
        break;

      case "tile":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.UrlTemplateImageryProvider({
          url: layerConfig.url,
          minimumLevel: layerConfig.minZoom,
          maximumLevel: layerConfig.maxZoom,
          tilingScheme: layerConfig.epsg === "3857" ? new Cesium.WebMercatorTilingScheme() : new Cesium.GeographicTilingScheme()
        }), index);
        break;
    }

    if (layer) {
      if (layerConfig.minimumTerrainLevel !== undefined) {
        layer.minimumTerrainLevel = layerConfig.minimumTerrainLevel;
      }

      if (layerConfig.maximumTerrainLevel !== undefined) {
        layer.maximumTerrainLevel = layerConfig.maximumTerrainLevel;
      }
    }

    return layer;
  }
  /**
   * 操作底图显隐的方法
   * @param layerKey 存储图层信息的key
   * @param layerInfo 创建图层的参数信息对象
   * @param visible 显隐
   */


  showBaseLayer(layerKey, layerInfo, visible) {
    let layers = this._baseLayers[layerKey];

    if (!layers) {
      layers = [];

      for (let i = 0; i < layerInfo.layers.length; i++) {
        let layer = this._createBaseLayer(layerInfo.layers[i]);

        if (layer) {
          layer.show = visible;
          layer.layerkey = layerInfo.layers[i].layerkey;
          layers.push(layer);
        }
      }

      this._baseLayers[layerKey] = layers;
    } else {
      for (let i = 0; i < layerInfo.layers.length; i++) {
        layers.forEach(layer => {
          if (layerInfo.layers[i].layerkey === layer.layerkey) {
            layer.show = visible;
          }
        });
      }
    }
  }
  /**
   * 获取在线底图index
   */


  _getOnlineBaseLayerIndex() {
    let index = 1;

    this._viewer.imageryLayers._layers.forEach(layer => {
      if (layer.target === "online") {
        index++;
      }
    });

    return index;
  } //创建在线底图


  _createOnlineLayer(layerConfig) {
    let layer = null;

    let index = this._getOnlineBaseLayerIndex();

    let layerType = layerConfig.renderType;
    if (layerType) layerType = layerType.toLowerCase();

    switch (layerType) {
      case "kqserver":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dKQGISMapServerImageryProviderExt({
          url: layerConfig.url,
          ua_token: layerConfig.accessToken
        }), index);
        break;

      case "wmts":
        let options = {
          url: layerConfig.url,
          layer: layerConfig.id,
          tileMatrixSetID: layerConfig.tilematrixSet || "default028mm",
          tileMatrixLabels: layerConfig.tileMatrixLabels,
          style: layerConfig.style || "default",
          format: layerConfig.format || "image/png",
          minimumLevel: layerConfig.minZoom,
          maximumLevel: layerConfig.maxZoom,
          subdomains: layerConfig.subdomains,
          tilingScheme: layerConfig.epsg === "4326" ? new Cesium.GeographicTilingScheme() : new Cesium.WebMercatorTilingScheme()
        };
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.WebMapTileServiceImageryProvider(options), index);
        break;

      case "wms":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.WebMapServiceImageryProvider({
          url: layerConfig.url,
          layers: layerConfig.id,
          parameters: {
            transparent: "true",
            format: "image/png"
          }
        }), index);
        break;

      case "tianditu":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dTiandituImageryProvider({
          mapStyle: layerConfig.layerType + "_c"
        }), index);
        break;

      case "baidu":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dBaiduMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "gaode":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dAMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "tencent":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dQQMapsImageryProvider({
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "bing":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.BingMapsImageryProvider({
          url: layerConfig.url || "https://dev.virtualearth.net",
          key: layerConfig.key || "AmXdbd8UeUJtaRSn7yVwyXgQlBBUqliLbHpgn2c76DfuHwAXfRrgS5qwfHU6Rhm8",
          mapStyle: layerConfig.layerType
        }), index);
        break;

      case "arcgisonline":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dArcGISMapServerImageryProvider({
          url: layerConfig.url
        }), index);
        break;

      case "mapbox":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.MapboxImageryProvider({
          mapId: "mapbox." + layerConfig.layerType,
          accessToken: layerConfig.key || "pk.eyJ1IjoiZXhhbXBsZXMiLCJhIjoiY2p1dHRybDR5MGJuZjQzcGhrZ2doeGgwNyJ9.a-vxW4UaxOoUMWUTGnEArw"
        }), index);
        break;

      case "osm":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.createOpenStreetMapImageryProvider({
          url: layerConfig.url
        }), index);
        break;
    }

    return layer;
  }
  /**
   * 操作在线底图，添加显示隐藏图层
   * @param {Object} layerConfig 图层数据
   * @param {boolean} visible 显隐
   */


  showOnlineBaseLayer(layerConfig, visible) {
    let guid = layerConfig.guid;
    let imageryLayers = this._viewer.imageryLayers._layers;
    let layer = imageryLayers.find(item => {
      return item.name === guid && item.target === "online";
    });

    if (!layer) {
      layer = this._createOnlineLayer(layerConfig);
      layer.name = guid;
      layer.target = "online";
    }

    if (layer) {
      if (visible) {
        layer.show = visible;
      } else {
        this._viewer.imageryLayers.remove(layer);
      }
    }
  }
  /**
   * 移除所有在线底图在地图中的显示
   */


  removeAllOnlineBaseLayer() {
    let imageryLayers = this._viewer.imageryLayers;
    let removeLayers = [];

    imageryLayers._layers.forEach(layer => {
      if (layer.target === "online") {
        removeLayers.push(layer);
      }
    });

    removeLayers.forEach(layer => {
      imageryLayers.remove(layer);
    });
  } //获取三维视角


  getViewPosition() {
    var camera = this._viewer.camera;
    var position = {
      x: camera.position.x,
      y: camera.position.y,
      z: camera.position.z
    };
    return {
      position: position,
      heading: camera.heading,
      pitch: camera.pitch,
      roll: camera.roll
    };
  } //设置三维视角


  setViewPosition(view) {
    this._viewer.camera.flyTo({
      destination: view.position,
      orientation: {
        heading: view.heading,
        pitch: view.pitch,
        roll: view.roll
      }
    });
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/scenceview/ScenceView.vue?vue&type=script&setup=true&lang=js

const _hoisted_1 = {
  class: "kq-scence-view",
  ondragstart: "return false;",
  oncontextmenu: "return false;"
};
const _hoisted_2 = ["id"];
const _hoisted_3 = {
  class: "reset-view"
};
const _hoisted_4 = {
  class: "compass"
};




const __default__ = {
  name: "KqScenceView"
};
/* harmony default export */ var ScenceViewvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(__default__, {
  props: {
    target: {
      type: String,
      default: "cesiumContainer"
    },
    options: Object,

    /**
     * 图层数据源
     * 事例：
     *  {
          name: null,// 服务名称
          url: null,//服务地址
          token: null,//服务token
          type: "kqmapserver", //服务类型  kqmapserver或者kq3dserver
          isShowAllLayers: true,
          defaultShowLayerNames: []
        }
     */
    service: Object,
    // ScenceView初始化的参数对象，包含初始化范围和layer信息。
    scenceInfo: Object,
    // 默认显示的图层组名称
    defaultShowLayerNames: Array,
    showToolButtons: {
      type: Boolean,
      default: true
    },

    /**
     * 例:"top-left","top-right","bottom-left","bottom-right","left","right","bottom"
     * {top:'16px',left:'16px'}, {top:16,left:16}
     */
    toolButtonsPosition: [String, Object],
    showLogo: {
      type: Boolean,
      default: false
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeMount)(() => {
      if (!(0,util_namespaceObject.checkAuditTime)()) {
        window.location.href = "./404.html";
      }
    });
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    /**
     * 支持传入属性：
     *   target - viewer对象渲染的div的id
     *   options - 三维球初始化属性设置
     *   scenceUrl - 场景地址
     *   showToolButtons - 是否显示工具栏按钮
     */

    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let toolButtonsCss = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("top-left vertical");
    let toolButtonsStyle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      if (props.toolButtonsPosition) {
        if (typeof props.toolButtonsPosition === "string") {
          let directionCss = "vertical";

          if (props.toolButtonsPosition === "top" || props.toolButtonsPosition === "bottom") {
            directionCss = "horizontal";
          }

          toolButtonsCss.value = props.toolButtonsPosition + " " + directionCss;
        } else if (props.toolButtonsPosition instanceof Object) {
          let styleString = "";

          for (let key in props.toolButtonsPosition) {
            styleString += key + ":" + props.toolButtonsPosition[key] + ";";
          }

          toolButtonsStyle.value = styleString;
        }
      } //设置语言


      let _lang = proxy.$i18n.locale;
      let _language = proxy.$i18n.messages[_lang]["webgl"];
      language.value = _language;
      let lang = {
        type: _lang,
        language: _language
      }; //初始化逻辑类

      viewModel = new ScenceViewViewModel(props, lang);
      viewModel.initViewer();
    });
    /**
     * 获取ScenceView的逻辑类
     */

    function getViewModel() {
      return viewModel;
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    }); // 抛出方法 外部调用

    expose({
      getViewModel
    });
    return (_ctx, _cache) => {
      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", _hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderSlot)(_ctx.$slots, "default"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        id: props.target,
        class: "view-container"
      }, [props.showToolButtons ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", {
        key: 0,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(toolButtonsCss)),
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(toolButtonsStyle))
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(FixedZoomout), {
        mapTarget: __props.target,
        showShadow: true,
        class: "zoomButton"
      }, null, 8
      /* PROPS */
      , ["mapTarget"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(FixedZoomin), {
        mapTarget: __props.target,
        showShadow: true,
        class: "zoomButton"
      }, null, 8
      /* PROPS */
      , ["mapTarget"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(ResetView), {
        mapTarget: __props.target,
        showShadow: true
      }, null, 8
      /* PROPS */
      , ["mapTarget"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_4, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(Compass), {
        mapTarget: __props.target,
        showShadow: true
      }, null, 8
      /* PROPS */
      , ["mapTarget"])])], 6
      /* CLASS, STYLE */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)], 8
      /* PROPS */
      , _hoisted_2)]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/scenceview/ScenceView.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/scenceview/ScenceView.vue



const __exports__ = ScenceViewvue_type_script_setup_true_lang_js;

/* harmony default export */ var ScenceView = (__exports__);
;// CONCATENATED MODULE: ./src/webgl/scenceview/index.js




ScenceView.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ScenceView.name, ScenceView);
};


;// CONCATENATED MODULE: external "@element-plus/icons-vue"
var icons_vue_namespaceObject = require("@element-plus/icons-vue");
;// CONCATENATED MODULE: ./src/webgl/fixedzoomout/FixedZoomoutViewModel.js

// 三维固定缩放逻辑
class FixedZoomout3dViewModel {
  //三维viewer对象
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    this._viewer = viewer;
  } //获取相机焦点


  getCameraFocus() {
    if (!this._viewer) return;
    var scene = this._viewer.scene;
    var camera = scene.camera;
    var rayScratch = new Cesium.Ray();
    rayScratch.origin = camera.positionWC;
    rayScratch.direction = camera.directionWC;
    var result = new Cesium.Cartesian3();
    result = scene.globe.pick(rayScratch, scene, result);

    if (result) {
      result = camera.worldToCameraCoordinatesPoint(result, result);
    }

    return result;
  } //地图缩放


  zoom(scale) {
    if (!this._viewer) return;
    var scene = this._viewer.scene;
    var camera = scene.camera;
    var focus = this.getCameraFocus();
    var orientation;

    if (!focus) {
      // Camera direction is not pointing at the globe, so use the ellipsoid horizon point as
      // the focal point.
      var ray = new Cesium.Ray(camera.worldToCameraCoordinatesPoint(scene.globe.ellipsoid.cartographicToCartesian(camera.positionCartographic)), camera.directionWC);
      focus = Cesium.IntersectionTests.grazingAltitudeLocation(ray, scene.globe.ellipsoid);
      orientation = {
        heading: camera.heading,
        pitch: camera.pitch,
        roll: camera.roll
      };
    } else {
      orientation = {
        direction: camera.direction,
        up: camera.up
      };
    }

    var cartesian3Scratch = new Cesium.Cartesian3();
    var direction = Cesium.Cartesian3.subtract(camera.position, focus, cartesian3Scratch);
    var movementVector = Cesium.Cartesian3.multiplyByScalar(direction, scale, direction);
    var endPosition = Cesium.Cartesian3.add(focus, movementVector, focus);
    camera.flyTo({
      destination: endPosition,
      orientation: orientation,
      duration: 0.5,
      convert: false
    });
  }

}
;// CONCATENATED MODULE: external "@kq_npm/client_common_vue/_utils/gis-utils"
var gis_utils_namespaceObject = require("@kq_npm/client_common_vue/_utils/gis-utils");
;// CONCATENATED MODULE: external "vue-i18n/dist/vue-i18n.cjs.js"
var vue_i18n_cjs_js_namespaceObject = require("vue-i18n/dist/vue-i18n.cjs.js");
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/fixedzoomout/FixedZoomout.vue?vue&type=script&setup=true&lang=js





 // 获取组件传参

const FixedZoomoutvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dFixedZoomout"
};
/* harmony default export */ var FixedZoomoutvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(FixedZoomoutvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 指定组件绑定的scence对象的div的id
    mapTarget: String,
    // 组件大小
    size: {
      type: Number,
      default: 32
    },
    showShadow: {
      type: Boolean,
      default: false
    }
  },

  setup(__props) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let btn = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      gis_utils_namespaceObject.utils.getWebMap(props.mapTarget, scenceView => {
        if (scenceView) {
          viewModel = new FixedZoomout3dViewModel(scenceView._viewer);
        }
      });
    }); // 按钮点击事件

    function btnClick() {
      btn.value.$el.blur();
      viewModel && viewModel.zoom(0.5);
    }

    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zoomIn,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)([{
          'kq-light-shadow': __props.showShadow
        }]),
        ref_key: "btn",
        ref: btn,
        onClick: btnClick,
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)('width:' + __props.size + 'px;height:' + __props.size + 'px;')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: __props.size / 2
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Plus))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["size"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "class", "style"]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/fixedzoomout/FixedZoomout.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/fixedzoomout/FixedZoomout.vue



const FixedZoomout_exports_ = FixedZoomoutvue_type_script_setup_true_lang_js;

/* harmony default export */ var FixedZoomout = (FixedZoomout_exports_);
;// CONCATENATED MODULE: ./src/webgl/fixedzoomout/index.js




FixedZoomout.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(FixedZoomout.name, FixedZoomout);
};


;// CONCATENATED MODULE: ./src/webgl/fixedzoomin/FixedZoominViewModel.js

// 三维固定缩放逻辑
class FixedZoomin3dViewModel {
  //三维viewer对象
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    this._viewer = viewer;
  } //获取相机焦点


  getCameraFocus() {
    if (!this._viewer) return;
    var scene = this._viewer.scene;
    var camera = scene.camera;
    var rayScratch = new Cesium.Ray();
    rayScratch.origin = camera.positionWC;
    rayScratch.direction = camera.directionWC;
    var result = new Cesium.Cartesian3();
    result = scene.globe.pick(rayScratch, scene, result);

    if (result) {
      result = camera.worldToCameraCoordinatesPoint(result, result);
    }

    return result;
  } //地图缩放


  zoom(scale) {
    if (!this._viewer) return;
    var scene = this._viewer.scene;
    var camera = scene.camera;
    var focus = this.getCameraFocus();
    var orientation;

    if (!focus) {
      // Camera direction is not pointing at the globe, so use the ellipsoid horizon point as
      // the focal point.
      var ray = new Cesium.Ray(camera.worldToCameraCoordinatesPoint(scene.globe.ellipsoid.cartographicToCartesian(camera.positionCartographic)), camera.directionWC);
      focus = Cesium.IntersectionTests.grazingAltitudeLocation(ray, scene.globe.ellipsoid);
      orientation = {
        heading: camera.heading,
        pitch: camera.pitch,
        roll: camera.roll
      };
    } else {
      orientation = {
        direction: camera.direction,
        up: camera.up
      };
    }

    var cartesian3Scratch = new Cesium.Cartesian3();
    var direction = Cesium.Cartesian3.subtract(camera.position, focus, cartesian3Scratch);
    var movementVector = Cesium.Cartesian3.multiplyByScalar(direction, scale, direction);
    var endPosition = Cesium.Cartesian3.add(focus, movementVector, focus);
    camera.flyTo({
      destination: endPosition,
      orientation: orientation,
      duration: 0.5,
      convert: false
    });
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/fixedzoomin/FixedZoomin.vue?vue&type=script&setup=true&lang=js





 // 获取组件传参

const FixedZoominvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dFixedZoomin"
};
/* harmony default export */ var FixedZoominvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(FixedZoominvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 指定组件绑定的scence对象的div的id
    mapTarget: String,
    // 组件大小
    size: {
      type: Number,
      default: 32
    },
    showShadow: {
      type: Boolean,
      default: false
    }
  },

  setup(__props) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let btn = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      gis_utils_namespaceObject.utils.getWebMap(props.mapTarget, scenceView => {
        if (scenceView) {
          viewModel = new FixedZoomin3dViewModel(scenceView._viewer);
        }
      });
    }); // 按钮点击事件

    function btnClick() {
      btn.value.$el.blur();
      viewModel && viewModel.zoom(2);
    }

    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zoomOut,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)([{
          'kq-light-shadow': __props.showShadow
        }]),
        ref_key: "btn",
        ref: btn,
        onClick: btnClick,
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)('width:' + __props.size + 'px;height:' + __props.size + 'px;')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: __props.size / 2
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Minus))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["size"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "class", "style"]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/fixedzoomin/FixedZoomin.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/fixedzoomin/FixedZoomin.vue



const FixedZoomin_exports_ = FixedZoominvue_type_script_setup_true_lang_js;

/* harmony default export */ var FixedZoomin = (FixedZoomin_exports_);
;// CONCATENATED MODULE: ./src/webgl/fixedzoomin/index.js




FixedZoomin.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(FixedZoomin.name, FixedZoomin);
};


;// CONCATENATED MODULE: ./src/webgl/resetview/ResetViewViewModel.js

// 重置视图
class ResetViewViewModel {
  //三维viewer对象
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    this._viewer = viewer;
  } //重置视角


  resetView() {
    this._viewer.camera.flyHome(1);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/resetview/ResetView.vue?vue&type=script&setup=true&lang=js





 // 获取组件传参

const ResetViewvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dResetView"
};
/* harmony default export */ var ResetViewvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ResetViewvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 指定组件绑定的scence对象的div的id
    mapTarget: String,
    // 组件大小
    size: {
      type: Number,
      default: 32
    },
    showShadow: {
      type: Boolean,
      default: false
    }
  },

  setup(__props) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let btn = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      gis_utils_namespaceObject.utils.getWebMap(props.mapTarget, scenceView => {
        if (scenceView) {
          viewModel = new ResetViewViewModel(scenceView._viewer);
        }
      });
    }); // 按钮点击事件

    function btnClick(e) {
      btn.value.$el.blur();
      viewModel && viewModel.resetView();
    }

    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        ref_key: "btn",
        ref: btn,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)([{
          'kq-light-shadow': __props.showShadow
        }]),
        onClick: btnClick,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).resetView,
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)('width:' + __props.size + 'px;height:' + __props.size + 'px;')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: __props.size / 2
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.RefreshLeft))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["size"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title", "style"]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/resetview/ResetView.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/resetview/ResetView.vue



const ResetView_exports_ = ResetViewvue_type_script_setup_true_lang_js;

/* harmony default export */ var ResetView = (ResetView_exports_);
;// CONCATENATED MODULE: ./src/webgl/resetview/index.js




ResetView.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ResetView.name, ResetView);
};


;// CONCATENATED MODULE: external "@kq_npm/client_icons_vue"
var client_icons_vue_namespaceObject = require("@kq_npm/client_icons_vue");
;// CONCATENATED MODULE: ./src/webgl/compass/CompassViewModel.js

// 重置视图
class CompassViewModel {
  //三维viewer对象
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    this._viewer = viewer;
  } //重置方向


  resetOrientation() {
    var camera = this._viewer.camera;
    var scene = this._viewer.scene;
    var depthTestAgainstTerrain = scene.globe.depthTestAgainstTerrain;

    if (!depthTestAgainstTerrain) {
      scene.globe.depthTestAgainstTerrain = true;
    }

    var canvas = scene.canvas;
    var windowCenter = new Cesium.Cartesian2(canvas.clientWidth / 2, canvas.clientHeight / 2);
    setTimeout(() => {
      var center = scene.pickPosition(windowCenter);

      if (!center) {
        center = scene.camera.pickEllipsoid(windowCenter, scene.globe.ellipsoid);
      }

      scene.globe.depthTestAgainstTerrain = depthTestAgainstTerrain;
      var distance = Cesium.Cartesian3.distance(center, camera.positionWC);
      var heading = 6.28319;
      var pitch = camera.pitch;
      var hpr = new Cesium.HeadingPitchRange(heading, pitch, distance);
      camera.lookAt(center, hpr);
      camera.lookAtTransform(Cesium.Matrix4.IDENTITY);
    }, 300);
  } //绑定指南针


  bindCompassEvent(heading) {
    var camera = this._viewer.camera;
    this._removeEventListener = camera.changed.addEventListener(function () {
      heading.value = camera.heading;
    });
  } // 注销事件


  destroy() {
    if (this._removeEventListener) {
      this._removeEventListener();

      this._removeEventListener = null;
    }

    this._viewer = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/compass/Compass.vue?vue&type=script&setup=true&lang=js





 // 获取组件传参

const Compassvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dCompass"
};
/* harmony default export */ var Compassvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Compassvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 指定组件绑定的scence对象的div的id
    mapTarget: String,
    // 按钮图标大小
    iconSize: {
      type: Number,
      default: 16
    },
    // 组件大小
    size: {
      type: Number,
      default: 32
    },
    showShadow: {
      type: Boolean,
      default: false
    }
  },

  setup(__props) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let heading = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(0); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      gis_utils_namespaceObject.utils.getWebMap(props.mapTarget, scenceView => {
        if (scenceView) {
          viewModel = new CompassViewModel(scenceView._viewer); //绑定指南针事件

          viewModel.bindCompassEvent(heading);
        }
      });
    }); // 按钮点击事件

    function btnClick(e) {
      viewModel && viewModel.resetOrientation();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        onClick: btnClick,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)([{
          'kq-light-shadow': __props.showShadow
        }]),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).resetOrientation,
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)('clip-path: circle(50%);width:' + __props.size + 'px;height:' + __props.size + 'px;')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: __props.size / 2,
          style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)('transform: rotate(-' + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(heading) + 'rad);-webkit-transform: rotate(-' + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(heading) + 'rad)')
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconCompass3D))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["size", "style"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title", "style"]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/compass/Compass.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/compass/Compass.vue



const Compass_exports_ = Compassvue_type_script_setup_true_lang_js;

/* harmony default export */ var Compass = (Compass_exports_);
;// CONCATENATED MODULE: ./src/webgl/compass/index.js




Compass.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Compass.name, Compass);
};


;// CONCATENATED MODULE: external "html2canvas"
var external_html2canvas_namespaceObject = require("html2canvas");
var external_html2canvas_default = /*#__PURE__*/__webpack_require__.n(external_html2canvas_namespaceObject);
;// CONCATENATED MODULE: external "vue3-print-nb"
var external_vue3_print_nb_namespaceObject = require("vue3-print-nb");
var external_vue3_print_nb_default = /*#__PURE__*/__webpack_require__.n(external_vue3_print_nb_namespaceObject);
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/clientPrint/ClientPrint.vue?vue&type=script&setup=true&lang=js


const ClientPrintvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-client-print-wrapper",
  ref: "clientRef"
};
const ClientPrintvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "setting-box-btn"
};
const ClientPrintvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "title"
};
const ClientPrintvue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "title"
};
const _hoisted_5 = {
  class: "title"
};
const _hoisted_6 = {
  class: "select-content-inner"
};
const _hoisted_7 = {
  style: {
    "text-align": "right"
  }
};
const _hoisted_8 = {
  class: "title"
};
const _hoisted_9 = {
  class: "select-layer-content"
};
const _hoisted_10 = {
  class: "title"
};
const _hoisted_11 = {
  class: "select-content-inner"
};
const _hoisted_12 = {
  style: {
    "float": "right"
  }
};
const _hoisted_13 = {
  class: "clientprint-title"
};
const _hoisted_14 = {
  class: "title"
};
const _hoisted_15 = {
  class: "select-content-inner"
};
const _hoisted_16 = ["placeholder"];
const _hoisted_17 = {
  class: "btn"
};
const _hoisted_18 = {
  class: "show-right-box-btn"
};
const _hoisted_19 = {
  class: "btn-group"
};
const _hoisted_20 = {
  class: "kq3d-client-print-titleContainerDiv"
};
const _hoisted_21 = {
  class: "baseImage"
};
const _hoisted_22 = ["src"];
const _hoisted_23 = ["id"];
const _hoisted_24 = ["onClick"];
const _hoisted_25 = {
  class: "kq3d-client-print-infomationContainer"
};
const _hoisted_26 = {
  class: "kq3d-client-print-companyName"
};
const _hoisted_27 = {
  class: "kq3d-client-print-systemTime"
};






const ClientPrintvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dClientPrint"
};
/* harmony default export */ var ClientPrintvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ClientPrintvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 每个地图相关组件的必须参数 非必传 指定组件绑定的map对象的div的id
    mapTarget: String,
    //打印标题
    printTitle: {
      type: String
    },
    //打印显示的公司名
    companyName: {
      type: String
    },
    // 是否显示阴影
    showShadow: {
      type: Boolean,
      default: true
    },
    options: Object,

    /**
     * 图层数据源
     * 事例：
     *  {
          name: null,// 服务名称
          url: null,//服务地址
          token: null,//服务token
          type: "kqmapserver", //服务类型  kqmapserver或者kq3dserver
          isShowAllLayers: true,
          defaultShowLayerNames: []
        }
     */
    service: Object,
    // ScenceView初始化的参数对象，包含初始化范围和layer信息。
    scenceInfo: Object,
    // 默认显示的图层组名称
    defaultShowLayerNames: Array,

    /**
     *   showToolButtons - 是否显示工具栏按钮
     */
    showToolButtons: {
      type: Boolean,
      default: true
    },

    /**
     * 例:"top-left","top-right","bottom-left","bottom-right","left","right","bottom"
     * {top:'16px',left:'16px'}, {top:16,left:16}
     */
    toolButtonsPosition: [String, Object],
    showLogo: {
      type: Boolean,
      default: false
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)(); //国际化

    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      companyName.value = props.companyName || language.value.comapanyname;
      systemTime.value = newVal == 'zh' ? getSystemIime() : getSystemEnTime();
      printObj.value.popTitle = language.value.print;
    });
    let setTitleDataform = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({
      style: {
        fontSize: "18px",
        fontFamily: "Microsoft YaHei",
        color: "rgba(0, 0, 0)",
        textarea: "",
        backgroundColor: "",
        padding: "5px",
        borderRadius: "3px",
        shadowShowBg: "red"
      },
      data: {
        title: "",
        shadowShow: false,
        titleShow: true
      }
    }); // 文本的数据

    let setLabelDataform = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({
      style: {
        fontSize: "18px",
        fontFamily: "Microsoft YaHei",
        color: "#000000",
        width: "100%",
        resize: "none",
        height: "96px",
        border: "solid 1px #dcdee2"
      },
      data: {
        labelValue: ""
      }
    });
    let cameraToImage = null; // 组件容器

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 选择容器

    let settingBoxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 主内容容器

    let mainBoxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let scenceImageUrl = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let titleRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 图层选择容器

    let selectLayerBoxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 样式设置容器

    let selectTitleBoxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 添加文本容器

    let selectTextBoxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); //页面设置tab设置

    const activeNames = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(["1"]); // 控制主容器与图层选择容器的切换

    let isShowSettingBox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(true); //图层选择显示控制

    let isShowLayer = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); //标题设置显示控制

    let isShowTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); //添加文本显示控制

    let isShowText = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 边框样式

    let borderStyleValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 纸张设置

    let sizeData = [[{
      f: "A2",
      a: "portrait"
    }, "a2VSize"], [{
      f: "A3",
      a: "portrait"
    }, "a3VSize"], [{
      f: "A4",
      a: "portrait"
    }, "a4VSize"], [{
      f: "A5",
      a: "portrait"
    }, "a5VSize"], [{
      f: "A6",
      a: "portrait"
    }, "a6VSize"], [{
      f: "A2",
      a: "landscape"
    }, "a2HSize"], [{
      f: "A3",
      a: "landscape"
    }, "a3HSize"], [{
      f: "A4",
      a: "landscape"
    }, "a4HSize"], [{
      f: "A5",
      a: "landscape"
    }, "a5HSize"], [{
      f: "A6",
      a: "landscape"
    }, "a6HSize"]]; // 字体大小

    let sizelist = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([]); // 纸张类型

    let papForm = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("A4"); // 默认
    // 纸张方向

    let papAnchor = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 默认
    // 图片格式

    let imageType = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("png"); //图例对象

    let lengend_ref = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 图例窗口显示与隐藏

    let legendShow = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 比例尺显示与隐藏

    let scalesShow = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 指北针的显示与隐藏

    let compassShow = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let isActive = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(0); //打印内容div

    let printContentDiv = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 打印内容

    let printDiv = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 打印内容中的地图容器

    let printMap = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 增加的文本的数据

    let setLabelData = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([]); //当前时间

    let systemTime = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 公司名

    let companyName = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let printState = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let printViewer = null; // 打印对象

    let printObj = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({
      id: "printMap",
      popTitle: "",

      beforeOpenCallback() {
        printState.value = true;
      },

      openCallback() {
        printState.value = false;
      }

    });
    let currentClick = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({});
    let scaleFloor = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(1);
    let scaleStep = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(0.2); // 查询进度条

    let loadState = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 三维球id

    global_event_default().setDefaultMapInfo("scencePrint", "cesium", null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      setTitleDataform.value.data.title = props.printTitle || language.value.oneimage;
      papAnchor.value = "portrait";
      borderStyleValue.value = "printborder1";
      sizelist.value = [];

      for (let i = 15; i <= 32; i++) {
        // 字体大小下拉
        sizelist.value.push(i);
      }

      setLabelData.value = [];
      initControl();
      global_event_default().getWebMapByMapTarget("scencePrint", scenceView => {
        if (scenceView && scenceView._viewer) {
          printViewer = scenceView._viewer;
          cameraToImage = new Cesium.Kq3dCanvasToImage(scenceView._viewer._container, {
            viewer: scenceView._viewer,
            canvas: scenceView._viewer.scene.canvas
          });
        }
      });
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      destroy();
    });
    /**
     * 获取当前时间
     * @returns {string}
     */

    function getSystemIime() {
      let numMap = new Map([["0", "零"], ["1", "一"], ["2", "二"], ["3", "三"], ["4", "四"], ["5", "五"], ["6", "六"], ["7", "七"], ["8", "八"], ["9", "九"]]);
      let tennumMap = new Map([["1", "十"], ["2", "二十"], ["3", "三十"]]);
      let nowDate = new Date();
      let year = nowDate.getFullYear() + ""; //年数字

      let month = nowDate.getMonth() + 1 + ""; //月数字

      let day = nowDate.getDate() + ""; //日数字

      let yearCNStr = ""; //年中文

      let nonthCNStr = ""; //月中文

      let dayCNStr = ""; //日中文

      for (let i = 0; i < year.length; i++) {
        yearCNStr += numMap.get(year[i]);
      }

      yearCNStr += "年";

      if (month.length > 1) {
        nonthCNStr = tennumMap.get(month[0]);

        if (month[1] != "0") {
          nonthCNStr += numMap.get(month[1]);
        }

        nonthCNStr += "月";
      } else {
        nonthCNStr = numMap.get(month[0]) + "月";
      }

      if (day.length > 1) {
        dayCNStr = tennumMap.get(day[0]);

        if (day[1] != "0") {
          dayCNStr += numMap.get(day[1]);
        }

        dayCNStr += "日";
      } else {
        dayCNStr = numMap.get(day[0]) + "日";
      }

      return yearCNStr + nonthCNStr + dayCNStr;
    }
    /**
     * 获取当前时间(英文)
     * @returns {string}
     */


    function getSystemEnTime() {
      var dt = new Date();
      var m = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Spt", "Oct", "Nov", "Dec");
      var d = new Array("st", "nd", "rd", "th");
      var mn = dt.getMonth();
      var dn = dt.getDate();
      var dns;

      if (dn % 10 < 1 || dn % 10 > 3) {
        dns = d[3];
      } else {
        dns = d[dn % 10 - 1];

        if (dn == 11 || dn == 12) {
          dns = d[3];
        }
      }

      return m[mn] + " " + dn + dns + "," + dt.getFullYear();
    }

    function changStatusBar() {
      if (printViewer) printViewer.statusBar.show = scalesShow.value;
    }
    /**
     * 显示切换
     * @param {string} type
     */


    function setShowChange(type) {
      settingBoxRef.value.style.height = `${mainBoxRef.value.clientHeight}px`; // settingBoxRef.value.style.height = `${mainBoxRef.value.clientHeight}px`;

      if (type === "layer") {
        isShowLayer.value = true;
        isShowTitle.value = false;
        isShowText.value = false;
        (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.nextTick)(() => {
          // settingBoxRef.value.style.height = `${selectLayerBoxRef.value.clientHeight}px`;
          settingBoxRef.value.style.height = `${selectLayerBoxRef.value.clientHeight}px`;
        });
      }

      if (type === "title") {
        isShowLayer.value = false;
        isShowTitle.value = true;
        isShowText.value = false;
        (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.nextTick)(() => {
          // settingBoxRef.value.style.height = `${selectTitleBoxRef.value.clientHeight}px`;
          settingBoxRef.value.style.height = `${selectTitleBoxRef.value.clientHeight}px`;
        });
      }

      if (type === "text") {
        isShowLayer.value = false;
        isShowTitle.value = false;
        isShowText.value = true;
        (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.nextTick)(() => {
          // settingBoxRef.value.style.height = `${selectTextBoxRef.value.clientHeight}px`;
          settingBoxRef.value.style.height = `${selectTextBoxRef.value.clientHeight}px`;
        });
      }
    }
    /**
     * 切换后的左侧高度样式还原
     */


    function setMainStyle() {
      isShowLayer.value = false;
      isShowTitle.value = false;
      isShowText.value = false;
      settingBoxRef.value.style.height = `${mainBoxRef.value.clientHeight}px`;
    }
    /**
     * 左侧窗口高度还原
     */


    function changeMainHeight() {
      settingBoxRef.value.style.height = "auto";
    }
    /**
     * 初始化要在地图中显示的控件
     */


    function initControl() {
      var mapdiv = document.getElementById("scencePrint");
      let html = mapdiv.innerHTML;
      var legendDiv = document.getElementById("divlegendDiv");
      var compassDiv = document.getElementById("divcompassDiv");
      legendDiv.className = "kq3d-client-print-legendDiv";
      compassDiv.className = "kq3d-client-print-compassDiv";
      mapdiv.appendChild(compassDiv);
      mapdiv.appendChild(legendDiv);
    }
    /**
     * 边框样式切换
     * @param {object} value
     */


    function changeBorderStyleData(value) {
      printContentDiv.value.className = "kq3d-client-print-printContentDiv " + "kq3d-client-print-" + borderStyleValue.value;
    }
    /**
     * 纸张大小的切换
     */


    function changeMapContainerSize() {
      sizeData.forEach(item => {
        if (item[0].f === papForm.value && item[0].a === papAnchor.value) {
          let param = item[1];
          printMap.value.className = "kq3d-client-print-mapContainerDiv " + "kq3d-client-print-" + param;
          setScroll();
        }
      });
    }
    /**
     * 滚动条居中
     */


    function setScroll() {
      printDiv.value.scrollTop = printMap.value.clientHeight / 2 - printDiv.value.clientHeight / 2;
      printDiv.value.scrollLeft = printMap.value.clientWidth / 2 - printDiv.value.clientWidth / 2;
    }
    /**
     * 添加文本
     */


    function addLabel() {
      let item = {
        style: {
          fontSize: setLabelDataform.value.style.fontSize,
          fontFamily: setLabelDataform.value.style.fontFamily,
          color: setLabelDataform.value.style.color,
          padding: "10px 10px 5px 5px"
        },
        data: {
          dataId: setLabelData.value.length + 1,
          labelValue: setLabelDataform.value.data.labelValue,
          isShow: false
        }
      };
      setLabelData.value.push(item);
      setTimeout(() => {
        var mapdiv = document.getElementById("scencePrint");

        for (let i = 0; i < setLabelData.value.length; i++) {
          var labelDiv = document.getElementById(setLabelData.value[i].data.dataId);
          labelDiv.style.display = "block";
          mapdiv.appendChild(labelDiv);
        }
      }, 200);
    }
    /**
     * 通过id删除文本
     * @param {string} id
     */


    function delLabel(id) {
      for (let i = 0; i < setLabelData.value.length; i++) {
        if (id === setLabelData.value[i].data.dataId) {
          setLabelData.value.splice(i, 1);
          break;
        }
      }
    }
    /**
     * 清空文本
     */


    function clearLabel() {
      setLabelData.value.splice(0, setLabelData.value.length);
      setLabelDataform.value.data.labelValue = "";
    }
    /**
     * 设置拖动时的鼠标样式
     * @param {object} event
     */


    function setdragCursor(event) {
      let el = event.currentTarget;
      el.style.cursor = "move";
    }
    /**
     * 拖动DIV,地图不随着拖动
     * @param {object} event
     */


    function dragTl(event) {
      let mx = 0;
      let my = 0;
      let dx = 0;
      let dy = 0;
      let isDraging = false;
      let el = event.currentTarget;

      if (el.offsetTop < 0) {
        el.style.top = "0px";
      }

      event = event || window.event;
      mx = event.pageX;
      my = event.pageY;
      dx = el.offsetLeft;
      dy = el.offsetTop;
      isDraging = true;
      document.addEventListener("mousemove", moveWin);
      document.addEventListener("mouseup", removeEvent);

      document.onselectstart = function () {
        return false;
      };

      event.stopPropagation(); // }

      function moveWin(event) {
        event = event || window.event;
        var x = event.pageX;
        var y = event.pageY;

        if (isDraging) {
          var moveX = dx + x - mx;
          var moveY = dy + y - my;
          let pageW = 0;
          let pageH = 0;
          pageW = printContentDiv.value.clientWidth - 2;
          pageH = printContentDiv.value.clientHeight - 2; // 2 控制下面的终点

          var dialogW = el.clientWidth;
          var dialogH = el.clientHeight;
          var maxX = pageW - dialogW;
          var maxY = pageH - dialogH;
          moveX = Math.min(Math.max(0, moveX), maxX); // 58 控制上面的起点

          moveY = Math.min(Math.max(0, moveY), maxY); // 58 控制上面的起点

          el.style.right = "auto";
          el.style.bottom = "auto";
          el.style.left = moveX + "px";
          el.style.top = moveY + "px";
        }
      }

      function removeEvent() {
        document.removeEventListener("mousemove", moveWin);
        document.removeEventListener("mouseup", removeEvent);
        el.style.cursor = "";

        document.onselectstart = function () {
          return true;
        };

        isDraging = false;
      }
    }

    function canvasToImage() {
      global_event_default().getWebMapByMapTarget("scencePrint", scenceView => {
        if (scenceView && scenceView._viewer) {
          scenceImageUrl.value = cameraToImage.toDataURL(scenceView._viewer.scene.canvas, {
            width: scenceView._viewer._lastWidth,
            height: scenceView._viewer._lastHeight,
            type: "JPG"
          });
        }
      });
    }
    /**
     * 保存为图片
     */


    function getPic() {
      canvasToImage();
      loadState.value = true; // 延时1000ms,等待图片读入到blob文件对象，然后使用URL.createObjectURL转换成src可用的地址

      setTimeout(() => {
        external_html2canvas_default()(printMap.value, {
          taintTest: true,
          // 检测每张图片都已经加载完成
          logging: true,
          // 启用日志记录以进行调试 (发现加上对去白边有帮助)
          allowTaint: true,
          // 否允许跨源图像污染画布
          backgroundColor: null,
          // 解决生成的图片有白边
          useCORS: true,
          // 如果截图的内容里有图片,解决文件跨域问题
          timeout: 2000 // 加载延时

        }).then(canvas => {
          loadState.value = false;
          let pageData = canvas.toDataURL("image/png", 1.0);
          let title = "printMap.png";

          if (imageType.value === "jpg") {
            pageData = canvas.toDataURL("image/jpeg", 1.0);
            title = "printMap.jpg";
          }

          const el = document.createElement("a"); // 设置 href 为图片经过 base64 编码后的字符串，默认为 png 格式

          el.href = pageData;
          el.download = title; // 创建一个点击事件并对 a 标签进行触发

          const event = new MouseEvent("click");
          el.dispatchEvent(event);
        });
      }, 1000);
    }
    /**
     * 显示图例
     * @param {object} e
     */


    function showLegend(e) {
      if (e) {
        (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.nextTick)(() => {
          lengend_ref.value.init();
        });
      }
    }
    /**
     * 等比例放大
     */


    function Enlarge() {
      isActive.value = 1;
      mouseScrollEnlarge(1);
    }
    /**
     * 等比例缩小
     */


    function Narrow() {
      isActive.value = 2;
      mouseScrollNarrow(-1);
    }
    /**
     * 拖动打印范围
     */


    function MovePrint() {
      if (isActive.value === 3) {
        isActive.value = 0;
      } else {
        isActive.value = 3;
        let divScreen = document.querySelector("#printMap");
        divScreen.addEventListener("mousedown", downFunc);
        divScreen.addEventListener("mouseup", upFunc);
      }
    }
    /**
     * 拖动打印范围后还原
     */


    function RefreshStatus() {
      isActive.value = 0;
      document.querySelector("#printMap").style.cursor = "";
      document.getElementById("printMap").style.marginLeft = "auto";
      document.getElementById("printMap").style.marginTop = 0;
      document.getElementById("printMap").style.transform = "";
    }
    /**
     * 拖动打印范围的点击鼠标左键事件
     * @param {object} e
     */


    function downFunc(e) {
      if (isActive.value !== 3) {
        return false;
      }

      document.querySelector("#printMap").style.cursor = "move";
      currentClick.x = e.pageX - document.getElementById("printMap").offsetLeft;
      currentClick.y = e.pageY - document.getElementById("printMap").offsetTop;
      document.addEventListener("mousemove", moveFunc);
    }
    /**
     * 拖动打印范围的松开鼠标左键事件
     * @param {object} e
     */


    function upFunc() {
      document.querySelector("#printMap").style.cursor = "";
      document.removeEventListener("mousemove", moveFunc);
    }
    /**
     * 拖动打印范围的拖动鼠标事件
     * @param {object} e
     */


    function moveFunc() {
      let mosPostion = getMousePos();
      moveScreenTable(mosPostion.x - currentClick.x, mosPostion.y - (currentClick.y + 50));
    }
    /**
     * 计算拖动后的位置
     * @param {nubmer} x
     * @param {nubmer} y
     */


    function moveScreenTable(x, y) {
      let docScreen = document.querySelector("#printMap");
      let moveX = getPixelValue(docScreen, "left");
      let moveY = getPixelValue(docScreen, "top");
      moveX += x;
      moveY += y;

      if (moveY < 0) {
        moveY = 0;
      }

      document.getElementById("printMap").style.marginLeft = moveX + "px";
      document.getElementById("printMap").style.marginTop = moveY + "px";
    }
    /**
     * 等比例放大
     * @param {number} step
     */


    function mouseScrollEnlarge(step) {
      if (step > 0) {
        scaleFloor.value = scaleFloor.value + scaleStep.value;
      }

      if (scaleFloor.value > 0) {
        document.getElementById("printMap").style.transform = "scale(" + scaleFloor.value + ")";
      } else {
        document.getElementById("printMap").style.transform = "";
      }
    }
    /**
     * 等比例缩小
     * @param {number} step
     */


    function mouseScrollNarrow(step) {
      if (step < 0 && scaleFloor.value > scaleStep.value * 2) {
        scaleFloor.value = scaleFloor.value - scaleStep.value;
      } else {
        undefined;
      }

      if (scaleFloor.value > 0) {
        document.getElementById("printMap").style.transform = "scale(" + scaleFloor.value + ")";
      } else {
        document.getElementById("printMap").style.transform = "";
      }
    }
    /**
     * 获取鼠标位置
     * @param {object} event
     */


    function getMousePos(event) {
      const e = event || window.event;
      const x = e.clientX - document.querySelector("#printMap").offsetLeft;
      const y = e.clientY - document.querySelector("#printMap").offsetTop;
      return {
        x: e.clientX,
        y: e.clientY
      };
    }

    function getPixelValue(doc, key) {
      return Number(doc.style[key].replace("px", ""));
    }
    /**
     * 清除设置
     */


    function destroy() {
      if (legendShow.value) {
        legendShow.value = false;
      }

      if (scalesShow.value) {
        scalesShow.value = false;
      }

      setLabelData.value = [];
      setTitleDataform.value = {
        // 标题的数据
        style: {
          fontSize: "18px",
          fontFamily: "Microsoft YaHei",
          color: "rgba(0, 0, 0)",
          textarea: "",
          backgroundColor: "",
          padding: "5px",
          borderRadius: "3px",
          shadowShowBg: "red"
        },
        data: {
          title: "",
          shadowShow: false,
          titleShow: true
        }
      };
      setLabelDataform.value = {
        // 文本的数据
        style: {
          fontSize: "18px",
          fontFamily: "Microsoft YaHei",
          color: "#000000",
          width: "216px",
          resize: "none",
          height: "96px",
          border: "solid 1px #dcdee2"
        },
        data: {
          labelValue: ""
        }
      };
    } // 抛出方法 外部调用


    expose({
      destroy
    });
    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_divider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-divider");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_layer_tree = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-layer-tree");

      const _component_kq_input = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq3d_status_bar = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq3d-status-bar");

      const _component_kq_legend = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-legend");

      const _component_kq3d_compass = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq3d-compass");

      const _component_kq_scence_view = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-scence-view");

      const _component_kq_scrollbar = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-scrollbar");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", ClientPrintvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "settleLayer",
        ref_key: "boxRef",
        ref: boxRef,
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
          left: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowSettingBox) ? `16px` : `-442px`
        })
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ClientPrintvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowSettingBox) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        key: 0,
        onClick: _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(isShowSettingBox) ? isShowSettingBox.value = false : isShowSettingBox = false),
        class: "hide-setting-box-btn"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.DArrowLeft))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), !(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowSettingBox) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
        key: 1,
        onClick: _cache[1] || (_cache[1] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(isShowSettingBox) ? isShowSettingBox.value = true : isShowSettingBox = true),
        class: "show-setting-box-btn"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.DArrowRight))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["setting-box", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "settingBoxRef",
        ref: settingBoxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["box", (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowLayer) ? 'is-show-layer' : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowTitle) ? 'is-show-layer' : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowText) ? 'is-show-layer' : null])
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "main-box",
        ref_key: "mainBoxRef",
        ref: mainBoxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 图层选择-bar "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar",
        onClick: _cache[2] || (_cache[2] = $event => setShowChange('layer'))
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", ClientPrintvue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).layerSelect), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowRight))]),
        _: 1
        /* STABLE */

      })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar select-layer-margin",
        onClick: _cache[3] || (_cache[3] = $event => setShowChange('title'))
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", ClientPrintvue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).titlesetting), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowRight))]),
        _: 1
        /* STABLE */

      })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar select-layer-margin",
        onClick: _cache[4] || (_cache[4] = $event => setShowChange('text'))
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", _hoisted_5, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).addtext), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowRight))]),
        _: 1
        /* STABLE */

      })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        modelValue: activeNames.value,
        "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => activeNames.value = $event),
        onChange: changeMainHeight
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          name: "1"
        }, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pageetting) + " ", 1
          /* TEXT */
          ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
            class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["header-icon", activeNames.value.includes('1') ? 'is-active' : null])
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.CaretRight))]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["class"])]),
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
              span: 9
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                class: "btnStyle",
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(legendShow),
                "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(legendShow) ? legendShow.value = $event : legendShow = $event),
                onChange: showLegend
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printlegend), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
              span: 9
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                class: "btnStyle",
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(compassShow),
                "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(compassShow) ? compassShow.value = $event : compassShow = $event)
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printcompass), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
              span: 6
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                class: "btnStyle",
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(scalesShow),
                "onUpdate:modelValue": _cache[7] || (_cache[7] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(scalesShow) ? scalesShow.value = $event : scalesShow = $event),
                onChange: changStatusBar
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printstatusbar), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_6, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            model: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform),
            "label-width": "70px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, null, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printlace
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(borderStyleValue),
                    "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(borderStyleValue) ? borderStyleValue.value = $event : borderStyleValue = $event),
                    onChange: changeBorderStyleData
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "printborder1",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).Template1
                    }, null, 8
                    /* PROPS */
                    , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "printborder2",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).Template2
                    }, null, 8
                    /* PROPS */
                    , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "printborder3",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).Template3
                    }, null, 8
                    /* PROPS */
                    , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "printborder4",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).Template4
                    }, null, 8
                    /* PROPS */
                    , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "printborder5",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).Template5
                    }, null, 8
                    /* PROPS */
                    , ["label"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, null, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).paperType
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(papForm),
                    "onUpdate:modelValue": _cache[9] || (_cache[9] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(papForm) ? papForm.value = $event : papForm = $event),
                    onChange: changeMapContainerSize
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "A2"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("A2")]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "A3"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("A3")]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "A4"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("A4")]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "A5"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("A5")]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "A6"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("A6")]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, null, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).paperDirection
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(papAnchor),
                    "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(papAnchor) ? papAnchor.value = $event : papAnchor = $event),
                    onChange: changeMapContainerSize
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "portrait",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).portrait
                    }, null, 8
                    /* PROPS */
                    , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "landscape",
                      label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).landscape
                    }, null, 8
                    /* PROPS */
                    , ["label"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, null, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).imageFormat
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(imageType),
                    "onUpdate:modelValue": _cache[11] || (_cache[11] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(imageType) ? imageType.value = $event : imageType = $event)
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "png"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("png")]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                      value: "jpg"
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)("jpg")]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["model"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_7, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            type: "primary",
            onClick: _cache[12] || (_cache[12] = $event => getPic()),
            loading: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(loadState)
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).savePicture), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["loading"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)(((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_button, {
            type: "plain",
            loading: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(printState),
            onClick: _cache[13] || (_cache[13] = $event => canvasToImage())
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).sendprinter), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["loading"])), [[(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)((external_vue3_print_nb_default())), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(printObj)]])])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["modelValue"])], 512
      /* NEED_PATCH */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 图层选择-box "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowLayer) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", {
        key: 0,
        class: "select-layer-box",
        ref_key: "selectLayerBoxRef",
        ref: selectLayerBoxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 图层选择-bar "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar",
        onClick: setMainStyle
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowLeft))]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", _hoisted_8, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).layerSelect), 1
      /* TEXT */
      )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_9, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_layer_tree, {
        showShadow: false,
        "map-target": 'scencePrint'
      })])], 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 标题设置-box "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-box",
        ref_key: "selectTitleBoxRef",
        ref: selectTitleBoxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 标题设置-bar "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar",
        onClick: setMainStyle
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowLeft))]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", _hoisted_10, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).titlesetting), 1
      /* TEXT */
      )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
        model: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform),
        "label-width": "70px",
        "label-position": "left"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_11, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 24
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printtitle
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.title,
                "onUpdate:modelValue": _cache[15] || (_cache[15] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.title = $event)
              }, null, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 24
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).font
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.fontFamily,
                "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.fontFamily = $event),
                placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pleaseselect,
                style: {
                  "width": "100%"
                }
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  value: "Microsoft YaHei",
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).yahei
                }, null, 8
                /* PROPS */
                , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  value: "NSimSun",
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).NSimSun
                }, null, 8
                /* PROPS */
                , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  value: "KaiTi",
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).KaiTi
                }, null, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue", "placeholder"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 16
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontsize
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.fontSize,
                "onUpdate:modelValue": _cache[17] || (_cache[17] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.fontSize = $event),
                placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontsize
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(sizelist).value, size => {
                  return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
                    key: size,
                    value: `${size}px`
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(size), 1
                    /* TEXT */
                    )]),
                    _: 2
                    /* DYNAMIC */

                  }, 1032
                  /* PROPS, DYNAMIC_SLOTS */
                  , ["value"]);
                }), 128
                /* KEYED_FRAGMENT */
                ))]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue", "placeholder"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 2
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)(" ")]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 6
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontcolor
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.color,
                "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.color = $event),
                "show-alpha": ""
              }, null, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 8
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).backgroundColor
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.backgroundColor,
                "onUpdate:modelValue": _cache[19] || (_cache[19] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.backgroundColor = $event),
                "show-alpha": ""
              }, null, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 8
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).shadowcolor
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.shadowShowBg,
                "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.shadowShowBg = $event),
                "show-alpha": ""
              }, null, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 8
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_12, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
              modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.shadowShow,
              "onUpdate:modelValue": _cache[21] || (_cache[21] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.shadowShow = $event)
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).backgroundShadow), 1
              /* TEXT */
              )]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["modelValue"])])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_13, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.titleShow,
          "onUpdate:modelValue": _cache[22] || (_cache[22] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.titleShow = $event)
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).displaytitle), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["modelValue"])])])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model"])], 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowTitle)]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 添加文本-box "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-box",
        ref_key: "selectTextBoxRef",
        ref: selectTextBoxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 添加文本-bar "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "select-layer-bar bar",
        onClick: setMainStyle
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowLeft))]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("h4", _hoisted_14, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).addtext), 1
      /* TEXT */
      )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_15, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
        model: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform),
        "label-width": "70px",
        "label-position": "left"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).font
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.fontFamily,
            "onUpdate:modelValue": _cache[23] || (_cache[23] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.fontFamily = $event),
            placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pleaseselect,
            style: {
              "width": "100%"
            }
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              value: "Microsoft YaHei",
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).yahei
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              value: "NSimSun",
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).NSimSun
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              value: "KaiTi",
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).KaiTi
            }, null, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue", "placeholder"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 16
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontsize
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.fontSize,
                "onUpdate:modelValue": _cache[24] || (_cache[24] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.fontSize = $event),
                placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontsize
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(sizelist).value, size => {
                  return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
                    key: size,
                    value: `${size}px`
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(size), 1
                    /* TEXT */
                    )]),
                    _: 2
                    /* DYNAMIC */

                  }, 1032
                  /* PROPS, DYNAMIC_SLOTS */
                  , ["value"]);
                }), 128
                /* KEYED_FRAGMENT */
                ))]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue", "placeholder"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 2
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)(" ")]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 6
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fontcolor
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.color,
                "onUpdate:modelValue": _cache[25] || (_cache[25] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style.color = $event),
                "show-alpha": ""
              }, null, 8
              /* PROPS */
              , ["modelValue"])])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
          class: "textarea",
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printtext
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("textarea", {
            class: "textcontent",
            rows: "12",
            placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pleaseentercontent,
            spellcheck: "false",
            "onUpdate:modelValue": _cache[26] || (_cache[26] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).data.labelValue = $event),
            style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).style)
          }, null, 12
          /* STYLE, PROPS */
          , _hoisted_16), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vModelText, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelDataform).data.labelValue]])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["label"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_17, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        type: "primary",
        onClick: addLabel
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printadd), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        type: "plain",
        onClick: clearLabel
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printclear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      })])])], 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isShowText)]])], 2
      /* CLASS */
      )], 2
      /* CLASS */
      )], 4
      /* STYLE */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_18, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_19, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: Enlarge,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).equalscalezoom,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) === 1 ? 'clickborder' : '')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ZoomIn))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "class"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: Narrow,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).scaleddown,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) === 2 ? 'clickborder' : '')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ZoomOut))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "class"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: MovePrint,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printdrag,
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) === 3 ? 'clickborder' : '')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Rank))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "class"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: RefreshStatus,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).restore
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Refresh))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        ref_key: "printDiv",
        ref: printDiv,
        class: "kq3d-client-print-printDiv"
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_scrollbar, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
          ref_key: "printMap",
          ref: printMap,
          class: "kq3d-client-print-mapContainerDiv kq3d-client-print-a4VSize",
          onselectstart: "return false",
          id: "printMap"
        }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_20, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
          ref_key: "titleRef",
          ref: titleRef,
          style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
            boxShadow: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.shadowShow ? (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style.shadowShowBg + ' 5px 2px 6px' : ''
          }),
          class: "kq3d-client-print-titleDivStyle"
        }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
          style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).style)
        }, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.title), 5
        /* TEXT, STYLE */
        )], 4
        /* STYLE */
        ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setTitleDataform).data.titleShow]])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
          class: "kq3d-client-print-printContentDiv kq3d-client-print-printborder1",
          ref_key: "printContentDiv",
          ref: printContentDiv
        }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_21, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
          src: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(scenceImageUrl)
        }, null, 8
        /* PROPS */
        , _hoisted_22)]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_scence_view, {
          target: 'scencePrint',
          options: __props.options,
          service: __props.service,
          scenceInfo: __props.scenceInfo,
          showToolButtons: __props.showToolButtons,
          defaultShowLayerNames: __props.defaultShowLayerNames,
          toolButtonsPosition: __props.toolButtonsPosition,
          showLogo: __props.showLogo,
          style: {
            "position": "relative"
          }
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(scalesShow) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq3d_status_bar, {
            key: 0
          })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("图例"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
            class: "kq3d-client-print-legendDiv",
            onMouseover: setdragCursor,
            onMousedown: dragTl,
            id: "divlegendDiv"
          }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(legendShow) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_legend, {
            key: 0,
            mapTarget: "scencePrint",
            ref_key: "lengend_ref",
            ref: lengend_ref
          }, null, 512
          /* NEED_PATCH */
          )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)], 32
          /* HYDRATE_EVENTS */
          ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("指北针"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
            class: "kq3d-client-print-compassDiv",
            onMouseover: setdragCursor,
            onMousedown: dragTl,
            id: "divcompassDiv"
          }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq3d_compass)], 544
          /* HYDRATE_EVENTS, NEED_PATCH */
          ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(compassShow)]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 文本标注 "), ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(setLabelData).value, item => {
            return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)(((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", {
              id: item.data.dataId,
              key: item.data.dataId,
              class: "kq3d-client-print-labelDivStyle",
              onMouseover: setdragCursor,
              onMousedown: dragTl
            }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
              style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)(item.style)
            }, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(item.data.labelValue), 5
            /* TEXT, STYLE */
            ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
              class: "closeIconDiv",
              onClick: $event => delLabel(item.data.dataId),
              style: {
                "position": "absolute",
                "top": "0px",
                "right": "0px",
                "display": "none"
              }
            }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 24,
              style: {
                "cursor": "Pointer",
                "color": "#da0000"
              },
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printclose
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Close))]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["title"])], 8
            /* PROPS */
            , _hoisted_24)], 40
            /* PROPS, HYDRATE_EVENTS */
            , _hoisted_23)), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, item.data.isShow]]);
          }), 128
          /* KEYED_FRAGMENT */
          ))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["options", "service", "scenceInfo", "showToolButtons", "defaultShowLayerNames", "toolButtonsPosition", "showLogo"])], 512
        /* NEED_PATCH */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_25, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_26, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printcompany) + "：" + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(companyName)), 1
        /* TEXT */
        )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", _hoisted_27, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).printdate) + "：" + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(systemTime)), 1
        /* TEXT */
        )])])], 512
        /* NEED_PATCH */
        )]),
        _: 1
        /* STABLE */

      })], 512
      /* NEED_PATCH */
      )], 512
      /* NEED_PATCH */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/clientPrint/ClientPrint.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/clientPrint/ClientPrint.vue



const ClientPrint_exports_ = ClientPrintvue_type_script_setup_true_lang_js;

/* harmony default export */ var ClientPrint = (ClientPrint_exports_);
;// CONCATENATED MODULE: ./src/webgl/clientPrint/index.js



ClientPrint.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ClientPrint.name, ClientPrint);
};


;// CONCATENATED MODULE: ./src/webgl/baseterraingallery/BaseterrainGalleryViewModel.js

//在线地形逻辑类
class BaseterrainGalleryViewModel {
  //基本地形对象
  constructor(viewer) {
    _defineProperty(this, "_baseterrainGallery", {});

    this._baseterrainGallery.viewer = viewer;
    this._baseterrainGallery.viewer.scene.globe.depthTestAgainstTerrain = false;
    this._baseterrainGallery.viewer.scene.postProcessStages.fxaa.enabled = false; //this.terrainTDT();

    this.terrainNo();
    this.terrainCesium();
  }

  setTerrainType(inx) {
    if (inx === 0) {
      this._baseterrainGallery.viewer.terrainProvider = this._baseterrainGallery.terrainTDT;
    } else if (inx === 1) {
      this._baseterrainGallery.viewer.terrainProvider = this._baseterrainGallery.terrainCesium;
    } else if (inx === 2) {
      this._baseterrainGallery.viewer.terrainProvider = this._baseterrainGallery.terrainNo;
    }
  } //天地图地形


  terrainTDT() {
    this._baseterrainGallery.terrainTDT = new window.Cesium.TiandituTerrainProvider({
      url: "https://t{s}.tianditu.gov.cn/DEM90M/DataServer?T=elv_c",
      subdomains: ["8", "9", "10", "11", "12"]
    });
  }
  /**
   * 无地形
   */


  terrainNo() {
    this._baseterrainGallery.terrainNo = new window.Cesium.EllipsoidTerrainProvider();
  }
  /**
   * cesium全球地形
   */


  terrainCesium() {
    window.Cesium.Ion.defaultAccessToken = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJqdGkiOiIwMTY2NmY5Yi05OTM4LTQzMDAtOWFiNS00NTFlZmVkYWE2OTMiLCJpZCI6Nzc1NDAsImlhdCI6MTY0MDMzNzc2MH0.V6JP-o1fF5PQZ6BQzo5vS1SATDid7sM0NjOtQuRULjU";
    this._baseterrainGallery.terrainCesium = new window.Cesium.createWorldTerrain({
      requestVertexNormals: true,
      requestWaterMask: true
    });
  }
  /**
   * 清理地图
   */


  clear() {
    this.setTerrainType(2);
  }
  /**
   * 注销
   */


  destroy() {
    this.clear();
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/baseterraingallery/BaseterrainGallery.vue?vue&type=script&setup=true&lang=js

const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-baseterrain-gallery-box"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "divSpan"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "divImg"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_4 = ["src"];
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_5 = {
  class: "divText"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_6 = {
  class: "text"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_7 = {
  class: "divImg"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_8 = ["src"];
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_9 = {
  class: "divText"
};
const BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_10 = {
  class: "text"
};







const BaseterrainGalleryvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dBaseterrainGallery"
};
/* harmony default export */ var BaseterrainGalleryvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(BaseterrainGalleryvue_type_script_setup_true_lang_js_default_, {
  props: {
    selectIndex: {
      type: Number,
      default: 2
    },
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconBaseterrainGallery
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props; //语言

    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); //地形选中值

    let currentIndex = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(2);
    let currentTerrain = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); //逻辑类对象

    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.onlineTerrain;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      currentIndex.value = props.selectIndex;
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          changSelectTerrain();
          viewModel = new BaseterrainGalleryViewModel(scenceView._viewer);
          viewModel.setTerrainType(currentIndex.value);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    };

    function changSelectTerrain() {
      switch (currentIndex.value) {
        case 0:
          currentTerrain.value = language.value["tiandituTerrain"];
          break;

        case 1:
          currentTerrain.value = language.value["cesiumTerrain"];
          break;

        case 2:
          currentTerrain.value = language.value["ellipsoidTerrain"];
          break;
      }
    } //地形选择事件


    function clickHandler(inx) {
      currentIndex.value = inx;
      changSelectTerrain();
      viewModel.setTerrainType(currentIndex.value);
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    }

    function getSelectIndex() {
      return currentIndex.value;
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      clearResult();
    });
    expose({
      changSelectTerrain,
      clickHandler,
      getSelectIndex,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-baseterrain-gallery", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        style: {
          "line-height": "48px",
          "height": "48px"
        }
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).onlineTerrain
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentTerrain)), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["label"])]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, null, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row @click=\"clickHandler(0)\" :class=\"currentIndex == 0 ? 'active' : ''\">\r\n              <kq-col :span=\"5\">\r\n                <img :src=\"TDT_TERRAiIN_URL\" alt=\"\" />\r\n              </kq-col>\r\n              <kq-col :span=\"19\">{{ language.tiandituTerrain }} </kq-col>\r\n            </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              onClick: _cache[0] || (_cache[0] = $event => clickHandler(1)),
              class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentIndex) == 1 ? 'active' : '')
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                src: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(const_image_namespaceObject.CESIUM_TERRAiIN_URL),
                alt: ""
              }, null, 8
              /* PROPS */
              , BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_4)]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_6, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cesiumTerrain), 1
              /* TEXT */
              )])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["class"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              onClick: _cache[1] || (_cache[1] = $event => clickHandler(2)),
              class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentIndex) == 2 ? 'active' : '')
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_7, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                src: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(const_image_namespaceObject.NO_TERRAiIN_URL),
                alt: ""
              }, null, 8
              /* PROPS */
              , BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_8)]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_9, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BaseterrainGalleryvue_type_script_setup_true_lang_js_hoisted_10, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).ellipsoidTerrain), 1
              /* TEXT */
              )])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["class"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      })])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/baseterraingallery/BaseterrainGallery.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/baseterraingallery/BaseterrainGallery.vue



const BaseterrainGallery_exports_ = BaseterrainGalleryvue_type_script_setup_true_lang_js;

/* harmony default export */ var BaseterrainGallery = (BaseterrainGallery_exports_);
;// CONCATENATED MODULE: ./src/webgl/baseterraingallery/index.js




BaseterrainGallery.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(BaseterrainGallery.name, BaseterrainGallery);
};


;// CONCATENATED MODULE: ./src/webgl/measure/MeasureViewModel.js

//测量操作类
class MeasureViewModel {
  //测量三维对象
  //测量事件
  //活动事件
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_measureHandler", null);

    _defineProperty(this, "measureEvent", null);

    _defineProperty(this, "activeEvent", null);

    //开启深度检测
    viewer.scene.globe.depthTestAgainstTerrain = true;
    this._measureHandler = new Cesium.Kq3dMeasureHandler(viewer);
    this._viewer = viewer;
    this.measureEvent = this._measureHandler.measureEvent;
    this.activeEvent = this._measureHandler.activeEvent;
  } //距离测量


  distanceMeasure(mode) {
    if (mode === "ground") {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.TerrainDistance);
    } else if (mode === "model") {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.ModelDistance);
    } else {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.Distance);
    }
  } //高度测量(三角测量)


  heightMeasure() {
    this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.ComplexDistance);
  } //面积测量


  areaMeasure(mode) {
    if (mode === "ground") {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.TerrainArea);
    } else if (mode === "model") {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.ModelArea);
    } else {
      this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.Area);
    }
  } //方位角测量


  azimuthMeasure() {
    this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.Azimuth);
  } //坐标测量


  coordinateMeasure() {
    this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.Coordinate);
  } //结束测量


  stopMeasure() {
    this._measureHandler.stopMeasure();
  } //更新距离测量单位


  updateDistanceUnit(distanceTotal, unit) {
    if (this._measureHandler.measureResults) {
      this._measureHandler.measureResults.forEach(measureResult => {
        let labels = measureResult.labels._labels;
        let positions = measureResult.polyline.positions;
        let dist = 0; // 更新每段长度值

        for (let i = 0; i < labels.length - 1; i++) {
          if (labels[i].show && labels[i].text) {
            dist = Cesium.Cartesian3.distance(positions[i], positions[i + 1]);
            labels[i].text = this.convertValueUnit(dist, unit);
          }
        } // 更新总长度值


        measureResult.label.text = this.convertValueUnit(distanceTotal, unit);
      }, this);
    }
  } //测量距离数值单位换算


  convertValueUnit(value, unit) {
    let newValue = "";

    switch (unit) {
      case "m":
        newValue = value.toFixed(2) + " m";
        break;

      case "km":
        newValue = (value / 1000).toFixed(2) + " km";
        break;

      case "n mile":
        newValue = (value / 1852).toFixed(2) + " n mile";
        break;

      default:
        break;
    }

    return newValue;
  } // 判断是否加载地形


  checkTerrainAdded() {
    return this._viewer.terrainProvider.availability;
  } // 判断是否加载模型


  checkModelAdded() {
    let isAdd = false;
    let models = this._viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i] instanceof Cesium.Cesium3DTileset) {
        isAdd = true;
        break;
      }
    }

    return isAdd;
  } //清除全部测量结果


  clear() {
    this._measureHandler && this._measureHandler.clear();
  } //销毁


  destroy() {
    this.clear();
    this._measureHandler = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/measure/Measure.vue?vue&type=script&setup=true&lang=js

const Measurevue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq-measure3d-box"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq-measure3d-mode"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "panel"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "title",
  style: {
    "line-height": "14px"
  }
};
const Measurevue_type_script_setup_true_lang_js_hoisted_5 = {
  class: "kq-measure3d-btns"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_6 = {
  key: 0,
  class: "kq-measure3d-tip"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_7 = {
  key: 0
};
const Measurevue_type_script_setup_true_lang_js_hoisted_8 = {
  key: 1
};
const Measurevue_type_script_setup_true_lang_js_hoisted_9 = {
  key: 1,
  class: "kq-measure3d-result"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_10 = {
  class: "kq-measure3d-result-panel"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_11 = {
  key: 0,
  class: "panel"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_12 = {
  class: "title"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_13 = {
  class: "panel"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_14 = {
  class: "title"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_15 = {
  key: 0,
  class: "result"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_16 = {
  class: "tit"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_17 = {
  class: "res"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_18 = {
  class: "tit"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_19 = {
  class: "res"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_20 = {
  class: "tit"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_21 = {
  class: "res"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_22 = {
  class: "tit"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_23 = {
  class: "res"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_24 = {
  key: 1,
  class: "result"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_25 = {
  class: "tit"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_26 = {
  class: "res"
};
const Measurevue_type_script_setup_true_lang_js_hoisted_27 = {
  class: "tit"
};
const _hoisted_28 = {
  class: "res"
};
const _hoisted_29 = {
  class: "tit"
};
const _hoisted_30 = {
  class: "res"
};
const _hoisted_31 = {
  key: 2,
  class: "result"
};
const _hoisted_32 = {
  class: "tit"
};
const _hoisted_33 = {
  class: "res"
};








const Measurevue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dMeasure"
};
/* harmony default export */ var Measurevue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Measurevue_type_script_setup_true_lang_js_default_, {
  props: {
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconMeasure2D
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let measureType = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 测量类型

    let isActive = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    let isResult = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let distanceValue = null;
    let distanceUnit = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let result = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("0");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let mode = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("space");
    let modeList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]);
    let viewModel = null; // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let measureTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      measureTitle.value = language.value.measure;
      modeList.value = loadModeData();
    }); // 距离测量单位

    let distanceUnits = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([{
      label: "m",
      value: "m"
    }, {
      label: "km",
      value: "km"
    }, {
      label: "n mile",
      value: "n mile"
    }]); // 面积测量单位

    let areaUnits = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([{
      label: "m²",
      value: "m²"
    }, {
      label: "km²",
      value: "km²"
    }]); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new MeasureViewModel(scenceView._viewer); //注册测量事件，以获取测量结果

          viewModel.measureEvent.addEventListener(function (res) {
            if (measureType.value === "distance") {
              if (res.distance) {
                distanceValue = res.distance;
                result.value = formatDistance(res.distance);
              }
            } else if (measureType.value === "height" && res) {
              result.value = {
                spaceDistance: res.distance ? res.distance.toFixed(2) : 0,
                horizontalDistance: res.hDistance ? res.hDistance.toFixed(2) : 0,
                verticalDistance: res.vDistance ? res.vDistance.toFixed(2) : 0,
                angle: res.angle ? res.angle.toFixed(2) : 0
              };
            } else if (measureType.value === "area") {
              if (res && res.area) result.value = formatArea(res.area);
            } else if (measureType.value === "azimuth") {
              if (res && res.azimuth) result.value = formatAzimuth(res.azimuth);
            } else if (measureType.value === "coordinate") {
              if (res && res.coordinate) {
                result.value = {
                  longitude: res.coordinate.longitude ? res.coordinate.longitude.toFixed(5) : 0,
                  latitude: res.coordinate.latitude ? res.coordinate.latitude.toFixed(5) : 0,
                  height: res.coordinate.height ? res.coordinate.height.toFixed(2) : 0
                };
                viewModel.stopMeasure();

                if (res.measureResult && res.measureResult.labels && res.measureResult.labels.length > 0) {
                  res.measureResult.labels._labels.forEach(label => {
                    label.text = label.text.replace('X', language.value.longitude).replace('Y', language.value.latitude).replace('Z', language.value.elevation).replace(/\n/g, '°\n');
                  });
                }
              }
            }
          });
          viewModel.activeEvent.addEventListener(function (active) {
            if (!active) {
              if (measureType.value === "height" && result.value.angle === 0) return;
              isActive.value = null;
              isResult.value = true;
            }
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, measureTitle);
      }
    }; //加载测量模式数据


    function loadModeData() {
      return [{
        label: language.value.spaceMeasure,
        value: "space"
      }, {
        label: language.value.groundMeasure,
        value: "ground"
      }, {
        label: language.value.modelMeasure,
        value: "model"
      }];
    }

    function formatDistance(dis) {
      if (dis > 5000) {
        dis = dis / 1000;
        distanceUnit.value = "km";
      } else {
        distanceUnit.value = "m";
      }

      return dis.toFixed(2) + " " + distanceUnit.value;
    }

    function formatArea(area) {
      var unit = "m²";

      if (area > 1000000) {
        area = area / 1000000;
        unit = "km²";
      }

      return area.toFixed(2) + " " + unit;
    }

    function formatAzimuth(azimuth) {
      var unit = "°";
      return azimuth.toFixed(4) + " " + unit;
    }
    /**
     * @description 监听单位变化操作
     * @param {string} unit - 单位
     */


    function onChangeUnit(unit) {
      result.value = convertValueUnitTotal(distanceValue, unit);
      viewModel && viewModel.updateDistanceUnit(distanceValue, unit);
    }
    /**
     * @description 测量距离数值单位换算
     * @param {string} value - 原始数值
     * @param {string} unit - 单位
     * @returns {string} 新数值
     */


    function convertValueUnitTotal(value, unit) {
      let newValue = "";

      switch (unit) {
        case "m":
          newValue = value.toFixed(2) + " m";
          break;

        case "km":
          newValue = (value / 1000).toFixed(2) + " km";
          break;

        case "n mile":
          newValue = (value / 1852).toFixed(2) + " n mile";
          break;

        default:
          break;
      }

      return newValue;
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      clearMeasure();
    }); //开始测量

    function startMeasure(type) {
      if (mode.value === "ground") {
        if (!viewModel.checkTerrainAdded()) {
          message({
            message: "请先加载地形!",
            type: "warning"
          });
          return;
        }
      }

      if (mode.value === "model") {
        if (!viewModel.checkModelAdded()) {
          message({
            message: "请先加载模型!",
            type: "warning"
          });
          return;
        }
      }

      viewModel.clear();
      isResult.value = false;
      measureType.value = type;
      isActive.value = type;

      switch (type) {
        case "distance":
          viewModel.distanceMeasure(mode.value);
          break;

        case "area":
          viewModel.areaMeasure(mode.value);
          break;

        case "height":
          viewModel.heightMeasure();
          break;

        case "coordinate":
          viewModel.coordinateMeasure();
          break;

        default:
          break;
      }
    }
    /**
     * 清除测量
     */


    function clearMeasure() {
      viewModel && viewModel.clear();
      measureType.value = null;
      isActive.value = null;
      isResult.value = false;
    }

    expose({
      loadModeData,
      formatDistance,
      formatArea,
      formatAzimuth,
      startMeasure,
      clearMeasure
    });
    return (_ctx, _cache) => {
      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_divider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-divider");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq-measure3d", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).mode), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
        modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(mode),
        "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(mode) ? mode.value = $event : mode = $event),
        disabled: !!(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(modeList), item => {
          return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
            key: item.value,
            label: item.label,
            value: item.value
          }, null, 8
          /* PROPS */
          , ["label", "value"]);
        }), 128
        /* KEYED_FRAGMENT */
        ))]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["modelValue", "disabled"])])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[1] || (_cache[1] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startMeasure('distance'), ["stop"])),
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) == 'distance' ? 'is-active' : null),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).distance
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconMeasureDistance))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[2] || (_cache[2] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startMeasure('area'), ["stop"])),
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) == 'area' ? 'is-active' : null),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).area
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconMeasureArea))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[3] || (_cache[3] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startMeasure('height'), ["stop"])),
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) == 'height' ? 'is-active' : null),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).height
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconMeasureCoordinate))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title"]), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(mode) == 'space']]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[4] || (_cache[4] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startMeasure('coordinate'), ["stop"])),
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) == 'coordinate' ? 'is-active' : null),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).coordinate
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconGroundSurvey))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["class", "title"]), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(mode) == 'space']]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        type: "danger",
        plain: "",
        onClick: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)(clearMeasure, ["stop"]),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          class: "icon-delete",
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Delete))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["onClick", "title"])]), !!(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isActive) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Measurevue_type_script_setup_true_lang_js_hoisted_6, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(measureType) === 'height' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("p", Measurevue_type_script_setup_true_lang_js_hoisted_7, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).measureTips1), 1
      /* TEXT */
      )) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("p", Measurevue_type_script_setup_true_lang_js_hoisted_8, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).measureTips), 1
      /* TEXT */
      ))])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isResult) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Measurevue_type_script_setup_true_lang_js_hoisted_9, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_10, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(measureType) === 'distance' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Measurevue_type_script_setup_true_lang_js_hoisted_11, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_12, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).unit), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
        modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(distanceUnit),
        "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(distanceUnit) ? distanceUnit.value = $event : distanceUnit = $event),
        onChange: onChangeUnit
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(distanceUnits), item => {
          return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
            key: item.value,
            label: item.label,
            value: item.value
          }, null, 8
          /* PROPS */
          , ["label", "value"]);
        }), 128
        /* KEYED_FRAGMENT */
        ))]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["modelValue"])])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Measurevue_type_script_setup_true_lang_js_hoisted_13, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_14, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).measureResult), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(measureType) === 'height' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Measurevue_type_script_setup_true_lang_js_hoisted_15, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_16, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).spaceDistance), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_17, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).spaceDistance) + " m", 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_18, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).horizontalDistance), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_19, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).horizontalDistance) + " m", 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_20, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).verticalDistance), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_21, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).verticalDistance) + " m", 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_22, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).angle), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_23, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).angle) + " °", 1
      /* TEXT */
      )])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(measureType) === 'coordinate' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Measurevue_type_script_setup_true_lang_js_hoisted_24, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_25, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).longitude), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_26, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).longitude) + "°", 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", Measurevue_type_script_setup_true_lang_js_hoisted_27, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).latitude), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", _hoisted_28, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).latitude) + "°", 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", _hoisted_29, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).elevation), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", _hoisted_30, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).height) + " m", 1
      /* TEXT */
      )])) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", _hoisted_31, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", _hoisted_32, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language)[(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(measureType)]), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", _hoisted_33, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result)), 1
      /* TEXT */
      )]))])])])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/measure/Measure.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/measure/Measure.vue



const Measure_exports_ = Measurevue_type_script_setup_true_lang_js;

/* harmony default export */ var Measure = (Measure_exports_);
;// CONCATENATED MODULE: ./src/webgl/measure/index.js




Measure.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Measure.name, Measure);
};


;// CONCATENATED MODULE: ./src/webgl/flight/FlightViewModel.js

//飞行操作类
class FlightViewModel {
  //飞行三维对象
  //停止事件
  constructor(viewer) {
    _defineProperty(this, "_animationPath", null);

    _defineProperty(this, "stopEvent", null);

    this._animationPath = new Cesium.Kq3dAnimationPath(viewer);
    this.stopEvent = this._animationPath.stoped;
  } //播放动画导航路径


  play() {
    this._animationPath.play();
  } //暂停动画导航路径


  pause() {
    this._animationPath.pause();
  } //停止动画导航路径


  stop() {
    this._animationPath.stop();
  } //获取动画导航是否重复播放


  getAutoRepeat() {
    return this._animationPath.getAutoRepeat();
  } //设置动画导航是否循环播放


  setAutoRepeat(autoRepeat) {
    this._animationPath.setAutoRepeat(autoRepeat);
  } //将当前相机位置添加到动画导航路径中


  addKeyPointByCurrentView(duration) {
    this._animationPath.addKeyPointByCurrentView(duration);
  } //使用当前视角修改指定索引位置的路径节点


  modifyKeyPointByCurrentView(index, duration) {
    this._animationPath.modifyKeyPointByCurrentView(index, duration);
  } //获取指定索引位置处的路径节点


  getKeyPoint(index) {
    return this._animationPath.getKeyPoint(index);
  } //获取指定索引位置的路径节点的耗时信息


  getKeyPointDur(index) {
    return this._animationPath.getKeyPointDur(index);
  } //修改指定索引位置的路径节点


  modifyKeyPoint(index, position, orientation, duration) {
    this._animationPath.modifyKeyPoint(index, position, orientation, duration);
  } //删除动画导航中指定索引位置的路径节点


  deleteKeyPoint(index) {
    this._animationPath.deleteKeyPoint(index);
  } //获取动画导航所有的路径节点


  getAllKeyPoints() {
    return this._animationPath.getAllKeyPoints();
  } //清空动画导航所有路径节点


  clearKeyPoints() {
    this._animationPath.clearKeyPoints();
  } //从xml字符串获取动画导航


  fromXmlString(xmlString) {
    this._animationPath.fromXmlString(xmlString);
  } //动画导航转换成xml字符串


  asXmlString() {
    return this._animationPath.asXmlString();
  } //从xml文件获取动画导航


  fromXmlFile(xmlFile) {
    return this._animationPath.fromXmlFile(xmlFile);
  } //动画导航导出为xml文件


  asXmlFile(xmlFileName) {
    this._animationPath.asXmlFile(xmlFileName);
  } //销毁


  destroy() {
    this._animationPath = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/flight/Flight.vue?vue&type=script&setup=true&lang=js

const Flightvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq-flight3d-box"
};
const Flightvue_type_script_setup_true_lang_js_hoisted_2 = {
  key: 0
};
const Flightvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq-flight3d-btns"
};
const Flightvue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "kq-flight3d-list-title"
};
const Flightvue_type_script_setup_true_lang_js_hoisted_5 = {
  key: 1
};
const Flightvue_type_script_setup_true_lang_js_hoisted_6 = {
  class: "kq-flight3d-add-title"
};
const Flightvue_type_script_setup_true_lang_js_hoisted_7 = {
  key: 0
};
const Flightvue_type_script_setup_true_lang_js_hoisted_8 = {
  key: 1
};
const Flightvue_type_script_setup_true_lang_js_hoisted_9 = {
  style: {
    "text-align": "right"
  }
};








const Flightvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dFlight"
};
/* harmony default export */ var Flightvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Flightvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },
    // 加载外部飞行路径数据方法
    loadFlightPath: {
      type: Function
    },
    // 外部保存飞行路径方法
    saveFlightPath: {
      type: Function
    },
    // 外部删除飞行路径方法
    deleteFlightPath: {
      type: Function
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconFlight
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let isAdd = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let isEdit = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let pathList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([]);
    let showMoreMenu = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let dropDownMenu = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    let pathName = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let tableData = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([]);
    let isPrePlaying = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let viewer = null;
    let pathPlayIndex = -1;
    let dropDownPath = null;
    let viewModel = null; // 表格头样式

    let headClass = args => {
      return {
        "background-color": "var(--kq-fill-color-light)",
        color: "var(--kq-color-info)",
        "font-size": "14px"
      };
    }; // 组件容器Ref


    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.flight;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewer = scenceView._viewer;
          viewModel = new FlightViewModel(viewer);
          viewModel.stopEvent.addEventListener(function () {
            isPrePlaying.value = false;
            pathList.forEach(path => {
              path.isPlaying = false;
            });
          }); //加载外部数据

          if (props.loadFlightPath) {
            props.loadFlightPath(dataList => {
              dataList = JSON.parse(JSON.stringify(dataList));
              dataList.forEach(path => {
                path.isPlaying = false;
                path.isRepeat = false;
                pathList.push(path);
              });
            });
          }
        }
      });
    }); // 销毁

    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel.stop();
      document.removeEventListener("click", hideDropDownMenu);
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; //新建路径


    function addPath() {
      pathList.forEach(path => {
        if (path.isPlaying) {
          stop(path);
        }
      });
      viewModel.clearKeyPoints();
      isAdd.value = true;
      pathPlayIndex = -1;
    } //编辑路径


    function editPath() {
      if (dropDownPath) {
        addPath();
        isEdit.value = true;
        pathName.value = dropDownPath.name;
        viewModel.fromXmlString(dropDownPath.xmlString);
        convertAnimationPathKeys();
      }
    } //转换AnimationPath节点数据


    function convertAnimationPathKeys() {
      var keyPoints = viewModel.getAllKeyPoints();
      keyPoints.forEach(key => {
        var lonlat = Cesium.Cartographic.fromCartesian(key.destination);
        var positionArr = [Cesium.Math.toDegrees(lonlat.longitude).toFixed(4) * 1, Cesium.Math.toDegrees(lonlat.latitude).toFixed(4) * 1, lonlat.height.toFixed(2) * 1];
        var position = positionArr.join(", ");
        var data = {
          position: position,
          interval: key.duration,
          positionArr: positionArr
        };
        tableData.push(data);
      });
    } //删除路径


    function deletePath() {
      if (dropDownPath) {
        if (dropDownPath.index === pathPlayIndex) {
          pathPlayIndex = -1;
        }

        pathList.splice(dropDownPath.index, 1); // 外部删除数据

        if (props.deleteFlightPath) {
          props.deleteFlightPath(dropDownPath.guid);
        }
      }
    } //路径播放


    function play(item, index) {
      if (index !== pathPlayIndex) {
        viewModel.fromXmlString(item.xmlString);
        pathPlayIndex = index;
      }

      viewModel.play();
      item.isPlaying = true; // 设置循环播放

      viewModel.setAutoRepeat(item.isRepeat);
    } //路径播放暂停


    function pause(item) {
      item.isPlaying = false;
      viewModel.pause();
    } //路径播放停止


    function stop(item) {
      item.isPlaying = false;
      viewModel.stop();
    } //循环播放


    function repeat(item) {
      item.isRepeat = !item.isRepeat;

      if (item.isPlaying) {
        viewModel.setAutoRepeat(item.isRepeat);
      }
    } //显示更多功能菜单


    function showDropDownMenu(item, index) {
      if (showMoreMenu.value === true && index === dropDownPath.index) {
        showMoreMenu.value = false;
        document.addEventListener("click", hideDropDownMenu);
        return;
      }

      showMoreMenu.value = true;
      let _menuDropdown = dropDownMenu.value.$el;
      _menuDropdown.style.left = window.event.clientX - 70 + "px";
      _menuDropdown.style.top = window.event.clientY + 15 + "px";
      dropDownPath = {
        index: index,
        ...item
      };
      document.addEventListener("click", hideDropDownMenu);
    } //隐藏更多功能菜单


    function hideDropDownMenu() {
      if (dropDownMenu.value) {
        // 去除选中样式
        let selectElement = dropDownMenu.value.$el.querySelector(".is-active");
        if (selectElement) selectElement.classList.remove("is-active");
      }

      document.removeEventListener("click", hideDropDownMenu);
      showMoreMenu.value = false;
    } //添加关键帧


    function addKey() {
      var duration = 5;
      var lonlat = viewer.getCurrentView();
      var positionArr = [lonlat.longitude.toFixed(4) * 1, lonlat.latitude.toFixed(4) * 1, lonlat.height.toFixed(2) * 1];
      var position = positionArr.join(", ");
      var data = {
        position: position,
        interval: duration,
        positionArr: positionArr
      };
      tableData.push(data);
      viewModel.addKeyPointByCurrentView(duration);
    } //替换关键帧


    function replaceKey(index, row) {
      var lonlat = viewer.getCurrentView();
      var positionArr = [lonlat.longitude.toFixed(4) * 1, lonlat.latitude.toFixed(4) * 1, lonlat.height.toFixed(2) * 1];
      var position = positionArr.join(", ");
      row.position = position;
      row.positionArr = positionArr;
      viewModel.modifyKeyPointByCurrentView(index, row.interval);
    } //删除关键帧


    function deleteKey(index) {
      viewModel.deleteKeyPoint(index);
      tableData.splice(index, 1);
    } //预播放


    function prePlay() {
      for (let index = 0; index < tableData.length; index++) {
        var duration = tableData[index].interval;
        var key = viewModel.getKeyPoint(index);
        var dur = viewModel.getKeyPointDur(index);

        if (dur !== duration) {
          viewModel.modifyKeyPoint(index, key.position, key.orientation, duration);
        }
      }

      isPrePlaying.value = true;
      viewModel.play();
    } //预播放暂停


    function prePause() {
      isPrePlaying.value = false;
      viewModel.pause();
    } //预播放停止


    function preStop() {
      isPrePlaying.value = false;
      viewModel.stop();
    } //保存


    function save() {
      if (pathName.value === "") {
        message({
          message: "请输入路径名称!",
          type: "warning"
        });
      } else {
        for (let index = 0; index < tableData.length; index++) {
          var duration = tableData[index].interval;
          var key = viewModel.getKeyPoint(index);
          var dur = viewModel.getKeyPointDur(index);

          if (dur !== duration) {
            viewModel.modifyKeyPoint(index, key.position, key.orientation, duration);
          }
        }

        var xmlString = viewModel.asXmlString();

        if (isEdit.value) {
          //编辑路径
          if (dropDownPath) {
            var editPath = pathList[dropDownPath.index];
            editPath.name = pathName.value;
            editPath.xmlString = xmlString; // 外部保存数据

            if (props.saveFlightPath) {
              props.saveFlightPath({
                guid: editPath.guid,
                name: editPath.name,
                xmlString: editPath.xmlString
              });
            }
          }
        } else {
          //新增路径
          var path = {
            guid: Cesium.createGuid(),
            name: pathName.value,
            xmlString: xmlString,
            isPlaying: false
          };
          pathList.push(path); // 外部保存数据

          if (props.saveFlightPath) {
            props.saveFlightPath({
              guid: path.guid,
              name: path.name,
              xmlString: path.xmlString
            });
          }
        }

        cancel();
      }
    } //取消


    function cancel() {
      preStop();
      viewModel.clearKeyPoints();
      tableData.length = 0;
      isAdd.value = false;
      pathName.value = "";
      isEdit.value = false;
    } //导入文件


    function importFile(file) {
      var name = file.name.split(".")[0];
      viewModel.fromXmlFile(file.raw).then(() => {
        var xmlString = viewModel.asXmlString();
        var path = {
          guid: Cesium.createGuid(),
          name: name,
          xmlString: xmlString,
          isPlaying: false
        };
        pathList.push(path); // 外部保存数据

        if (props.saveFlightPath) {
          props.saveFlightPath({
            guid: path.guid,
            name: path.name,
            xmlString: path.xmlString
          });
        }
      });
    } //导出文件


    function exportFile() {
      if (dropDownPath) {
        viewModel.fromXmlString(dropDownPath.xmlString);
        viewModel.asXmlFile(dropDownPath.name);
      }
    }

    expose({
      convertAnimationPathKeys,
      showDropDownMenu,
      hideDropDownMenu,
      save,
      cancel,
      addPath,
      editPath,
      deletePath,
      play,
      pause,
      stop,
      repeat,
      addKey,
      replaceKey,
      deleteKey,
      prePlay,
      prePause,
      preStop,
      importFile,
      exportFile
    });
    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_upload = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-upload");

      const _component_kq_menu_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-menu-item");

      const _component_kq_menu = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-menu");

      const _component_kq_input = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_table_column = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table-column");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_table = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table");

      const _component_kq_divider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-divider");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq-flight3d", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Flightvue_type_script_setup_true_lang_js_hoisted_1, [!(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isAdd) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Flightvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Flightvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: addPath,
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).addPath
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Plus))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_upload, {
        style: {
          "margin-left": "4px"
        },
        "on-change": importFile,
        "auto-upload": false,
        "show-file-list": false,
        accept: "text/xml"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).importXML
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
            size: 24
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconUploadCloud))]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Flightvue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pathName), 1
      /* TEXT */
      ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_menu, {
        class: "pathlist-ul"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(pathList), (item, index) => {
          return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_menu_item, {
            index: index,
            key: index
          }, {
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(item.name), 1
            /* TEXT */
            ), item.isPlaying ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_icon, {
              key: 0,
              size: 16,
              class: "menuIcon",
              onClick: $event => pause(item),
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pause
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoPause))]),
              _: 2
              /* DYNAMIC */

            }, 1032
            /* PROPS, DYNAMIC_SLOTS */
            , ["onClick", "title"])) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_icon, {
              key: 1,
              size: 16,
              class: "menuIcon",
              onClick: $event => play(item, index),
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).play
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoPlay))]),
              _: 2
              /* DYNAMIC */

            }, 1032
            /* PROPS, DYNAMIC_SLOTS */
            , ["onClick", "title"])), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 16,
              class: "menuIcon",
              onClick: $event => stop(item),
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).stop
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoStop))]),
              _: 2
              /* DYNAMIC */

            }, 1032
            /* PROPS, DYNAMIC_SLOTS */
            , ["onClick", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 16,
              class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(item.isRepeat ? 'kq-icon-light' : ''),
              onClick: $event => repeat(item),
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).repeat
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoRepeat))]),
              _: 2
              /* DYNAMIC */

            }, 1032
            /* PROPS, DYNAMIC_SLOTS */
            , ["class", "onClick", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 16,
              class: "menuIcon",
              onClick: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => showDropDownMenu(item, index), ["prevent", "stop"]),
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).more
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.More))]),
              _: 2
              /* DYNAMIC */

            }, 1032
            /* PROPS, DYNAMIC_SLOTS */
            , ["onClick", "title"])]),
            _: 2
            /* DYNAMIC */

          }, 1032
          /* PROPS, DYNAMIC_SLOTS */
          , ["index"]);
        }), 128
        /* KEYED_FRAGMENT */
        ))]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_menu, {
        class: "dropdown-ul",
        ref_key: "dropDownMenu",
        ref: dropDownMenu
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_menu_item, {
          index: "1",
          onClick: editPath
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
            size: 16
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Edit))]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).edit), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_menu_item, {
          index: "2",
          onClick: exportFile
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
            size: 14
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconExport))]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).export), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_menu_item, {
          index: "3",
          onClick: deletePath
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
            size: 16
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Delete))]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).delete), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 512
      /* NEED_PATCH */
      )], 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showMoreMenu)]])])) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", Flightvue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Flightvue_type_script_setup_true_lang_js_hoisted_6, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        text: "",
        onClick: cancel
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 16
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.ArrowLeft))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), !(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isEdit) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("span", Flightvue_type_script_setup_true_lang_js_hoisted_7, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).addPath), 1
      /* TEXT */
      )) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("span", Flightvue_type_script_setup_true_lang_js_hoisted_8, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).editPath), 1
      /* TEXT */
      ))]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
        class: "kq-flight3d-item-name",
        label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pathName
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input, {
          placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).enterPathName,
          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(pathName),
          "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(pathName) ? pathName.value = $event : pathName = $event)
        }, null, 8
        /* PROPS */
        , ["placeholder", "modelValue"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table, {
        border: "",
        data: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tableData),
        "header-cell-style": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headClass)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).no,
          width: "50",
          type: "index",
          align: "center"
        }, null, 8
        /* PROPS */
        , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).position,
          prop: "position",
          align: "center"
        }, null, 8
        /* PROPS */
        , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).interval,
          width: "100",
          align: "center"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(scope => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
            modelValue: scope.row.interval,
            "onUpdate:modelValue": $event => scope.row.interval = $event,
            min: 1,
            "controls-position": "right",
            style: {
              "width": "83px"
            }
          }, null, 8
          /* PROPS */
          , ["modelValue", "onUpdate:modelValue"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).operation,
          width: "90",
          align: "center"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(scope => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: $event => replaceKey(scope.$index, scope.row),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).replaceKeyframe
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 16
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconReplace))]),
              _: 1
              /* STABLE */

            })]),
            _: 2
            /* DYNAMIC */

          }, 1032
          /* PROPS, DYNAMIC_SLOTS */
          , ["onClick", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: $event => deleteKey(scope.$index),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).delete
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
              size: 16
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Delete))]),
              _: 1
              /* STABLE */

            })]),
            _: 2
            /* DYNAMIC */

          }, 1032
          /* PROPS, DYNAMIC_SLOTS */
          , ["onClick", "title"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["label"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["data", "header-cell-style"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        class: "kq-flight3d-btn-add",
        onClick: addKey
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 16
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Plus))]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).addkeyframe), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
        class: "kq-flight3d-ybf",
        label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).prePlay
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [!(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isPrePlaying) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_icon, {
          key: 0,
          size: 32,
          onClick: prePlay,
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).play
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoPlay))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])) : ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_icon, {
          key: 1,
          size: 32,
          onClick: prePause,
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pause
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoPause))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 32,
          onClick: preStop,
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).stop
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconVideoStop))]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Flightvue_type_script_setup_true_lang_js_hoisted_9, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        type: "primary",
        onClick: save
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).save), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: cancel
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cancel), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      })])]))])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/flight/Flight.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/flight/Flight.vue



const Flight_exports_ = Flightvue_type_script_setup_true_lang_js;

/* harmony default export */ var Flight = (Flight_exports_);
;// CONCATENATED MODULE: ./src/webgl/flight/index.js




Flight.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Flight.name, Flight);
};


;// CONCATENATED MODULE: external "xe-utils"
var external_xe_utils_namespaceObject = require("xe-utils");
var external_xe_utils_default = /*#__PURE__*/__webpack_require__.n(external_xe_utils_namespaceObject);
;// CONCATENATED MODULE: ./src/webgl/gpuspatialquery/GPUSpatialQueryViewModel.js

//GPU空间查询逻辑类

class GPUSpatialQueryViewModel {
  //GPU查询三维对象
  //绘制管理对象
  //绘制的图形
  //绘制图形的坐标
  //传入参数
  //绘制后的查询事件
  //绘制完成监听事件
  constructor(scenceView, options) {
    _defineProperty(this, "_gpuSpatialQuery", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_geometry", null);

    _defineProperty(this, "_center", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "finishedQuery", null);

    _defineProperty(this, "_removeEventListener", null);

    options.viewer = scenceView._viewer;
    options.viewer.scene.globe.depthTestAgainstTerrain = true;
    options.viewer.scene.logarithmicDepthBuffer = true;
    options.viewer.scene.globe.enableLighting = true;
    this._options = options;
    this._gpuSpatialQuery = new Cesium.Kq3dSpatialQuery({
      viewer: options.viewer
    });
    this.finishedQuery = this._gpuSpatialQuery.finishSQ;
    this._drawManager = scenceView._drawManager;
    var that = this;
    that._removeEventListener = that._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._drawManager && that._drawManager.clear();
        that._center = shape.position; //that.startQuery();

        setTimeout(() => {
          //绘制跟高亮显示有冲突，所以延时执行查询
          that.startQuery();
          that._drawManager && that._drawManager.startDraw("marker", {
            image: null
          });
        }, 10);
      }
    });

    that._gpuSpatialQuery.finishSQ.addEventListener(function () {
      // 查询结束后的回调事件,高亮结果
      for (let l = 0; l < that._gpuSpatialQuery._layers.length; l++) {
        //if (that._gpuSpatialQuery._layers[l].sqResult.length != 0) { 该代码导致无法清除高亮效果
        const tileset = that._gpuSpatialQuery._layers[l].layer;
        const queryIds = that._gpuSpatialQuery._layers[l].sqResult;

        for (let n = 0; n < tileset._selectedTiles.length; n++) {
          const tile = tileset._selectedTiles[n];
          const content = tile.content;

          if (content) {
            for (let i = 0; i < content.featuresLength; i++) {
              const feature = content.getFeature(i);
              let bFind = false;

              if (feature.pickId) {
                const id = feature.pickId.key;

                for (let j = 0; j < queryIds.length; j++) {
                  if (queryIds[j] == id) {
                    bFind = true;
                  }
                }
              }

              if (bFind) {
                feature.color = Cesium.Color.AQUA;
              } else {
                feature.color = Cesium.Color.WHITE;
              }
            }
          }
        }

        tileset.makeStyleDirty(); //}
      }
    });
  } //开始绘制


  start() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._options.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      this.clear();
      this.findLayers();

      this._drawManager.startDraw("marker", {
        image: null
      });
    } else {
      message({
        message: "请添加模型后分析!",
        type: "warning"
      });
    }
  } // 开始查询


  startQuery() {
    this.createGeometry();

    this._gpuSpatialQuery.setGeom(this._geometry);

    this._gpuSpatialQuery.setSpaceTopology(this._options.positionMode);

    this._gpuSpatialQuery.setLayers(this._options.layers);

    this._gpuSpatialQuery.start();
  } //清除全部结果


  clear() {
    this._gpuSpatialQuery && this._gpuSpatialQuery.clear();
  } //销毁


  destroy() {
    this.clear(); // this._gpuSpatialQuery && this._gpuSpatialQuery.destroy();

    this._gpuSpatialQuery = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } // 查找所有3dtiles模型对象


  findLayers() {
    this._options.layers = [];
    const primitives = this._options.viewer.scene.primitives._primitives;

    for (let m = 0; m < primitives.length; m++) {
      if (primitives[m] instanceof Cesium.Cesium3DTileset) {
        this._options.layers.push(new Cesium.Kq3dLayerQuery(primitives[m]));
      }
    }
  } //创建查询体


  createGeometry() {
    switch (this._options.volumeType) {
      case 0:
        var options0 = {
          length: 260,
          width: 260,
          height: 260,
          position: this._center
        };
        this._geometry = new Cesium.Kq3dGeoBox(options0);
        break;

      case 1:
        var options1 = {
          position: this._center,
          radius: 160
        };
        this._geometry = new Cesium.Kq3dGeoSphere(options1);
        break;

      case 2:
        var options2 = {
          position: this._center,
          height: 300,
          topRadius: 130,
          bottomRadius: 130
        };
        this._geometry = new Cesium.Kq3dGeoCylinder(options2);
        break;

      case 3:
        var options3 = {
          position: this._center,
          xRadius: 200,
          yRadius: 120,
          zRadius: 160
        };
        this._geometry = new Cesium.Kq3dGeoEllipsoid(options3);
        break;

      case 4:
        var options4 = {
          position: this._center,
          height: 300,
          bottomRadius: 160
        };
        this._geometry = new Cesium.Kq3dGeoCone(options4);
        break;

      default:
        break;
    }

    if (this._geometry) {
      this._geometry.scaleX = this._options.scale;
      this._geometry.scaleY = this._options.scale;
      this._geometry.scaleZ = this._options.scale;
      this._geometry.rotationX = this._options.xAngle;
      this._geometry.rotationY = this._options.yAngle;
      this._geometry.rotationZ = this._options.zAngle;
    }
  } //查询体类型


  setType(type) {
    this._options.volumeType = type;
    this.createGeometry();

    if (this._gpuSpatialQuery) {
      this._gpuSpatialQuery.setGeom(this._geometry);

      this._gpuSpatialQuery.start();
    } //this.startQuery();

  } //查询体模式 相交  相离  包含


  setMode(mode) {
    this._options.positionMode = mode;

    if (this._gpuSpatialQuery) {
      this._gpuSpatialQuery.setSpaceTopology(mode);

      this._gpuSpatialQuery.start();
    } //this.startQuery();

  } //查询体缩放


  setScale(scale) {
    this._options.scale = scale;

    if (this._geometry) {
      this._geometry.scaleX = scale;
      this._geometry.scaleY = scale;
      this._geometry.scaleZ = scale;
      this._gpuSpatialQuery && this._gpuSpatialQuery.start();
    } //this.startQuery();

  } //查询体绕X轴旋转


  setXangle(xAngle) {
    this._options.xAngle = xAngle;

    if (this._geometry) {
      this._geometry.rotationX = xAngle;
      this._gpuSpatialQuery && this._gpuSpatialQuery.start();
    } //this.startQuery();

  } //查询体绕Y轴旋转


  setYangle(yAngle) {
    this._options.yAngle = yAngle;

    if (this._geometry) {
      this._geometry.rotationY = yAngle;
      this._gpuSpatialQuery && this._gpuSpatialQuery.start();
    } //this.startQuery();

  } //查询体绕Z轴旋转


  setZangle(zAngle) {
    this._options.zAngle = zAngle;

    if (this._geometry) {
      this._geometry.rotationZ = zAngle;
      this._gpuSpatialQuery && this._gpuSpatialQuery.start();
    } //this.startQuery();

  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/gpuspatialquery/GPUSpatialQuery.vue?vue&type=script&setup=true&lang=js

const GPUSpatialQueryvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-gpu-spatial-query-box"
};
const GPUSpatialQueryvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-gpu-spatial-query-footer"
};







const GPUSpatialQueryvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dGPUSpatialQuery"
};
/* harmony default export */ var GPUSpatialQueryvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(GPUSpatialQueryvue_type_script_setup_true_lang_js_default_, {
  props: {
    //图形
    volumeType: {
      type: Number,
      default: 0,

      validator(value) {
        // 输入值必须被包含
        return external_xe_utils_default().includeArrays([0, 1, 2, 3, 4], value);
      }

    },
    // 空间关系
    positionMode: {
      type: Number,
      default: 0,

      validator(value) {
        // 输入值必须被包含
        return external_xe_utils_default().includeArrays([0, 1, 2], value);
      }

    },
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: icons_vue_namespaceObject.Search
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      volumeType: props.volumeType || 0,
      // 查询体类型
      positionMode: props.positionMode || 0,
      // 空间关系
      scale: props.settingParams && props.settingParams.scale || 1,
      // 查询体缩放
      minScale: props.settingParams && props.settingParams.minScale || 0.1,
      // 查询体缩放最小值
      maxScale: props.settingParams && props.settingParams.maxScale || 10,
      // 查询体缩放最大值
      xRotate: props.settingParams && props.settingParams.xRotate || 0,
      // 绕X轴旋转
      minXRotate: props.settingParams && props.settingParams.minXRotate || 0,
      // 绕X轴旋转最小值
      maxXRotate: props.settingParams && props.settingParams.maxXRotate || 120,
      // 绕X轴旋转最大值
      yRotate: props.settingParams && props.settingParams.yRotate || 0,
      // 绕Y轴旋转
      minYRotate: props.settingParams && props.settingParams.minYRotate || 0,
      // 绕Y轴旋转最小值
      maxYRotate: props.settingParams && props.settingParams.maxYRotate || 90,
      // 绕Y轴旋转最大值
      zRotate: props.settingParams && props.settingParams.zRotate || 0,
      // 绕Z轴旋转
      minZRotate: props.settingParams && props.settingParams.minZRotate || 0,
      // 绕Z轴旋转最小值
      maxZRotate: props.settingParams && props.settingParams.maxZRotate || 90 // 绕Z轴旋转最大值

    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.spatialQuery;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new GPUSpatialQueryViewModel(scenceView, {
            volumeType: formItem.volumeType,
            positionMode: formItem.positionMode,
            scale: formItem.scale,
            xAngle: formItem.xRotate,
            yAngle: formItem.yRotate,
            zAngle: formItem.zRotate
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 参数切换


    function paramsChanged(key) {
      switch (key) {
        case "type":
          viewModel.setType(formItem.volumeType);
          break;

        case "mode":
          viewModel.setMode(formItem.positionMode);
          break;

        case "scale":
          viewModel.setScale(formItem.scale);
          break;

        case "xRotate":
          viewModel.setXangle(formItem.xRotate);
          break;

        case "yRotate":
          viewModel.setYangle(formItem.yRotate);
          break;

        case "zRotate":
          viewModel.setZangle(formItem.zRotate);
          break;

        default:
          break;
      }
    } // 查询


    function query() {
      viewModel && viewModel.start();
    } // 重置


    function reset() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      query,
      reset
    });
    return (_ctx, _cache) => {
      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-gpu-spatial-query", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", GPUSpatialQueryvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
        "label-width": "100px",
        "label-position": "left"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).queryShape
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
              modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).volumeType,
              "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).volumeType = $event),
              onChange: _cache[1] || (_cache[1] = $event => paramsChanged('type'))
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cube,
                value: 0
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).sphere,
                value: 1
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cylinder,
                value: 2
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).ellipsoid,
                value: 3
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cone,
                value: 4
              }, null, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["modelValue"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).locaLMode
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
              modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).positionMode,
              "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).positionMode = $event),
              onChange: _cache[3] || (_cache[3] = $event => paramsChanged('mode'))
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intersect,
                value: 0
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).disjoint,
                value: 1
              }, null, 8
              /* PROPS */
              , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contain,
                value: 2
              }, null, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["modelValue"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-gpu-spatial-query-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).queryTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-gpu-spatial-query-set-title"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "100px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zoom
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).scale,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).scale = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minScale,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxScale,
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('scale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).scale,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).scale = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minScale,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxScale,
                      step: 0.1,
                      "controls-position": "right",
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('scale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).xRotate
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xRotate,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xRotate = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minXRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxXRotate,
                      onInput: _cache[9] || (_cache[9] = $event => paramsChanged('xRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xRotate,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xRotate = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minXRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxXRotate,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('xRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).yRotate
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yRotate,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yRotate = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minXRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxXRotate,
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('yRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yRotate,
                      "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yRotate = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minXRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxXRotate,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[15] || (_cache[15] = $event => paramsChanged('yRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zRotate
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zRotate,
                      "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zRotate = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minZRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxZRotate,
                      onInput: _cache[17] || (_cache[17] = $event => paramsChanged('zRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zRotate,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zRotate = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minZRotate,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxZRotate,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[19] || (_cache[19] = $event => paramsChanged('zRotate'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", GPUSpatialQueryvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[20] || (_cache[20] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => query(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gpuQuery,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gpuQuery), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[21] || (_cache[21] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => reset(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/gpuspatialquery/GPUSpatialQuery.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/gpuspatialquery/GPUSpatialQuery.vue



const GPUSpatialQuery_exports_ = GPUSpatialQueryvue_type_script_setup_true_lang_js;

/* harmony default export */ var GPUSpatialQuery = (GPUSpatialQuery_exports_);
;// CONCATENATED MODULE: ./src/webgl/gpuspatialquery/index.js




GPUSpatialQuery.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(GPUSpatialQuery.name, GPUSpatialQuery);
};


;// CONCATENATED MODULE: ./src/webgl/modelselect/ModelSelectViewModel.js

//模型拾取逻辑类

class ModelSelectViewModel {
  //三维viewer对象
  //屏幕空间事件处理程序三维对象
  //拾取状态
  //高亮三维对象
  //高亮颜色
  // 模型属性唯一值字段集合
  // 模型属性匹配字段
  constructor(scenceView, pickCallFunc) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_handler", null);

    _defineProperty(this, "_isPick", false);

    _defineProperty(this, "_highlight", null);

    _defineProperty(this, "_highlightColor", "#FF0000");

    _defineProperty(this, "_modeFiledArray", null);

    _defineProperty(this, "_modeFiled", "id");

    this._viewer = scenceView._viewer;
    this._drawManager = scenceView._drawManager;
    this._handler = new Cesium.ScreenSpaceEventHandler(this._viewer.scene.canvas);
    let that = this;

    this._handler.setInputAction(function (movement) {
      if (that._isPick) {
        let pickedObject = that._viewer.scene.pick(movement.position); // console.log(pickedObject);


        if (pickedObject) {
          if (pickedObject instanceof Cesium.Cesium3DTileFeature) {
            let properties = pickedObject.getPropertyNames() || []; // console.log(properties);

            if (that._modeFiledArray && that._modeFiledArray.length && that._modeFiledArray.length > 0) {
              for (let val in that._modeFiledArray) {
                if (properties.indexOf(val) > -1) {
                  that._modeFiled = val;
                  break;
                }
              }
            }

            if (properties.indexOf(that._modeFiled) > -1) {
              let id = pickedObject.getProperty(that._modeFiled); // that.clear();

              that._highlight = new Cesium.Kq3dHighlight({
                viewer: that._viewer,
                tileset: pickedObject.tileset,
                attrName: that._modeFiled,
                attrValue: [id],
                color: [Cesium.Color.fromCssColorString(that._highlightColor)]
              });
              let attrs = {};
              properties.forEach(prop => {
                attrs[prop] = pickedObject.getProperty(prop);
              });
              pickCallFunc && pickCallFunc(pickedObject.tileset.name || "LayerName", attrs);
            } else {
              console.log("Feature has no id attribute!");
            }
          } else {
            console.log("no Cesium3DTileFeature!");
          }
        }
      }
    }, Cesium.ScreenSpaceEventType.LEFT_CLICK);
  }

  setCursor(style) {
    this._viewer.canvas.style.cursor = style;
  } //拾取


  pick() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      this.setCursor("crosshair");
      this._isPick = true;
    } else {
      message({
        message: "请添加模型后拾取!",
        type: "warning"
      });
    }
  } //清除


  clear() {
    this._highlight && this._highlight.remove();
    this._highlight = null;
    this.setCursor("default");
    this._isPick = false;
  } //销毁


  destroy() {
    this.clear();
    this._handler && this._handler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/modelselect/ModelSelect.vue?vue&type=script&setup=true&lang=js

const ModelSelectvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "title"
};
const ModelSelectvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "footer-buttons"
};





 // tree数据源

const ModelSelectvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dModelSelect"
};
/* harmony default export */ var ModelSelectvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ModelSelectvue_type_script_setup_true_lang_js_default_, {
  props: {
    //指定组件绑定的viewer对象的div的id
    mapTarget: String,
    // 外部字段别名映射
    aliasNameReflection: {
      type: Function
    },
    // 高亮颜色
    highlightColor: {
      type: String,
      default: "#FF0000"
    },
    // 模型属性唯一值字段集合
    modeFiledArray: {
      type: Array,
      default: () => {
        return null;
      }
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconModelSelect
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let layerNameTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 属性值

    let tableData = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); //语言

    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    let ref_box = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 获取组件传参
    // 表格头样式

    let headClass = args => {
      return {
        "background-color": "var(--kq-fill-color-light)",
        color: "var(--kq-color-info)",
        "font-size": "14px"
      };
    }; // 组件容器Ref


    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.modelPick;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      }); //父组件ScenceView初始化完成后执行

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new ModelSelectViewModel(scenceView, pickCallFunc);
          viewModel._highlightColor = props.highlightColor;
          viewModel._modeFiledArray = props.modeFiledArray;
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    };

    function pick() {
      viewModel && viewModel.pick();
    }

    function pickCallFunc(layerName, properties) {
      layerNameTitle.value = layerName;
      let propertiesData = [];

      if (props.aliasNameReflection) {
        let arrKeys = [];

        for (let key in properties) {
          arrKeys.push(key);
        }

        props.aliasNameReflection(arrKeys, item => {
          // console.log(item);
          for (let key in properties) {
            propertiesData.push({
              field: item[key] ? item[key] : key,
              value: properties[key]
            });
          }
        });
      } else {
        for (let key in properties) {
          propertiesData.push({
            field: key,
            value: properties[key]
          });
        }
      }

      tableData.value = propertiesData;
    }

    function clear() {
      layerNameTitle.value = "";
      tableData.value = [];
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      pick,
      clear,
      pickCallFunc
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_table_column = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table-column");

      const _component_kq_table = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-model-select", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
        class: "kq3d-model-select-box",
        ref_key: "ref_box",
        ref: ref_box
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ModelSelectvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).modelLayerName) + " : ", 1
        /* TEXT */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(layerNameTitle)), 1
        /* TEXT */
        )])]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "modelTable",
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)(__props.showHeaderTemp ? 'height: calc(100% - 70px)' : 'height: calc(100% - 35px)')
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table, {
          border: "",
          stripe: "",
          data: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tableData),
          style: {
            "width": "100%",
            "height": "100%"
          },
          "cell-style": {
            padding: '8px 0'
          },
          "header-cell-style": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headClass)
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fieldName,
            prop: "field",
            align: "center"
          }, null, 8
          /* PROPS */
          , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fieldValue,
            prop: "value",
            align: "center"
          }, null, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["data", "header-cell-style"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["style"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ModelSelectvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[0] || (_cache[0] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => pick(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pick,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pick), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[1] || (_cache[1] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clear(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])], 512
      /* NEED_PATCH */
      )], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/modelselect/ModelSelect.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/modelselect/ModelSelect.vue



const ModelSelect_exports_ = ModelSelectvue_type_script_setup_true_lang_js;

/* harmony default export */ var ModelSelect = (ModelSelect_exports_);
;// CONCATENATED MODULE: ./src/webgl/modelselect/index.js




ModelSelect.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ModelSelect.name, ModelSelect);
};


// EXTERNAL MODULE: ./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js
var injectStylesIntoStyleTag = __webpack_require__(379);
var injectStylesIntoStyleTag_default = /*#__PURE__*/__webpack_require__.n(injectStylesIntoStyleTag);
// EXTERNAL MODULE: ./node_modules/css-loader/dist/cjs.js!./node_modules/sass-loader/dist/cjs.js!./src/webgl/sightlineanalysis/style/divpoint.scss
var divpoint = __webpack_require__(868);
;// CONCATENATED MODULE: ./src/webgl/sightlineanalysis/style/divpoint.scss

            

var options = {};

options.insert = "head";
options.singleton = false;

var update = injectStylesIntoStyleTag_default()(divpoint/* default */.Z, options);



/* harmony default export */ var style_divpoint = (divpoint/* default.locals */.Z.locals || {});
;// CONCATENATED MODULE: ./src/webgl/sightlineanalysis/SightlineAnalysisViewModel.js



 //通视分析逻辑类

class SightlineAnalysisViewModel {
  //三维viewer对象
  //通视分析三维对象
  //绘制管理对象
  //绘制完成监听事件
  //障碍物颜色
  //是否显示标注
  //添加的点的类型
  //创建的divpoint集合
  //拾取的点位集合
  //高亮的障碍物的id集合
  // 点位图标billboards集合
  constructor(scenceView, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_sightlineAnalysis", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    _defineProperty(this, "_obstacleColor", Cesium.Color.RED);

    _defineProperty(this, "_isLabel", false);

    _defineProperty(this, "_addType", 0);

    _defineProperty(this, "_pointCollection", []);

    _defineProperty(this, "_cartographicList", []);

    _defineProperty(this, "_highlightIds", []);

    _defineProperty(this, "_billboards", []);

    this._viewer = scenceView._viewer;
    this._viewer.scene.postProcessStages._fxaa.enabled = true;
    this._viewer.scene.globe.depthTestAgainstTerrain = true; //开启深度检测

    options.viewer = this._viewer;

    if (options.visibleColor) {
      options.visibleColor = Cesium.Color.fromCssColorString(options.visibleColor);
    }

    if (options.visibleColor) {
      options.invisibleColor = Cesium.Color.fromCssColorString(options.invisibleColor);
    }

    if (options.obstacleColor) {
      this._obstacleColor = Cesium.Color.fromCssColorString(options.obstacleColor);
    }

    this._isLabel = options.isLabel;
    options.isLabel = false;
    this._sightlineAnalysis = new Cesium.Kq3dSightAnalysis(options);
    this._drawManager = scenceView._drawManager;

    this._drawManager.enableMultiDraw(true);

    let that = this;
    this._removeEventListener = this._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape && shape.type === "marker") {
        that.createBillboard(shape.position);

        if (that._addType === 1) {
          that._sightlineAnalysis.setSeePoint(shape.position);

          that.clearDisplay();
          that.createLabels(that._sightlineAnalysis._pickedPos);
          that.highlightObstacles(that._sightlineAnalysis._pickedFeatures);
        } else if (that._addType === 2) {
          let result = that._sightlineAnalysis.addTargetPoint(shape.position);

          that.createLabels(result.cartographic);
          that.highlightObstacles(result.id);
        }

        that._drawManager.clear();
      }
    });
  } // 创建图标


  createBillboard(pos) {
    if (this._addType == 1) this.clearBillboards("marker" + this._addType);

    this._billboards.push(this._viewer.entities.add({
      position: pos,
      name: "marker" + this._addType,
      billboard: {
        image: this._addType === 1 ? const_image_namespaceObject.OBSERVATION_POINT : const_image_namespaceObject.TARGET_POINT,
        verticalOrigin: Cesium.VerticalOrigin.BOTTOM,
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      }
    }));
  } //创建点位置


  createDivPoint(position) {
    if (position) {
      var longitude = Cesium.Math.toDegrees(position.longitude).toFixed(5);
      var latitude = Cesium.Math.toDegrees(position.latitude).toFixed(5);
      var height = position.height.toFixed(3);
      position = Cesium.Cartesian3.fromRadians(position.longitude, position.latitude, position.height);
      var html = `<div class="coord">
                    <table>
                        <tr>
                            <td>X:</td>
                            <td>{X}</td>
                        </tr>
                        <tr>
                            <td>Y:</td>
                            <td>{Y}</td>
                        </tr>
                        <tr>
                            <td>Z:</td>
                            <td>{Z}</td>
                        </tr>
                    </table>
                    <span class="triangle"></span>
                </div>`;
      html = html.replace('{X}', longitude).replace('{Y}', latitude).replace('{Z}', height);
      var divpoint = new Cesium.Kq3dHtmlTag(this._viewer, {
        html: html,
        position: position,
        anchor: [-50, -95],
        noEvent: true
      });

      if (!this._isLabel) {
        divpoint.setVisible(false);
      }

      this._pointCollection.push(divpoint);
    }
  } //创建label标签


  createLabels(positions) {
    for (let i = 0; i < positions.length; i++) {
      let include = this._cartographicList.some(item => {
        if (item.longitude === positions[i].longitude && item.latitude === positions[i].latitude && item.height === positions[i].height) {
          return true;
        }
      });

      if (!include) {
        this.createDivPoint(positions[i]);
      }
    }

    this._cartographicList = [].concat(positions);
  } //设置3DTileset颜色


  set3DTilesetColor(color, ids) {
    if (!ids) ids = [];
    let primitives = this._viewer.scene.primitives._primitives;

    for (let i = 0; i < primitives.length; i++) {
      if (primitives[i] instanceof Cesium.Cesium3DTileset) {
        primitives[i].style = new Cesium.Cesium3DTileStyle({
          color: {
            evaluateColor: function (feature, result) {
              if (feature && feature.pickId && ids.includes(feature.pickId.key)) Cesium.Color.clone(color, result);else Cesium.Color.clone(Cesium.Color.WHITE, result);
              return result;
            }
          }
        });
      }
    }
  } //高亮障碍物


  highlightObstacles(ids) {
    if (!ids || ids.length === 0) return;
    this._highlightIds = ids;
    this.set3DTilesetColor(this._obstacleColor, ids);
  } //清除所有高亮效果


  clearHighlights() {
    this._highlightIds = [];
    this.set3DTilesetColor(Cesium.Color.WHITE);
  } //添加观察点


  addSeePoint() {
    this._addType = 1;

    this._drawManager.startDraw("point", {
      image: const_image_namespaceObject.OBSERVATION_POINT
    });
  } //添加目标点


  addTargetPoint() {
    if (!this._sightlineAnalysis._seePoint) return;
    this._addType = 2;

    this._drawManager.startDraw("point", {
      image: const_image_namespaceObject.TARGET_POINT
    });
  } //清除显示结果


  clearDisplay() {
    //清除标注
    for (var i = 0; i < this._pointCollection.length; i++) {
      this._pointCollection[i].destroy();
    }

    this._pointCollection = [];
  } // 清楚billboards


  clearBillboards(val) {
    for (var i = 0; i < this._billboards.length; i++) {
      if (val) {
        if (this._billboards[i].name == val) this._viewer.entities.remove(this._billboards[i]);
      } else {
        this._viewer.entities.remove(this._billboards[i]);
      }
    }

    if (!val) this._billboards = [];
  } //清除全部


  clearAll() {
    this._drawManager.stopDraw();

    this.clearDisplay();
    this.clearHighlights();
    this.clearBillboards();
    this._sightlineAnalysis && this._sightlineAnalysis.remove();
  } //销毁


  destroy() {
    this.clearAll(); //销毁分析对象

    this._sightlineAnalysis && this._sightlineAnalysis.destroy();
    this._sightlineAnalysis = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;

    this._drawManager.enableMultiDraw(false);
  } // //设置线宽
  // setLineWidth(lineWith) {
  //   this._sightlineAnalysis.lineWith = Number(lineWith);
  // }
  //设置可视颜色


  setVisibleColor(visibleColor) {
    this._sightlineAnalysis.visibleColor = Cesium.Color.fromCssColorString(visibleColor);
  } //设置不可视颜色


  setInvisibleColor(invisibleColor) {
    this._sightlineAnalysis.invisibleColor = Cesium.Color.fromCssColorString(invisibleColor);
  } //设置障碍物颜色


  setObstacleColor(obstacleColor) {
    this._obstacleColor = Cesium.Color.fromCssColorString(obstacleColor);

    if (this._highlightIds.length > 0) {
      this.set3DTilesetColor(this._obstacleColor, this._highlightIds);
    }
  } //显示/隐藏标注


  setShowLabel(isLabel) {
    this._isLabel = isLabel;

    for (var i = 0; i < this._pointCollection.length; i++) {
      this._pointCollection[i].setVisible(isLabel);
    }
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/sightlineanalysis/SightlineAnalysis.vue?vue&type=script&setup=true&lang=js

const SightlineAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-sightline-analysis-box"
};
const SightlineAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-sightline-analysis-footer"
};






const SightlineAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dSightlineAnalysis"
};
/* harmony default export */ var SightlineAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(SightlineAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconSightlineAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      // lineWidth: (props.settingParams && props.settingParams.lineWidth) || 2,
      visibleColor: props.settingParams && props.settingParams.visibleColor || "#67c23a",
      invisibleColor: props.settingParams && props.settingParams.invisibleColor || "#e6a23c",
      obstacleColor: props.settingParams && props.settingParams.obstacleColor || "#F56C6C",
      obstaclePoint: props.settingParams && props.settingParams.obstaclePoint !== undefined || false,
      highlightObstacle: props.settingParams && props.settingParams.highlightObstacle !== undefined || false,
      isLabel: props.settingParams && props.settingParams.isLabel !== undefined || true
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.sightlineAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      }); //父组件ScenceView初始化完成后执行

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            lineWidth: formItem.lineWidth,
            visibleColor: formItem.visibleColor,
            invisibleColor: formItem.invisibleColor,
            obstacleColor: formItem.obstacleColor,
            isLabel: formItem.isLabel
          };
          viewModel = new SightlineAnalysisViewModel(scenceView, options);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    };

    function paramsChanged(key) {
      switch (key) {
        // case "lineWidth":
        //   viewModel.setLineWidth(formItem.lineWidth);
        //   break;
        case "visibleColor":
          viewModel.setVisibleColor(formItem.visibleColor);
          break;

        case "invisibleColor":
          viewModel.setInvisibleColor(formItem.invisibleColor);
          break;

        case "obstacleColor":
          viewModel.setObstacleColor(formItem.obstacleColor);
          break;

        case "isLabel":
          viewModel.setShowLabel(formItem.isLabel);
          break;

        default:
          break;
      }
    } //添加观察点


    function addSeePoint() {
      viewModel && viewModel.addSeePoint();
    } //添加目标点


    function addTargetPoint() {
      viewModel && viewModel.addTargetPoint();
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clearAll();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      addSeePoint,
      addTargetPoint,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-sightline-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SightlineAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-sightline-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).sightTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "120px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row>\r\n            <kq-form-item :label=\"language.lineWidth\">\r\n              <kq-row style=\"display: flex\">\r\n                <kq-col :span=\"16\">\r\n                  <kq-slider v-model=\"formItem.lineWidth\" :min=\"1\" :max=\"10\" @input=\"paramsChanged('lineWidth')\"></kq-slider>\r\n                </kq-col>\r\n                <kq-col :span=\"8\">\r\n                  <kq-input-number v-model=\"formItem.lineWidth\" :min=\"1\" :max=\"10\" controls-position=\"right\" @input=\"paramsChanged('lineWidth')\">\r\n                  </kq-input-number>\r\n                </kq-col>\r\n              </kq-row>\r\n            </kq-form-item>\r\n          </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).visibleColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).visibleColor,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).visibleColor = $event),
                  onChange: _cache[1] || (_cache[1] = $event => paramsChanged('visibleColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).invisibleColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).invisibleColor,
                  "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).invisibleColor = $event),
                  onChange: _cache[3] || (_cache[3] = $event => paramsChanged('invisibleColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).obstacleColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).obstacleColor,
                  "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).obstacleColor = $event),
                  onChange: _cache[5] || (_cache[5] = $event => paramsChanged('obstacleColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row style=\"display: flex\">\r\n            <kq-col :span=\"12\">\r\n              <kq-checkbox v-model=\"formItem.obstaclePoint\">{{ language.obstaclePoint }}</kq-checkbox>\r\n            </kq-col>\r\n            <kq-col :span=\"12\">\r\n              <kq-checkbox v-model=\"formItem.highlightObstacle\">{{ language.highlightObstacle }}</kq-checkbox>\r\n            </kq-col>\r\n          </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).isLabel,
                "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).isLabel = $event),
                onChange: _cache[7] || (_cache[7] = $event => paramsChanged('isLabel'))
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).showLabel), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SightlineAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)(addSeePoint, ["stop"]),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).seePoint,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).seePoint), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["onClick", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)(addTargetPoint, ["stop"]),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).targetPoint,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).targetPoint), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["onClick", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)(clearResult, ["stop"]),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["onClick", "title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/sightlineanalysis/SightlineAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/sightlineanalysis/SightlineAnalysis.vue



const SightlineAnalysis_exports_ = SightlineAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var SightlineAnalysis = (SightlineAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/sightlineanalysis/index.js




SightlineAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(SightlineAnalysis.name, SightlineAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/viewshedanalysis/ViewshedAnalysisViewModel.js

 //可视域分析逻辑类

class ViewshedAnalysisViewModel {
  //可视域分析三维对象
  //三维场景对象
  //可视域分析存储参数对象
  //可视域分析初始点图标
  //可视域分析初始点坐标
  constructor(scenceView, options) {
    _defineProperty(this, "_viewshedAnalysis", null);

    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_scene", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_marker", null);

    _defineProperty(this, "_position", null);

    this._viewer = scenceView._viewer;
    this._scene = scenceView._viewer.scene;
    this._scene.globe.depthTestAgainstTerrain = true;
    this._options = options;

    if (this._options.visibleColor) {
      this._options.visibleColor = Cesium.Color.fromCssColorString(this._options.visibleColor);
    }

    if (this._options.visibleColor) {
      this._options.invisibleColor = Cesium.Color.fromCssColorString(this._options.invisibleColor);
    }
  } //开始分析


  start() {
    this.clear();
    this._viewshedAnalysis = new Cesium.Kq3dViewshedInteractive(this._scene, this._options);
    let that = this;

    this._viewshedAnalysis.event.addEventListener((p1, p2) => {
      if (p1 && p2 == undefined) {
        that._position = p1;
        let cartographic = Cesium.Cartographic.fromCartesian(p1);
        let newPos = Cesium.Cartesian3.fromRadians(cartographic.longitude, cartographic.latitude, cartographic.height + that._options.offsetHeight);

        if (that._marker) {
          that._marker.position = newPos;
        } else {
          that._marker = that._viewer.entities.add({
            position: newPos,
            billboard: {
              image: const_image_namespaceObject.OBSERVATION_POINT,
              verticalOrigin: Cesium.VerticalOrigin.CENTER,
              disableDepthTestDistance: Number.POSITIVE_INFINITY
            }
          });
        }
      }
    });

    this._viewshedAnalysis.start(); // if (!this._viewshedAnalysis.isRunning()) {
    //   // 绘制完成后，需要释放绘制事件
    // }

  } //清除全部结果


  clear() {
    // this._viewshedAnalysis && this._viewshedAnalysis.pause();
    this.destroy();
  } //销毁


  destroy() {
    this._viewshedAnalysis && this._viewshedAnalysis.destroy();
    this._viewshedAnalysis = null;

    if (this._marker) {
      this._viewer.entities.remove(this._marker);

      this._marker = null;
    }
  } //设置偏移高度


  setOffsetHeight(offsetHeight) {
    this._options.offsetHeight = Number(offsetHeight);
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.offsetHeight = this._options.offsetHeight;

    if (this._marker) {
      let cartographic = Cesium.Cartographic.fromCartesian(this._position);
      this._marker.position = Cesium.Cartesian3.fromRadians(cartographic.longitude, cartographic.latitude, cartographic.height + this._options.offsetHeight);
    }
  } //设置水平角


  setFovH(fovH) {
    this._options.fovH = Number(fovH);
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.fovH = this._options.fovH;
  } //设置竖直角


  setFovV(fovV) {
    this._options.fovV = Number(fovV);
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.fovV = this._options.fovV;
  } //设置可视颜色


  setVisibleColor(visibleColor) {
    this._options.visibleColor = Cesium.Color.fromCssColorString(visibleColor);
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.visibleColor = this._options.visibleColor;
  } //设置不可视颜色


  setInvisibleColor(invisibleColor) {
    this._options.invisibleColor = Cesium.Color.fromCssColorString(invisibleColor);
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.invisibleColor = this._options.invisibleColor;
  } //设置网格线颜色


  setLineColor(lineColor) {
    this._options.lineColor = lineColor;
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.lineColor = Cesium.Color.fromCssColorString(lineColor);
  } //显示/隐藏网格线


  setShowGridLine(showGridLine) {
    this._options.showGridLine = showGridLine;
    if (this._viewshedAnalysis) this._viewshedAnalysis.attachedViewshed.showGridLine = showGridLine;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/viewshedanalysis/ViewshedAnalysis.vue?vue&type=script&setup=true&lang=js

const ViewshedAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-viewshed-analysis-box"
};
const ViewshedAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-viewshed-analysis-footer"
};






const ViewshedAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dViewshedAnalysis"
};
/* harmony default export */ var ViewshedAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ViewshedAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconViewshedAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      offsetHeight: props.settingParams && props.settingParams.offsetHeight || 1.8,
      // 视点高
      minOffsetHeight: props.settingParams && props.settingParams.minOffsetHeight || 0,
      // 视点高范围最小值
      maxOffsetHeight: props.settingParams && props.settingParams.maxOffsetHeight || 100,
      // 视点高范围最大值
      fovV: props.settingParams && props.settingParams.fovV || 60,
      // 垂直张角
      minFovV: props.settingParams && props.settingParams.minFovV || 0,
      // 垂直张角范围最小值
      maxFovV: props.settingParams && props.settingParams.maxFovV || 90,
      // 垂直张角范围最大值
      fovH: props.settingParams && props.settingParams.fovH || 120,
      // 水平张角范围
      minFovH: props.settingParams && props.settingParams.minFovH || 0,
      // 水平张角范围最小值
      maxFovH: props.settingParams && props.settingParams.maxFovH || 180,
      // 水平张角范围最大值
      visibleColor: props.settingParams && props.settingParams.visibleColor || "#409EFF",
      // 可见颜色
      invisibleColor: props.settingParams && props.settingParams.invisibleColor || "#F56C6C",
      // 不可见颜色
      lineColor: props.settingParams && props.settingParams.lineColor || "#E6A23C"
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.viewshedAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言类型

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new ViewshedAnalysisViewModel(scenceView, {
            offsetHeight: formItem.offsetHeight,
            fovV: formItem.fovV,
            fovH: formItem.fovH,
            visibleColor: formItem.visibleColor,
            invisibleColor: formItem.invisibleColor,
            lineColor: "#E6A23C"
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    };

    function paramsChanged(key) {
      switch (key) {
        case "height":
          viewModel.setOffsetHeight(formItem.offsetHeight);
          break;

        case "fovV":
          viewModel.setFovV(formItem.fovV);
          break;

        case "fovH":
          viewModel.setFovH(formItem.fovH);
          break;

        case "visibleColor":
          viewModel.setVisibleColor(formItem.visibleColor);
          break;

        case "invisibleColor":
          viewModel.setInvisibleColor(formItem.invisibleColor);
          break;

        case "lineColor":
          viewModel.setLineColor(formItem.lineColor);
          break;

        default:
          break;
      }
    } //开始分析


    function startAnalysis() {
      viewModel && viewModel.start();
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      startAnalysis,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-viewshed-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ViewshedAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-viewshed-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).viewshedTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '90px' : '140px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).offsetHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).offsetHeight,
                      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).offsetHeight = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minOffsetHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxOffsetHeight,
                      onInput: _cache[1] || (_cache[1] = $event => paramsChanged('height'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).offsetHeight,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).offsetHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minOffsetHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxOffsetHeight,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[3] || (_cache[3] = $event => paramsChanged('height'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).FovV
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovV,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovV = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFovV,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFovV,
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('fovV'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovV,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovV = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFovV,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFovV,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('fovV'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).FovH
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovH,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovH = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFovH,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFovH,
                      onInput: _cache[9] || (_cache[9] = $event => paramsChanged('fovH'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovH,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fovH = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFovH,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFovH,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('fovH'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).visibleColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).visibleColor,
                  "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).visibleColor = $event),
                  onChange: _cache[13] || (_cache[13] = $event => paramsChanged('visibleColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).invisibleColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).invisibleColor,
                  "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).invisibleColor = $event),
                  onChange: _cache[15] || (_cache[15] = $event => paramsChanged('invisibleColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row>\r\n            <kq-form-item :label=\"language.lineColor\">\r\n              <kq-color-picker v-model=\"formItem.lineColor\" @change=\"paramsChanged('lineColor')\"> </kq-color-picker>\r\n            </kq-form-item>\r\n          </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("<kq-row :gutter=\"20\">\r\n            <kq-col :span=\"8\">\r\n              <kq-checkbox v-model=\"formItem.showVisible\">{{ language.showVisible }}</kq-checkbox>\r\n            </kq-col>\r\n            <kq-col :span=\"8\">\r\n              <kq-checkbox v-model=\"formItem.showInvisible\">{{ language.showInvisible }}</kq-checkbox>\r\n            </kq-col>\r\n            <kq-col :span=\"8\">\r\n              <kq-checkbox v-model=\"formItem.dynamicVisual\">{{ language.dynamicVisual }}</kq-checkbox>\r\n            </kq-col>\r\n          </kq-row> ")]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ViewshedAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[16] || (_cache[16] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[17] || (_cache[17] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/viewshedanalysis/ViewshedAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/viewshedanalysis/ViewshedAnalysis.vue



const ViewshedAnalysis_exports_ = ViewshedAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var ViewshedAnalysis = (ViewshedAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/viewshedanalysis/index.js




ViewshedAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ViewshedAnalysis.name, ViewshedAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/shadowanalysis/ShadowAnalysisViewModel.js

// 分析逻辑类

class ShadowAnalysisViewModel {
  //阴影分析三维对象
  constructor(scenceView, viewModel) {
    _defineProperty(this, "_shadowAnalysis", null);

    _defineProperty(this, "_globaOptions", {
      //全局参数
      viewer: null,
      _drawManager: null
    });

    this._globaOptions.viewer = scenceView._viewer;
    this._globaOptions.viewModel = {
      viewer: this._globaOptions.viewer,
      type: "cube",
      showAnimate: true,
      baseHeight: viewModel.baseHeight,
      extrudeHeight: viewModel.extrudeHeight,
      width: viewModel.width,
      spacing: viewModel.spacing,
      currentDate: new Date(viewModel.currentDate),
      startTime: viewModel.startTime,
      endTime: viewModel.endTime,
      timeSpacing: viewModel.timeSpacing,
      showCurrent: false,
      alpha: true,
      filterValue: viewModel.filterValue,
      alphaScale: viewModel.alphaScale
    };
    this._globaOptions.viewer.shadows = true;
    this._globaOptions.viewer.shouldAnimate = true;
    this._globaOptions.viewer.scene.globe.enableLighting = true;
    this._globaOptions.viewer.scene.globe.depthTestAgainstTerrain = true;
    this._globaOptions.viewer.scene.postProcessStages.fxaa.enabled = true;
    this._globaOptions.viewer.shadowMap.darkness = 0.8;
    this._globaOptions.viewer.shadowMap.maxmimumDistance = 10000.0;
    this._globaOptions._drawManager = scenceView._drawManager;
    var that = this;
    this._globaOptions._drawFinishedEventListener = this._globaOptions._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._globaOptions.viewModel.positions = shape._controlPoints; // 实例化分析对象

        that.setKq3dShadowAnalyse();

        that._globaOptions._drawManager.clear();
      }
    });
  } // 处理绘制坐标，转成二维坐标


  coordinateTransform(points) {
    let cutPoints = points.map(function (point) {
      let cartesPh = Cesium.Cartographic.fromCartesian(point);
      cartesPh.longitude = cartesPh.longitude / Math.PI * 180;
      cartesPh.latitude = cartesPh.latitude / Math.PI * 180;
      let map = {
        longitude: cartesPh.longitude,
        latitude: cartesPh.latitude,
        height: cartesPh.height
      };
      return map;
    });
    return cutPoints;
  } // 开始分析


  start() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._globaOptions.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      if (this._globaOptions._drawManager) this._globaOptions._drawManager.startDraw("polygon", {
        clampToGround: true
      });
    } else {
      message({
        message: "请添加模型后分析!",
        type: "warning"
      });
    }
  } // 阴影分析


  setKq3dShadowAnalyse() {
    this._shadowAnalysis = new window.Cesium.Kq3dShadowAnalyse(this._globaOptions.viewModel); //this._globaOptions.viewer.scene.primitives.add(this._shadowAnalysis);
  } // 分析日期


  setCurrentDate(newValue) {
    this._globaOptions.viewModel.currentDate = new Date(newValue);
    if (this._shadowAnalysis) this._shadowAnalysis.currentDate = new Date(newValue);
  } //设置时间


  setTime(newValue) {
    if (newValue && newValue.length && newValue.length > 1) {
      if (this._globaOptions.viewModel.startTime == newValue[0] && this._globaOptions.viewModel.endTime == newValue[1]) return;
      this._globaOptions.viewModel.startTime = newValue[0];
      this._globaOptions.viewModel.endTime = newValue[1];

      if (this._shadowAnalysis) {
        this._shadowAnalysis.startTime = Number(this._globaOptions.viewModel.startTime);
        this._shadowAnalysis.endTime = Number(this._globaOptions.viewModel.endTime);
      }
    }
  } // 开始时刻


  setStartTime(newValue) {
    if (this._globaOptions.viewModel.startTime == newValue) return;
    this._globaOptions.viewModel.startTime = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.startTime = Number(newValue);
  } // 结束时刻


  setEndTime(newValue) {
    if (this._globaOptions.viewModel.endTime == newValue) return;
    this._globaOptions.viewModel.endTime = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.endTime = Number(newValue);
  } // 分析间隔


  setTimeSpacing(newValue) {
    if (this._globaOptions.viewModel.timeSpacing == newValue) return;
    this._globaOptions.viewModel.timeSpacing = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.timeSpacing = Number(newValue);
  } // 基底高度


  setBaseHeight(newValue) {
    if (this._globaOptions.viewModel.baseHeight == newValue) return;
    this._globaOptions.viewModel.baseHeight = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.baseHeight = Number(newValue);
  } // 拉伸高度


  setExtrudeHeight(newValue) {
    if (this._globaOptions.viewModel.extrudeHeight == newValue) return;
    this._globaOptions.viewModel.extrudeHeight = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.extrudeHeight = Number(newValue);
  } // 是否显示体素


  setShowVoxel(checked) {
    if (this._shadowAnalysis) this._shadowAnalysis.voxel.show = checked;
  } // 体素大小


  setRadius(newValue) {
    if (this._globaOptions.viewModel.width == newValue) return;
    this._globaOptions.viewModel.width = newValue;

    if (this._shadowAnalysis) {
      this.clear();
      this.setKq3dShadowAnalyse();
    }
  } // 体素间距


  setSpacing(newValue) {
    if (this._globaOptions.viewModel.spacing == newValue) return;
    this._globaOptions.viewModel.spacing = newValue;

    if (this._shadowAnalysis) {
      this.clear();
      this.setKq3dShadowAnalyse();
    }
  } // 阴影率过滤


  setFilterValue(newValue) {
    this._globaOptions.viewModel.filterValue = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.filterValue = Number(newValue);
  } // 透明缩放


  setAlphaScale(newValue) {
    this._globaOptions.viewModel.alphaScale = newValue;
    if (this._shadowAnalysis) this._shadowAnalysis.alphaScale = Number(newValue);
  } //日照效果


  sunshineEffect() {
    let timeNumber = new Date(this._globaOptions.viewModel.currentDate.toLocaleDateString()).getTime();
    let startTimeNumber = timeNumber + this._globaOptions.viewModel.startTime * 3600 * 1000;
    let endTimeNumber = timeNumber + this._globaOptions.viewModel.endTime * 3600 * 1000;
    let startTime = new Date(startTimeNumber);
    let endTime = new Date(endTimeNumber);
    let clock = this._globaOptions.viewer.clock;
    clock.startTime = Cesium.JulianDate.fromDate(startTime);
    clock.stopTime = Cesium.JulianDate.fromDate(endTime);
    clock.currentTime = Cesium.JulianDate.fromDate(startTime);
    clock.multiplier = 7200;
    clock.clockRange = Cesium.ClockRange.CLAMPED;
    clock.shouldAnimate = true;
  } // 清除全部结果


  clear() {
    this._globaOptions._drawManager && this._globaOptions._drawManager.stopDraw();

    if (this._shadowAnalysis) {
      this._globaOptions.viewer.scene.primitives.remove(this._shadowAnalysis);

      this._shadowAnalysis = null;
    }

    this._globaOptions.viewModel.showCurrent = false;
  } // 销毁


  destroy() {
    this.clear();
    this._globaOptions.viewer.shadows = false;
    this._globaOptions.viewer.shouldAnimate = false;
    this._globaOptions.viewer.scene.globe.enableLighting = false; //移除监听事件

    this._globaOptions._drawFinishedEventListener && this._globaOptions._drawFinishedEventListener();
    this._globaOptions._drawFinishedEventListener = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/shadowanalysis/ShadowAnalysis.vue?vue&type=script&setup=true&lang=js

const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-shadow-analysis-box"
};
const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-shadow-analysis-span"
};
const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-shadow-analysis-span"
};

const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, "0.0", -1
/* HOISTED */
);

const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_5 = ["src"];

const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_6 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", null, "1.0", -1
/* HOISTED */
);

const ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_7 = {
  class: "kq3d-shadow-analysis-footer"
};







const ShadowAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dShadowAnalysis"
};
/* harmony default export */ var ShadowAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ShadowAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconShadowAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let time = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([6, 12]); //计算属性

    const timeMarks = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.computed)(() => {
      let marks = {};

      for (let i = 0; i <= 24; i++) {
        if (i % 6 === 0) {
          // 几个特殊的，显示数字
          marks[i] = {
            style: {
              color: "#ccc"
            },
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.h)("div", {}, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.h)("span", "|"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.h)("span", i + ":00")])
          };
        } else if (i % 2 === 0) {
          marks[i] = {
            style: {
              color: "#ccc"
            },
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.h)("div", {}, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.h)("span", {
              class: "spanLine"
            })])
          };
        }
      }

      return marks;
    }); // 获取组件传参
    // 分析类

    let viewModel = null;
    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      showVoxel: props.settingParams && props.settingParams.showBuilding !== undefined || true,
      // 显示体素
      baseHeight: props.settingParams && props.settingParams.baseHeight || 0,
      // 基地高度
      minBaseHeight: props.settingParams && props.settingParams.minBaseHeight || 0,
      // 基地高度范围最小值
      maxBaseHeight: props.settingParams && props.settingParams.maxBaseHeight || 100,
      // 基地高度范围最大值
      extrudeHeight: props.settingParams && props.settingParams.extrudeHeight || 150,
      // 拉伸高度
      minExtrudeHeight: props.settingParams && props.settingParams.minExtrudeHeight || 0,
      // 拉伸高度范围最小值
      maxExtrudeHeight: props.settingParams && props.settingParams.maxExtrudeHeight || 500,
      // 拉伸高度范围最大值
      width: props.settingParams && props.settingParams.width || 6,
      // 体素大小
      minWidth: props.settingParams && props.settingParams.minWidth || 0,
      // 体素大小范围最小值
      maxWidth: props.settingParams && props.settingParams.maxWidth || 100,
      // 体素大小范围最大值
      spacing: props.settingParams && props.settingParams.spacing || 0.8,
      // 体素间距
      minSpacing: props.settingParams && props.settingParams.minSpacing || 0,
      // 体素间距范围最小值
      maxSpacing: props.settingParams && props.settingParams.maxSpacing || 100,
      // 体素间距范围最大值
      currentDate: props.settingParams && props.settingParams.currentDate || new Date().toLocaleDateString(),
      // 日期
      startTime: props.settingParams && props.settingParams.startTime || 12,
      // 开始日期
      endTime: props.settingParams && props.settingParams.endTime || 18,
      // 结束日期
      timeSpacing: props.settingParams && props.settingParams.timeSpacing || 30,
      filterValue: props.settingParams && props.settingParams.filterValue || 0,
      // 阴影率过滤
      minFilterValue: props.settingParams && props.settingParams.minFilterValue || 0,
      // 阴影率过滤范围最小值
      maxFilterValue: props.settingParams && props.settingParams.maxFilterValue || 0,
      // 阴影率过滤范围最大值
      alphaScale: props.settingParams && props.settingParams.alphaScale || 1,
      // 透明缩放
      minAlphaScale: props.settingParams && props.settingParams.alphaScale || 1,
      // 透明缩放范围最小值
      maxAlphaScale: props.settingParams && props.settingParams.alphaScale || 1 // 透明缩放范围最大值

    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.shadowAnalysis;
      currentLang.value = newVal;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      time.value = [formItem.startTime, formItem.endTime];
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new ShadowAnalysisViewModel(scenceView, {
            showVoxel: formItem.showBuilding,
            // 显示体素
            baseHeight: formItem.baseHeight,
            // 基地高度
            extrudeHeight: formItem.extrudeHeight,
            // 拉伸高度
            width: formItem.width,
            // 体素大小
            spacing: formItem.spacing,
            // 体素间距
            currentDate: formItem.currentDate,
            // 日期
            startTime: formItem.startTime,
            // 开始日期
            endTime: formItem.endTime,
            // 结束日期
            timeSpacing: formItem.timeSpacing,
            filterValue: formItem.filterValue,
            // 阴影率过滤
            alphaScale: formItem.alphaScale // 透明缩放

          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 获取当前日期


    function GetDateStr() {
      var dd = new Date();
      var y = dd.getFullYear();
      var m = dd.getMonth() + 1; //获取当前月份的日期

      var d = dd.getDate();
      console.log(y + "-" + (m < 10 ? "0" + m : m) + "-" + (d < 10 ? "0" + d : d));
      return y + "-" + (m < 10 ? "0" + m : m) + "-" + (d < 10 ? "0" + d : d);
    } // 日期改变


    function changeDate(val) {
      console.log(formItem.currentDate);
      if (viewModel.setCurrentDate) viewModel.setCurrentDate(formItem.currentDate);
    } // 改变时刻


    function changeTime(val) {} // 参数改变


    function paramsChanged(key) {
      switch (key) {
        case "currentDate":
          // 改变日期
          if (viewModel.setCurrentDate) viewModel.setCurrentDate(formItem.currentDate);
          break;

        case "time":
          // 改变时刻
          if (!time.value || !time.value.length) return;
          formItem.startTime = time.value[0];
          formItem.endTime = time.value[1];
          if (viewModel.setTime) viewModel.setTime(time.value);
          break;

        case "extrudeHeight":
          // 改变拉伸高度
          if (viewModel.setExtrudeHeight) viewModel.setExtrudeHeight(formItem.extrudeHeight);
          break;

        case "baseHeight":
          // 改变基地高度
          if (viewModel.setBaseHeight) viewModel.setBaseHeight(formItem.baseHeight);
          break;

        case "width":
          // 改变体素大小
          if (viewModel.setRadius) viewModel.setRadius(formItem.width);
          break;

        case "spacing":
          // 改变体素间距
          if (viewModel.setSpacing) viewModel.setSpacing(formItem.spacing);
          break;

        case "filterValue":
          // 改变阴影率过滤
          if (viewModel.setFilterValue) viewModel.setFilterValue(formItem.filterValue);
          break;

        case "alphaScale":
          // 改变透明缩放
          if (viewModel.setAlphaScale) viewModel.setAlphaScale(formItem.alphaScale);
          break;

        default:
          break;
      }
    } // 开始分析


    function startAnalysis() {
      // this.clearResult();
      viewModel && viewModel.clear();
      viewModel && viewModel.start();
    } // 日照效果


    function playTime() {
      viewModel && viewModel.sunshineEffect();
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      startAnalysis,
      playTime,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_date_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-date-picker");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-shadow-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-shadow-analysis-datetime"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 4,
          class: "colDate"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analyseDate), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 20
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_date_picker, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).currentDate,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).currentDate = $event),
            editable: false,
            type: "date",
            onChange: _cache[1] || (_cache[1] = $event => paramsChanged('currentDate')),
            clearable: false,
            format: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? 'YYYY年MM月DD日' : 'YYYY-MM-DD'
          }, null, 8
          /* PROPS */
          , ["modelValue", "format"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-shadow-analysis-datetime"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 4,
          class: "colTime"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).time), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 20
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(time),
            "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(time) ? time.value = $event : time = $event),
            step: 1,
            min: 0,
            max: 24,
            range: "",
            "show-tooltip": false,
            onChange: _cache[3] || (_cache[3] = $event => paramsChanged('time')),
            onClick: _cache[4] || (_cache[4] = $event => paramsChanged('time')),
            marks: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(timeMarks)
          }, null, 8
          /* PROPS */
          , ["modelValue", "marks"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row class=\"kq3d-shadow-analysis-datetime\">\r\n        <kq-col :span=\"6\">\r\n          <span class=\"kq3d-shadow-analysis-span\">{{ language.analysisYear }}</span>\r\n        </kq-col>\r\n        <kq-col :span=\"18\">\r\n          <kq-date-picker v-model=\"year\" align=\"right\" type=\"year\" format=\"YYYY年\"></kq-date-picker>\r\n          <kq-row :gutter=\"20\">\r\n            <kq-col :span=\"20\">\r\n              <kq-slider\r\n                v-model=\"month\"\r\n                :step=\"1\"\r\n                :min=\"formItem.1\"\r\n                :max=\"formItem.12\"\r\n                range\r\n                :show-tooltip=\"false\"\r\n                @change=\"changeMonth\"\r\n                :marks=\"monthMarks\"></kq-slider>\r\n            </kq-col>\r\n            <kq-col :span=\"4\" class=\"kq3d-shadow-analysis-timeline\">\r\n              <kq-icon @click=\"playOrPauseMonth\">\r\n                <IconVideoPlay v-if=\"!playMonth\" />\r\n                <IconVideoPause v-else />\r\n              </kq-icon>\r\n            </kq-col>\r\n          </kq-row>\r\n        </kq-col>\r\n      </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-shadow-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).shadowTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "120px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extrudeHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extrudeHeight,
                      "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extrudeHeight = $event),
                      onChange: _cache[6] || (_cache[6] = $event => paramsChanged('extrudeHeight')),
                      onClick: _cache[7] || (_cache[7] = $event => paramsChanged('extrudeHeight')),
                      step: 10,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtrudeHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtrudeHeight
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extrudeHeight,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extrudeHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtrudeHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtrudeHeight,
                      step: 10,
                      onChange: _cache[9] || (_cache[9] = $event => paramsChanged('extrudeHeight')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).baseHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).baseHeight,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).baseHeight = $event),
                      onChange: _cache[11] || (_cache[11] = $event => paramsChanged('baseHeight')),
                      onClick: _cache[12] || (_cache[12] = $event => paramsChanged('baseHeight')),
                      step: 10,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minBaseHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxBaseHeight
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).baseHeight,
                      "onUpdate:modelValue": _cache[13] || (_cache[13] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).baseHeight = $event),
                      onChange: _cache[14] || (_cache[14] = $event => paramsChanged('baseHeight')),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minBaseHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxBaseHeight,
                      step: 10,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).voxelSize
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).width,
                      "onUpdate:modelValue": _cache[15] || (_cache[15] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).width = $event),
                      onChange: _cache[16] || (_cache[16] = $event => paramsChanged('width')),
                      onClick: _cache[17] || (_cache[17] = $event => paramsChanged('width')),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxWidth
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).width,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).width = $event),
                      onChange: _cache[19] || (_cache[19] = $event => paramsChanged('width')),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxWidth,
                      step: 1,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).voxelSpacing
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).spacing,
                      "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).spacing = $event),
                      onChange: _cache[21] || (_cache[21] = $event => paramsChanged('spacing')),
                      onClick: _cache[22] || (_cache[22] = $event => paramsChanged('spacing')),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpacing,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpacing
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).spacing,
                      "onUpdate:modelValue": _cache[23] || (_cache[23] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).spacing = $event),
                      onChange: _cache[24] || (_cache[24] = $event => paramsChanged('spacing')),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpacing,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpacing,
                      step: 0.1,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).filterValue
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).filterValue,
                      "onUpdate:modelValue": _cache[25] || (_cache[25] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).filterValue = $event),
                      onInput: _cache[26] || (_cache[26] = $event => paramsChanged('filterValue')),
                      step: 0.01,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFilterValue,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFilterValue
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).filterValue,
                      "onUpdate:modelValue": _cache[27] || (_cache[27] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).filterValue = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFilterValue,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFilterValue,
                      step: 0.01,
                      onInput: _cache[28] || (_cache[28] = $event => paramsChanged('filterValue')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).alphaScale
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).alphaScale,
                      "onUpdate:modelValue": _cache[29] || (_cache[29] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).alphaScale = $event),
                      onInput: _cache[30] || (_cache[30] = $event => paramsChanged('alphaScale')),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minAlphaScale,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxAlphaScale
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).alphaScale,
                      "onUpdate:modelValue": _cache[31] || (_cache[31] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).alphaScale = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minAlphaScale,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxAlphaScale,
                      step: 0.1,
                      onInput: _cache[32] || (_cache[32] = $event => paramsChanged('alphaScale')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "kq3d-shadow-analysis-legend"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).shadowRateLegend
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                  src: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(const_image_namespaceObject.SHADOW_LEGEND_URL),
                  alt: ""
                }, null, 8
                /* PROPS */
                , ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_5), ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_6]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row :gutter=\"20\" style=\"display: flex\">\r\n              <kq-col :span=\"12\">\r\n                <kq-checkbox v-model=\"formItem.showBuilding\">{{ language.showBuilding }}</kq-checkbox>\r\n              </kq-col>\r\n              <kq-col :span=\"12\">\r\n                <kq-checkbox v-model=\"formItem.showVoxel\">{{ language.showVoxel }}</kq-checkbox>\r\n              </kq-col>\r\n            </kq-row> ")]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ShadowAnalysisvue_type_script_setup_true_lang_js_hoisted_7, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[33] || (_cache[33] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[34] || (_cache[34] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => playTime(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).sunshine,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).sunshine), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[35] || (_cache[35] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/shadowanalysis/ShadowAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/shadowanalysis/ShadowAnalysis.vue



const ShadowAnalysis_exports_ = ShadowAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var ShadowAnalysis = (ShadowAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/shadowanalysis/index.js




ShadowAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ShadowAnalysis.name, ShadowAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/profileanalysis/ProfileAnalysisViewModel.js

//分析逻辑类
let floatingPoint;
let drawPoints = [];
let activeShapePoints = [];
let activeCartographicPoints = [];
class ProfileAnalysisViewModel {
  //剖面分析三维对象
  //显示结果的DOM元素
  //显示结果的DOM元素显隐
  //全局参数对象
  constructor(scenceView, viewModel, chart) {
    _defineProperty(this, "_profileAnalysis", null);

    _defineProperty(this, "_ProfileAnalysisChart", null);

    _defineProperty(this, "_ProfileAnalysisChartVis", null);

    _defineProperty(this, "_language", null);

    _defineProperty(this, "_globaOptions", {
      width: 360,
      height: 360
    });

    this._language = scenceView._language;
    this._globaOptions.viewModel = {
      angle: viewModel.perspectiveAngle || 90,
      frustumH: viewModel.targetAreaHeight || 200,
      extendWidth: viewModel.targetAreaWidth || 1,
      isPerspective: viewModel.enablePerspective || true,
      cameraHeight: viewModel.cameraHeight || 0
    };
    this._globaOptions.viewer = scenceView._viewer;
    this._globaOptions.viewer.scene.postProcessStages._fxaa.enabled = true;
    this._globaOptions.viewer.scene.globe.depthTestAgainstTerrain = true;
    this._ProfileAnalysisChart = chart;
    this._ProfileAnalysisChartVis = chart || {}; // 实例化单线剖面分析对象

    this._profileAnalysis = new window.Cesium.Kq3dProfileAnalysis({
      viewer: this._globaOptions.viewer,
      width: this._globaOptions.width,
      height: this._globaOptions.height,
      angle: this._globaOptions.viewModel.angle,
      frustumH: this._globaOptions.viewModel.frustumH,
      extendWidth: this._globaOptions.viewModel.extendWidth,
      isPerspective: this._globaOptions.viewModel.isPerspective,
      cameraHeight: this._globaOptions.viewModel.cameraHeight,
      isShowDown: false,
      debugCamera: {
        show: true,
        color: window.Cesium.Color.fromBytes(0, 255, 255, 200)
      }
    });
    this._globaOptions._handler = new window.Cesium.ScreenSpaceEventHandler(this._globaOptions.viewer.canvas); //创建剖面分析结果显示窗口

    this._globaOptions.canvas = document.createElement("canvas");
    this._globaOptions.canvas.id = "pro";
    this._globaOptions.ctx = this._globaOptions.canvas.getContext("2d");

    this._ProfileAnalysisChart.appendChild(this._globaOptions.canvas);
  } //开始分析


  start() {
    //清空绘制结果
    this.remove();
    let that = this;

    this._globaOptions._handler.removeInputAction(window.Cesium.ScreenSpaceEventType.LEFT_CLICK);

    this._globaOptions._handler.setInputAction(function (event) {
      var earthPosition = that._globaOptions.viewer.scene.pickPosition(event.position);

      if (window.Cesium.defined(earthPosition)) {
        //绘制点
        floatingPoint = that.createPoint(earthPosition);
        drawPoints.push(floatingPoint);
        activeShapePoints.push(earthPosition);
        let earthPositionCarto = window.Cesium.Cartographic.fromCartesian(earthPosition);
        activeCartographicPoints.push(earthPositionCarto); //单线分析结果显示

        if (activeShapePoints.length == 2) {
          var newPositions = [];
          activeShapePoints.forEach(position => {
            var newPosition = window.Cesium.Cartographic.fromCartesian(position);
            newPositions.push(newPosition);
          });
          that._profileAnalysis.elevation = newPositions;
          that.updatePorfileAnalysis();
          drawPoints.forEach(function (point) {
            that._globaOptions.viewer.entities.remove(point);
          });
          drawPoints = [];
          activeShapePoints = [];
        }
      }
    }, window.Cesium.ScreenSpaceEventType.LEFT_CLICK);
  } //绘制点


  createPoint(worldPosition) {
    var point = this._globaOptions.viewer.entities.add({
      position: worldPosition,
      point: {
        color: window.Cesium.Color.YELLOW,
        pixelSize: 5
      }
    });

    return point;
  } //更新单线剖面分析结果


  updatePorfileAnalysis() {
    if (this._profileAnalysis) {
      this._profileAnalysis.frustumH = this._globaOptions.viewModel.frustumH;
      this._profileAnalysis.angle = this._globaOptions.viewModel.angle;
      this._profileAnalysis.extendWidth = this._globaOptions.viewModel.extendWidth;
      this._profileAnalysis.cameraHeight = this._globaOptions.viewModel.cameraHeight;
      this._profileAnalysis.isPerspective = this._globaOptions.viewModel.isPerspective;

      if (this._globaOptions._handler) {
        let buffer = this._profileAnalysis.updateBuffer();

        this._ProfileAnalysisChartVis.value = true;
        setTimeout(() => {
          this.getPorfileAnalysisTexture(buffer);

          this._globaOptions._handler.removeInputAction(window.Cesium.ScreenSpaceEventType.LEFT_CLICK);
        }, 500);
      }
    }
  } //获取单线剖面分析纹理


  getPorfileAnalysisTexture(buffer) {
    if (buffer) {
      this._globaOptions.canvas.height = this._globaOptions.height;
      this._globaOptions.canvas.width = this._globaOptions.width;

      let imgData = this._globaOptions.ctx.createImageData(this._globaOptions.width, this._globaOptions.height); // flipY


      var line = this._globaOptions.width * 4;

      for (let h = 0; h < this._globaOptions.height; h++) {
        for (let w = 0; w < this._globaOptions.width; w++) {
          for (let n = 0; n < 4; n++) {
            imgData.data[(this._globaOptions.height - 1 - h) * line + w * 4 + n] = buffer[h * line + w * 4 + n];
          }
        }
      }

      this._globaOptions.ctx.putImageData(imgData, 0, 0); //=====================


      this._globaOptions.ctx.setLineDash([20, 5]);

      this._globaOptions.ctx.lineWidth = 1;
      this._globaOptions.ctx.strokeStyle = "#ff2";
      let fTop = (1.0 - this._profileAnalysis._frustumH / this._profileAnalysis._maxH) * 360;
      let fLeft = (1.0 - this._profileAnalysis._frustumW / this._profileAnalysis._maxW) / 2 * 360;

      this._globaOptions.ctx.moveTo(fLeft, 360); // bottom


      this._globaOptions.ctx.lineTo(fLeft, fTop);

      this._globaOptions.ctx.lineTo(360 - fLeft, fTop);

      this._globaOptions.ctx.lineTo(360 - fLeft, 360);

      this._globaOptions.ctx.stroke(); //=====================


      let str = String(this._profileAnalysis._frustumW.toFixed(2));
      let str1 = this._language.profileLength + " : " + str + "m";
      str = String(this._profileAnalysis._maxW.toFixed(2));
      let str2 = this._language.totalLength + " : " + str + "m";
      str = String(this._profileAnalysis._frustumH.toFixed(2));
      let str3 = this._language.profileHeight + " : " + str + "m";
      str = String(this._profileAnalysis._maxH.toFixed(2));
      let str4 = this._language.totalHeight + " : " + str + "m";
      this._globaOptions.ctx.font = "bold 15px Arial";
      this._globaOptions.ctx.textAlign = "left";
      this._globaOptions.ctx.textBaseline = "bottom";
      this._globaOptions.ctx.fillStyle = "#ccc";

      this._globaOptions.ctx.fillText(str1, 10, 20);

      this._globaOptions.ctx.fillText(str2, 10, 40);

      this._globaOptions.ctx.fillText(str3, 10, 60);

      this._globaOptions.ctx.fillText(str4, 10, 80);
    }
  } // 是否透视


  setEnablePerspective(val) {
    this._globaOptions.viewModel.isPerspective = val;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 透视角度


  setPerspectiveAngle(val) {
    this._globaOptions.viewModel.angle = val;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 目标区域宽度


  setTargetAreaWidth(val) {
    this._globaOptions.viewModel.extendWidth = val;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 目标区域高度


  setTargetAreaHeight(val) {
    this._globaOptions.viewModel.frustumH = val;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 相机高度


  setCameraHeight(val) {
    this._globaOptions.viewModel.cameraHeight = val;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 切换语言


  changeLanguage(lang) {
    this._language = lang;
    if (this._ProfileAnalysisChartVis.value) this.updatePorfileAnalysis();
  } // 清理剖面分析


  remove() {
    this._ProfileAnalysisChartVis.value = false;
    this._profileAnalysis && this._profileAnalysis.clearPrimitives();
  } //清除全部结果


  clear() {
    this.remove();

    this._globaOptions._handler.removeInputAction(window.Cesium.ScreenSpaceEventType.LEFT_CLICK);
  } // 销毁


  destroy() {
    this.remove();

    this._globaOptions._handler.removeInputAction(window.Cesium.ScreenSpaceEventType.LEFT_CLICK);

    this._globaOptions._handler = null;
    this._ProfileAnalysisChartVis.value = false;
    this._profileAnalysis && this._profileAnalysis.destroy();
    this._profileAnalysis = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/profileanalysis/ProfileAnalysis.vue?vue&type=script&setup=true&lang=js

const ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-profile-analysis-box"
};
const ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-profile-analysis-footer"
};
const ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-profile-analysis-result"
};
const ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = {
  id: "resultCahrt",
  class: "resultCahrt"
};






const ProfileAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dProfileAnalysis"
};
/* harmony default export */ var ProfileAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ProfileAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconProfileAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); // 设置

    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 分析类

    let viewModel = null; // chart显示

    let resultCahrtVis = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(true); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      perspectiveAngle: props.settingParams && props.settingParams.perspectiveAngle || 90,
      // 透视角度
      minPerspectiveAngle: props.settingParams && props.settingParams.minPerspectiveAngle || 0,
      // 透视角度范围最小值
      maxPerspectiveAngle: props.settingParams && props.settingParams.maxPerspectiveAngle || 90,
      // 透视角度范围最大值
      targetAreaWidth: props.settingParams && props.settingParams.targetAreaWidth || 1,
      // 目标区域宽度
      minTargetAreaWidth: props.settingParams && props.settingParams.minTargetAreaWidth || 0,
      // 目标区域宽度范围最小值
      maxTargetAreaWidth: props.settingParams && props.settingParams.maxTargetAreaWidth || 500,
      // 目标区域宽度范围最大值
      targetAreaHeight: props.settingParams && props.settingParams.targetAreaHeight || 200,
      // 目标区域高度
      minTargetAreaHeight: props.settingParams && props.settingParams.minTargetAreaHeight || 0,
      // 目标区域高度范围最小值
      maxTargetAreaHeight: props.settingParams && props.settingParams.maxTargetAreaHeight || 500,
      // 目标区域高度范围最大值
      cameraHeight: props.settingParams && props.settingParams.cameraHeight || 0,
      // 相机高度
      minCameraHeight: props.settingParams && props.settingParams.minCameraHeight || 0,
      // 相机高度范围最小值
      maxCameraHeight: props.settingParams && props.settingParams.maxCameraHeight || 500,
      // 相机高度范围最大值
      enablePerspective: props.settingParams && props.settingParams.isLabel !== undefined || true // 是否透视

    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.profileAnalysis;
      viewModel && viewModel.changeLanguage(language.value);
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new ProfileAnalysisViewModel(scenceView, {
            perspectiveAngle: formItem.perspectiveAngle,
            // 透视角度
            targetAreaWidth: formItem.targetAreaWidth,
            // 目标区域宽度
            targetAreaHeight: formItem.targetAreaHeight,
            // 目标区域高度
            cameraHeight: formItem.cameraHeight,
            // 相机高度
            enablePerspective: formItem.enablePerspective // 是否透视

          }, document.getElementById("resultCahrt"));
          viewModel._ProfileAnalysisChartVis = resultCahrtVis;
          resultCahrtVis.value = false;
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 开始分析


    function startAnalysis() {
      viewModel && viewModel.start();
    } // 清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 是否透视


    function onChangeEnablePerspective() {
      viewModel && viewModel.setEnablePerspective(formItem.enablePerspective);
    } // 透视角度


    function onChangePerspectiveAngle() {
      viewModel && viewModel.setPerspectiveAngle(formItem.perspectiveAngle);
    } // 目标区域宽度


    function onChangeTargetAreaWidth() {
      viewModel && viewModel.setTargetAreaWidth(formItem.targetAreaWidth);
    } // 目标区域高度


    function onChangeTargetAreaHeight() {
      viewModel && viewModel.setTargetAreaHeight(formItem.targetAreaHeight);
    } // 相机高度


    function onChangeCameraHeight() {
      viewModel && viewModel.setCameraHeight(formItem.cameraHeight);
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      startAnalysis,
      clearResult,
      onChangeEnablePerspective,
      onChangePerspectiveAngle,
      onChangeTargetAreaWidth,
      onChangeTargetAreaHeight,
      onChangeCameraHeight
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-profile-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-profile-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).profileTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "135px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).perspectiveAngle
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).perspectiveAngle,
                      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).perspectiveAngle = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minPerspectiveAngle,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxPerspectiveAngle,
                      onInput: onChangePerspectiveAngle
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).perspectiveAngle,
                      "onUpdate:modelValue": _cache[1] || (_cache[1] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).perspectiveAngle = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minPerspectiveAngle,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxPerspectiveAngle,
                      step: 1,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).targetAreaWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaWidth,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaWidth = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minTargetAreaWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxTargetAreaWidth,
                      onInput: onChangeTargetAreaWidth
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaWidth,
                      "onUpdate:modelValue": _cache[3] || (_cache[3] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaWidth = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minTargetAreaWidth,
                      step: 1,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxTargetAreaWidth,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).targetAreaHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaHeight,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaHeight = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minTargetAreaHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxTargetAreaHeight,
                      onInput: onChangeTargetAreaHeight
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaHeight,
                      "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).targetAreaHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minTargetAreaHeight,
                      step: 1,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxTargetAreaHeight,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).cameraHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).cameraHeight,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).cameraHeight = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minCameraHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxCameraHeight,
                      onInput: onChangeCameraHeight
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).cameraHeight,
                      "onUpdate:modelValue": _cache[7] || (_cache[7] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).cameraHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minCameraHeight,
                      step: 1,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxCameraHeight,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enablePerspective,
                "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enablePerspective = $event),
                onChange: onChangeEnablePerspective
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).enablePerspective), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[9] || (_cache[9] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[10] || (_cache[10] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ProfileAnalysisvue_type_script_setup_true_lang_js_hoisted_4, null, 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(resultCahrtVis)]])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/profileanalysis/ProfileAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/profileanalysis/ProfileAnalysis.vue



const ProfileAnalysis_exports_ = ProfileAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var ProfileAnalysis = (ProfileAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/profileanalysis/index.js




ProfileAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ProfileAnalysis.name, ProfileAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/skylineanalysis/SkylineAnalysisViewModel.js

//天际线分析逻辑类

class SkylineAnalysisViewModel {
  /**
   * 天际线分析逻辑类
   * @param {Object} _skylineAnalysis 天际线分析三维对象
   * @param {Object} _skylineAnalysisChart 二维天际线折线图表（外部生成）
   * @param {String} _skylineAnalysisChartTitle 二维天际线折线图表标题（中英文适配）
   * @param {Object} _options 天际线分析存储参数对象
   * @param {Object} _showLimitHeightBody 限高体是否显示
   */

  /**
   * 天际线分析逻辑类构造函数
   * @param {*} viewer 三维对象
   * @param {*} option 天际线分析参数对象
   */
  constructor(viewer, option, chartStyle) {
    _defineProperty(this, "_skylineAnalysis", null);

    _defineProperty(this, "_skylineAnalysisChart", null);

    _defineProperty(this, "_skylineAnalysisChartTitle", "");

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_showLimitHeightBody", null);

    _defineProperty(this, "_chartStyle", null);

    this._chartStyle = chartStyle;
    viewer.scene.globe.depthTestAgainstTerrain = true; //开启深度检测

    viewer.scene.postProcessStages._fxaa.enabled = true; // 创建分析参数对象

    this._options = {
      viewer: viewer,
      lineColor: window.Cesium.Color.fromCssColorString(option.skylineColor),
      //天际线颜色
      faceColor: window.Cesium.Color.fromCssColorString(option.limitHeightBodyColor).withAlpha(option.limitHeightBodyAlpha),
      //限高体颜色
      faceOutlineColor: window.Cesium.Color.fromCssColorString("#E6A23C").withAlpha(0),
      //限高体轮廓颜色
      lineWidth: option.skylineWidth,
      //天际线线宽
      radius: option.skylineRadius //天际线分析范围

    };
    if (option.viewPosition) this._options.viewPosition = option.viewPosition;
    if (option.heading) this._options.heading = option.heading;
    if (option.pitch) this._options.pitch = option.pitch;
    if (option.roll) this._options.viewPosition = option.roll;
    if (option.fov) this._options.fov = option.fov; // 实例化天际线分析类

    this._skylineAnalysis = new window.Cesium.Kq3dSkyline(this._options);
  }
  /**
   * 提取天际线
   */


  pickSkyLine() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._options.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      if (!this._skylineAnalysis || this._skylineAnalysis.isDestroyed()) {
        this._skylineAnalysis = new window.Cesium.Kq3dSkyline(this._options);
      }

      this._skylineAnalysis.updateBuffer();

      this._skylineAnalysis.pickSkyLine();

      this.setSkyline2D();
    } else {
      message({
        message: "请添加模型后提取!",
        type: "warning"
      });
    }
  }
  /**
   * 绘制限高体
   */


  drawLimitHeightBody() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._options.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      if (!this._skylineAnalysis || this._skylineAnalysis.isDestroyed()) {
        this._skylineAnalysis = new window.Cesium.Kq3dSkyline(this._options);
      }

      this._showLimitHeightBody = true;
      this._skylineAnalysis.faceColor = this._options.faceColor;
      this._skylineAnalysis.faceOutlineColor = this._options.faceOutlineColor;

      this._skylineAnalysis.drawHeightGeo();

      this._skylineAnalysis.viewer.camera.moveBackward(1);
    } else {
      message({
        message: "请添加模型后提取!",
        type: "warning"
      });
    }
  }
  /**
   * 展示二维天际线
   */


  setSkyline2D() {
    let chartStyle = this._chartStyle;
    if (!this._skylineAnalysis) return;

    var data = this._skylineAnalysis.updateBuffer();

    var option = {
      title: {
        text: this._skylineAnalysisChartTitle,
        textStyle: {
          color: chartStyle.textColor
        }
      },
      tooltip: {
        trigger: "axis",
        backgroundColor: chartStyle.backgroundColor,
        borderWidth: 0,
        textStyle: {
          color: chartStyle.textColor
        }
      },
      grid: {
        containLabel: true,
        left: "10px",
        top: "50px",
        right: "10px",
        bottom: "5px"
      },
      calculable: true,
      xAxis: [{
        type: "category",
        boundaryGap: false,
        data: data.x,
        show: false
      }],
      yAxis: [{
        type: "value",
        min: 0,
        max: 1,
        axisLabel: {
          color: chartStyle.textColor
        }
      }],
      series: [{
        name: "",
        type: "line",
        data: data.y
      }]
    };
    this._skylineAnalysisChart && this._skylineAnalysisChart.setOption(option);
  }
  /**
   * 设置echarts图表样式
   */


  setChartStyle(style) {
    this._chartStyle = style;

    if (this._skylineAnalysisChart) {
      let option = this._skylineAnalysisChart.getOption();

      option.title[0].textStyle.color = style.textColor;
      option.tooltip[0].backgroundColor = style.backgroundColor;
      option.tooltip[0].textStyle.color = style.textColor;
      option.yAxis[0].axisLabel.color = style.textColor;

      this._skylineAnalysisChart.setOption(option);
    }
  }

  setChartTitle(title) {
    this._skylineAnalysisChartTitle = title;

    if (this._skylineAnalysisChart) {
      let option = this._skylineAnalysisChart.getOption();

      option.title[0].text = title;

      this._skylineAnalysisChart.setOption(option);
    }
  }
  /**
   * 清除限高体
   */


  removeLimitHeightBody() {
    this._showLimitHeightBody = false;

    if (this._skylineAnalysis && !this._skylineAnalysis.isDestroyed()) {
      this._skylineAnalysis.removeAlllimitHeights();

      this._skylineAnalysis.removeAllFaces(); // this._skylineAnalysis.removeGeoJsonDataSource();


      this._skylineAnalysis.removeCzmlJsonDataSource();
    }
  }
  /**
   * 设置天际线颜色
   * @param {String} lineColor 天际线颜色
   */


  setLineColor(lineColor) {
    if (!lineColor) return;
    this._options.lineColor = window.Cesium.Color.fromCssColorString(lineColor);
    if (this._skylineAnalysis) this._skylineAnalysis.lineColor = this._options.lineColor;
  }
  /**
   * 设置限高体颜色
   * @param {String} faceColor 限高体轮廓颜色
   * @param {String} alpha 限高体轮廓颜色透明度
   */


  setFaceColor(faceColor, alpha) {
    if (!faceColor) return;
    this._options.faceColor = window.Cesium.Color.fromCssColorString(faceColor).withAlpha(alpha || 1);
    if (this._skylineAnalysis && this._showLimitHeightBody) this._skylineAnalysis.faceColor = this._options.faceColor;
  }
  /**
   * 设置天际线半径
   * @param {String} radius 天际线半径
   */


  setRadius(radius) {
    if (!radius) return;
    this._options.radius = radius;
    if (this._skylineAnalysis) this._skylineAnalysis.radius = radius;
  }
  /**
   * 设置限高体透明度
   * @param {String} faceColor 限高体轮廓颜色
   * @param {String} alpha 限高体轮廓颜色透明度
   */


  setFaceColorAlpha(faceColor, alpha) {
    if (!faceColor) return;
    this._options.faceColor = window.Cesium.Color.fromCssColorString(faceColor).withAlpha(alpha || 1);
    if (this._skylineAnalysis && this._showLimitHeightBody) this._skylineAnalysis.faceColor = this._options.faceColor;
  }
  /**
   * 设置限高体轮廓颜色
   * @param {String} faceOutlineColor 限高体轮廓颜色
   * @param {String} alpha 限高体轮廓颜色透明度
   */


  setFaceOutlineColor(faceOutlineColor, alpha) {
    if (!faceOutlineColor) return;
    this._options.faceOutlineColor = window.Cesium.Color.fromCssColorString(faceOutlineColor).withAlpha(alpha || 1);

    if (this._skylineAnalysis && this._showLimitHeightBody) {
      this._skylineAnalysis.faceOutlineColor = this._options.faceOutlineColor;
    }
  }
  /*
   * 清除
   */


  clear() {
    this._showLimitHeightBody = false;

    if (this._skylineAnalysis) {
      this._skylineAnalysis.destroy();

      this._skylineAnalysis = new window.Cesium.Kq3dSkyline(this._options);
    }
  }
  /**
   * 销毁
   */


  destroy() {
    this._showLimitHeightBody = false;

    if (this._skylineAnalysis) {
      this._skylineAnalysis.destroy();

      this._skylineAnalysis = null;
    }
  }

}
;// CONCATENATED MODULE: external "echarts"
var external_echarts_namespaceObject = require("echarts");
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/skylineanalysis/SkylineAnalysis.vue?vue&type=script&setup=true&lang=js

const SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-skyline-analysis-box"
};
const SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-skyline-analysis-footer"
};
const SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-skyline-analysis-result"
};
const SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = {
  key: 0,
  id: "resultEcahrt",
  class: "resultEcahrt"
};






 // 语言

const SkylineAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dSkylineAnalysis"
};
/* harmony default export */ var SkylineAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(SkylineAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconSkylineAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); // 设置

    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 分析类

    let viewModel = null; // chart显示

    let resultEcahrtVis = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      skylineColor: props.settingParams && props.settingParams.skylineColor || "#E6A23C",
      // 天际线颜色
      skylineRadius: props.settingParams && props.settingParams.skylineRadius || 1000,
      // 天际线半径
      minSkylineRadius: props.settingParams && props.settingParams.minSkylineRadius || 0,
      // 天际线半径范围最小值
      maxSkylineRadius: props.settingParams && props.settingParams.maxSkylineRadius || 5000,
      // 天际线半径范围最大值
      limitHeightBodyColor: props.settingParams && props.settingParams.limitHeightBodyColor || "#67C23A",
      // 限高体颜色
      limitHeightBodyAlpha: props.settingParams && props.settingParams.limitHeightBodyAlpha || 0.7,
      // 限高体透明度
      minLimitHeightBodyAlpha: props.settingParams && props.settingParams.minLimitHeightBodyAlpha || 0,
      // 限高体透明度范围最小值
      maxLimitHeightBodyAlpha: props.settingParams && props.settingParams.maxLimitHeightBodyAlpha || 1,
      // 限高体透明度范围最大值
      skylineWidth: 2 // 天际线宽度

    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.skylineAnalysis;
      viewModel && viewModel.setChartTitle(language.value["skylineAnalysisChartTitle"]);
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new SkylineAnalysisViewModel(scenceView._viewer, {
            skylineColor: formItem.skylineColor || "#E6A23C",
            skylineRadius: formItem.skylineRadius || 2000,
            limitHeightBodyColor: formItem.limitHeightBodyColor || "#67C23A",
            limitHeightBodyAlpha: formItem.limitHeightBodyAlpha || 0.7,
            skylineWidth: formItem.skylineWidth || 2
          }, setEchartsColor());
          viewModel._skylineAnalysisChartTitle = scenceView._language["skylineAnalysisChartTitle"];
        }
      });
    }); // 监听主题变化，重置Echarts

    const observer = new MutationObserver(mutationsList => {
      for (let mutation of mutationsList) {
        if (mutation.type === "attributes" && mutation.attributeName === "class") {
          let style = setEchartsColor();
          viewModel.setChartStyle(style);
        }
      }
    }); // 配置要观察的目标节点及其属性

    const targetNode = document.querySelector("html");
    const config = {
      attributes: true
    };
    observer.observe(targetNode, config);

    const setEchartsColor = () => {
      let style = {};
      let themeStyle = window.getComputedStyle(document.documentElement).getPropertyValue("color-scheme");

      if (themeStyle === "dark") {
        style.textColor = "#fff";
        style.backgroundColor = "#2A2A2A";
      } else {
        style.textColor = "#333";
        style.backgroundColor = "#ffffff";
      }

      return style;
    };
    /**
     * @description 监听header生成
     */


    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 提取天际线


    function pickSkyLine() {
      resultEcahrtVis.value = true;
      setTimeout(() => {
        viewModel._skylineAnalysisChart = external_echarts_namespaceObject.init(document.getElementById("resultEcahrt"));
        viewModel && viewModel.pickSkyLine();
      }, 500);
    } // 绘制限高体


    function drawLimitHeightBody() {
      viewModel && viewModel.drawLimitHeightBody();
    } // 清除限高体


    function removeLimitHeightBody() {
      viewModel && viewModel.removeLimitHeightBody();
    } //清除结果


    function clearResult() {
      resultEcahrtVis.value = false;
      viewModel && viewModel.clear();
    } // 改变天际线颜色


    function onChangeSkylineColor() {
      viewModel && viewModel.setLineColor(formItem.skylineColor);
    } // 改变限高体颜色


    function onChangeLimitHeightBodyColor() {
      viewModel && viewModel.setFaceColor(formItem.limitHeightBodyColor, formItem.limitHeightBodyAlpha);
    } // 改变天际线半径


    function onChangeSkylineRadius() {
      viewModel && viewModel.setRadius(formItem.skylineRadius);
    } // 限高体轮廓透明度


    function onChangeLimitHeightBodyAlpha() {
      viewModel && viewModel.setFaceColorAlpha(formItem.limitHeightBodyColor, formItem.limitHeightBodyAlpha);
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      resultEcahrtVis.value = false;
      viewModel && viewModel.destroy();
    });
    expose({
      pickSkyLine,
      drawLimitHeightBody,
      removeLimitHeightBody,
      onChangeSkylineColor,
      onChangeLimitHeightBodyColor,
      onChangeSkylineRadius,
      onChangeLimitHeightBodyAlpha,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-skyline-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-skyline-analysis-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "120px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineColor,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineColor = $event),
                  onChange: onChangeSkylineColor
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineRadius
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineRadius,
                      "onUpdate:modelValue": _cache[1] || (_cache[1] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineRadius = $event),
                      step: 100,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSkylineRadius,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSkylineRadius,
                      onInput: onChangeSkylineRadius
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineRadius,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).skylineRadius = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSkylineRadius,
                      step: 100,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSkylineRadius,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).limitHeightBodyColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyColor,
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyColor = $event),
                  onChange: onChangeLimitHeightBodyColor
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).limitHeightBodyAlpha
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyAlpha,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyAlpha = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLimitHeightBodyAlpha,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLimitHeightBodyAlpha,
                      onInput: onChangeLimitHeightBodyAlpha
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyAlpha,
                      "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).limitHeightBodyAlpha = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLimitHeightBodyAlpha,
                      step: 0.1,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLimitHeightBodyAlpha,
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "step", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "btnClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 12
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[6] || (_cache[6] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => pickSkyLine(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pickSkyLine,
            type: "primary"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).pickSkyLine), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 12
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[7] || (_cache[7] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => drawLimitHeightBody(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).drawLimitHeightBody,
            type: "primary"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).drawLimitHeightBody), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 12
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[8] || (_cache[8] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => removeLimitHeightBody(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).removeLimitHeightBody
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).removeLimitHeightBody), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 12
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[9] || (_cache[9] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(resultEcahrtVis) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", SkylineAnalysisvue_type_script_setup_true_lang_js_hoisted_4)) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/skylineanalysis/SkylineAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/skylineanalysis/SkylineAnalysis.vue



const SkylineAnalysis_exports_ = SkylineAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var SkylineAnalysis = (SkylineAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/skylineanalysis/index.js




SkylineAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(SkylineAnalysis.name, SkylineAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/terrainoperation/TerrainOperationViewModel.js

//地形淹没分析逻辑类

class TerrainOperationViewModel {
  //地形开挖三维对象
  //地形修改三维对象
  //绘制管理对象
  //全局参数
  //绘制的坐标点集合
  //地形操作类型
  //开挖深度
  //绘制完成监听事件
  constructor(scenceView, viewModel) {
    _defineProperty(this, "_terrainexcavationext", null);

    _defineProperty(this, "_terrainmodification", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_globaOptions", {});

    _defineProperty(this, "_positions", []);

    _defineProperty(this, "_terrainStyle", null);

    _defineProperty(this, "_height", 0);

    _defineProperty(this, "_removeEventListener", null);

    this._globaOptions.viewer = scenceView._viewer;
    this._globaOptions.viewer.scene.logarithmicDepthBuffer = false;
    this._globaOptions.viewer.scene.globe.depthTestAgainstTerrain = true;
    this._drawManager = scenceView._drawManager;
    this._terrainStyle = viewModel.terrainStyle;
    this._height = viewModel.excavationDepth;
    var that = this;
    this._removeEventListener = this._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._globaOptions.positions = shape._controlPoints;

        if (that._terrainStyle === 1) {
          that._positions.push(shape._controlPoints);

          if (that._terrainexcavationext) {
            that.setTerrainExcavationAddPolygon();
          } else {
            this.createTerrainExcavation(() => {
              that.setTerrainExcavationAddPolygon();
            });
          }
        } else if (that._terrainStyle === 2) {
          if (that._terrainmodification) {
            that.setTerrainModification();
          } else {
            this.createTerrainModification();
          }
        }

        that._drawManager.clear();
      }
    });
  } // 创建地形分析类


  createTerrainExcavation(callback) {
    var that = this;

    this._globaOptions.viewer.terrainProvider.readyPromise.then(function () {
      setTimeout(() => {
        // 地形开挖
        that._terrainexcavationext = new window.Cesium.Kq3dTerrainExcavationExt({
          viewer: that._globaOptions.viewer
        });
        if (callback) callback();
      }, 500);
    });
  } // 创建地形修改分析类


  createTerrainModification(callback) {
    var that = this;

    this._globaOptions.viewer.terrainProvider.readyPromise.then(function () {
      setTimeout(() => {
        let heights = [];
        let positions = [];

        that._globaOptions.positions.forEach((item, index) => {
          console.log(index);
          let cag = window.Cesium.Cartographic.fromCartesian(item);
          positions.push(cag);
          heights.push(cag.height);
        }); // 地形平整


        if (!that._terrainmodification) {
          that._terrainmodification = new window.Cesium.Kq3dTerrainModification({
            viewer: that._globaOptions.viewer,
            positions: positions,
            heights: heights
          });
        } else {
          that._terrainmodification.heights = heights;
          that._terrainmodification.positions = positions;
        }

        that._terrainmodification._clippingPlanesEnabled = true;
        if (callback) callback();
      }, 500);
    });
  } // 地形开挖分析更新分析位置和高度


  setTerrainExcavationAddPolygon() {
    this._terrainexcavationext.addPolygon({
      polygonArray: this._globaOptions.positions,
      height: Number(this._height)
    });
  } // 地形平整执行分析


  setTerrainModification() {
    let heights = [];
    let positions = [];

    this._globaOptions.positions.forEach((item, index) => {
      console.log(index);
      let cag = window.Cesium.Cartographic.fromCartesian(item);
      positions.push(cag);
      heights.push(cag.height);
    });

    this._terrainmodification.heights = heights;
    this._terrainmodification.positions = positions;
  } //开始分析


  start() {
    // 判断是否添加了地形
    if (this._globaOptions.viewer.terrainProvider.availability) {
      if (this._globaOptions.viewer.terrainProvider instanceof Cesium.CesiumTerrainProvider) {
        this.clear();

        this._drawManager.startDraw("polygon", {
          clampToGround: true
        });
      } else {
        message({
          message: "只支持STK类型的地形分析!",
          type: "warning"
        });
      }
    } else {
      message({
        message: "请加载地形后分析!",
        type: "warning"
      });
    }
  } //改变分析类型


  setTerrainStyle(val) {
    this._terrainStyle = val;
    this.clear();
  } // 设置开挖深度


  setHeight(height) {
    let that = this;
    this._height = height;

    if (this._terrainStyle === 0 && this._terrainexcavationext) {
      this._terrainexcavationext && this._terrainexcavationext.destroy();
      this._terrainexcavationext = new window.Cesium.Kq3dTerrainExcavationExt({
        viewer: this._globaOptions.viewer
      });

      this._positions.forEach(item => {
        if (that._terrainexcavationext) {
          that._terrainexcavationext.addPolygon({
            polygonArray: item,
            height: Number(that._height)
          });
        }
      });
    }
  } //清除全部结果


  clear() {
    this._drawManager.stopDraw(); // 销毁地形开挖


    if (this._terrainexcavationext) {
      this._terrainexcavationext.destroy();

      this._terrainexcavationext = null;
      this._positions = [];
    } // 销毁地形平整


    if (this._terrainmodification) {
      this._terrainmodification && this._terrainmodification.remove();
      this._terrainmodification = null;
    }
  } // 销毁


  destroy() {
    this.clear(); //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/terrainoperation/TerrainOperation.vue?vue&type=script&setup=true&lang=js

const TerrainOperationvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-terrain-operation-analysis-box"
};
const TerrainOperationvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-terrain-operation-analysis-span"
};
const TerrainOperationvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-terrain-operation-analysis-footer"
};






const TerrainOperationvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dTerrainOperation"
};
/* harmony default export */ var TerrainOperationvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(TerrainOperationvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 地形开挖和地形修改显示设置。0:同时显示;1:显示地形开挖;2:显示地形修改
    operationMode: {
      type: Number,
      default: 0
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconTerrainOperation
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      terrainStyle: props.settingParams && props.settingParams.terrainStyle || 1,
      // 地形操作类型。1:地形开挖;2:地形修改
      excavationDepth: props.settingParams && props.settingParams.excavationDepth || 500,
      // 地形开挖深度
      minExcavationDepth: props.settingParams && props.settingParams.minExcavationDepth || 100,
      // 地形开挖深度范围最小值
      maxExcavationDepth: props.settingParams && props.settingParams.maxExcavationDepth || 5000 // 地形开挖深度范围最大值

    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.terrainOperation;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          if (props.operationMode !== 0) {
            formItem.terrainStyle = props.operationMode;
          }

          viewModel = new TerrainOperationViewModel(scenceView, {
            terrainStyle: formItem.terrainStyle,
            excavationDepth: formItem.excavationDepth
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 改变样式


    function changeStyle() {
      viewModel && viewModel.setTerrainStyle(formItem.terrainStyle);
    } // 调整开挖深度


    function changeHeight() {
      viewModel && viewModel.setHeight(formItem.excavationDepth);
    } // 开始分析


    function startOperation() {
      viewModel && viewModel.start();
    } // 清除


    function clear() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      changeStyle,
      changeHeight,
      startOperation,
      clear
    });
    return (_ctx, _cache) => {
      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-terrain-operation-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", TerrainOperationvue_type_script_setup_true_lang_js_hoisted_1, [__props.operationMode === 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
        key: 0
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).terrainStyle,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).terrainStyle = $event),
          label: 1,
          onChange: changeStyle
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).terrainExcavation), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["modelValue"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).terrainStyle,
          "onUpdate:modelValue": _cache[1] || (_cache[1] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).terrainStyle = $event),
          label: 2,
          onChange: changeStyle
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).TerrainModification), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["modelValue"])]),
        _: 1
        /* STABLE */

      })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).terrainStyle === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
        key: 1,
        gutter: 10
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? 7 : 10
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", TerrainOperationvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).excavationDepth), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["span"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? 11 : 8
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavationDepth,
            "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavationDepth = $event),
            step: 100,
            min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExcavationDepth,
            max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExcavationDepth,
            onChange: _cache[3] || (_cache[3] = $event => changeHeight()),
            onClick: _cache[4] || (_cache[4] = $event => changeHeight())
          }, null, 8
          /* PROPS */
          , ["modelValue", "min", "max"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["span"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          style: {
            "text-align": "end"
          }
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavationDepth,
            "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavationDepth = $event),
            min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExcavationDepth,
            step: 100,
            max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExcavationDepth,
            "controls-position": "right",
            onInput: _cache[6] || (_cache[6] = $event => changeHeight())
          }, null, 8
          /* PROPS */
          , ["modelValue", "min", "max"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-terrain-operation-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineTips), 1
        /* TEXT */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <p v-if=\"formItem.terrainStyle === 2\">{{ \"(\" + language.reverseDrawPolygon + \")\" }}</p> ")]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", TerrainOperationvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[7] || (_cache[7] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startOperation(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startOperation,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startOperation), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[8] || (_cache[8] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clear(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/terrainoperation/TerrainOperation.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/terrainoperation/TerrainOperation.vue



const TerrainOperation_exports_ = TerrainOperationvue_type_script_setup_true_lang_js;

/* harmony default export */ var TerrainOperation = (TerrainOperation_exports_);
;// CONCATENATED MODULE: ./src/webgl/terrainoperation/index.js




TerrainOperation.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(TerrainOperation.name, TerrainOperation);
};


;// CONCATENATED MODULE: ./src/webgl/excavatefillanalysis/ExcavateFillAnalysisViewModel.js

//填挖方分析逻辑类

class ExcavateFillAnalysisViewModel {
  //填挖方分析三维对象
  //绘制管理对象
  //填挖方分析存储参数对象
  //绘制完成监听事件
  constructor(scenceView, options, callback) {
    _defineProperty(this, "_excavateFillAnalysis", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_removeEventListener", null);

    options.viewer = scenceView._viewer;
    options.viewer.scene.globe.depthTestAgainstTerrain = true;

    if (options.cutColor) {
      options.cutColor = Cesium.Color.fromCssColorString(options.cutColor).withAlpha(0.7);
    }

    if (options.fillColor) {
      options.fillColor = Cesium.Color.fromCssColorString(options.fillColor).withAlpha(0.7);
    }

    this._options = options;
    this._drawManager = scenceView._drawManager;
    var that = this;
    this._removeEventListener = this._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        options.positions = that.coordinateTransform(shape._controlPoints);
        that._excavateFillAnalysis = new Cesium.Kq3dCutFill(options);

        that._drawManager.clear();

        callback && callback(); // callback && setTimeout(callback, 1500);
      }
    });
  } // 处理绘制坐标，转成二维坐标


  coordinateTransform(points) {
    let cutPoints = points.map(function (point) {
      let cartesPh = Cesium.Cartographic.fromCartesian(point);
      cartesPh.longitude = cartesPh.longitude / Math.PI * 180;
      cartesPh.latitude = cartesPh.latitude / Math.PI * 180;
      let map = {
        longitude: cartesPh.longitude,
        latitude: cartesPh.latitude,
        height: cartesPh.height
      };
      return map;
    });
    return cutPoints;
  } //开始分析


  start() {
    // 判断是否添加了地形
    if (this._options.viewer.terrainProvider.availability) {
      if (this._options.viewer.terrainProvider instanceof Cesium.CesiumTerrainProvider) {
        this._drawManager.startDraw("polygon", {
          clampToGround: true
        });
      } else {
        message({
          message: "只支持STK类型的地形分析!",
          type: "warning"
        });
      }
    } else {
      message({
        message: "请加载地形后分析!",
        type: "warning"
      });
    }
  } //清除全部结果


  clear() {
    this._drawManager.stopDraw();

    this._excavateFillAnalysis && this._excavateFillAnalysis.removeAll();
  } //销毁


  destroy() {
    this.clear(); // this._excavateFillAnalysis && this._excavateFillAnalysis.destroy();

    this._excavateFillAnalysis = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } //设置基准高度


  setReferenceHeight(height) {
    this._options.referenceHeight = Number(height);

    if (this._excavateFillAnalysis) {
      this._excavateFillAnalysis.referenceHeight = Number(height);
    }
  } //设置挖方颜色


  setCutColor(cutColor) {
    this._options.cutColor = Cesium.Color.fromCssColorString(cutColor).withAlpha(0.7);

    if (this._excavateFillAnalysis) {
      this._excavateFillAnalysis.cutColor = this._options.cutColor;
    }
  } //设置填方颜色


  setFillColor(fillColor) {
    this._options.fillColor = Cesium.Color.fromCssColorString(fillColor).withAlpha(0.7);

    if (this._excavateFillAnalysis) {
      this._excavateFillAnalysis.fillColor = this._options.fillColor;
    }
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/excavatefillanalysis/ExcavateFillAnalysis.vue?vue&type=script&setup=true&lang=js

const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-excavate-fill-analysis-box"
};
const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-excavate-fill-analysis-content"
};
const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-excavate-fill-analysis-footer"
};
const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = {
  key: 0,
  class: "kq3d-excavate-fill-analysis-result"
};
const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_5 = {
  class: "kq3d-excavate-fill-analysis-result-div"
};
const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_6 = {
  class: "title"
};






const ExcavateFillAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dExcavateFillAnalysis"
};
/* harmony default export */ var ExcavateFillAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ExcavateFillAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconExcavateFillAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let showResult = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let result = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      cutVolumn: "NaN",
      fillVolumn: "NaN"
    }); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      altitudeHeight: props.settingParams && props.settingParams.altitudeHeight || 2920,
      // 基准高度
      minAltitudeHeight: props.settingParams && props.settingParams.altitudeHeight || 0,
      // 基准高度区间最小值
      maxAltitudeHeight: props.settingParams && props.settingParams.altitudeHeight || 5000,
      // 基准高度区间最大值
      excavateColor: props.settingParams && props.settingParams.excavateColor || "#67C23A",
      // 挖方颜色
      fillColor: props.settingParams && props.settingParams.fillColor || "#E6A23C" //  // 填方颜色

    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.excavateFillAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          var options = {
            referenceHeight: formItem.altitudeHeight,
            cutColor: formItem.excavateColor,
            fillColor: formItem.fillColor
          };
          viewModel = new ExcavateFillAnalysisViewModel(scenceView, options, function () {
            setTimeout(() => {
              showResult.value = true;
              const cutVolumn = viewModel._excavateFillAnalysis.cutVolumn;

              if (cutVolumn > 1000000000) {
                result.cutVolumn = (cutVolumn / 1000000000).toFixed(2) + " km³";
              } else {
                result.cutVolumn = cutVolumn.toFixed(2) + " m³";
              }

              const fillVolumn = viewModel._excavateFillAnalysis.fillVolumn;

              if (fillVolumn > 1000000000) {
                result.fillVolumn = (fillVolumn / 1000000000).toFixed(2) + " km³";
              } else {
                result.fillVolumn = fillVolumn.toFixed(2) + " m³";
              }
            }, 500);
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; //开始分析


    function startAnalysis() {
      // this.clearResult();
      showResult.value = false;
      viewModel && viewModel.clear();
      viewModel && viewModel.start();
    } //清除结果


    function clearResult() {
      showResult.value = false;
      viewModel && viewModel.clear();
    }

    function paramsChanged(key) {
      switch (key) {
        case "height":
          viewModel.setReferenceHeight(formItem.altitudeHeight);

          if (showResult.value) {
            const cutVolumn = viewModel._excavateFillAnalysis.cutVolumn;

            if (cutVolumn > 1000000000) {
              result.cutVolumn = (cutVolumn / 1000000000).toFixed(2) + " km³";
            } else {
              result.cutVolumn = cutVolumn.toFixed(2) + " m³";
            }

            const fillVolumn = viewModel._excavateFillAnalysis.fillVolumn;

            if (fillVolumn > 1000000000) {
              result.fillVolumn = (fillVolumn / 1000000000).toFixed(2) + " km³";
            } else {
              result.fillVolumn = fillVolumn.toFixed(2) + " m³";
            }
          }

          break;

        case "cutColor":
          viewModel.setCutColor(formItem.excavateColor);
          break;

        case "fillColor":
          viewModel.setFillColor(formItem.fillColor);
          break;

        default:
          break;
      }
    }

    function closeBtn() {
      showResult.value = false;
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      startAnalysis,
      paramsChanged,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-excavate-fill-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        style: {
          "display": "flex"
        }
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
          class: "kq3d-excavate-fill-analysis-label",
          style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
            width: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '100px' : '130px'
          })
        }, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).altitudeHeight), 5
        /* TEXT, STYLE */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
          style: {
            "display": "flex"
          }
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 16
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
              modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).altitudeHeight,
              "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).altitudeHeight = $event),
              step: 100,
              min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minAltitudeHeight,
              max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxAltitudeHeight,
              onInput: _cache[1] || (_cache[1] = $event => paramsChanged('height'))
            }, null, 8
            /* PROPS */
            , ["modelValue", "min", "max"])]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
            span: 8,
            style: {
              "text-align": "end"
            }
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
              modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).altitudeHeight,
              "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).altitudeHeight = $event),
              min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minAltitudeHeight,
              step: 100,
              max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxAltitudeHeight,
              "controls-position": "right",
              onInput: _cache[3] || (_cache[3] = $event => paramsChanged('height'))
            }, null, 8
            /* PROPS */
            , ["modelValue", "min", "max"])]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        })])]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-excavate-fill-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).excavateFillTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '90px' : '70px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              gutter: 20
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).efillColor
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillColor,
                    "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillColor = $event),
                    onChange: _cache[5] || (_cache[5] = $event => paramsChanged('fillColor'))
                  }, null, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                  label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).excavateColor
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavateColor,
                    "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).excavateColor = $event),
                    onChange: _cache[7] || (_cache[7] = $event => paramsChanged('cutColor'))
                  }, null, 8
                  /* PROPS */
                  , ["modelValue"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["label"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[8] || (_cache[8] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[9] || (_cache[9] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showResult) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_4, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-excavate-fill-analysis-result-title"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", ExcavateFillAnalysisvue_type_script_setup_true_lang_js_hoisted_6, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisResult), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-col :span=\"6\" class=\"btn\">\r\n              <kq-icon @click=\"closeBtn()\">\r\n                <Close />\r\n              </kq-icon>\r\n            </kq-col> ")]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).excavateArea) + "：" + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).cutVolumn), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fillArea) + "：" + (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(result).fillVolumn), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      })])])])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/excavatefillanalysis/ExcavateFillAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/excavatefillanalysis/ExcavateFillAnalysis.vue



const ExcavateFillAnalysis_exports_ = ExcavateFillAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var ExcavateFillAnalysis = (ExcavateFillAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/excavatefillanalysis/index.js




ExcavateFillAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ExcavateFillAnalysis.name, ExcavateFillAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/floodanalysis/FloodAnalysisViewModel.js

 //地形淹没分析逻辑类


class FloodAnalysisViewModel {
  //地形淹没三维对象
  //模型淹没三维对象
  //测量三维对象
  //测量结果
  //淹没模式
  constructor(scenceView, options) {
    _defineProperty(this, "_options", {});

    _defineProperty(this, "_floodTerrainAnalysis", null);

    _defineProperty(this, "_floodModelAnalysis", null);

    _defineProperty(this, "_measureHandler", null);

    _defineProperty(this, "_measureResult", null);

    _defineProperty(this, "_mode", 0);

    _defineProperty(this, "_colorImages", [//淹没纹理图片集合
    {
      value: "0",
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: "1",
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: "2",
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }]);

    this._mode = options.mode;
    options.viewer = scenceView._viewer;
    options.viewer.scene.globe.depthTestAgainstTerrain = true;
    options.colorImage = this.getImagePath(options.colorImage);
    this._options = options; //this._floodModelAnalysis = new Cesium.Kq3dFloodModelAnalysis(options);

    this._floodModelAnalysis = scenceView._floodModelAnalysis;
    this._floodModelAnalysis.moveMode = options.moveMode;
    this._floodModelAnalysis.speed = options.speed;
    this._floodModelAnalysis.alpha = options.alpha;
    this._floodModelAnalysis.minHeight = options.minHeight;
    this._floodModelAnalysis.maxHeight = options.maxHeight;
    this._floodModelAnalysis.colorImage = options.colorImage;
    var that = this;
    this._measureHandler = new Cesium.Kq3dMeasureHandler(scenceView._viewer, {
      dblClickEnd: true
    });

    this._measureHandler.measureEvent.addEventListener(function (result) {
      that._measureResult = result;
      result.measureResult.label.show = false;
    });

    this._measureHandler.activeEvent.addEventListener(function (ret) {
      if (ret == false) {
        if (that._measureResult) {
          if (that._mode === 0) {
            that._options.positions = that._measureResult.positions;

            if (!that._floodTerrainAnalysis) {
              that._floodTerrainAnalysis = new Cesium.Kq3dFloodTerrainAnalysis(that._options);
            } else {
              that._floodTerrainAnalysis.positions = that._measureResult.positions;
            }

            that._floodTerrainAnalysis.start();
          } else if (that._mode === 1) {
            if (that._measureResult.positions && that._measureResult.positions.length > 0) {
              that._floodModelAnalysis.center = that._measureResult.positions[0];
            }

            let polygon = Cesium.PolygonGeometry.fromPositions({
              positions: that._measureResult.positions
            });

            that._floodModelAnalysis.addPolygon(polygon);

            that._floodModelAnalysis.start();
          }

          that._measureResult.measureResult.destroy();
        }
      }
    });
  } //获取图片路径


  getImagePath(value) {
    var imagePath = '';

    var image = this._colorImages.find(item => item.value === value);

    if (image) {
      imagePath = image.src;
    }

    return imagePath;
  } //开始分析


  start() {
    // 判断是否添加了地形
    if (this._mode === 0) {
      if (this._floodModelAnalysis.viewer.terrainProvider.availability) {
        if (this._floodModelAnalysis.viewer.terrainProvider instanceof Cesium.CesiumTerrainProvider) {
          this.clear();

          this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.HorizontalArea);
        } else {
          message({
            message: "只支持STK类型的地形分析!",
            type: "warning"
          });
        }
      } else {
        message({
          message: "请加载地形后分析!",
          type: "warning"
        });
      }
    } else if (this._mode === 1) {
      var modelFlag = false;
      var models = this._floodModelAnalysis.viewer.scene.primitives._primitives;

      for (let i = 0; i < models.length; i++) {
        if (models[i] instanceof Cesium.Cesium3DTileset) {
          modelFlag = true;
          break;
        }
      }

      if (modelFlag) {
        this.clear();

        this._measureHandler.startMeasure(Cesium.Kq3dMeasureMode.HorizontalArea);
      } else {
        message({
          message: "请添加模型后分析!",
          type: "warning"
        });
      }
    }
  } //清除全部结果


  clear() {
    this._measureHandler.stopMeasure();

    if (this._floodTerrainAnalysis) {
      var options = {
        viewer: this._floodTerrainAnalysis.viewer,
        moveMode: this._floodTerrainAnalysis.moveMode,
        speed: this._floodTerrainAnalysis.speed,
        alpha: this._floodTerrainAnalysis.alpha,
        positions: this._floodTerrainAnalysis.positions,
        minHeight: this._floodTerrainAnalysis.minHeight,
        maxHeight: this._floodTerrainAnalysis.maxHeight,
        colorImage: this._floodTerrainAnalysis.colorImage
      };

      this._floodTerrainAnalysis.destroy();

      this._floodTerrainAnalysis = new Cesium.Kq3dFloodTerrainAnalysis(options);
    }

    if (this._floodModelAnalysis) {
      this._floodModelAnalysis.reset();
    }
  } //销毁


  destroy() {
    this._floodTerrainAnalysis && this._floodTerrainAnalysis.destroy();
    this._floodTerrainAnalysis = null;
    this._floodModelAnalysis && this._floodModelAnalysis.reset();
    this._floodModelAnalysis = null;
    this._measureHandler && this._measureHandler.destroy();
    this._measureHandler = null;
  } //设置淹没模式


  setMoveMode(mode) {
    this._mode = Number(mode);
  } //设置淹没方向


  setMoveDirection(direction) {
    direction = Number(direction);
    this._options.moveMode = direction;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.moveMode = direction;
    if (this._floodModelAnalysis) this._floodModelAnalysis.moveMode = direction;
  } //设置淹没速度


  setMoveSpeed(speed) {
    speed = Number(speed);
    this._options.speed = speed;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.speed = speed;
    if (this._floodModelAnalysis) this._floodModelAnalysis.speed = speed;
  } //设置淹没纹理透明度


  setMoveAlpha(alpha) {
    alpha = Number(alpha);
    this._options.alpha = alpha;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.alpha = alpha;
    if (this._floodModelAnalysis) this._floodModelAnalysis.alpha = alpha;
  } //设置最小淹没高度


  setMoveMinHeight(minHeight) {
    minHeight = Number(minHeight);
    this._options.minHeight = minHeight;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.minHeight = minHeight;
    if (this._floodModelAnalysis) this._floodModelAnalysis.minHeight = minHeight;
  } //设置最大淹没高度


  setMoveMaxHeight(maxHeight) {
    maxHeight = Number(maxHeight);
    this._options.maxHeight = maxHeight;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.maxHeight = maxHeight;
    if (this._floodModelAnalysis) this._floodModelAnalysis.maxHeight = maxHeight;
  } //设置淹没填充纹理


  setMoveImage(image) {
    this._options.colorImage = image;
    if (this._floodTerrainAnalysis) this._floodTerrainAnalysis.colorImage = image;
    if (this._floodModelAnalysis) this._floodModelAnalysis.colorImage = image;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/floodanalysis/FloodAnalysis.vue?vue&type=script&setup=true&lang=js

const FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-flood-analysis-box"
};
const FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = ["src"];
const FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-flood-analysis-footer"
};







const FloodAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dFloodAnalysis"
};
/* harmony default export */ var FloodAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(FloodAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    //指定组件绑定的viewer对象的div的id
    target: String,
    // 是否显示淹没模式下拉选择框
    isShowMode: {
      type: Boolean,
      default: true
    },
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconFloodAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 淹没色调图片

    const colorImages = [{
      value: "0",
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: "1",
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: "2",
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }]; // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      floodMode: props.settingParams && props.settingParams.floodMode || 0,
      // 淹没模式：0：地形淹没 1：模型淹没
      floodDirection: props.settingParams && props.settingParams.floodDirection || 1,
      // 淹没方向，0：单向 1：双向
      floodSpeed: props.settingParams && props.settingParams.floodSpeed || 300,
      // 淹没速度
      minFloodSpeed: props.settingParams && props.settingParams.minFloodSpeed || 0,
      // 淹没速度最小值
      maxFloodSpeed: props.settingParams && props.settingParams.maxFloodSpeed || 1000,
      // 淹没速度最大值
      floodAlpha: props.settingParams && props.settingParams.floodAlpha || 0.85,
      // 淹没透明度
      minFloodAlpha: props.settingParams && props.settingParams.minFloodAlpha || 0,
      // 淹没透明度范围最小值
      maxFloodAlpha: props.settingParams && props.settingParams.maxFloodAlpha || 1,
      // 淹没透明度范围最大值
      floodHeightStep: props.settingParams && props.settingParams.floodHeightStep || 100,
      // 淹没高度的控件间隔
      floodMinHeight: props.settingParams && props.settingParams.floodMinHeight || 1200,
      // 淹没高度最小值
      minFloodMinHeight: props.settingParams && props.settingParams.minFloodMinHeight || 0,
      // 淹没最小高度范围的最小值
      maxFloodMinHeight: props.settingParams && props.settingParams.maxFloodMinHeight || 10000,
      // 淹没最小高度范围的最大值
      floodMaxHeight: props.settingParams && props.settingParams.floodMaxHeight || 5000,
      // 淹没高度最大值
      minFloodMaxHeight: props.settingParams && props.settingParams.minFloodMaxHeight || 0,
      // 淹没最大高度范围的最小值
      maxFloodMaxHeight: props.settingParams && props.settingParams.maxFloodMaxHeight || 10000,
      // 淹没最大高度范围的最大值
      floodColorImage: props.settingParams && props.settingParams.floodColorImage || "0" // 淹没纹理色带值

    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = (formItem.floodMode == 0 ? language.value.floodTerrain : language.value.floodModel) + language.value.floodAnalysis1;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(props.target, scenceView => {
        if (scenceView) {
          viewModel = new FloodAnalysisViewModel(scenceView, {
            mode: formItem.floodMode,
            moveMode: formItem.floodDirection,
            speed: formItem.floodSpeed,
            alpha: formItem.floodAlpha,
            minHeight: formItem.floodMinHeight,
            maxHeight: formItem.floodMaxHeight,
            colorImage: formItem.floodColorImage
          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; //获取图片路径


    function getImagePath(value) {
      var imagePath = "";
      var image = colorImages.find(item => item.value === value);

      if (image) {
        imagePath = image.src;
      }

      return imagePath;
    } // 开始分析


    function startAnalysis() {
      viewModel && viewModel.start();
    } // 清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 参数切换


    function paramsChanged(key) {
      if (!viewModel) return;

      switch (key) {
        case "mode":
          viewModel.setMoveMode(formItem.floodMode);
          break;

        case "moveMode":
          viewModel.setMoveDirection(formItem.floodDirection);
          break;

        case "speed":
          viewModel.setMoveSpeed(formItem.floodSpeed);
          break;

        case "alpha":
          viewModel.setMoveAlpha(formItem.floodAlpha);
          break;

        case "minHeight":
          viewModel.setMoveMinHeight(formItem.floodMinHeight);
          break;

        case "maxHeight":
          viewModel.setMoveMaxHeight(formItem.floodMaxHeight);
          break;

        case "colorImage":
          var imageUrl = getImagePath(formItem.floodColorImage);
          viewModel.setMoveImage(imageUrl);
          break;

        default:
          break;
      }
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      startAnalysis,
      clearResult,
      getImagePath,
      paramsChanged
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_radio_group = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio-group");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-flood-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-flood-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "110px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [__props.isShowMode ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_form_item, {
                key: 0,
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodMode
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMode,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMode = $event),
                  onChange: _cache[1] || (_cache[1] = $event => paramsChanged('mode'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodTerrain,
                    value: 0
                  }, null, 8
                  /* PROPS */
                  , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodModel,
                    value: 1
                  }, null, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodDirection
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodDirection,
                  "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodDirection = $event),
                  onChange: _cache[3] || (_cache[3] = $event => paramsChanged('moveMode'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodDirection0,
                    value: 0
                  }, null, 8
                  /* PROPS */
                  , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodDirection1,
                    value: 1
                  }, null, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodSpeed
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodSpeed,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodSpeed = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodSpeed,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodSpeed,
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('speed'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodSpeed,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodSpeed = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodSpeed,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodSpeed,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('speed'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodAlpha
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodAlpha,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodAlpha = $event),
                      step: 0.01,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodAlpha,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodAlpha,
                      onInput: _cache[9] || (_cache[9] = $event => paramsChanged('alpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodAlpha,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodAlpha = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodAlpha,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodAlpha,
                      step: 0.01,
                      "controls-position": "right",
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('alpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodMinHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMinHeight,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMinHeight = $event),
                      step: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodHeightStep,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodMinHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodMinHeight,
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('minHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMinHeight,
                      "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMinHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodMinHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodMinHeight,
                      step: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodHeightStep,
                      "controls-position": "right",
                      onInput: _cache[15] || (_cache[15] = $event => paramsChanged('minHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodMaxHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMaxHeight,
                      "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMaxHeight = $event),
                      step: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodHeightStep,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodMaxHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodMaxHeight,
                      onInput: _cache[17] || (_cache[17] = $event => paramsChanged('maxHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMaxHeight,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodMaxHeight = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFloodMaxHeight,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFloodMaxHeight,
                      step: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodHeightStep,
                      "controls-position": "right",
                      onInput: _cache[19] || (_cache[19] = $event => paramsChanged('maxHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).floodColorImage
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio_group, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodColorImage,
                  "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).floodColorImage = $event),
                  onChange: _cache[21] || (_cache[21] = $event => paramsChanged('colorImage'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)(colorImages, (item, index) => {
                    return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                      key: index,
                      label: item.value
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                        class: "kq3d-flood-analysis-legend",
                        src: item.src,
                        alt: ""
                      }, null, 8
                      /* PROPS */
                      , FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_2)]),
                      _: 2
                      /* DYNAMIC */

                    }, 1032
                    /* PROPS, DYNAMIC_SLOTS */
                    , ["label"]);
                  }), 64
                  /* STABLE_FRAGMENT */
                  ))]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          })]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", FloodAnalysisvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[22] || (_cache[22] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[23] || (_cache[23] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/floodanalysis/FloodAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/floodanalysis/FloodAnalysis.vue



const FloodAnalysis_exports_ = FloodAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var FloodAnalysis = (FloodAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/floodanalysis/index.js




FloodAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(FloodAnalysis.name, FloodAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/slopeanalysis/SlopeAnalysisViewModel.js

 // 分析逻辑类


class SlopeAnalysisViewModel {
  // 坡度坡向三维对象
  constructor(scenceView, viewModel) {
    _defineProperty(this, "_slopeAnalysis", null);

    _defineProperty(this, "_globaOptions", {
      //全局参数
      viewer: null,
      _drawManager: null
    });

    _defineProperty(this, "_colorImages", [//渐变图片集合
    {
      value: "0",
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: "1",
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: "2",
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }]);

    this._globaOptions.viewer = scenceView._viewer;
    this._globaOptions.viewModel = {
      fillStyle: viewModel.fillStyle,
      viewer: this._globaOptions.viewer,
      isFilter: false,
      // 自定义颜色
      colorTableDegree: viewModel.colorTableDegree,
      colorTable: viewModel.colorTable,
      // 渐变纹理
      imageSrc: this.getColorLine(viewModel.colorImage),
      // 坡度过滤
      minSlope: viewModel.minSlope,
      maxSlope: viewModel.maxSlope,
      slopeColorText: viewModel.slopeColorText,
      slopeColorAlpha: viewModel.slopeColorAlpha,
      colorImage: this.getImagePath(viewModel.colorImage)
    };
    this._globaOptions.viewer.scene.globe.depthTestAgainstTerrain = true; //开启深度检测
    // this._globaOptions.viewer.scene.globe.enableLighting = true;

    this._globaOptions._drawManager = scenceView._drawManager;
    var that = this;
    that._slopeAnalysis = new Cesium.Kq3dSlope({
      viewer: that._globaOptions.viewer,
      positions: [new Cesium.Cartesian3(528486.4951355414, 5591866.071664512, 3011848.5874731047), new Cesium.Cartesian3(511851.92328430264, 5590161.386242805, 3017839.604729828), new Cesium.Cartesian3(512863.7934440037, 5579087.150988879, 3037957.9974059854), new Cesium.Cartesian3(526764.7827270611, 5574253.865524863, 3044401.4321003747), new Cesium.Cartesian3(544782.217496756, 5578126.194618411, 3034189.5478781504), new Cesium.Cartesian3(546626.3798432688, 5588179.698741777, 3015426.663665117)],
      isFilter: false,
      colorTableDegree: that._globaOptions.viewModel.colorTableDegree,
      colorTable: that._globaOptions.viewModel.colorTable
    });

    that._slopeAnalysis.destroy();

    that._slopeAnalysis = null;
    this._globaOptions._drawFinishedEventListener = this._globaOptions._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._globaOptions.viewModel.positions = shape._controlPoints; // 实例化分析对象

        if (!that._slopeAnalysis) {
          switch (that._globaOptions.viewModel.fillStyle) {
            case "tableColor":
              that._slopeAnalysis = new Cesium.Kq3dSlope({
                viewer: that._globaOptions.viewer,
                positions: that._globaOptions.viewModel.positions,
                isFilter: false,
                colorTableDegree: that._globaOptions.viewModel.colorTableDegree,
                colorTable: that._globaOptions.viewModel.colorTable
              });
              break;

            case "colorImage":
              that._slopeAnalysis = new Cesium.Kq3dSlope({
                viewer: that._globaOptions.viewer,
                positions: that._globaOptions.viewModel.positions,
                isFilter: false,
                colorImage: that._globaOptions.viewModel.imageSrc
              });
              break;

            case "slopeFilter":
              that._slopeAnalysis = new Cesium.Kq3dSlope({
                viewer: that._globaOptions.viewer,
                positions: that._globaOptions.viewModel.positions,
                isFilter: true,
                minSlope: that._globaOptions.viewModel.minSlope,
                maxSlope: that._globaOptions.viewModel.maxSlope,
                color: Cesium.Color.fromCssColorString(that._globaOptions.viewModel.slopeColorText).withAlpha(Number(that._globaOptions.viewModel.slopeColorAlpha))
              });
              break;
          }
        } else {
          that._slopeAnalysis.positions = that._globaOptions.viewModel.positions;
        }

        that._globaOptions._drawManager.clear();
      }
    });
  } //获取图片路径


  getImagePath(value) {
    var imagePath = '';

    var image = this._colorImages.find(item => item.value === value);

    if (image) {
      imagePath = image.src;
    }

    return imagePath;
  } // 开始分析


  start() {
    // 判断是否添加了地形
    if (this._globaOptions.viewModel.viewer.terrainProvider.availability) {
      if (this._globaOptions.viewModel.viewer.terrainProvider instanceof Cesium.CesiumTerrainProvider) {
        if (this._globaOptions.viewModel.fillStyle === "slopeFilter") {
          // 坡度过滤不需要进行绘制
          this._slopeAnalysis = new Cesium.Kq3dSlope({
            viewer: this._globaOptions.viewer,
            positions: [],
            isFilter: true,
            minSlope: this._globaOptions.viewModel.minSlope,
            maxSlope: this._globaOptions.viewModel.maxSlope,
            color: Cesium.Color.fromCssColorString(this._globaOptions.viewModel.slopeColorText).withAlpha(Number(this._globaOptions.viewModel.slopeColorAlpha))
          });
        } else {
          // this.clear();
          if (this._globaOptions._drawManager) {
            this._globaOptions._drawManager.startDraw("polygon", {
              clampToGround: true
            });
          }
        }
      } else {
        message({
          message: "只支持STK类型的地形分析!",
          type: "warning"
        });
      }
    } else {
      message({
        message: "请加载地形后分析!",
        type: "warning"
      });
    }
  } //修改填充样式


  changeFilltyle(key) {
    this._globaOptions.viewModel.fillStyle = key;
    if (!this._slopeAnalysis) return;

    switch (key) {
      case "tableColor":
        if (this._slopeAnalysis.isFilter) this._slopeAnalysis.isFilter = false;
        this._slopeAnalysis.colorImage = null;
        this._slopeAnalysis.color = null;
        this._slopeAnalysis.colorTableDegree = this._globaOptions.viewModel.colorTableDegree;
        this._slopeAnalysis.colorTable = this._globaOptions.viewModel.colorTable;
        break;

      case "colorImage":
        if (this._slopeAnalysis.isFilter) this._slopeAnalysis.isFilter = false;
        this._slopeAnalysis.colorTableDegree = [];
        this._slopeAnalysis.colorTable = [];
        this._slopeAnalysis.color = null;
        this._slopeAnalysis.colorImage = this._globaOptions.viewModel.imageSrc;
        break;

      case "slopeFilter":
        this._slopeAnalysis.colorImage = null;
        this._slopeAnalysis.isFilter = true;
        this._slopeAnalysis.minSlope = this._globaOptions.viewModel.minSlope, this._slopeAnalysis.maxSlope = this._globaOptions.viewModel.maxSlope, this._slopeAnalysis.color = Cesium.Color.fromCssColorString(this._globaOptions.viewModel.slopeColorText).withAlpha(Number(this._globaOptions.viewModel.slopeColorAlpha));
        break;
    }
  } // 设置填充纹理值


  setColorTableDegree(newValue) {
    this._globaOptions.viewModel.colorTableDegree = newValue;
    if (this._slopeAnalysis) this._slopeAnalysis.colorTableDegree = this._globaOptions.viewModel.colorTableDegree;
  } // 设置填充纹理颜色


  setColorTable(newValue) {
    this._globaOptions.viewModel.colorTable = newValue;
    if (this._slopeAnalysis) this._slopeAnalysis.colorTable = this._globaOptions.viewModel.colorTable;
  } // 设置填充纹理


  setColorImage(newValue) {
    this._globaOptions.viewModel.imageSrc = newValue;
    if (this._slopeAnalysis) this._slopeAnalysis.colorImage = this._globaOptions.viewModel.imageSrc;
  } // 设置渐变纹理


  getColorLine(key) {
    var path = "";

    switch (key) {
      case 0:
        path = const_image_namespaceObject.RED_TO_PURPLE_URL;
        break;

      case 1:
        path = const_image_namespaceObject.PURPLE_TO_YELLOW_URL;
        break;

      case 2:
        path = const_image_namespaceObject.GREEN_TO_BLUE_URL;
        break;

      default:
        path = const_image_namespaceObject.RED_TO_PURPLE_URL;
        break;
    }

    return path;
  } // 设置坡度过滤样式


  setSlopeFilterColor(slopeColorText, slopeColorAlpha) {
    this._globaOptions.viewModel.slopeColorText = slopeColorText;
    this._globaOptions.viewModel.slopeColorAlpha = Number(slopeColorAlpha);
    if (this._slopeAnalysis) this._slopeAnalysis.color = Cesium.Color.fromCssColorString(slopeColorText).withAlpha(Number(slopeColorAlpha));
  } // 设置最小坡度值


  setSlopeFilterMin(newValue) {
    this._globaOptions.viewModel.minSlope = Number(newValue);
    if (this._slopeAnalysis) this._slopeAnalysis.minSlope = this._globaOptions.viewModel.minSlope;
  } // 设置最大坡度值


  setSlopeFilterMax(newValue) {
    this._globaOptions.viewModel.maxSlope = Number(newValue);
    if (this._slopeAnalysis) this._slopeAnalysis.maxSlope = this._globaOptions.viewModel.maxSlope;
  } // 清除全部结果


  clear() {
    this._globaOptions._drawManager && this._globaOptions._drawManager.stopDraw();
    this._slopeAnalysis && this._slopeAnalysis.destroy();
    this._slopeAnalysis = null;
  } // 销毁


  destroy() {
    // 移除监听事件
    this._globaOptions._drawFinishedEventListener && this._globaOptions._drawFinishedEventListener();
    this._globaOptions._drawFinishedEventListener = null;
    this._slopeAnalysis && this._slopeAnalysis.destroy();
    this._slopeAnalysis = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/slopeanalysis/SlopeAnalysis.vue?vue&type=script&setup=true&lang=js

const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-slope-analysis-box"
};
const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  key: 0
};
const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-slope-analysis-span"
};
const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = {
  key: 1
};

const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_5 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, "0°", -1
/* HOISTED */
);

const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_6 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
  class: "kq3d-slope-analysis-line"
}, null, -1
/* HOISTED */
);

const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_7 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, "90°", -1
/* HOISTED */
);

const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_8 = ["src"];
const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_9 = {
  key: 2
};
const SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_10 = {
  class: "kq3d-slope-analysis-footer"
};







const SlopeAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dSlopeAnalysis"
};
/* harmony default export */ var SlopeAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(SlopeAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconSlopeAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let dataList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([{
      colorTableDegree: 0,
      colorTable: null
    }, {
      colorTableDegree: 10,
      colorTable: "#00FF00"
    }, {
      colorTableDegree: 20,
      colorTable: "#0000FF"
    }, {
      colorTableDegree: 30,
      colorTable: "#FFFF00"
    }, {
      colorTableDegree: 40,
      colorTable: "#FF7F00"
    }, {
      colorTableDegree: 90,
      colorTable: "#FF0000"
    }]);
    const colorImages = [{
      value: 0,
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: 1,
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: 2,
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }]; //计算属性
    // 获取组件传参
    // 分析类

    let viewModel = null; // 默认参数

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      fillStyle: props.settingParams && props.settingParams.fillStyle || "tableColor",
      colorTableDegree: props.settingParams && props.settingParams.colorTableDegree || [10, 20, 30, 40, 90],
      colorTable: props.settingParams && props.settingParams.colorTable || ["#00FF00", "#0000FF", "#FFFF00", "#FF7F00", "#FF0000"],
      colorImage: props.settingParams && props.settingParams.colorImage || 0,
      minSlope: props.settingParams && props.settingParams.minSlope || 10,
      maxSlope: props.settingParams && props.settingParams.maxSlope || 60,
      slopeColorAlpha: props.settingParams && props.settingParams.slopeColorAlpha || 0.3,
      slopeColorText: props.settingParams && props.settingParams.slopeColorText || "#FF0000"
    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.slopeAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          refactorArr();
          viewModel = new SlopeAnalysisViewModel(scenceView, formItem); // var imageUrl = getImagePath(formItem.colorImage);
          // viewModel.setColorImage(imageUrl);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 刷新自定义样式数组


    function refactorArr(type) {
      if (!dataList || !dataList.length) return;

      if (type == "degree") {
        formItem.colorTableDegree = dataList.map(item => {
          return item.colorTableDegree;
        });
        formItem.colorTableDegree.shift();
      } else if (type == "color") {
        formItem.colorTable = dataList.map(item => {
          return item.colorTable;
        });
        formItem.colorTable.shift();
      }
    } //获取图片路径


    function getImagePath(value) {
      var imagePath = "";
      var image = colorImages.find(item => item.value === value);

      if (image) {
        imagePath = image.src;
      }

      return imagePath;
    } // 参数改变


    function paramsChanged(key) {
      switch (key) {
        case "fillStyle":
          // 填充样式
          viewModel.changeFilltyle(formItem.fillStyle);
          break;

        case "colorTableDegree":
          // 自定义填充样式区间
          refactorArr("degree");
          viewModel.setColorTableDegree(formItem.colorTableDegree);
          break;

        case "colorTable":
          // 自定义填充样式颜色
          refactorArr("color");
          viewModel.setColorTable(formItem.colorTable);
          break;

        case "colorImage":
          // 填充样式
          var imageUrl = getImagePath(formItem.colorImage);
          viewModel.setColorImage(imageUrl);
          break;

        case "minSlope":
          // 填充样式
          viewModel.setSlopeFilterMin(formItem.minSlope);
          break;

        case "maxSlope":
          // 填充样式
          viewModel.setSlopeFilterMax(formItem.maxSlope);
          break;

        case "slopeColorAlpha":
          // 填充样式
          viewModel.setSlopeFilterColor(formItem.slopeColorText, formItem.slopeColorAlpha);
          break;

        case "slopeColorText":
          // 填充样式
          viewModel.setSlopeFilterColor(formItem.slopeColorText, formItem.slopeColorAlpha);
          break;

        default:
          break;
      }
    } // 开始分析


    function startAnalysis() {
      clearResult();
      viewModel && viewModel.start();
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      refactorArr,
      getImagePath,
      paramsChanged,
      startAnalysis,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_radio_group = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio-group");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-slope-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle !== 'slopeFilter' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
        key: 0,
        class: "kq3d-slope-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue)
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '90px' : '120px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "block"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fillStyle
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle = $event),
                  onChange: _cache[1] || (_cache[1] = $event => paramsChanged('fillStyle'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).customColorScheme,
                    value: "tableColor"
                  }, null, 8
                  /* PROPS */
                  , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientTexture,
                    value: "colorImage"
                  }, null, 8
                  /* PROPS */
                  , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).slopeFilter,
                    value: "slopeFilter"
                  }, null, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 'tableColor' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 18
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setSlopeRange), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 6
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setColor), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList), (item, index) => {
              return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
                key: index,
                style: {
                  "display": "flex",
                  "padding-bottom": "8px"
                }
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index > 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, {
                  key: 0
                }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                  span: 18
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 0,
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableDegree,
                    "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableDegree = $event,
                    disabled: true,
                    onInput: _cache[2] || (_cache[2] = $event => paramsChanged('colorTableDegree')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index > 1 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 1,
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableDegree,
                    "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableDegree = $event,
                    disabled: true,
                    step: 1,
                    onInput: _cache[3] || (_cache[3] = $event => paramsChanged('colorTableDegree')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).to), 1
                  /* TEXT */
                  ), index > 0 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 2,
                    modelValue: item.colorTableDegree,
                    "onUpdate:modelValue": $event => item.colorTableDegree = $event,
                    min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableDegree,
                    max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index + 1].colorTableDegree,
                    step: 1,
                    onInput: _cache[4] || (_cache[4] = $event => paramsChanged('colorTableDegree')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue", "min", "max"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index === (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 3,
                    modelValue: item.colorTableDegree,
                    "onUpdate:modelValue": $event => item.colorTableDegree = $event,
                    step: 1,
                    disabled: true,
                    onInput: _cache[5] || (_cache[5] = $event => paramsChanged('colorTableDegree')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                  _: 2
                  /* DYNAMIC */

                }, 1024
                /* DYNAMIC_SLOTS */
                ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                  span: 6
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                    modelValue: item.colorTable,
                    "onUpdate:modelValue": $event => item.colorTable = $event,
                    onChange: _cache[6] || (_cache[6] = $event => paramsChanged('colorTable'))
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])]),
                  _: 2
                  /* DYNAMIC */

                }, 1024
                /* DYNAMIC_SLOTS */
                )], 64
                /* STABLE_FRAGMENT */
                )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                _: 2
                /* DYNAMIC */

              }, 1024
              /* DYNAMIC_SLOTS */
              );
            }), 128
            /* KEYED_FRAGMENT */
            ))])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 'colorImage' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_4, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_5, SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_6, SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_7]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio_group, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage,
                  "onUpdate:modelValue": _cache[7] || (_cache[7] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage = $event),
                  onChange: _cache[8] || (_cache[8] = $event => paramsChanged('colorImage'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)(colorImages, (item, index) => {
                    return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                      key: index,
                      label: index
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                        class: "kq3d-slope-analysis-legend",
                        src: item.src,
                        alt: ""
                      }, null, 8
                      /* PROPS */
                      , SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_8)]),
                      _: 2
                      /* DYNAMIC */

                    }, 1032
                    /* PROPS, DYNAMIC_SLOTS */
                    , ["label"]);
                  }), 64
                  /* STABLE_FRAGMENT */
                  ))]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 'slopeFilter' ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_9, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).minSlope
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSlope,
                      "onUpdate:modelValue": _cache[9] || (_cache[9] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSlope = $event),
                      step: 1,
                      min: 0,
                      max: 90,
                      onInput: _cache[10] || (_cache[10] = $event => paramsChanged('minSlope'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSlope,
                      "onUpdate:modelValue": _cache[11] || (_cache[11] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSlope = $event),
                      step: 1,
                      min: 0,
                      max: 90,
                      "controls-position": "right",
                      onInput: _cache[12] || (_cache[12] = $event => paramsChanged('minSlope'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).maxSlope
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSlope,
                      "onUpdate:modelValue": _cache[13] || (_cache[13] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSlope = $event),
                      step: 1,
                      min: 0,
                      max: 90,
                      onInput: _cache[14] || (_cache[14] = $event => paramsChanged('maxSlope'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSlope,
                      "onUpdate:modelValue": _cache[15] || (_cache[15] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSlope = $event),
                      step: 1,
                      min: 0,
                      max: 90,
                      "controls-position": "right",
                      onInput: _cache[16] || (_cache[16] = $event => paramsChanged('maxSlope'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).transparents
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorAlpha,
                      "onUpdate:modelValue": _cache[17] || (_cache[17] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorAlpha = $event),
                      min: 0,
                      max: 1,
                      step: 0.01,
                      onInput: _cache[18] || (_cache[18] = $event => paramsChanged('slopeColorAlpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorAlpha,
                      "onUpdate:modelValue": _cache[19] || (_cache[19] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorAlpha = $event),
                      min: 0,
                      max: 1,
                      step: 0.01,
                      "controls-position": "right",
                      onInput: _cache[20] || (_cache[20] = $event => paramsChanged('slopeColorAlpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "padding-bottom": "8px"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).color
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorText,
                  "onUpdate:modelValue": _cache[21] || (_cache[21] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).slopeColorText = $event),
                  onChange: _cache[22] || (_cache[22] = $event => paramsChanged('slopeColorText'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", SlopeAnalysisvue_type_script_setup_true_lang_js_hoisted_10, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[23] || (_cache[23] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[24] || (_cache[24] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/slopeanalysis/SlopeAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/slopeanalysis/SlopeAnalysis.vue



const SlopeAnalysis_exports_ = SlopeAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var SlopeAnalysis = (SlopeAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/slopeanalysis/index.js




SlopeAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(SlopeAnalysis.name, SlopeAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/aspectanalysis/AspectAnalysisViewModel.js


/**
 * 坡向逻辑类
 **/

class AspectAnalysisViewModel {
  // 坡向三维对象
  constructor(scenceView, aspect) {
    _defineProperty(this, "_aspectAnalysis", null);

    _defineProperty(this, "_globaOptions", {
      //全局参数
      viewer: null,
      _drawManager: null
    });

    this._globaOptions.viewer = scenceView._viewer;
    let options = {
      interval: aspect.interval || 500,
      // 采样间隔
      width: aspect.arrowWidth || 20,
      // 箭头宽度
      color: Cesium.Color.fromCssColorString(aspect.color || "#FFFF00"),
      // 箭头颜色
      viewer: scenceView._viewer
    };
    this._globaOptions.viewer.scene.globe.depthTestAgainstTerrain = true; //开启深度检测
    // this._globaOptions.viewer.scene.globe.enableLighting = true;

    this._globaOptions._drawManager = scenceView._drawManager;
    var that = this;
    this._aspectAnalysis = new Cesium.Kq3dAspect(options);
    this._globaOptions._drawFinishedEventListener = this._globaOptions._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._aspectAnalysis.positions = shape._controlPoints;

        that._globaOptions._drawManager.clear();
      }
    });
  } // 开始分析


  start() {
    // 判断是否添加了地形
    if (this._globaOptions.viewer.terrainProvider.availability) {
      if (this._globaOptions.viewer.terrainProvider instanceof Cesium.CesiumTerrainProvider) {
        if (this._globaOptions._drawManager) {
          this.clear();

          this._globaOptions._drawManager.startDraw("polygon", {
            clampToGround: true
          });
        }
      } else {
        message({
          message: "只支持STK类型的地形分析!",
          type: "warning"
        });
      }
    } else {
      message({
        message: "请加载地形后分析!",
        type: "warning"
      });
    }
  } // 设置采样间隔


  setInterval(newValue) {
    if (this._aspectAnalysis) this._aspectAnalysis._interval = newValue;
  } // 设置箭头宽度


  setArrowWidth(newValue) {
    if (this._aspectAnalysis) this._aspectAnalysis._width = newValue;
  } // 设置箭头颜色


  setArrowColor(newValue) {
    if (this._aspectAnalysis) this._aspectAnalysis._color = Cesium.Color.fromCssColorString(newValue);
  } // 清除全部结果


  clear() {
    this._globaOptions._drawManager && this._globaOptions._drawManager.stopDraw();
    this._aspectAnalysis && this._aspectAnalysis.clear();
  } // 销毁


  destroy() {
    // 移除监听事件
    this._globaOptions._drawFinishedEventListener && this._globaOptions._drawFinishedEventListener();
    this._globaOptions._drawFinishedEventListener = null;
    this._aspectAnalysis && this._aspectAnalysis.clear();
    this._aspectAnalysis = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/aspectanalysis/AspectAnalysis.vue?vue&type=script&setup=true&lang=js

const AspectAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-aspect-analysis-box"
};
const AspectAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-aspect-analysis-footer"
};






const AspectAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dAspectAnalysis"
};
/* harmony default export */ var AspectAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(AspectAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconAspectAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); // 获取组件传参
    // 分析类

    let viewModel = null; // 默认参数

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      interval: props.settingParams && props.settingParams.interval || 500,
      // 采样间隔
      minInterval: props.settingParams && props.settingParams.minInterval || 100,
      // 采样间隔最小值
      maxInterval: props.settingParams && props.settingParams.maxInterval || 1000,
      // 采样间隔最大值
      arrowWidth: props.settingParams && props.settingParams.arrowWidth || 20,
      // 箭头宽度
      minArrowWidth: props.settingParams && props.settingParams.minArrowWidth || 1,
      // 箭头宽度最小值
      maxArrowWidth: props.settingParams && props.settingParams.maxArrowWidth || 30,
      // 箭头宽度最大值
      arrowColor: props.settingParams && props.settingParams.arrowColor || "#FFFF00" // 箭头颜色

    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.aspectAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new AspectAnalysisViewModel(scenceView, {
            interval: formItem.interval,
            // 采样间隔
            arrowWidth: formItem.arrowWidth,
            // 箭头宽度
            arrowColor: formItem.arrowColor // 箭头颜色

          });
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 参数改变


    function paramsChanged(key) {
      switch (key) {
        case "interval":
          // 采样间隔
          viewModel.setInterval(formItem.interval);
          break;

        case "arrowWidth":
          // 箭头间隔
          viewModel.setArrowWidth(formItem.arrowWidth);
          break;

        case "arrowColor":
          // 箭头颜色
          viewModel.setArrowColor(formItem.arrowColor);
          break;

        default:
          break;
      }
    } // 开始分析


    function startAnalysis() {
      viewModel && viewModel.start();
    } //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      startAnalysis,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-aspect-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AspectAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-aspect-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": _ctx.collapseValue
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '90px' : '120px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).samplingInterval
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).interval,
                      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).interval = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minInterval,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxInterval,
                      onInput: _cache[1] || (_cache[1] = $event => paramsChanged('interval'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).interval,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).interval = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minInterval,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxInterval,
                      "controls-position": "right",
                      onInput: _cache[3] || (_cache[3] = $event => paramsChanged('interval'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).arrowWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowWidth,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowWidth = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minArrowWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxArrowWidth,
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('arrowWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowWidth,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowWidth = $event),
                      step: 1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minArrowWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxArrowWidth,
                      "controls-position": "right",
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('arrowWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).arrowColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowColor,
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).arrowColor = $event),
                  onChange: _cache[9] || (_cache[9] = $event => paramsChanged('arrowColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AspectAnalysisvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[10] || (_cache[10] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[11] || (_cache[11] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/aspectanalysis/AspectAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/aspectanalysis/AspectAnalysis.vue



const AspectAnalysis_exports_ = AspectAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var AspectAnalysis = (AspectAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/aspectanalysis/index.js




AspectAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(AspectAnalysis.name, AspectAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/isolineanalysis/IsolineAnalysisViewModel.js

 //等值线分析逻辑类


class IsolineAnalysisViewModel {
  //等值线分析三维对象
  //等高面高度区间
  //等高面区间颜色数组
  //等高面渐变纹理图片
  //绘制管理对象
  //绘制完成监听事件
  //等值线分析存储参数对象
  constructor(scenceView, options) {
    _defineProperty(this, "_elevation", null);

    _defineProperty(this, "_surfaceColorTableValue", [0.0, 0.1, 0.2, 0.3, 0.4]);

    _defineProperty(this, "_surfaceColorTable", ["#2a2828", "#2747E0", "#D33B7D", "#D33038", "#FF9742"]);

    _defineProperty(this, "_surfaceColorImage", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    _defineProperty(this, "_colorImages", [//渐变纹理编号和图片地址对象
    {
      value: "0",
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: "1",
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: "2",
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }]);

    _defineProperty(this, "_options", null);

    this._options = options;
    this._options.viewer = scenceView._viewer;
    this._options.viewer.scene.globe.depthTestAgainstTerrain = true;
    this._options.colorImage = this.getImagePath(this._options.colorImage);
    this._surfaceColorImage = this._options.colorImage;

    if (options.firstCurve.color) {
      options.firstCurve.color = Cesium.Color.fromCssColorString(options.firstCurve.color);
    }

    if (options.rememberCurve.color) {
      options.rememberCurve.color = Cesium.Color.fromCssColorString(options.rememberCurve.color);
    }

    if (options.timeCurve.color) {
      options.timeCurve.color = Cesium.Color.fromCssColorString(options.timeCurve.color);
    }

    if (options.helpCurve.color) {
      options.helpCurve.color = Cesium.Color.fromCssColorString(options.helpCurve.color);
    } // scenceView._viewer.imageryLayers.addImageryProvider(new Cesium.SingleTileImageryProvider({
    //     url: './images/5e1e7ff00b274.jpg"'
    //   }));


    options.positions = Cesium.Cartesian3.fromDegreesArray([86.207634, 28.056729, 86.102906, 28.00936]);
    this._elevation = new Cesium.Kq3dContourAnalysis(options);

    this._elevation.destroy();

    this._elevation = null;
    this._drawManager = scenceView._drawManager;
    var that = this;
    that._removeEventListener = that._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._options.positions = shape._controlPoints;

        that._drawManager.clear();

        switch (that._options.filltype) {
          case 0:
            that._options.type = Cesium.Kq3dContourAnalysisType.LINE;
            break;

          case 1:
            that._options.type = Cesium.Kq3dContourAnalysisType.SURFACE;
            break;

          case 2:
            that._options.type = Cesium.Kq3dContourAnalysisType.SUFACE_LINE;
            break;
        }

        that._elevation = new Cesium.Kq3dContourAnalysis(that._options);
      }
    });
  } // 设置等高面区间


  setColorTableHeight(heights) {
    this._surfaceColorTableValue = heights.map(function (item) {
      return item / 8000;
    });
    this.changeSurfaceFillStyle(0);
  } // 设置等高面填充样式


  setColorTable(newValue) {
    this._surfaceColorTable = newValue;
    this.changeSurfaceFillStyle(0);
  } //设置填充图片


  setFillStyleImage(image) {
    this._options.colorImage = image;
    this._surfaceColorImage = image;
    if (this._elevation) this._elevation.colorImage = image;
  } //设置填充样式


  setFillStyle(value) {
    this.changeSurfaceFillStyle(value);
  } //修改等高面填充样式


  changeSurfaceFillStyle(value) {
    if (!this._elevation) return;

    switch (value) {
      case 0:
        // 自定义颜色表
        this._elevation.colorImage = "";
        this._elevation.colorTable = this._surfaceColorTable;
        this._elevation.colorTableValue = this._surfaceColorTableValue;
        break;

      case 1:
        // 图片纹理
        this._elevation.colorImage = this._surfaceColorImage;
        break;
    }
  } //获取图片路径


  getImagePath(value) {
    var imagePath = "";

    var image = this._colorImages.find(item => item.value === value);

    if (image) {
      imagePath = image.src;
    }

    return imagePath;
  } //修改填充图片


  setColorLine(value) {
    var path = "";

    switch (value) {
      case 0:
        path = const_image_namespaceObject.RED_TO_PURPLE_URL;
        break;

      case 1:
        path = const_image_namespaceObject.PURPLE_TO_YELLOW_URL;
        break;

      case 2:
        path = const_image_namespaceObject.GREEN_TO_BLUE_URL;
        break;
    }

    return path;
  } //设置填充类型


  setFillType(value) {
    // if(!this._elevation) return;
    switch (value) {
      case 0:
        this._options.filltype = "surface_table";
        this._options.type = Cesium.Kq3dContourAnalysisType.LINE;
        if (this._elevation) this._elevation.type = Cesium.Kq3dContourAnalysisType.LINE;
        break;

      case 1:
        this._options.filltype = "surface_img";
        this._options.type = Cesium.Kq3dContourAnalysisType.SURFACE;

        if (this._elevation) {
          this._elevation.type = Cesium.Kq3dContourAnalysisType.SURFACE; // this._surfaceColorImage = this.setColorLine(value);

          this._elevation.colorImage = this._surfaceColorImage;
        }

        break;

      case 2:
        this._options.filltype = "surface_img";
        this._options.type = Cesium.Kq3dContourAnalysisType.SUFACE_LINE;

        if (this._elevation) {
          this._elevation.type = Cesium.Kq3dContourAnalysisType.SUFACE_LINE;
          this._elevation.colorImage = this._surfaceColorImage;
        }

        break;
    }
  } //开始分析


  start() {
    var that = this; // 判断是否添加了地形

    if (that._options.viewer.terrainProvider.availability) {
      that._drawManager.startDraw("polygon", {
        clampToGround: true
      });
    } else {
      message({
        message: "请添加模型后分析!",
        type: "warning"
      });
    }
  } //清除全部结果


  clear() {
    this._drawManager && this._drawManager.stopDraw();
    this._elevation && this._elevation.destroy();
    this._elevation = null;
  } //销毁


  destroy() {
    this._drawManager && this._drawManager.stopDraw();
    this._elevation && this._elevation.destroy();
    this._elevation = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } //设置首曲线显隐


  setElevationMarking(show) {
    this._options.label = show;
    if (this._elevation) this._elevation._isLabel = this._options.label;
  } //设置首曲线显隐


  setFirstCurve(show) {
    this._options.firstCurve.show = show;
    if (this._elevation) this._elevation.firstCurve = this._options.firstCurve;
  } //设置首曲线宽度


  setFirstCurveWidth(width) {
    this._options.firstCurve.width = Number(width);
    if (this._elevation) this._elevation.firstCurve = this._options.firstCurve;
  } //设置首曲线颜色


  setFirstCurveColor(color) {
    this._options.firstCurve.color = new Cesium.Color.fromCssColorString(color);
    if (this._elevation) this._elevation.firstCurve = this._options.firstCurve;
  } //设置计曲线显隐


  setRememberCurve(show) {
    this._options.rememberCurve.show = show;
    if (this._elevation) this._elevation.rememberCurve = this._options.rememberCurve;
  } //设置计曲线宽度


  setRememberCurveWidth(width) {
    this._options.rememberCurve.width = Number(width);
    if (this._elevation) this._elevation.rememberCurve = this._options.rememberCurve;
  } //设置计曲线颜色


  setRememberCurveColor(color) {
    this._options.rememberCurve.color = new Cesium.Color.fromCssColorString(color);
    if (this._elevation) this._elevation.rememberCurve = this._options.rememberCurve;
  } //设置间曲线显隐


  setIntervalCurve(show) {
    this._options.timeCurve.show = show;
    if (this._elevation) this._elevation.timeCurve = this._options.timeCurve;
  } //设置间曲线宽度


  setIntervalCurveWidth(width) {
    this._options.timeCurve.width = Number(width);
    if (this._elevation) this._elevation.timeCurve = this._options.timeCurve;
  } //设置间曲线颜色


  setIntervalCurveColor(color) {
    this._options.timeCurve.color = new Cesium.Color.fromCssColorString(color);
    if (this._elevation) this._elevation.timeCurve = this._options.timeCurve;
  } //设置助曲线显隐


  setExtraCurve(show) {
    this._options.helpCurve.show = show;
    if (this._elevation) this._elevation.helpCurve = this._options.helpCurve;
  } //设置助曲线宽度


  setExtraCurveWidth(width) {
    this._options.helpCurve.width = Number(width);
    if (this._elevation) this._elevation.helpCurve = this._options.helpCurve;
  } //设置助曲线颜色


  setExtraCurveColor(color) {
    if (this._elevation) this._elevation.helpCurve = this._options.helpCurve;
    this._options.helpCurve.color = new Cesium.Color.fromCssColorString(color);
  } //设置面透明度


  setSurfaceAlpha(alpha) {
    this._options.surfaceAlpha = Number(alpha);
    if (this._elevation) this._elevation.surfaceAlpha = Number(alpha);
  } //设置最小高度


  setMinHeight(minHeight) {
    this._options.minHeight = Number(minHeight);
    if (this._elevation) this._elevation.minHeight = Number(minHeight);
  } //设置最大高度


  setMaxHeight(maxHeight) {
    this._options.maxHeight = Number(maxHeight);
    if (this._elevation) this._elevation.maxHeight = Number(maxHeight);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/isolineanalysis/IsolineAnalysis.vue?vue&type=script&setup=true&lang=js

const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-isoline-analysis-box"
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-isoline-analysis-span"
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_3 = {
  key: 0
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "kq3d-isoline-analysis-heightspan"
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_5 = {
  key: 1
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_6 = {
  style: {
    "width": "15%",
    "text-align": "left"
  }
};

const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_7 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
  class: "kq3d-isoline-analysis-line"
}, null, -1
/* HOISTED */
);

const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_8 = {
  style: {
    "width": "15%",
    "text-align": "right"
  }
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_9 = ["src"];
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_10 = {
  key: 0
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_11 = {
  class: "kq3d-isoline-analysis-heightspan"
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_12 = {
  key: 1
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_13 = {
  style: {
    "width": "15%",
    "text-align": "left"
  }
};

const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_14 = /*#__PURE__*/(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", {
  class: "kq3d-isoline-analysis-line"
}, null, -1
/* HOISTED */
);

const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_15 = {
  style: {
    "width": "15%",
    "text-align": "right"
  }
};
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_16 = ["src"];
const IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_17 = {
  class: "kq3d-isoline-analysis-footer"
};







const IsolineAnalysisvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dIsolineAnalysis"
};
/* harmony default export */ var IsolineAnalysisvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(IsolineAnalysisvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconIsolineAnalysis
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let dataList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([{
      colorTableHeight: 0,
      colorTable: null
    }, {
      colorTableHeight: 1000,
      colorTable: "#00FF00"
    }, {
      colorTableHeight: 2000,
      colorTable: "#0000FF"
    }, {
      colorTableHeight: 3000,
      colorTable: "#FFFF00"
    }, {
      colorTableHeight: 4000,
      colorTable: "#FF7F00"
    }, {
      colorTableHeight: 8000,
      colorTable: "#FF0000"
    }]);
    const colorImages = [{
      value: "0",
      src: const_image_namespaceObject.RED_TO_PURPLE_URL
    }, {
      value: "1",
      src: const_image_namespaceObject.PURPLE_TO_YELLOW_URL
    }, {
      value: "2",
      src: const_image_namespaceObject.GREEN_TO_BLUE_URL
    }];
    let activeName = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("line"); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      fillType: props.settingParams && props.settingParams.fillType || 0,
      // 填充类型
      fillTypeShow: props.settingParams && props.settingParams.fillTypeShow || true,
      // 填充类型是否显示
      elevationMarking: props.settingParams && props.settingParams.elevationMarking || true,
      // 高程标注
      firstCurve: props.settingParams && props.settingParams.firstCurve !== undefined || true,
      // 首曲线
      firstCurveWidth: props.settingParams && props.settingParams.firstCurveWidth || 2,
      // 首曲线宽度
      minFirstCurveWidth: props.settingParams && props.settingParams.minFirstCurveWidth || 0,
      // 首曲线宽度最下值
      maxFirstCurveWidth: props.settingParams && props.settingParams.maxFirstCurveWidth || 5,
      // 首曲线宽度最大值
      firstCurveColor: props.settingParams && props.settingParams.firstCurveColor || "#E6A23C",
      // 首曲线颜色
      rememberCurve: props.settingParams && props.settingParams.rememberCurve !== undefined || true,
      // 计曲线
      rememberCurveWidth: props.settingParams && props.settingParams.rememberCurveWidth || 4,
      // 计曲线宽度
      minRememberCurveWidth: props.settingParams && props.settingParams.minRememberCurveWidth || 0,
      // 计曲线宽度最小值
      maxRememberCurveWidth: props.settingParams && props.settingParams.maxRememberCurveWidth || 5,
      // 计曲线宽度最大值
      rememberCurveColor: props.settingParams && props.settingParams.rememberCurveColor || "#409EFF",
      // 计曲线颜色
      intervalCurve: props.settingParams && props.settingParams.intervalCurve !== undefined || true,
      // 间曲线
      intervalCurveWidth: props.settingParams && props.settingParams.intervalCurveWidth || 1,
      // 间曲线宽度
      intervalCurveColor: props.settingParams && props.settingParams.intervalCurveColor || "#67C23A",
      // 间曲线颜色
      extraCurve: props.settingParams && props.settingParams.extraCurve !== undefined || true,
      // 助曲线
      extraCurveWidth: props.settingParams && props.settingParams.extraCurveWidth || 1,
      // 助曲线宽度
      minExtraCurveWidth: props.settingParams && props.settingParams.minExtraCurveWidth || 1,
      // 助曲线宽度最小值
      maxExtraCurveWidth: props.settingParams && props.settingParams.maxExtraCurveWidth || 1,
      // 助曲线宽度最大值
      extraCurveColor: props.settingParams && props.settingParams.extraCurveColor || "#F56C6C",
      // 助曲线颜色
      fillStyle: props.settingParams && props.settingParams.fillStyle || 1,
      // 填充样式
      colorTableHeight: props.settingParams && props.settingParams.colorTableHeight || [1000, 2000, 3000, 4000, 8000],
      colorTable: props.settingParams && props.settingParams.colorTable || ["#00FF00", "#0000FF", "#FFFF00", "#FF7F00", "#FF0000"],
      colorImage: props.settingParams && props.settingParams.colorImage || "0",
      // 渐变颜色
      minHeight: props.settingParams && props.settingParams.minHeight || 300,
      // 最小高度
      maxHeight: props.settingParams && props.settingParams.maxHeight || 5100,
      // 最大高度
      surfaceAlpha: props.settingParams && props.settingParams.surfaceAlpha || 0.6 // 面透明度

    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.isolineAnalysis;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          var options = {
            minHeight: formItem.minHeight,
            maxHeight: formItem.maxHeight,
            spaceing: 600,
            filltype: formItem.fillType,
            fillStyle: formItem.fillStyle,
            colorTableValue: [0.0, 0.1, 0.2, 0.3, 0.4],
            colorTable: formItem.colorTable,
            label: formItem.elevationMarking,
            firstCurve: {
              color: formItem.firstCurveColor,
              show: formItem.firstCurve,
              width: formItem.firstCurveWidth
            },
            rememberCurve: {
              color: formItem.rememberCurveColor,
              show: formItem.rememberCurve,
              width: formItem.rememberCurveWidth
            },
            timeCurve: {
              color: formItem.intervalCurveColor,
              show: formItem.intervalCurve,
              width: formItem.intervalCurveWidth
            },
            helpCurve: {
              color: formItem.extraCurveColor,
              show: formItem.extraCurve,
              width: formItem.extraCurveWidth
            },
            surfaceAlpha: formItem.surfaceAlpha,
            colorImage: formItem.colorImage
          };
          viewModel = new IsolineAnalysisViewModel(scenceView, options);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 刷新自定义样式数组


    function refactorArr(type) {
      if (!dataList || !dataList.length) return;

      if (type == "height") {
        formItem.colorTableHeight = dataList.map(item => {
          return item.colorTableHeight;
        });
        formItem.colorTableHeight.shift();
      } else if (type == "color") {
        formItem.colorTable = dataList.map(item => {
          return item.colorTable;
        });
        formItem.colorTable.shift();
      }
    } //开始分析


    function startAnalysis() {
      viewModel && viewModel.start();
    } //修改填充类型


    const onChangeSelect = value => {
      viewModel.setFillType(value);
    }; //修改填充样式


    const onChangeFillStyle = value => {
      viewModel.setFillStyle(value);
    }; //清除结果


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    }); //获取图片路径

    function getImagePath(value) {
      var imagePath = "";
      var image = colorImages.find(item => item.value === value);

      if (image) {
        imagePath = image.src;
      }

      return imagePath;
    }

    function paramsChanged(key) {
      switch (key) {
        case "elevationMarking":
          viewModel.setElevationMarking(formItem.elevationMarking);
          break;

        case "firstCurve":
          viewModel.setFirstCurve(formItem.firstCurve);
          break;

        case "firstCurveWidth":
          viewModel.setFirstCurveWidth(formItem.firstCurveWidth);
          break;

        case "firstCurveColor":
          viewModel.setFirstCurveColor(formItem.firstCurveColor);
          break;

        case "rememberCurve":
          viewModel.setRememberCurve(formItem.rememberCurve);
          break;

        case "rememberCurveWidth":
          viewModel.setRememberCurveWidth(formItem.rememberCurveWidth);
          break;

        case "rememberCurveColor":
          viewModel.setRememberCurveColor(formItem.rememberCurveColor);
          break;

        case "intervalCurve":
          viewModel.setIntervalCurve(formItem.intervalCurve);
          break;

        case "intervalCurveWidth":
          viewModel.setIntervalCurveWidth(formItem.intervalCurveWidth);
          break;

        case "intervalCurveColor":
          viewModel.setIntervalCurveColor(formItem.intervalCurveColor);
          break;

        case "extraCurve":
          viewModel.setExtraCurve(formItem.extraCurve);
          break;

        case "extraCurveWidth":
          viewModel.setExtraCurveWidth(formItem.extraCurveWidth);
          break;

        case "extraCurveColor":
          viewModel.setExtraCurveColor(formItem.extraCurveColor);
          break;

        case "alpha":
          viewModel.setSurfaceAlpha(formItem.surfaceAlpha);
          break;

        case "minHeight":
          viewModel.setMinHeight(formItem.minHeight);
          break;

        case "maxHeight":
          viewModel.setMaxHeight(formItem.maxHeight);
          break;

        case "colorTableHeight":
          // 自定义填充样式区间
          refactorArr("height");
          viewModel.setColorTableHeight(formItem.colorTableHeight);
          break;

        case "colorTable":
          // 自定义填充样式颜色
          refactorArr("color");
          viewModel.setColorTable(formItem.colorTable);
          break;

        case "image":
          var imageUrl = getImagePath(formItem.colorImage);
          viewModel.setFillStyleImage(imageUrl);
          break;

        default:
          break;
      }
    }

    expose({
      refactorArr,
      startAnalysis,
      onChangeSelect,
      onChangeFillStyle,
      clearResult,
      getImagePath,
      paramsChanged
    });
    return (_ctx, _cache) => {
      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_switch = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-switch");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_divider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-divider");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_color_picker = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-color-picker");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_radio_group = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio-group");

      const _component_kq_tab_pane = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-tab-pane");

      const _component_kq_tabs = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-tabs");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-isoline-analysis", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fillType), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillType,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillType = $event),
            onChange: onChangeSelect
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contourLine,
              value: 0
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contourSurface,
              value: 1
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contourLineSurface,
              value: 2
            }, null, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillTypeShow]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-isoline-analysis-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", {
          style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
            'margin-top': (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillTypeShow ? '16px' : '0px'
          })
        }, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).skylineTips), 5
        /* TEXT, STYLE */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-isoline-analysis-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillType === 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_form, {
            key: 0,
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '110px' : '180px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).elevationMarking
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).elevationMarking,
                  "onUpdate:modelValue": _cache[1] || (_cache[1] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).elevationMarking = $event),
                  onChange: _cache[2] || (_cache[2] = $event => paramsChanged('elevationMarking'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurve
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve,
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve = $event),
                  onChange: _cache[4] || (_cache[4] = $event => paramsChanged('firstCurve'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurveWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth,
                      "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFirstCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFirstCurveWidth,
                      onInput: _cache[6] || (_cache[6] = $event => paramsChanged('firstCurveWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth,
                      "onUpdate:modelValue": _cache[7] || (_cache[7] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFirstCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFirstCurveWidth,
                      step: 0.1,
                      onInput: _cache[8] || (_cache[8] = $event => paramsChanged('firstCurveWidth')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurveColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveColor,
                  "onUpdate:modelValue": _cache[9] || (_cache[9] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveColor = $event),
                  onChange: _cache[10] || (_cache[10] = $event => paramsChanged('firstCurveColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })], 512
            /* NEED_PATCH */
            ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurve
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve,
                  "onUpdate:modelValue": _cache[11] || (_cache[11] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve = $event),
                  onChange: _cache[12] || (_cache[12] = $event => paramsChanged('rememberCurve'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurveWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth,
                      "onUpdate:modelValue": _cache[13] || (_cache[13] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minRememberCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxRememberCurveWidth,
                      onInput: _cache[14] || (_cache[14] = $event => paramsChanged('rememberCurveWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth,
                      "onUpdate:modelValue": _cache[15] || (_cache[15] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minRememberCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxRememberCurveWidth,
                      step: 0.1,
                      onInput: _cache[16] || (_cache[16] = $event => paramsChanged('rememberCurveWidth')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurveColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveColor,
                  "onUpdate:modelValue": _cache[17] || (_cache[17] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveColor = $event),
                  onChange: _cache[18] || (_cache[18] = $event => paramsChanged('rememberCurveColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })], 512
            /* NEED_PATCH */
            ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurve
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve,
                  "onUpdate:modelValue": _cache[19] || (_cache[19] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve = $event),
                  onChange: _cache[20] || (_cache[20] = $event => paramsChanged('intervalCurve'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurveWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth,
                      "onUpdate:modelValue": _cache[21] || (_cache[21] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minIntervalCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxIntervalCurveWidth,
                      onInput: _cache[22] || (_cache[22] = $event => paramsChanged('intervalCurveWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth,
                      "onUpdate:modelValue": _cache[23] || (_cache[23] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minIntervalCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxIntervalCurveWidth,
                      step: 0.1,
                      onInput: _cache[24] || (_cache[24] = $event => paramsChanged('intervalCurveWidth')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurveColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveColor,
                  "onUpdate:modelValue": _cache[25] || (_cache[25] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveColor = $event),
                  onChange: _cache[26] || (_cache[26] = $event => paramsChanged('intervalCurveColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })], 512
            /* NEED_PATCH */
            ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurve
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve,
                  "onUpdate:modelValue": _cache[27] || (_cache[27] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve = $event),
                  onChange: _cache[28] || (_cache[28] = $event => paramsChanged('extraCurve'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurveWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth,
                      "onUpdate:modelValue": _cache[29] || (_cache[29] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth = $event),
                      step: 0.1,
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtraCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtraCurveWidth,
                      onInput: _cache[30] || (_cache[30] = $event => paramsChanged('extraCurveWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min", "max"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth,
                      "onUpdate:modelValue": _cache[31] || (_cache[31] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth = $event),
                      min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtraCurveWidth,
                      max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtraCurveWidth,
                      step: 0.1,
                      onInput: _cache[32] || (_cache[32] = $event => paramsChanged('extraCurveWidth')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurveColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveColor,
                  "onUpdate:modelValue": _cache[33] || (_cache[33] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveColor = $event),
                  onChange: _cache[34] || (_cache[34] = $event => paramsChanged('extraCurveColor'))
                }, null, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })], 512
            /* NEED_PATCH */
            ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve]])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillType === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_form, {
            key: 1,
            "label-width": "100px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "block"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fillStyle
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle,
                  "onUpdate:modelValue": _cache[35] || (_cache[35] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle = $event),
                  onChange: onChangeFillStyle
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).customColorScheme,
                    value: 0
                  }, null, 8
                  /* PROPS */
                  , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientTexture,
                    value: 1
                  }, null, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).surfaceAlpha
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha,
                      "onUpdate:modelValue": _cache[36] || (_cache[36] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha = $event),
                      min: 0,
                      max: 1,
                      step: 0.01,
                      onInput: _cache[37] || (_cache[37] = $event => paramsChanged('alpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha,
                      "onUpdate:modelValue": _cache[38] || (_cache[38] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha = $event),
                      min: 0,
                      max: 1,
                      step: 0.01,
                      "controls-position": "right",
                      onInput: _cache[39] || (_cache[39] = $event => paramsChanged('alpha'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).isolineMinHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight,
                      "onUpdate:modelValue": _cache[40] || (_cache[40] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight = $event),
                      min: 0,
                      step: 100,
                      max: 8000,
                      onInput: _cache[41] || (_cache[41] = $event => paramsChanged('minHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight,
                      "onUpdate:modelValue": _cache[42] || (_cache[42] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight = $event),
                      min: 0,
                      step: 100,
                      max: 8000,
                      "controls-position": "right",
                      onInput: _cache[43] || (_cache[43] = $event => paramsChanged('minHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).isolineMaxHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight,
                      "onUpdate:modelValue": _cache[44] || (_cache[44] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight = $event),
                      min: 0,
                      step: 100,
                      max: 8000,
                      onInput: _cache[45] || (_cache[45] = $event => paramsChanged('maxHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight,
                      "onUpdate:modelValue": _cache[46] || (_cache[46] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight = $event),
                      min: 0,
                      step: 100,
                      max: 8000,
                      "controls-position": "right",
                      onInput: _cache[47] || (_cache[47] = $event => paramsChanged('maxHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_3, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 18
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setHeightRange), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 6
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setColor), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList), (item, index) => {
              return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
                key: index,
                style: {
                  "display": "flex"
                }
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index > 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, {
                  key: 0
                }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                  span: 18
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 0,
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                    "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight = $event,
                    disabled: true,
                    onInput: _cache[48] || (_cache[48] = $event => paramsChanged('colorTableHeight')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index > 1 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 1,
                    modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                    "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight = $event,
                    disabled: true,
                    step: 1,
                    onInput: _cache[49] || (_cache[49] = $event => paramsChanged('colorTableHeight')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).to), 1
                  /* TEXT */
                  ), index > 0 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 2,
                    modelValue: item.colorTableHeight,
                    "onUpdate:modelValue": $event => item.colorTableHeight = $event,
                    min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                    max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index + 1].colorTableHeight,
                    step: 1,
                    onInput: _cache[50] || (_cache[50] = $event => paramsChanged('colorTableHeight')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue", "min", "max"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index === (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                    key: 3,
                    modelValue: item.colorTableHeight,
                    "onUpdate:modelValue": $event => item.colorTableHeight = $event,
                    step: 1,
                    disabled: true,
                    onInput: _cache[51] || (_cache[51] = $event => paramsChanged('colorTableHeight')),
                    "controls-position": "right"
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                  _: 2
                  /* DYNAMIC */

                }, 1024
                /* DYNAMIC_SLOTS */
                ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                  span: 6
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                    modelValue: item.colorTable,
                    "onUpdate:modelValue": $event => item.colorTable = $event,
                    onChange: _cache[52] || (_cache[52] = $event => paramsChanged('colorTable'))
                  }, null, 8
                  /* PROPS */
                  , ["modelValue", "onUpdate:modelValue"])]),
                  _: 2
                  /* DYNAMIC */

                }, 1024
                /* DYNAMIC_SLOTS */
                )], 64
                /* STABLE_FRAGMENT */
                )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                _: 2
                /* DYNAMIC */

              }, 1024
              /* DYNAMIC_SLOTS */
              );
            }), 128
            /* KEYED_FRAGMENT */
            ))])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientColor
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_6, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight) + "m", 1
                  /* TEXT */
                  ), IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_7, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_8, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight) + "m", 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio_group, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage,
                  "onUpdate:modelValue": _cache[53] || (_cache[53] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage = $event),
                  onChange: _cache[54] || (_cache[54] = $event => paramsChanged('image'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)(colorImages, (item, index) => {
                    return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                      key: index,
                      label: item.value
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                        class: "kq3d-isoline-analysis-legend",
                        src: item.src,
                        alt: "无"
                      }, null, 8
                      /* PROPS */
                      , IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_9)]),
                      _: 2
                      /* DYNAMIC */

                    }, 1032
                    /* PROPS, DYNAMIC_SLOTS */
                    , ["label"]);
                  }), 64
                  /* STABLE_FRAGMENT */
                  ))]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
            _: 1
            /* STABLE */

          })) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillType === 2 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_tabs, {
            key: 2,
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(activeName),
            "onUpdate:modelValue": _cache[109] || (_cache[109] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(activeName) ? activeName.value = $event : activeName = $event),
            onTabChange: _ctx.handleChange
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_tab_pane, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contourLine,
              name: "line"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
                "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '110px' : '180px',
                "label-position": "left"
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).elevationMarking
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).elevationMarking,
                      "onUpdate:modelValue": _cache[55] || (_cache[55] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).elevationMarking = $event),
                      onChange: _cache[56] || (_cache[56] = $event => paramsChanged('elevationMarking'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurve
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve,
                      "onUpdate:modelValue": _cache[57] || (_cache[57] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve = $event),
                      onChange: _cache[58] || (_cache[58] = $event => paramsChanged('firstCurve'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurveWidth
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth,
                          "onUpdate:modelValue": _cache[59] || (_cache[59] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth = $event),
                          step: 0.1,
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFirstCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFirstCurveWidth,
                          onInput: _cache[60] || (_cache[60] = $event => paramsChanged('firstCurveWidth'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step", "min", "max"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth,
                          "onUpdate:modelValue": _cache[61] || (_cache[61] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveWidth = $event),
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minFirstCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxFirstCurveWidth,
                          step: 0.1,
                          onInput: _cache[62] || (_cache[62] = $event => paramsChanged('firstCurveWidth')),
                          "controls-position": "right"
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "min", "max", "step"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).firstCurveColor
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveColor,
                      "onUpdate:modelValue": _cache[63] || (_cache[63] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurveColor = $event),
                      onChange: _cache[64] || (_cache[64] = $event => paramsChanged('firstCurveColor'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                })], 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).firstCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurve
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve,
                      "onUpdate:modelValue": _cache[65] || (_cache[65] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve = $event),
                      onChange: _cache[66] || (_cache[66] = $event => paramsChanged('rememberCurve'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurveWidth
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth,
                          "onUpdate:modelValue": _cache[67] || (_cache[67] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth = $event),
                          step: 0.1,
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minRememberCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxRememberCurveWidth,
                          onInput: _cache[68] || (_cache[68] = $event => paramsChanged('rememberCurveWidth'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step", "min", "max"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth,
                          "onUpdate:modelValue": _cache[69] || (_cache[69] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveWidth = $event),
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minRememberCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxRememberCurveWidth,
                          step: 0.1,
                          onInput: _cache[70] || (_cache[70] = $event => paramsChanged('rememberCurveWidth')),
                          "controls-position": "right"
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "min", "max", "step"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rememberCurveColor
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveColor,
                      "onUpdate:modelValue": _cache[71] || (_cache[71] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurveColor = $event),
                      onChange: _cache[72] || (_cache[72] = $event => paramsChanged('rememberCurveColor'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                })], 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rememberCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurve
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve,
                      "onUpdate:modelValue": _cache[73] || (_cache[73] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve = $event),
                      onChange: _cache[74] || (_cache[74] = $event => paramsChanged('intervalCurve'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurveWidth
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth,
                          "onUpdate:modelValue": _cache[75] || (_cache[75] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth = $event),
                          step: 0.1,
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minIntervalCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxIntervalCurveWidth,
                          onInput: _cache[76] || (_cache[76] = $event => paramsChanged('intervalCurveWidth'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step", "min", "max"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth,
                          "onUpdate:modelValue": _cache[77] || (_cache[77] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveWidth = $event),
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minIntervalCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxIntervalCurveWidth,
                          step: 0.1,
                          onInput: _cache[78] || (_cache[78] = $event => paramsChanged('intervalCurveWidth')),
                          "controls-position": "right"
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "min", "max", "step"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).intervalCurveColor
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveColor,
                      "onUpdate:modelValue": _cache[79] || (_cache[79] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurveColor = $event),
                      onChange: _cache[80] || (_cache[80] = $event => paramsChanged('intervalCurveColor'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                })], 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).intervalCurve]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_divider), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurve
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve,
                      "onUpdate:modelValue": _cache[81] || (_cache[81] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve = $event),
                      onChange: _cache[82] || (_cache[82] = $event => paramsChanged('extraCurve'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurveWidth
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth,
                          "onUpdate:modelValue": _cache[83] || (_cache[83] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth = $event),
                          step: 0.1,
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtraCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtraCurveWidth,
                          onInput: _cache[84] || (_cache[84] = $event => paramsChanged('extraCurveWidth'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step", "min", "max"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth,
                          "onUpdate:modelValue": _cache[85] || (_cache[85] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveWidth = $event),
                          min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minExtraCurveWidth,
                          max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxExtraCurveWidth,
                          step: 0.1,
                          onInput: _cache[86] || (_cache[86] = $event => paramsChanged('extraCurveWidth')),
                          "controls-position": "right"
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "min", "max", "step"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).extraCurveColor
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveColor,
                      "onUpdate:modelValue": _cache[87] || (_cache[87] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurveColor = $event),
                      onChange: _cache[88] || (_cache[88] = $event => paramsChanged('extraCurveColor'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                })], 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).extraCurve]])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label-width"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_tab_pane, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).contourSurface,
              name: "surface"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
                "label-width": "100px",
                "label-position": "left"
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "block"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fillStyle
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle,
                      "onUpdate:modelValue": _cache[89] || (_cache[89] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle = $event),
                      onChange: onChangeFillStyle
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                        label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).customColorScheme,
                        value: 0
                      }, null, 8
                      /* PROPS */
                      , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                        label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientTexture,
                        value: 1
                      }, null, 8
                      /* PROPS */
                      , ["label"])]),
                      _: 1
                      /* STABLE */

                    }, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).surfaceAlpha
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha,
                          "onUpdate:modelValue": _cache[90] || (_cache[90] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha = $event),
                          min: 0,
                          max: 1,
                          step: 0.01,
                          onInput: _cache[91] || (_cache[91] = $event => paramsChanged('alpha'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha,
                          "onUpdate:modelValue": _cache[92] || (_cache[92] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).surfaceAlpha = $event),
                          min: 0,
                          max: 1,
                          step: 0.01,
                          "controls-position": "right",
                          onInput: _cache[93] || (_cache[93] = $event => paramsChanged('alpha'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue", "step"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).isolineMinHeight
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight,
                          "onUpdate:modelValue": _cache[94] || (_cache[94] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight = $event),
                          min: 0,
                          step: 100,
                          max: 8000,
                          onInput: _cache[95] || (_cache[95] = $event => paramsChanged('minHeight'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight,
                          "onUpdate:modelValue": _cache[96] || (_cache[96] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight = $event),
                          min: 0,
                          step: 100,
                          max: 8000,
                          "controls-position": "right",
                          onInput: _cache[97] || (_cache[97] = $event => paramsChanged('minHeight'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).isolineMaxHeight
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 16
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight,
                          "onUpdate:modelValue": _cache[98] || (_cache[98] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight = $event),
                          min: 0,
                          step: 100,
                          max: 8000,
                          onInput: _cache[99] || (_cache[99] = $event => paramsChanged('maxHeight'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue"])]),
                        _: 1
                        /* STABLE */

                      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                        span: 8
                      }, {
                        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight,
                          "onUpdate:modelValue": _cache[100] || (_cache[100] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight = $event),
                          min: 0,
                          step: 100,
                          max: 8000,
                          "controls-position": "right",
                          onInput: _cache[101] || (_cache[101] = $event => paramsChanged('maxHeight'))
                        }, null, 8
                        /* PROPS */
                        , ["modelValue"])]),
                        _: 1
                        /* STABLE */

                      })]),
                      _: 1
                      /* STABLE */

                    })]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_10, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 18
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setHeightRange), 1
                    /* TEXT */
                    )]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 6
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).setColor), 1
                    /* TEXT */
                    )]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                }), ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList), (item, index) => {
                  return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
                    key: index,
                    style: {
                      "display": "flex"
                    }
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index > 0 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, {
                      key: 0
                    }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                      span: 18
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [index === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                        key: 0,
                        modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                        "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight = $event,
                        disabled: true,
                        onInput: _cache[102] || (_cache[102] = $event => paramsChanged('colorTableHeight')),
                        "controls-position": "right"
                      }, null, 8
                      /* PROPS */
                      , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index > 1 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                        key: 1,
                        modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                        "onUpdate:modelValue": $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight = $event,
                        disabled: true,
                        step: 1,
                        onInput: _cache[103] || (_cache[103] = $event => paramsChanged('colorTableHeight')),
                        "controls-position": "right"
                      }, null, 8
                      /* PROPS */
                      , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_11, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).to), 1
                      /* TEXT */
                      ), index > 0 && index < (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                        key: 2,
                        modelValue: item.colorTableHeight,
                        "onUpdate:modelValue": $event => item.colorTableHeight = $event,
                        min: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index - 1].colorTableHeight,
                        max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList)[index + 1].colorTableHeight,
                        step: 1,
                        onInput: _cache[104] || (_cache[104] = $event => paramsChanged('colorTableHeight')),
                        "controls-position": "right"
                      }, null, 8
                      /* PROPS */
                      , ["modelValue", "onUpdate:modelValue", "min", "max"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), index === (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataList).length - 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_input_number, {
                        key: 3,
                        modelValue: item.colorTableHeight,
                        "onUpdate:modelValue": $event => item.colorTableHeight = $event,
                        step: 1,
                        disabled: true,
                        onInput: _cache[105] || (_cache[105] = $event => paramsChanged('colorTableHeight')),
                        "controls-position": "right"
                      }, null, 8
                      /* PROPS */
                      , ["modelValue", "onUpdate:modelValue"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                      _: 2
                      /* DYNAMIC */

                    }, 1024
                    /* DYNAMIC_SLOTS */
                    ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                      span: 6
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_color_picker, {
                        modelValue: item.colorTable,
                        "onUpdate:modelValue": $event => item.colorTable = $event,
                        onChange: _cache[106] || (_cache[106] = $event => paramsChanged('colorTable'))
                      }, null, 8
                      /* PROPS */
                      , ["modelValue", "onUpdate:modelValue"])]),
                      _: 2
                      /* DYNAMIC */

                    }, 1024
                    /* DYNAMIC_SLOTS */
                    )], 64
                    /* STABLE_FRAGMENT */
                    )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                    _: 2
                    /* DYNAMIC */

                  }, 1024
                  /* DYNAMIC_SLOTS */
                  );
                }), 128
                /* KEYED_FRAGMENT */
                ))])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).fillStyle === 1 ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_12, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                    label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gradientColor
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                      style: {
                        "display": "flex"
                      }
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_13, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minHeight) + "m", 1
                      /* TEXT */
                      ), IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_14, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_15, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxHeight) + "m", 1
                      /* TEXT */
                      )]),
                      _: 1
                      /* STABLE */

                    }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio_group, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage,
                      "onUpdate:modelValue": _cache[107] || (_cache[107] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).colorImage = $event),
                      onChange: _cache[108] || (_cache[108] = $event => paramsChanged('image'))
                    }, {
                      default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)(colorImages, (item, index) => {
                        return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                          key: index,
                          label: item.value
                        }, {
                          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("img", {
                            class: "kq3d-isoline-analysis-legend",
                            src: item.src,
                            alt: ""
                          }, null, 8
                          /* PROPS */
                          , IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_16)]),
                          _: 2
                          /* DYNAMIC */

                        }, 1032
                        /* PROPS, DYNAMIC_SLOTS */
                        , ["label"]);
                      }), 64
                      /* STABLE_FRAGMENT */
                      ))]),
                      _: 1
                      /* STABLE */

                    }, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }, 8
                  /* PROPS */
                  , ["label"])]),
                  _: 1
                  /* STABLE */

                })])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue", "onTabChange"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true)]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", IsolineAnalysisvue_type_script_setup_true_lang_js_hoisted_17, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[110] || (_cache[110] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => startAnalysis(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startAnalysis), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[111] || (_cache[111] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearResult), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/isolineanalysis/IsolineAnalysis.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/isolineanalysis/IsolineAnalysis.vue



const IsolineAnalysis_exports_ = IsolineAnalysisvue_type_script_setup_true_lang_js;

/* harmony default export */ var IsolineAnalysis = (IsolineAnalysis_exports_);
;// CONCATENATED MODULE: ./src/webgl/isolineanalysis/index.js




IsolineAnalysis.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(IsolineAnalysis.name, IsolineAnalysis);
};


;// CONCATENATED MODULE: ./src/webgl/boxclip/BoxClipViewModel.js

//Box裁剪逻辑类

class BoxClipViewModel {
  //三维viewer对象
  //Box裁剪存储参数对象
  //Box裁剪三维对象
  //绘制管理对象
  //绘制完成监听事件
  constructor(scenceView, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_options", {});

    _defineProperty(this, "_defaultOptions", {
      //默认参数对象
      clipTyp: 1,
      boxColor: Cesium.Color.fromCssColorString("#316882").withAlpha(0.4),
      clipEdgeWidth: 6.0,
      clipEdgeColorLables: "#63cf25",
      clipEdgeColor: Cesium.Color.fromCssColorString("#63cf25"),
      paddingFill: true,
      paddingFillColor: Cesium.Color.fromCssColorString("#ffffff"),
      paddingFillColorLabel: "#ffffff",
      paddingFillColorAlpha: 0.7,
      paddingStroke: true,
      paddingStrokeColor: Cesium.Color.fromCssColorString("#dd2bff"),
      paddingStrokeColorLabel: "#dd2bff",
      paddingStrokeColorAlpha: 0.6,
      paddingStrokeSize: 3.5,
      paddingStrokeSoftSize: 2.0,
      paddingStrokeDirection: 35.0,
      paddingStrokeSpace: 5.0
    });

    _defineProperty(this, "_boxclipAnalysis", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    this._options = Object.assign({}, options, this._defaultOptions);
    this._viewer = scenceView._viewer; // this._viewer.enabledFXAA = true;

    this._options.viewer = this._viewer;
    this._drawManager = scenceView._drawManager;
    let that = this;
    this._removeEventListener = this._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._options.position = shape.position; // 实例化分析对象

        that._boxclipAnalysis = new Cesium.Kq3dBoxClip(that._options);

        that._drawManager.clear();
      }
    });
  } // 查找所有3dtiles模型对象


  findLayers() {
    let tilesets = [];
    const primitives = this._options.viewer.scene.primitives._primitives;

    for (let m = 0; m < primitives.length; m++) {
      if (primitives[m] instanceof Cesium.Cesium3DTileset) {
        tilesets.push({
          guid: primitives[m].guid,
          name: primitives[m].name ? primitives[m].name : primitives[m].guid
        });
      }
    }

    return tilesets;
  } //根据id获取tileset对象


  findLayerById(id) {
    const primitives = this._options.viewer.scene.primitives._primitives;
    const tileset = primitives.find(function (item) {
      return item.guid === id;
    });
    return tileset;
  } // 开始分析


  start() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._options.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      if (this._drawManager) this._drawManager.startDraw("marker", {
        image: null
      });
    } else {
      message({
        message: "请添加模型后裁剪!",
        type: "warning"
      });
    }
  } //清除全部


  clear() {
    if (this._boxclipAnalysis) this._boxclipAnalysis.boxEnable = false;
    this._boxclipAnalysis && this._boxclipAnalysis.remove(); // this._boxclipAnalysis = null;
  } //销毁


  destroy() {
    this.clear(); //销毁分析对象

    this._boxclipAnalysis && this._boxclipAnalysis.destroy();
    this._boxclipAnalysis = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } // 设置裁剪对象


  setLayer(layerId) {
    this.clear();
    this._options.tileset = this.findLayerById(layerId);
  } // 设置裁剪方式,为true时，则为外部裁剪，否则为内部裁剪


  setClipType(val) {
    this._options.unionClippingRegions = val;
    if (this._boxclipAnalysis) this._boxclipAnalysis.unionClippingRegions = val;
  } //是否裁剪


  setClip(val) {
    this._options.enable = val;

    if (this._boxclipAnalysis) {
      this._boxclipAnalysis.enable = val;
      this._boxclipAnalysis.boxEnable = this._options.boxEnable;
    }
  } //显/隐辅助对象


  setShowBox(val) {
    this._options.boxEnable = val;
    if (this._boxclipAnalysis) this._boxclipAnalysis.boxEnable = val;
  } // X方向上移动


  setXDistance(val) {
    this._options.x = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.translationClip("x", Number(val));
  } // Y方向上移动


  setYDistance(val) {
    this._options.y = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.translationClip("y", Number(val));
  } // Z方向上移动


  setZDistance(val) {
    this._options.z = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.translationClip("z", Number(val));
  } //设置裁剪体长度


  setAxisX(val) {
    this._options.axisX = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.axisX = Number(val);
  } //设置裁剪体宽度


  setAxisY(val) {
    this._options.axisY = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.axisY = Number(val);
  } //设置裁剪体高度


  setAxisZ(val) {
    this._options.axisZ = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.axisZ = Number(val);
  } //设置裁剪体旋转角


  setAngle(val) {
    this._options.angle = Number(val);
    if (this._boxclipAnalysis) this._boxclipAnalysis.angle = Number(val);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/boxclip/BoxClip.vue?vue&type=script&setup=true&lang=js

const BoxClipvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-box-clip-box"
};
const BoxClipvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-box-clip-span"
};
const BoxClipvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-box-clip-span"
};
const BoxClipvue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "kq3d-box-clip-footer"
};






const BoxClipvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dBoxClip"
};
/* harmony default export */ var BoxClipvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(BoxClipvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconBoxClip
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let tiles = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      tileset: props.settingParams && props.settingParams.tileset || null,
      unionClippingRegions: props.settingParams && props.settingParams.unionClippingRegions !== undefined || false,
      enableClip: props.settingParams && props.settingParams.enableClip !== undefined || true,
      boxEnable: props.settingParams && props.settingParams.boxEnable !== undefined || false,
      xDistance: props.settingParams && props.settingParams.xDistance || -17,
      yDistance: props.settingParams && props.settingParams.yDistance || 0,
      zDistance: props.settingParams && props.settingParams.yDistance || 12,
      clipLength: props.settingParams && props.settingParams.clipLength || 7,
      clipWidth: props.settingParams && props.settingParams.clipWidth || 9.7,
      clipHeight: props.settingParams && props.settingParams.clipHeight || 4.7,
      clipRotation: props.settingParams && props.settingParams.clipRotation || 90
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.boxClip;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言
      //父组 件ScenceView初始化完成后执行

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            tileset: formItem.tileset,
            unionClippingRegions: formItem.unionClippingRegions,
            enable: formItem.enableClip,
            boxEnable: formItem.boxEnable,
            x: formItem.xDistance,
            y: formItem.yDistance,
            z: formItem.zDistance,
            axisX: formItem.clipLength,
            axisY: formItem.clipWidth,
            axisZ: formItem.clipHeight,
            angle: formItem.clipRotation
          };
          viewModel = new BoxClipViewModel(scenceView, options);
        }
      });
      setTimeout(() => {
        if (viewModel) {
          tiles.value = viewModel.findLayers(); // 获取所有tileset对象

          if (tiles.value.length > 0) {
            formItem.tileset = tiles.value[0].guid;
            paramsChanged("tileset");
          }
        }
      }, 1000);
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 参数改变


    function paramsChanged(key) {
      switch (key) {
        case "tileset":
          viewModel.setLayer(formItem.tileset);
          break;

        case "unionClip":
          viewModel.setClipType(formItem.unionClippingRegions);
          break;

        case "enableClip":
          viewModel.setClip(formItem.enableClip);
          break;

        case "boxEnable":
          viewModel.setShowBox(formItem.boxEnable);
          break;

        case "xDistance":
          viewModel.setXDistance(formItem.xDistance);
          break;

        case "yDistance":
          viewModel.setYDistance(formItem.yDistance);
          break;

        case "zDistance":
          viewModel.setZDistance(formItem.zDistance);
          break;

        case "clipLength":
          viewModel.setAxisX(formItem.clipLength);
          break;

        case "clipWidth":
          viewModel.setAxisY(formItem.clipWidth);
          break;

        case "clipHeight":
          viewModel.setAxisZ(formItem.clipHeight);
          break;

        case "angle":
          viewModel.setAngle(formItem.clipRotation);
          break;

        default:
          break;
      }
    } // 开始裁剪


    function clip() {
      viewModel && viewModel.start();
    } // 清除


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      clip,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-box-clip", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BoxClipvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", BoxClipvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipObj), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).tileset,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).tileset = $event),
            onChange: _cache[1] || (_cache[1] = $event => paramsChanged('tileset'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tiles), (item, index) => {
              return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
                key: index,
                value: item.guid,
                label: item.name
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(item.name), 1
                /* TEXT */
                )]),
                _: 2
                /* DYNAMIC */

              }, 1032
              /* PROPS, DYNAMIC_SLOTS */
              , ["value", "label"]);
            }), 128
            /* KEYED_FRAGMENT */
            ))]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", BoxClipvue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipPattern), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).unionClippingRegions,
            "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).unionClippingRegions = $event),
            label: false,
            onChange: _cache[3] || (_cache[3] = $event => paramsChanged('unionClip'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).insideClip), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).unionClippingRegions,
            "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).unionClippingRegions = $event),
            label: true,
            onChange: _cache[5] || (_cache[5] = $event => paramsChanged('unionClip'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).outsideClip), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-box-clip-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-box-clip-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '110px' : '160px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enableClip,
                  "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enableClip = $event),
                  onChange: _cache[7] || (_cache[7] = $event => paramsChanged('enableClip'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).enableClip), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).boxEnable,
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).boxEnable = $event),
                  onChange: _cache[9] || (_cache[9] = $event => paramsChanged('boxEnable'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).boxEnable), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).xDistance
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xDistance,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xDistance = $event),
                      step: 1,
                      min: -40.0,
                      max: 40,
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('xDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xDistance,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).xDistance = $event),
                      min: -40,
                      max: 40,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('xDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).yDistance
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yDistance,
                      "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yDistance = $event),
                      step: 1,
                      min: -40.0,
                      max: 40,
                      onInput: _cache[15] || (_cache[15] = $event => paramsChanged('yDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yDistance,
                      "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).yDistance = $event),
                      min: -40.0,
                      max: 40,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[17] || (_cache[17] = $event => paramsChanged('yDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zDistance
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zDistance,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zDistance = $event),
                      step: 1,
                      min: -40.0,
                      max: 40,
                      onInput: _cache[19] || (_cache[19] = $event => paramsChanged('zDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zDistance,
                      "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).zDistance = $event),
                      min: -40.0,
                      max: 40,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[21] || (_cache[21] = $event => paramsChanged('zDistance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipLength
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipLength,
                      "onUpdate:modelValue": _cache[22] || (_cache[22] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipLength = $event),
                      step: 0.1,
                      min: 0,
                      max: 50,
                      onInput: _cache[23] || (_cache[23] = $event => paramsChanged('clipLength'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipLength,
                      "onUpdate:modelValue": _cache[24] || (_cache[24] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipLength = $event),
                      min: 0,
                      max: 50,
                      step: 0.1,
                      "controls-position": "right",
                      onInput: _cache[25] || (_cache[25] = $event => paramsChanged('clipLength'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipWidth
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipWidth,
                      "onUpdate:modelValue": _cache[26] || (_cache[26] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipWidth = $event),
                      step: 0.1,
                      min: 0,
                      max: 50,
                      onInput: _cache[27] || (_cache[27] = $event => paramsChanged('clipWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipWidth,
                      "onUpdate:modelValue": _cache[28] || (_cache[28] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipWidth = $event),
                      step: 0.1,
                      min: 0,
                      max: 50,
                      "controls-position": "right",
                      onInput: _cache[29] || (_cache[29] = $event => paramsChanged('clipWidth'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipHeight
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipHeight,
                      "onUpdate:modelValue": _cache[30] || (_cache[30] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipHeight = $event),
                      step: 0.1,
                      min: 0,
                      max: 10,
                      onInput: _cache[31] || (_cache[31] = $event => paramsChanged('clipHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipHeight,
                      "onUpdate:modelValue": _cache[32] || (_cache[32] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipHeight = $event),
                      step: 0.1,
                      min: 0,
                      max: 10,
                      "controls-position": "right",
                      onInput: _cache[33] || (_cache[33] = $event => paramsChanged('clipHeight'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "margin-bottom": "8px"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipRotation
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipRotation,
                      "onUpdate:modelValue": _cache[34] || (_cache[34] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipRotation = $event),
                      step: 1,
                      min: 0,
                      max: 360,
                      onInput: _cache[35] || (_cache[35] = $event => paramsChanged('angle'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipRotation,
                      "onUpdate:modelValue": _cache[36] || (_cache[36] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipRotation = $event),
                      min: 0,
                      max: 360,
                      step: 1,
                      "controls-position": "right",
                      onInput: _cache[37] || (_cache[37] = $event => paramsChanged('angle'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", BoxClipvue_type_script_setup_true_lang_js_hoisted_4, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[38] || (_cache[38] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clip(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clip,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clip), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[39] || (_cache[39] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/boxclip/BoxClip.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/boxclip/BoxClip.vue



const BoxClip_exports_ = BoxClipvue_type_script_setup_true_lang_js;

/* harmony default export */ var BoxClip = (BoxClip_exports_);
;// CONCATENATED MODULE: ./src/webgl/boxclip/index.js




BoxClip.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(BoxClip.name, BoxClip);
};


;// CONCATENATED MODULE: ./src/webgl/planeclip/PlaneClipViewModel.js

//平面裁剪逻辑类

class PlaneClipViewModel {
  //三维viewer对象
  //平面裁剪存储参数对象
  //平面裁剪三维逻辑类
  //绘制管理对象
  //绘制完成事件监听
  constructor(scenceView, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_options", {});

    _defineProperty(this, "_defaultOptions", {
      //默认参数对象
      x: 0,
      y: 0,
      z: 0,
      angle: 0,
      boxColor: Cesium.Color.fromCssColorString("#316882").withAlpha(0.4),
      clipEdgeWidth: 4.0,
      clipEdgeColorLables: "#63cf25",
      clipEdgeColor: Cesium.Color.fromCssColorString("#63cf25"),
      clipEdgeWidth: 3,
      paddingFill: true,
      paddingFillColor: Cesium.Color.fromCssColorString("#1c6920"),
      paddingFillColorLabel: "#1c6920",
      paddingFillColorAlpha: 0.7,
      paddingStroke: true,
      paddingStrokeColor: Cesium.Color.fromCssColorString("#dd2bff"),
      paddingStrokeColorLabel: "#dd2bff",
      paddingStrokeColorAlpha: 1.0,
      paddingStrokeSize: 7.0,
      paddingStrokeSoftSize: 2.0,
      paddingStrokeDirection: 30.0,
      paddingStrokeSpace: 7.0
    });

    _defineProperty(this, "_planeclipAnalysis", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    this._options = Object.assign({}, options, this._defaultOptions);
    this._viewer = scenceView._viewer; // this._viewer.enabledFXAA = true;

    this._options.viewer = this._viewer;
    this._drawManager = scenceView._drawManager;
    let that = this;
    this._removeEventListener = this._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape) {
        that._options.position = shape.position; // 实例化分析对象

        that._planeclipAnalysis = new Cesium.Kq3dBoxClip(that._options);

        that._drawManager.clear();
      }
    });
  } // 查找所有3dtiles模型对象


  findLayers() {
    let tilesets = [];
    const primitives = this._options.viewer.scene.primitives._primitives;

    for (let m = 0; m < primitives.length; m++) {
      if (primitives[m] instanceof Cesium.Cesium3DTileset) {
        tilesets.push({
          guid: primitives[m].guid,
          name: primitives[m].name ? primitives[m].name : primitives[m].guid
        });
      }
    }

    return tilesets;
  } //根据id获取tileset对象


  findLayerById(id) {
    const primitives = this._options.viewer.scene.primitives._primitives;
    const tileset = primitives.find(function (item) {
      return item.guid === id;
    });
    return tileset;
  } // 开始分析


  start() {
    // 判断是否添加了模型
    var flag = false;
    var models = this._options.viewer.scene.primitives._primitives;

    for (let i = 0; i < models.length; i++) {
      if (models[i]._url) {
        flag = true;
      }
    }

    if (flag) {
      if (this._drawManager) this._drawManager.startDraw("marker", {
        image: null
      });
    } else {
      message({
        message: "请添加模型后裁剪!",
        type: "warning"
      });
    }
  } //清除全部


  clear() {
    if (this._planeclipAnalysis) this._planeclipAnalysis.boxEnable = false;
    this._planeclipAnalysis && this._planeclipAnalysis.remove(); // this._planeclipAnalysis = null;
  } //销毁


  destroy() {
    this.clear(); //销毁分析对象

    this._planeclipAnalysis && this._planeclipAnalysis.destroy();
    this._planeclipAnalysis = null; //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } // 设置裁剪对象


  setLayer(layerId) {
    this.clear();
    this._options.tileset = this.findLayerById(layerId);
  } // 设置裁剪方向,2:x,3:y,z:4


  setClipDirection(val) {
    this._options.clipType = val;
    if (this._planeclipAnalysis) this._planeclipAnalysis.clipType = val;
  } // 设置裁剪方式,为false时，则为正向裁剪，否则为逆向裁剪


  setClipType(val) {
    this._options.reverseClip = val;

    if (this._planeclipAnalysis) {
      this._planeclipAnalysis.reverseClip = val;
      this._planeclipAnalysis.distance = this._options.distance;
    }
  } //是否裁剪


  setEnable(val) {
    this._options.enable = val;

    if (this._planeclipAnalysis) {
      this._planeclipAnalysis.enable = val;
      this._planeclipAnalysis.boxEnable = this._options.boxEnable;
    }
  } //显/隐辅助对象


  setShowBox(val) {
    this._options.boxEnable = val;
    if (this._planeclipAnalysis) this._planeclipAnalysis.boxEnable = val;
  } //设置裁剪距离


  setDistance(val) {
    if (this._options.clipType == 4) {
      this._options.distance = -Number(val);
    } else {
      this._options.distance = Number(val);
    }

    if (this._planeclipAnalysis) this._planeclipAnalysis.distance = this._options.distance;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/planeclip/PlaneClip.vue?vue&type=script&setup=true&lang=js

const PlaneClipvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-plane-clip-box"
};
const PlaneClipvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-plane-clip-span"
};
const PlaneClipvue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-plane-clip-span"
};
const PlaneClipvue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "kq3d-plane-clip-span"
};
const PlaneClipvue_type_script_setup_true_lang_js_hoisted_5 = {
  class: "kq3d-plane-clip-footer"
};






const PlaneClipvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dPlaneClip"
};
/* harmony default export */ var PlaneClipvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(PlaneClipvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconPlaneClip
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let tiles = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      tileset: props.settingParams && props.settingParams.tileset || null,
      clipDirection: props.settingParams && props.settingParams.clipDirection || 2,
      reverseClip: props.settingParams && props.settingParams.reverseClip !== undefined ? props.settingParams.reverseClip : false,
      enableClip: props.settingParams && props.settingParams.enableClip !== undefined || true,
      boxEnable: props.settingParams && props.settingParams.boxEnable !== undefined || false,
      clipDistance: props.settingParams && props.settingParams.clipDistance || 0
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.planeClip;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言
      //父组 件ScenceView初始化完成后执行

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            tileset: formItem.tileset,
            clipType: formItem.clipDirection,
            reverseClip: formItem.reverseClip,
            enable: formItem.enableClip,
            boxEnable: formItem.boxEnable,
            distance: formItem.clipDistance
          };
          viewModel = new PlaneClipViewModel(scenceView, options);
        }
      });
      setTimeout(() => {
        if (viewModel) {
          tiles.value = viewModel.findLayers(); // 获取所有tileset对象

          if (tiles.value.length > 0) {
            formItem.tileset = tiles.value[0].guid;
            paramsChanged("tileset");
          }
        }
      }, 1000);
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 参数改变


    function paramsChanged(key) {
      switch (key) {
        case "tileset":
          viewModel.setLayer(formItem.tileset);
          break;

        case "clipDirection":
          viewModel.setClipDirection(formItem.clipDirection);
          break;

        case "reverseClip":
          viewModel.setClipType(formItem.reverseClip);
          break;

        case "enableClip":
          viewModel.setEnable(formItem.enableClip);
          break;

        case "boxEnable":
          viewModel.setShowBox(formItem.boxEnable);
          break;

        case "distance":
          viewModel.setDistance(formItem.clipDistance);
          break;

        default:
          break;
      }
    } // 开始裁剪


    function clip() {
      viewModel && viewModel.start();
    } // 清除


    function clearResult() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      clip,
      clearResult
    });
    return (_ctx, _cache) => {
      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-plane-clip", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", PlaneClipvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", PlaneClipvue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipObj), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).tileset,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).tileset = $event),
            onChange: _cache[1] || (_cache[1] = $event => paramsChanged('tileset'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tiles), (item, index) => {
              return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
                key: index,
                value: item.guid,
                label: item.name
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(item.name), 1
                /* TEXT */
                )]),
                _: 2
                /* DYNAMIC */

              }, 1032
              /* PROPS, DYNAMIC_SLOTS */
              , ["value", "label"]);
            }), 128
            /* KEYED_FRAGMENT */
            ))]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", PlaneClipvue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipStyle), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDirection,
            "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDirection = $event),
            onChange: _cache[3] || (_cache[3] = $event => paramsChanged('clipDirection'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).xClip,
              value: 2
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).yClip,
              value: 3
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).zClip,
              value: 4
            }, null, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowClass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 6,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", PlaneClipvue_type_script_setup_true_lang_js_hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipPattern), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 18,
          class: "colClass"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).reverseClip,
            "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).reverseClip = $event),
            onChange: _cache[5] || (_cache[5] = $event => paramsChanged('reverseClip'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).forwardClip,
              value: false
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).reverseClip,
              value: true
            }, null, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-plane-clip-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-plane-clip-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '90px' : '120px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enableClip,
                  "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).enableClip = $event),
                  onChange: _cache[7] || (_cache[7] = $event => paramsChanged('enableClip'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).enableClip), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 12
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).boxEnable,
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).boxEnable = $event),
                  onChange: _cache[9] || (_cache[9] = $event => paramsChanged('boxEnable'))
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).boxEnable), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clipDistance
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDistance,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDistance = $event),
                      step: 1,
                      min: -50,
                      max: 50,
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('distance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDistance,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).clipDistance = $event),
                      step: 1,
                      min: -50,
                      max: 50,
                      "controls-position": "right",
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('distance'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", PlaneClipvue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[14] || (_cache[14] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clip(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clip,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clip), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[15] || (_cache[15] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clearResult(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/planeclip/PlaneClip.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/planeclip/PlaneClip.vue



const PlaneClip_exports_ = PlaneClipvue_type_script_setup_true_lang_js;

/* harmony default export */ var PlaneClip = (PlaneClip_exports_);
;// CONCATENATED MODULE: ./src/webgl/planeclip/index.js




PlaneClip.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(PlaneClip.name, PlaneClip);
};


;// CONCATENATED MODULE: ./src/webgl/adddata/AddDataViewModel.js




 //添加数据逻辑类

class AddDataViewModel {
  constructor(scenceView, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_layerManager", null);

    _defineProperty(this, "_language", null);

    _defineProperty(this, "_geojsonStyle", {
      label: {
        express: "name",
        // font: "25px 微软雅黑",
        font: "28px sans-serif",
        fontSize: 28,
        fillColor: Cesium.Color.WHITE,
        scale: 0.6,
        outlineColor: Cesium.Color.BLACK,
        outlineWidth: 5,
        style: Cesium.LabelStyle.FILL_AND_OUTLINE,
        eyeOffset: Cesium.Cartesian3.ZERO,
        pixelOffset: new Cesium.Cartesian2(0, -8),
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      },
      billboard: {
        image: const_image_namespaceObject.BILLBOARD_IMAGE_URL,
        width: 12,
        height: 12,
        disableDepthTestDistance: Number.POSITIVE_INFINITY
      },
      polyline: {
        width: 2.0,
        material: Cesium.Color.RED,
        clampToGround: true
      },
      polygon: {
        material: Cesium.Color.BLUE.withAlpha(0.3),
        outline: true,
        outlineWidth: 1,
        outlineColor: Cesium.Color.YELLOW,
        perPositionHeight: false
      }
    });

    this._viewer = scenceView._viewer;
    this._layerManager = scenceView._layerManager;
    this._language = scenceView._language;
    this._geometryServerUrl = options.geometryServerUrl;
    this._geometryServerToken = options.geometryServerToken;
  } //解析文件


  parseFile(file, cb) {
    var that = this;
    return new Promise((resolve, reject) => {
      var ext = file.name.replace(/.+\./, "").toLowerCase(); //文件扩展名

      var name = file.name.replace(/(.*\/)*([^.]+).*/gi, "$2"); //文件名

      if (ext === "zip") {
        (0,util_namespaceObject.uploadSHP)(that._geometryServerUrl, file, that._geometryServerToken, null, function (res) {
          if (res) {
            if (res.srs) {
              //返回的geojson数据已经做了处理,返回数据坐标系为4326
              delete res.srs;
            }

            var ds = new Cesium.Kq3dGeoJsonDataSource(name);
            ds.load(res, that._geojsonStyle).then(ds => {
              ds.entities.values.forEach(entity => {
                if (entity.polygon) {
                  entity.polyline = {
                    positions: entity.polygon.hierarchy._value.positions,
                    width: that._geojsonStyle.polygon.outlineWidth,
                    material: that._geojsonStyle.polygon.outlineColor
                  };
                }
              });

              that._viewer.dataSources.add(ds);

              ds.autoAvoid(that._viewer);

              that._viewer.flyTo(ds);

              resolve("success");
              var layer = {
                guid: ds.guid,
                name: name,
                visible: true,
                serverType: "datasource",
                lsType: "ls",
                url: res,
                addType: "geojson",
                shapeType: that._layerManager.getShapeType(ds)
              };

              that._layerManager.addTempLayerNode(layer);

              cb && cb(layer);
            });
          } else {
            reject(file.name + " service parse error.");
            cb && cb("error");
          }
        });
      } else if (ext === "txt") {
        let dataUrl = that._geometryServerUrl + (that._geometryServerToken ? "?ua_token=" + that._geometryServerToken : "");
        (0,util_namespaceObject.readTxT)(file, dataUrl, "4326", res => {
          if (res) {
            var ds = new Cesium.Kq3dGeoJsonDataSource(name);
            ds.load(res, that._geojsonStyle).then(ds => {
              ds.entities.values.forEach(entity => {
                if (entity.polygon) {
                  entity.polyline = {
                    positions: entity.polygon.hierarchy._value.positions,
                    width: that._geojsonStyle.polygon.outlineWidth,
                    material: that._geojsonStyle.polygon.outlineColor
                  };
                }
              });

              that._viewer.dataSources.add(ds);

              ds.autoAvoid(that._viewer);

              that._viewer.flyTo(ds);

              resolve("success");
              var layer = {
                guid: ds.guid,
                name: name,
                visible: true,
                serverType: "datasource",
                lsType: "ls",
                url: res,
                addType: "geojson",
                shapeType: that._layerManager.getShapeType(ds)
              };

              that._layerManager.addTempLayerNode(layer);

              cb && cb(layer);
            });
          } else {
            reject(file.name + " service parse error.");
          }
        });
      } else {
        var reader = new FileReader();
        reader.readAsText(file); //文本
        //readAsDataURL(file);  //base64 图片
        //readAsArrayBuffer(file); //原始二进制数据
        //readAsBinaryString(file);//二进制字符串
        //reader.readAsBinaryString(file);

        reader.onload = function (event) {
          var ret = event.target.result;

          switch (ext) {
            case "json":
            case "geojson":
            case "topojson":
              ret = ret.replace(/(^\s*)|(\s*$)/, "");
              ret = ret.substring(ret.indexOf("{"));

              try {
                var data = JSON.parse(ret);

                if (typeof data == "object" && data) {
                  ret = data;
                }
              } catch (e) {}

              var style = { ...that._geojsonStyle
              };
              var ds = new Cesium.Kq3dGeoJsonDataSource(name);
              var addType = "geojson"; // 判断是否是arcgis格式的json数据

              if (ret.geometryType) {
                ds = new Cesium.Kq3dEsriGeoJsonDataSource(name);
                style.label.express = "NAME";
                addType = "arcjson";
              }

              ds.load(ret, style).then(ds => {
                ds.entities.values.forEach(entity => {
                  if (entity.polygon) {
                    entity.polyline = {
                      positions: entity.polygon.hierarchy._value.positions,
                      width: style.polygon.outlineWidth,
                      material: style.polygon.outlineColor
                    };
                  }
                });

                that._viewer.dataSources.add(ds);

                ds.autoAvoid(that._viewer);

                that._viewer.flyTo(ds);

                resolve("success");
                var layer = {
                  guid: ds.guid,
                  name: name,
                  visible: true,
                  serverType: "datasource",
                  lsType: "ls",
                  url: ret,
                  addType: addType,
                  shapeType: that._layerManager.getShapeType(ds)
                };

                that._layerManager.addTempLayerNode(layer);

                cb && cb(layer);
              });
              break;

            case "kml":
              ret = ret.replace(/(^\s*)|(\s*$)/, "");
              var options = {
                name: name,
                camera: that._viewer.scene.camera,
                canvas: that._viewer.scene.canvas
              };
              var ds = new Cesium.KmlDataSource(options);
              var data = new Blob([ret], {
                type: "text/xml"
              });
              ds.load(data).then(ds => {
                that._viewer.dataSources.add(ds);

                that._viewer.flyTo(ds);

                resolve("success");
                var layer = {
                  guid: ds.guid,
                  name: name,
                  visible: true,
                  serverType: "datasource",
                  lsType: "ls",
                  url: data,
                  addType: "kml"
                };

                that._layerManager.addTempLayerNode(layer);

                cb && cb(layer);
              });
              break;

            case "kmz":
              var options = {
                name: name,
                camera: that._viewer.scene.camera,
                canvas: that._viewer.scene.canvas
              };
              var ds = new Cesium.KmlDataSource(options);
              ds.load(file).then(ds => {
                that._viewer.dataSources.add(ds);

                that._viewer.flyTo(ds);

                resolve("success");
                var layer = {
                  guid: ds.guid,
                  name: name,
                  visible: true,
                  serverType: "datasource",
                  lsType: "ls",
                  url: file,
                  addType: "kml"
                };

                that._layerManager.addTempLayerNode(layer);

                cb && cb(layer);
              });
              break;

            case "czml":
              ret = ret.replace(/(^\s*)|(\s*$)/, "");

              try {
                var data = JSON.parse(ret);

                if (typeof data == "object" && data) {
                  ret = data;
                }
              } catch (e) {}

              that._viewer.dataSources.add(Cesium.CzmlDataSource.load(ret, {
                name: name
              })).then(ds => {
                that._viewer.flyTo(ds);

                resolve("success");
                var layer = {
                  guid: ds.guid,
                  name: name,
                  visible: true,
                  serverType: "datasource",
                  lsType: "ls",
                  url: ret,
                  addType: "czml"
                };

                that._layerManager.addTempLayerNode(layer);

                cb && cb(layer);
              });

              break;

            case "txt":
              break;

            case "csv":
              break;

            case "xls":
            case "xlsx":
              break;

            default:
              break;
          }
        };

        reader.onerror = function () {
          console.log(file.name + " read error.");
          reject(file.name + " read error.");
        };
      }
    });
  } //解析数据源


  parseDataSource(options, cb) {
    options = options || {};

    if (options.url && options.url !== "") {
      let url = options.url;

      if (options.type === "stkterrain") {
        if (url.indexOf("?") > 0) {
          url = url.replace("?", "layer.json?");
        } else {
          url += "layer.json";
        }
      }

      try {
        new URL(url);
      } catch (error) {
        message({
          message: this._language.errorUrlAddress,
          type: "error"
        });
        return;
      }

      if (options.type === "kml") {
        this.parseService(options, cb);
        return;
      }

      fetch(url).then(data => {
        return data;
      }).then(data => {
        if (data.status !== 200) {
          message({
            message: this._language.serviceNotAvailable,
            type: "error"
          });
        } else {
          try {
            this.parseService(options, cb);
          } catch {}
        }
      }).catch(() => {
        message({
          message: this._language.serviceNotAvailable,
          type: "error"
        });
      });
    } else {
      message({
        message: this._language.inputUrlAddress,
        type: "warning"
      });
    }
  } //解析服务


  parseService(options, cb) {
    let url = options.url;
    let type = options.type || "";
    type = type.toLowerCase();
    let name = options.name;

    if (!name || name === "") {
      let ext;

      if (url.lastIndexOf(".") > url.lastIndexOf("/")) {
        ext = url.substring(url.lastIndexOf(".") + 1);
        ext = ext.toLowerCase();
      }

      if (["kml", "kmz", "czml", "geojson", "json", "topojson"].indexOf(ext) > -1) {
        name = url.substring(url.lastIndexOf("/") + 1);
      } else {
        if (type !== "wms" && type !== "wmts") {
          name = url.substring(0, url.lastIndexOf("/"));
          name = name.substring(name.lastIndexOf("/") + 1);
        }
      }
    }

    let node, layer;

    switch (type) {
      case "kq3dimageryfile":
        //影像瓦片文件
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dFileImageryProvider({
          name: name,
          url: url
        }));
        this.flyToLayer(layer);
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "imagerylayer",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        cb && cb(node);
        break;

      case "obterrain":
        //ob地形瓦片文件
        layer = new Cesium.Kq3dFileTerrainProvider({
          name: name,
          url: url
        });

        this._layerManager.setTerrain(layer);

        this.flyToLayer(layer);
        if (!layer.guid) layer.guid = Cesium.createGuid();
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "terrainprovider",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        this._layerManager._terrainProviders.push(layer);

        cb && cb(node);
        break;

      case "stkterrain":
        //stk地形瓦片文件
        layer = new Cesium.CesiumTerrainProvider({
          name: name,
          url: url,
          requestVertexNormals: true,
          requestWaterMask: false
        });
        if (!layer.guid) layer.guid = Cesium.createGuid();

        this._layerManager.setTerrain(layer);

        this.flyToLayer(layer);
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "terrainprovider",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        this._layerManager._terrainProviders.push(layer);

        cb && cb(node);
        break;

      case "3dtiles":
        var tileset = this._viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
          name: name,
          url: url
        }));

        this.flyToLayer(tileset);
        node = {
          guid: tileset.guid,
          name: name,
          visible: true,
          serverType: "3dtiles",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        cb && cb(node);
        break;

      case "kqgis3dserver":
        this._viewer.addKq3dServerLayerGroupExt(url).then(group => {
          var layers = group._addedLayers || group._layers;

          if (layers && layers.length > 0) {
            node = {
              guid: group.guid,
              name: name,
              children: [],
              lsType: "ls"
            };
            var serverType = "";
            var addType = "";

            for (var i = 0; i < layers.length; i++) {
              if (layers[i] instanceof Cesium.Cesium3DTileset) {
                serverType = "3dtiles";
                addType = "3dtiles";
                url = layers[i].url;
              } else if (layers[i] instanceof Cesium.ImageryLayer) {
                serverType = "imagerylayer";
                addType = "kq3dimageryfile";
                url = layers[i]._imageryProvider._originUrl;
              } else if (layers[i] instanceof Cesium.Kq3dFileTerrainProvider) {
                serverType = "terrainprovider";
                addType = "obterrain";
                url = layers[i].url;

                this._layerManager._terrainProviders.push(layers[i]);
              } else if (layers[i] instanceof Cesium.CesiumTerrainProvider) {
                serverType = "terrainprovider";
                addType = "stkterrain";
                url = layers[i].url;

                this._layerManager._terrainProviders.push(layers[i]);
              } else if (layers[i] instanceof Cesium.Kq3dGeoJsonDataSource) {
                serverType = "datasource";
                addType = "geojson";
                url = layers[i]._baseUri + layers[i]._name;
              }

              if (!layers[i].guid) layers[i].guid = Cesium.createGuid();
              node.children.push({
                guid: layers[i].guid,
                name: layers[i].name,
                visible: true,
                serverType: serverType,
                url: url,
                addType: addType
              });
            }

            this.flyToLayer(layers[0]);

            this._layerManager.addTempLayerNode(node);

            cb && cb(node);
          }
        });

        break;

      case "kqgisimageserver":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dKQGISServerImageryProviderExt({
          name: name,
          url: url,
          layerName: name
        }));
        this.flyToLayer(layer);
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "imagerylayer",
          lsType: "ls",
          url: url,
          addType: type,
          layerName: name,
          type: "Image" // 图层树显示图标使用

        };

        this._layerManager.addTempLayerNode(node);

        cb && cb(node);
        break;

      case "kqgismapserver":
        //使用二维方式解析服务
        let serverName = url.split("services/")[1].split("/")[0];
        let serverUrl = url.split("services/")[0] + "services/";
        let token;

        if (url.indexOf("ua_token") != -1) {
          token = url.split("ua_token=")[1].split("&")[0];
        }

        let webMapService = new (webmapservice_default())(serverName, {
          token: token,
          serviceUrl: serverUrl
        });
        webMapService.getMapInfo().then(mapInfo => {
          if (mapInfo.resultcode === "error") {
            message({
              message: mapInfo.message,
              type: "error"
            });
            return;
          }

          mapInfo = mapInfo.result;
          let mapServerInfo = (0,util_namespaceObject.formatKQMapInfo)(mapInfo, serverUrl, serverName, token, null, true);
          let showLayers = [];
          showLayers = showLayers.concat(mapServerInfo.layers_show);
          showLayers.reverse(); //获取图层筛选类型时用

          showLayers.forEach(layer => {
            layer.sourceType = "kqserver";
          });
          this._layerManager._layerListData = this._layerManager._layerListData.concat(showLayers);
          showLayers.forEach(layer => {
            var imageryProvider = new Cesium.Kq3dKQGISMapServerImageryProviderExt({
              url: layer.url,
              ua_token: layer.accessToken,
              layers: layer.id + ""
            });
            var imageryLayer = new Cesium.ImageryLayer(imageryProvider, {
              show: layer.visible
            });
            imageryLayer._guid = layer.guid;

            this._viewer.imageryLayers.add(imageryLayer);
          }, this);

          if (mapInfo.rect84) {
            if (mapInfo.rect84 instanceof Array) {
              this._viewer.camera.flyTo({
                destination: Cesium.Rectangle.fromDegrees(mapInfo.rect84[0], mapInfo.rect84[1], mapInfo.rect84[2], mapInfo.rect84[3])
              });
            } else {
              this._viewer.camera.flyTo({
                destination: Cesium.Rectangle.fromDegrees(mapInfo.rect84.minx, mapInfo.rect84.miny, mapInfo.rect84.maxx, mapInfo.rect84.maxy)
              });
            }
          }

          setChildrenAddType(mapServerInfo.layerTreeData, type);
          mapServerInfo.layerTreeData.forEach(node => {
            node.lsType = "ls";

            this._layerManager.addTempLayerNode(node, 1);

            cb && cb(node);
          }, this);
        });
        break;

      case "arcgismapserver":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dArcGISMapServerImageryProvider({
          name: name,
          url: url
        }));
        this.flyToLayer(layer);
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "imagerylayer",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        cb && cb(node);
        break;

      case "mvt":
        layer = this._viewer.imageryLayers.addImageryProvider(new Cesium.Kq3dMvtImageryProviderExt({
          name: name,
          style: url
        }));
        this.flyToLayer(layer);
        node = {
          guid: layer.guid,
          name: name,
          visible: true,
          serverType: "imagerylayer",
          lsType: "ls",
          url: url,
          addType: type,
          renderType: "vectortile" // 图层树显示图标使用

        };

        this._layerManager.addTempLayerNode(node);

        cb && cb(node);
        break;

      case "kqgisdataflowserver":
        let guid = Cesium.createGuid();
        layer = new Cesium.Kq3dDataFlowLayer(this._viewer, {
          url: url,
          style: {
            image: const_image_namespaceObject.CAR_URL,
            width: 30,
            height: 30
          }
        });
        layer.guid = guid;
        layer.init();
        layer.flyToBounds();
        node = {
          guid: guid,
          name: name,
          visible: true,
          serverType: "dataflowlayer",
          lsType: "ls",
          url: url,
          addType: type
        };

        this._layerManager.addTempLayerNode(node);

        this._layerManager._dataFlowLayerList.push(layer);

        cb && cb(node);
        break;

      case "wms":
        this._viewer.addWMSLayerGroup(url).then(group => {
          node = {
            guid: group.guid,
            name: name || "wms",
            children: [],
            lsType: "ls",
            serverType: 'ogcwms' //图层树显示图标使用

          };
          var layers = group._addedLayers || group._layers;

          if (layers) {
            for (var i = layers.length - 1; i >= 0; i--) {
              if (i === 0) {
                this.flyToLayer(layers[i]);
              }

              node.children.push({
                guid: layers[i].guid,
                name: layers[i].name,
                visible: true,
                serverType: "imagerylayer",
                url: url,
                addType: type,
                id: layers[i]._imageryProvider.layers
              });
            }
          }

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });

        break;

      case "wmts":
      case "kqgistileserver":
      case "kqgisaggregationserver":
        this._viewer.addWMTSLayerGroup(url).then(group => {
          var defaultName = 'wmts';
          if (type === "kqgistileserver") defaultName = 'tile';
          if (type === "kqgisaggregationserver") defaultName = 'aggregation';
          node = {
            guid: group.guid,
            name: name || defaultName,
            children: [],
            lsType: "ls"
          };

          if (type === "wmts") {
            //图层树显示图标使用
            node.serverType = "ogcwmts";
          }

          var layers = group._addedLayers || group._layers;

          if (layers) {
            for (var i = layers.length - 1; i >= 0; i--) {
              if (i === 0) {
                this.flyToLayer(layers[i]);
              }

              node.children.push({
                guid: layers[i].guid,
                name: layers[i].name,
                visible: true,
                serverType: "imagerylayer",
                url: url,
                addType: type,
                id: layers[i]._imageryProvider._layer
              });
            }
          }

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });

        break;

      case "wfs":
        var wfsProvider = new Cesium.Kq3dWebFeatureServiceProvider({
          url: url,
          typeName: name
        });
        var that = this;
        wfsProvider.load().then(function (data) {
          var ds = new Cesium.Kq3dGeoJsonDataSource(name);
          ds.load(data, that._geojsonStyle).then(ds => {
            that._viewer.dataSources.add(ds);

            ds.autoAvoid(that._viewer);

            that._viewer.flyTo(ds);

            node = {
              guid: ds.guid,
              name: name,
              visible: true,
              serverType: "datasource",
              lsType: "ls",
              url: url,
              addType: type
            };

            that._layerManager.addTempLayerNode(node);

            cb && cb(node);
          });
        });
        break;

      case "geojson":
        var ds = new Cesium.Kq3dGeoJsonDataSource(name);
        ds.load(url, this._geojsonStyle).then(ds => {
          ds.entities.values.forEach(entity => {
            if (entity.polygon) {
              entity.polyline = {
                positions: entity.polygon.hierarchy._value.positions,
                width: this._geojsonStyle.polygon.outlineWidth,
                material: this._geojsonStyle.polygon.outlineColor
              };
            }
          }, this);

          this._viewer.dataSources.add(ds);

          ds.autoAvoid(this._viewer);

          this._viewer.flyTo(ds);

          node = {
            guid: ds.guid,
            name: name,
            visible: true,
            serverType: "datasource",
            lsType: "ls",
            url: url,
            addType: type,
            shapeType: this._layerManager.getShapeType(ds)
          };

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });
        break;

      case "arcjson":
        var ds = new Cesium.Kq3dEsriGeoJsonDataSource(name);
        var geojsonStyle = { ...this._geojsonStyle
        };
        geojsonStyle.label.express = 'NAME';
        ds.load(url, geojsonStyle).then(ds => {
          ds.entities.values.forEach(entity => {
            if (entity.polygon) {
              entity.polyline = {
                positions: entity.polygon.hierarchy._value.positions,
                width: geojsonStyle.polygon.outlineWidth,
                material: geojsonStyle.polygon.outlineColor
              };
            }
          }, this);

          this._viewer.dataSources.add(ds);

          this._viewer.flyTo(ds);

          node = {
            guid: ds.guid,
            name: name,
            visible: true,
            serverType: "datasource",
            lsType: "ls",
            url: url,
            addType: type,
            shapeType: this._layerManager.getShapeType(ds)
          };

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });
        break;

      case "kml":
        var ds = new Cesium.KmlDataSource({
          name: name,
          camera: this._viewer.camera,
          canvas: this._viewer.scene.canvas
        });
        ds.load(url).then(ds => {
          this._viewer.dataSources.add(ds);

          this._viewer.flyTo(ds);

          node = {
            guid: ds.guid,
            name: name,
            visible: true,
            serverType: "datasource",
            lsType: "ls",
            url: url,
            addType: type
          };

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });
        break;

      case "czml":
        var ds = new Cesium.CzmlDataSource(name);
        ds.load(url).then(ds => {
          this._viewer.dataSources.add(ds);

          this._viewer.flyTo(ds);

          node = {
            guid: ds.guid,
            name: name,
            visible: true,
            serverType: "datasource",
            lsType: "ls",
            url: url,
            addType: type
          };

          this._layerManager.addTempLayerNode(node);

          cb && cb(node);
        });
        break;

      default:
        break;
    }
  }

  flyToLayer(layer) {
    let viewer = this._viewer;

    if (layer instanceof Cesium.ImageryLayer) {
      layer.getViewableRectangle().then(function (rectangle) {
        viewer.camera.flyTo({
          destination: rectangle
        });
      });
    } else if (layer instanceof Cesium.Cesium3DTileset) {
      viewer.zoomTo(layer);
    } else if (layer instanceof Cesium.GeoJsonDataSource || layer instanceof Cesium.Kq3dGeoJsonDataSource || layer instanceof Cesium.KmlDataSource || layer instanceof Cesium.CzmlDataSource) {
      viewer.flyTo(layer);
    } else if (layer instanceof Cesium.Kq3dKQGISServerTerrainProvider || layer instanceof Cesium.Kq3dFileTerrainProvider || layer instanceof Cesium.CesiumTerrainProvider) {
      layer.getViewableRectangle().then(function (rectangle) {
        if (layer.ExtentSource) {
          var rectangle = Cesium.Rectangle.fromDegrees(layer.ExtentSource.left, layer.ExtentSource.bottom, layer.ExtentSource.right, layer.ExtentSource.top);
          viewer.scene.camera.flyTo({
            destination: rectangle
          });
        } else if (rectangle) {
          viewer.camera.flyTo({
            destination: rectangle
          });
        }
      });
    }
  }

} // 设置子节点addType属性

function setChildrenAddType(nodeList, addType) {
  for (let i = 0; i < nodeList.length; i++) {
    const node = nodeList[i];

    if (node.children) {
      setChildrenAddType(node.children, addType);
    } else {
      node.addType = addType;
    }
  }
}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/adddata/AddData.vue?vue&type=script&setup=true&lang=js

const AddDatavue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-add-data-box"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-add-data-desc"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_3 = {
  class: "kq3d-add-data-upload_text"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_4 = {
  class: "kq3d-add-data-filelist"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_5 = {
  class: "kq3d-add-data-file"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_6 = ["title"];
const AddDatavue_type_script_setup_true_lang_js_hoisted_7 = {
  class: "kq3d-add-data-footer"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_8 = {
  class: "btns_box"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_9 = {
  class: "kq3d-add-data-tip"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_10 = {
  class: "kq3d-add-data-tip"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_11 = {
  class: "kq3d-add-data-footer"
};
const AddDatavue_type_script_setup_true_lang_js_hoisted_12 = {
  class: "btns_box"
};






 //accept=".zip,.geojson,.topojson,.json,.kml,.kmz,.czml,.csv,.xls,.xlsx,.txt"

const AddDatavue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dAddData"
};
/* harmony default export */ var AddDatavue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(AddDatavue_type_script_setup_true_lang_js_default_, {
  props: {
    // 是否显示阴影
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 几何服务地址前缀，例：http://support.kqgeo.com:29800/geometry-proxy/kqgis/rest/services/geometry
    geometryServerUrl: {
      type: String,
      required: true
    },
    // 几何服务token，例：eyJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJob3N0IiwiY3JlYXRlZCI6MTY1NTk2MzU1NzUyMywiZXhwIjoxNzY3MTEwNDAwfQ.BiNOr6vL6liHzlMK89XSvqmFY9fuWiYqDEwYmWxk-6vFKBgLeMC8FloBXyKcxOCl9Rd28y_pX4PhVRYP5cZTwA
    geometryServerToken: {
      type: String,
      required: true
    },
    // 当前展示的tab标签页
    activeName: {
      type: String,
      default: "upload"
    },
    // 加载回调函数
    loadCallback: {
      type: Function,
      default: null
    },
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconAddData
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let selectTypeIndex = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(0); //URL服务支持的数据源类型

    let dataSourceTypeList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); //选择的数据源类型

    let dataSourceType = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let dataSource = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      url: "",
      name: ""
    });
    let upload_ref = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    let upload_btn_ref = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    let fileList = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]);
    let loadingFile = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 获取组件传参

    let operatorArray = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.computed)(() => {
      let array = [];
      let list = [...fileList.value];
      let len = list.length;

      for (let i = 0, j = 0; i < len; i += 3, j++) {
        array[j] = list.splice(0, 3);
      }

      return array;
    });
    let disabled = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.computed)(() => {
      let flag = true;

      if (fileList.value.length > 0) {
        flag = false;
      }

      return flag;
    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let viewModel = null; // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let addDataTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      addDataTitle.value = language.value.addData;
      dataSourceTypeList.value = setDataSourceType();
      dataSourceType.value = dataSourceTypeList.value[selectTypeIndex.value];
    });

    function setDataSourceType() {
      return [// {
      //     type: 'kq3dimageryfile',
      //     name: language.value.ImagertyTileFile,
      //     namePlaceholder: language.value.unnamedLayer,
      //     urlPlaceholder: language.value.format +':http://<host>:<port>/xxx/<servername>/info.xml',
      //     description: language.value.imagertyTileFiledescription
      // }, {
      //     type: 'obterrain',
      //     name: language.value.ObTerrainTileFile,
      //     namePlaceholder: language.value.unnamedLayer,
      //     urlPlaceholder: language.value.format +':http://<host>:<port>/xxx/<servername>/info.xml',
      //     description: language.value.imagertyObTerrainTileFiledescription
      // },
      {
        type: "kqgis3dserver",
        name: language.value.KQGIS3DServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/realspace",
        description: language.value.imagerty3DServerdescription
      }, {
        type: "kqgismapserver",
        name: language.value.KQGISMapServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/map",
        description: language.value.imagertyMapServerdescription
      }, {
        type: "kqgisimageserver",
        name: language.value.KQGISImageServer,
        namePlaceholder: language.value.imageCollectionName,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/image",
        description: language.value.imagertyImageServerdescription
      }, {
        type: "kqgisdataflowserver",
        name: language.value.KQGISDataflowServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/streaming/rest/services/<servername>/dataflow",
        description: language.value.imagertyDataflowServerdescription
      }, {
        type: "kqgistileserver",
        name: language.value.KQGISTileServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/tile/wmts",
        description: language.value.imagertyTileServerdescription
      }, {
        type: "kqgisaggregationserver",
        name: language.value.KQGISAggregationServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/map/wmts",
        description: language.value.imagertyAggregationServerdescription
      }, {
        type: "arcgismapserver",
        name: language.value.ArcGISMapServer,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/ArcGIS/rest/services/<servername>/MapServer",
        description: language.value.imagertyArcGISMapServerdescription
      }, {
        type: "wms",
        name: language.value.OGCWMS,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/map/wms",
        description: language.value.imagertyOGCWMSdescription
      }, {
        type: "wmts",
        name: language.value.OGCWMTS,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/kqgis/rest/services/<servername>/map/wmts",
        description: language.value.imagertyOGCWMTSdescription
      }, {
        type: "3dtiles",
        name: language.value.Cesium3DTilesFile,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/tileset.json",
        description: language.value.imagerty3DTilesFiledescription
      }, {
        type: "stkterrain",
        name: language.value.StkTerrainTileFile,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/xxx/<foldername>/",
        description: language.value.imagertyStkTerrainTileFiledescription
      }, {
        type: "geojson",
        name: language.value.GeoJson,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/xxx.geojson",
        description: language.value.imagertyGeoJsondescription
      }, {
        type: "arcjson",
        name: language.value.ArcJson,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/xxx.json",
        description: language.value.imagertyArcJsondescription
      }, {
        type: "mvt",
        name: language.value.MVT,
        namePlaceholder: language.value.unnamedLayer,
        urlPlaceholder: language.value.format + ":http://<host>:<port>/mvt/style.json",
        description: language.value.imagertyMVTdescription
      }
      /*, {
        type: 'wfs',
        name: language.value.OGCWFS,
        namePlaceholder: language.value.wfsLayer,
        urlPlaceholder: language.value.format +':http://<host>:<port>/ArcGIS/rest/services/<servername>/wfs',
        description: language.value.imagertyOGCWFSdescription
      }, {
          type: 'kml',
          name: language.value.KML,
          namePlaceholder: language.value.unnamedLayer,
          urlPlaceholder: language.value.format +': http://<host>:<port>/xxx/<servername>/xxx.kml',
          description: language.value.imagertyKMLdescription
      }, {
          type: 'czml',
          name: language.value.CZML,
          namePlaceholder: language.value.unnamedLayer,
          urlPlaceholder: language.value.format +': http://<host>:<port>/xxx/<servername>/xxx.czml',
          description: language.value.imagertyCZMLdescription
      }*/
      ];
    }

    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            geometryServerUrl: props.geometryServerUrl,
            geometryServerToken: props.geometryServerToken
          };
          viewModel = new AddDataViewModel(scenceView, options);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, addDataTitle);
      }
    }; // 切换tab页


    function handleChange(pane) {} // 切换类型


    function changeType(index) {
      dataSourceType.value = dataSourceTypeList.value[index];
      dataSource.url = "";
      dataSource.name = "";
    } //选择文件


    function changeFile(file) {
      fileList.value.push(file);
    } // 删除文件


    function removeFile(file) {
      fileList.value.forEach((item, index) => {
        if (item.uid === file.uid) {
          fileList.value.splice(index, 1);
        }
      });
    } //清空所有文件


    function removeFiles() {
      upload_ref.value.$refs.child.clearFiles();
      upload_btn_ref.value.$refs.child.clearFiles();
      fileList.value = [];
    } //加载文件


    function loadFiles() {
      loadingFile.value = true;
      let promiseList = [];
      fileList.value.forEach(file => {
        promiseList.push(viewModel.parseFile(file.raw, props.loadCallback));
      });
      Promise.all(promiseList).then(() => {
        removeFiles();
        loadingFile.value = false;
      });
    } //加载URL


    function loadURL() {
      viewModel.parseDataSource({
        type: dataSourceType.value.type,
        url: dataSource.url,
        name: dataSource.name
      }, props.loadCallback);
    } // 重置


    function reset() {
      dataSource.url = "";
      dataSource.name = "";
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {});
    expose({});
    return (_ctx, _cache) => {
      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_upload = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-upload");

      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_tab_pane = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-tab-pane");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_input = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_tabs = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-tabs");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-add-data", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_tabs, {
        modelValue: props.activeName,
        "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => props.activeName = $event),
        onTabChange: handleChange
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderSlot)(_ctx.$slots, "tabs"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_tab_pane, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).localData,
          name: "upload"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
            class: "kq3d-add-data-title"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fileFormatDescription), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
            class: "kq3d-add-data-tip"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).fileFormatDescriptionTips), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          })]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <div>\r\n          <kq-row>{{ language.coordinateSystemDescription }}</kq-row>\r\n          <kq-row class=\"kq3d-add-data-tip\">{{ language.coordinateSystemDescriptionTips }}</kq-row>\r\n        </div> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_upload, {
            drag: "",
            action: "",
            "show-file-list": false,
            "auto-upload": false,
            "file-list": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(fileList),
            "onUpdate:file-list": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(fileList) ? fileList.value = $event : fileList = $event),
            accept: ".zip,.geojson,.topojson,.json,.kml,.kmz,.czml,.txt",
            "on-change": changeFile,
            ref_key: "upload_ref",
            ref: upload_ref
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).dragFileToArea), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["file-list"]), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(fileList).length === 0]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_4, [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(operatorArray), (rowItem, i) => {
            return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_row, {
              key: i,
              gutter: 20
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)(rowItem, (file, j) => {
                return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_col, {
                  span: 8,
                  key: j
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
                    class: "kq3d-add-data-doc"
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.Document))]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", {
                    title: file.name
                  }, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)(file.name), 9
                  /* TEXT, PROPS */
                  , AddDatavue_type_script_setup_true_lang_js_hoisted_6), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
                    class: "kq3d-add-data-close",
                    onClick: $event => removeFile(file)
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(icons_vue_namespaceObject.CircleClose))]),
                    _: 2
                    /* DYNAMIC */

                  }, 1032
                  /* PROPS, DYNAMIC_SLOTS */
                  , ["onClick"])])]),
                  _: 2
                  /* DYNAMIC */

                }, 1024
                /* DYNAMIC_SLOTS */
                );
              }), 128
              /* KEYED_FRAGMENT */
              ))]),
              _: 2
              /* DYNAMIC */

            }, 1024
            /* DYNAMIC_SLOTS */
            );
          }), 128
          /* KEYED_FRAGMENT */
          ))], 512
          /* NEED_PATCH */
          ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(fileList).length > 0]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_7, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderSlot)(_ctx.$slots, "loadingFilesSwitch"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_8, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_upload, {
            action: "",
            "show-file-list": false,
            "auto-upload": false,
            accept: ".zip,.geojson,.topojson,.json,.kml,.kmz,.czml,.txt",
            ref_key: "upload_btn_ref",
            ref: upload_btn_ref,
            class: "kq3d-add-data-footer-upload",
            "on-change": changeFile
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
              title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).selectFiles,
              type: "primary"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).selectFiles), 1
              /* TEXT */
              )]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["title"])]),
            _: 1
            /* STABLE */

          }, 512
          /* NEED_PATCH */
          ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[1] || (_cache[1] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => removeFiles(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearFiles,
            type: "primary"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clearFiles), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[2] || (_cache[2] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => loadFiles(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).loadFiles,
            type: "primary",
            disabled: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(disabled),
            loading: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(loadingFile)
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).loadFiles), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title", "disabled", "loading"])])])]),
          _: 3
          /* FORWARDED */

        }, 8
        /* PROPS */
        , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_tab_pane, {
          label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).urlData,
          name: "url"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": "70px",
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).type
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(selectTypeIndex),
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(selectTypeIndex) ? selectTypeIndex.value = $event : selectTypeIndex = $event),
                  onChange: changeType
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSourceTypeList), (item, index) => {
                    return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
                      label: item.name,
                      value: index
                    }, null, 8
                    /* PROPS */
                    , ["label", "value"]);
                  }), 256
                  /* UNKEYED_FRAGMENT */
                  ))]),
                  _: 1
                  /* STABLE */

                }, 8
                /* PROPS */
                , ["modelValue"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", AddDatavue_type_script_setup_true_lang_js_hoisted_9, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSourceType).description), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).url
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSource).url,
                  "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSource).url = $event),
                  placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSourceType).urlPlaceholder
                }, null, 8
                /* PROPS */
                , ["modelValue", "placeholder"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", AddDatavue_type_script_setup_true_lang_js_hoisted_10, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSourceType).urlPlaceholder), 1
                /* TEXT */
                )]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).layerName
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSource).name,
                  "onUpdate:modelValue": _cache[5] || (_cache[5] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSource).name = $event),
                  placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(dataSourceType).namePlaceholder
                }, null, 8
                /* PROPS */
                , ["modelValue", "placeholder"])]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_11, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderSlot)(_ctx.$slots, "loadingURLSwitch"), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", AddDatavue_type_script_setup_true_lang_js_hoisted_12, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[6] || (_cache[6] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => loadURL(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).loadFiles,
            type: "primary"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).loadFiles), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
            onClick: _cache[7] || (_cache[7] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => reset(), ["stop"])),
            title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).reset
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).reset), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["title"])])])]),
          _: 3
          /* FORWARDED */

        }, 8
        /* PROPS */
        , ["label"])])]),
        _: 3
        /* FORWARDED */

      }, 8
      /* PROPS */
      , ["modelValue"])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/adddata/AddData.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/adddata/AddData.vue



const AddData_exports_ = AddDatavue_type_script_setup_true_lang_js;

/* harmony default export */ var AddData = (AddData_exports_);
;// CONCATENATED MODULE: ./src/webgl/adddata/index.js




AddData.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(AddData.name, AddData);
};


;// CONCATENATED MODULE: ./src/webgl/particleeffect/ParticleEffectViewModel.js


let _gravityScratch = null;
let _gravity = 1.0; //粒子特效逻辑类

class ParticleEffectViewModel {
  //三维球场景视图对象
  //粒子特效集合
  //绘制管理对象
  //绘制完成监听事件
  //粒子特效存储参数对象
  //火焰图片url地址
  //烟雾图片url地址
  constructor(scenceView) {
    _defineProperty(this, "_scene", null);

    _defineProperty(this, "_particleSystemList", []);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_fireImage", const_image_namespaceObject.FIRE_URL);

    _defineProperty(this, "_smokeImage", const_image_namespaceObject.SMOKE_URL);

    scenceView._viewer.clock.shouldAnimate = true;
    scenceView._viewer.scene.globe.depthTestAgainstTerrain = true;
    this._scene = scenceView._viewer.scene;
    this._drawManager = scenceView._drawManager; // 启动连续绘制

    this._drawManager.enableMultiDraw(true);

    _gravityScratch = new Cesium.Cartesian3();
    var that = this;
    that._removeEventListener = that._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape && shape.type === "marker") {
        // that._drawManager.clear();
        let position = shape.position;

        if (position) {
          let matrix = new Cesium.Matrix4.fromTranslation(position);

          if (that._options.mode === "flame") {
            let fireParticle = new Cesium.ParticleSystem({
              emissionRate: that._options.particleNum,
              imageSize: new Cesium.Cartesian2(that._options.particleSize, 2 * that._options.particleSize),
              minimumParticleLife: that._options.minLifeCycle,
              maximumParticleLife: that._options.maxLifeCycle,
              minimumSpeed: that._options.minSpeed,
              maximumSpeed: that._options.maxSpeed,
              startScale: that._options.startScale,
              endScale: that._options.endScale,
              modelMatrix: matrix,
              image: that._fireImage,
              startColor: new Cesium.Color.fromCssColorString("#ffffff"),
              endColor: new Cesium.Color.fromCssColorString("#ffa000"),
              emitter: new Cesium.ConeEmitter(Cesium.Math.toRadians(35.0)),
              mass: 10,
              sizeInMeters: true,
              updateCallback: that.applyGravity
            });

            that._scene.primitives.add(fireParticle);

            that._particleSystemList.push(fireParticle);
          } else if (that._options.mode === "smoke") {
            let smokeParticle = new Cesium.ParticleSystem({
              emissionRate: that._options.particleNum,
              imageSize: new Cesium.Cartesian2(that._options.particleSize, that._options.particleSize),
              minimumParticleLife: that._options.minLifeCycle,
              maximumParticleLife: that._options.maxLifeCycle,
              minimumSpeed: that._options.minSpeed,
              maximumSpeed: that._options.maxSpeed,
              startScale: that._options.startScale,
              endScale: that._options.endScale,
              modelMatrix: matrix,
              image: that._smokeImage,
              startColor: new Cesium.Color.fromCssColorString("#a2a2a2"),
              endColor: new Cesium.Color.fromCssColorString("#5c5c5c"),
              emitter: new Cesium.ConeEmitter(70),
              sizeInMeters: true,
              bursts: [// 随着时间改变产生越来越多的粒子
              new Cesium.ParticleBurst({
                time: 5.0,
                minimum: 1,
                maximum: 5
              }), new Cesium.ParticleBurst({
                time: 10.0,
                minimum: 10,
                maximum: 10
              }), new Cesium.ParticleBurst({
                time: 15.0,
                minimum: 20,
                maximum: 20
              })],
              updateCallback: that.applyGravity
            });

            that._scene.primitives.add(smokeParticle);

            that._particleSystemList.push(smokeParticle);
          }
        }
      }
    });
  }

  applyGravity(particle, dt) {
    _gravityScratch = Cesium.Cartesian3.normalize(particle.position, _gravityScratch);
    Cesium.Cartesian3.multiplyByScalar(_gravityScratch, _gravity * dt, _gravityScratch);
    particle.velocity = Cesium.Cartesian3.add(particle.velocity, _gravityScratch, particle.velocity);
  } //添加粒子特效


  addParticleEffect(options) {
    let mode = options.mode;

    if (mode !== "flame" && mode !== "smoke") {
      console.log("This mode is not supported.");
      return;
    }

    if (options.gravity) this.setGravity(options.gravity);
    this._options = options;

    this._drawManager.startDraw("marker", {
      image: null
    });
  } //清除粒子特效


  clear() {
    this._drawManager.stopDraw();

    this._drawManager.clear();

    for (let i = 0; i < this._particleSystemList.length; i++) {
      this._scene.primitives.remove(this._particleSystemList[i]);
    }

    this._particleSystemList = [];
  } //销毁


  destroy() {
    this.clear();

    this._drawManager.enableMultiDraw(false); //移除监听事件


    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } //设置粒子数量


  setParticleNumber(number) {
    this._particleSystemList.forEach(particle => {
      particle.emissionRate = number;
    });
  } //设置粒子大小


  setParticleSize(size) {
    let mode = this._options.mode;

    this._particleSystemList.forEach(particle => {
      if (mode === "flame") {
        particle.minimumImageSize = new Cesium.Cartesian2(size, 2 * size);
        particle.maximumImageSize = new Cesium.Cartesian2(size, 2 * size);
      } else {
        particle.minimumImageSize = new Cesium.Cartesian2(size, size);
        particle.maximumImageSize = new Cesium.Cartesian2(size, size);
      }
    });
  } //设置最小生命周期


  setMinLifeCycle(minLifeCycle) {
    this._particleSystemList.forEach(particle => {
      particle.minimumParticleLife = minLifeCycle;
    });
  } //设置最大生命周期


  setmaxLifeCycle(maxLifeCycle) {
    this._particleSystemList.forEach(particle => {
      particle.maximumParticleLife = maxLifeCycle;
    });
  } //设置最小速度


  setMinSpeed(minSpeed) {
    this._particleSystemList.forEach(particle => {
      particle.minimumSpeed = minSpeed;
    });
  } //设置最大速度


  setMaxSpeed(maxSpeed) {
    this._particleSystemList.forEach(particle => {
      particle.maximumSpeed = maxSpeed;
    });
  } //设置初始比例


  setStartScale(startScale) {
    this._particleSystemList.forEach(particle => {
      particle.startScale = startScale;
    });
  } //设置结束比例


  setEndScale(endScale) {
    this._particleSystemList.forEach(particle => {
      particle.endScale = endScale;
    });
  } //设置重力


  setGravity(gravity) {
    _gravity = gravity;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/particleeffect/ParticleEffect.vue?vue&type=script&setup=true&lang=js

const ParticleEffectvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-particle-effect-box"
};
const ParticleEffectvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-particle-effect-footer"
};






const ParticleEffectvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dParticleEffect"
};
/* harmony default export */ var ParticleEffectvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(ParticleEffectvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconParticleEffect
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      mode: props.settingParams && props.settingParams.mode || "flame",
      particleNum: props.settingParams && props.settingParams.particleNum || 40,
      particleSize: props.settingParams && props.settingParams.particleSize || 2.5,
      minLifeCycle: props.settingParams && props.settingParams.minLifeCycle || 0.5,
      maxLifeCycle: props.settingParams && props.settingParams.maxLifeCycle || 0.5,
      minSpeed: props.settingParams && props.settingParams.minSpeed || 15.0,
      maxSpeed: props.settingParams && props.settingParams.maxSpeed || 15.0,
      startScale: props.settingParams && props.settingParams.startScale || 1.0,
      endScale: props.settingParams && props.settingParams.endScale || 1.0,
      gravity: props.settingParams && props.settingParams.gravity || 0.0
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.particleEffect;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new ParticleEffectViewModel(scenceView);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    };

    function changeMode(mode) {
      if (formItem.mode !== mode) {
        // viewModel && viewModel.clear();
        formItem.mode = mode;

        if (mode === "flame") {
          formItem.particleNum = 40;
          formItem.particleSize = 2.5;
          formItem.minLifeCycle = 0.5;
          formItem.maxLifeCycle = 0.5;
          formItem.minSpeed = 15.0;
          formItem.maxSpeed = 15.0;
          formItem.startScale = 1.0;
          formItem.endScale = 1.0;
          formItem.gravity = 0.0;
        } else if (mode === "smoke") {
          formItem.particleNum = 50;
          formItem.particleSize = 2;
          formItem.minLifeCycle = 3.5;
          formItem.maxLifeCycle = 3.0;
          formItem.minSpeed = 7.0;
          formItem.maxSpeed = 9.0;
          formItem.startScale = 2.0;
          formItem.endScale = 9.0;
          formItem.gravity = 5.0;
        }
      }
    }

    function paramsChanged(key) {
      switch (key) {
        case "particleNum":
          viewModel.setParticleNumber(formItem.particleNum);
          break;

        case "particleSize":
          viewModel.setParticleSize(formItem.particleSize);
          break;

        case "minLifeCycle":
          viewModel.setMinLifeCycle(formItem.minLifeCycle);
          break;

        case "maxLifeCycle":
          viewModel.setmaxLifeCycle(formItem.maxLifeCycle);
          break;

        case "minSpeed":
          viewModel.setMinSpeed(formItem.minSpeed);
          break;

        case "maxSpeed":
          viewModel.setMaxSpeed(formItem.maxSpeed);
          break;

        case "startScale":
          viewModel.setStartScale(formItem.startScale);
          break;

        case "endScale":
          viewModel.setEndScale(formItem.endScale);
          break;

        case "gravity":
          viewModel.setGravity(formItem.gravity);
          break;

        default:
          break;
      }
    }

    function add() {
      viewModel && viewModel.addParticleEffect(formItem);
    }

    function clear() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      changeMode,
      paramsChanged,
      add,
      clear
    });
    return (_ctx, _cache) => {
      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-particle-effect", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ParticleEffectvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowclass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
          icon: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconFlame),
          class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(['kq3d-particle-effect-btn', (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 'flame' ? 'kq3d-particle-effect-btn_active' : '']),
          onClick: _cache[0] || (_cache[0] = $event => changeMode('flame')),
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).flame
        }, null, 8
        /* PROPS */
        , ["icon", "class", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
          icon: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconSmoke),
          class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(['kq3d-particle-effect-btn', (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 'smoke' ? 'kq3d-particle-effect-btn_active' : '']),
          onClick: _cache[1] || (_cache[1] = $event => changeMode('smoke')),
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).smoke
        }, null, 8
        /* PROPS */
        , ["icon", "class", "title"])]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-particle-effect-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-particle-effect-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '110px' : '160px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleNum
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum = $event),
                      step: 10,
                      min: 0,
                      max: 1000,
                      onInput: _cache[3] || (_cache[3] = $event => paramsChanged('particleNum'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum = $event),
                      step: 10,
                      min: 0,
                      max: 1000,
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('particleNum')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleSize
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('particleSize'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[9] || (_cache[9] = $event => paramsChanged('particleSize')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).minLifeCycle
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLifeCycle,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLifeCycle = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('minLifeCycle'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLifeCycle,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minLifeCycle = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('minLifeCycle')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).maxLifeCycle
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLifeCycle,
                      "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLifeCycle = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[15] || (_cache[15] = $event => paramsChanged('maxLifeCycle'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLifeCycle,
                      "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxLifeCycle = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[17] || (_cache[17] = $event => paramsChanged('maxLifeCycle')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).minSpeed
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpeed,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpeed = $event),
                      step: 1,
                      min: 1,
                      max: 50,
                      onInput: _cache[19] || (_cache[19] = $event => paramsChanged('minSpeed'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpeed,
                      "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).minSpeed = $event),
                      step: 1,
                      min: 1,
                      max: 50,
                      onInput: _cache[21] || (_cache[21] = $event => paramsChanged('minSpeed')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).maxSpeed
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpeed,
                      "onUpdate:modelValue": _cache[22] || (_cache[22] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpeed = $event),
                      step: 1,
                      min: 1,
                      max: 50,
                      onInput: _cache[23] || (_cache[23] = $event => paramsChanged('maxSpeed'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpeed,
                      "onUpdate:modelValue": _cache[24] || (_cache[24] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).maxSpeed = $event),
                      step: 1,
                      min: 1,
                      max: 50,
                      onInput: _cache[25] || (_cache[25] = $event => paramsChanged('maxSpeed')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startScale
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale,
                      "onUpdate:modelValue": _cache[26] || (_cache[26] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale = $event),
                      min: 0.1,
                      max: 10.0,
                      step: 0.1,
                      onInput: _cache[27] || (_cache[27] = $event => paramsChanged('startScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale,
                      "onUpdate:modelValue": _cache[28] || (_cache[28] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale = $event),
                      min: 0.1,
                      max: 10.0,
                      step: 0.1,
                      onInput: _cache[29] || (_cache[29] = $event => paramsChanged('startScale')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).endScale
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale,
                      "onUpdate:modelValue": _cache[30] || (_cache[30] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale = $event),
                      min: 0.1,
                      max: 10.0,
                      step: 0.1,
                      onInput: _cache[31] || (_cache[31] = $event => paramsChanged('endScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale,
                      "onUpdate:modelValue": _cache[32] || (_cache[32] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale = $event),
                      min: 0.1,
                      max: 10.0,
                      step: 0.1,
                      onInput: _cache[33] || (_cache[33] = $event => paramsChanged('endScale')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gravity
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity,
                      "onUpdate:modelValue": _cache[34] || (_cache[34] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity = $event),
                      step: 0.1,
                      min: 0.0,
                      max: 10,
                      onInput: _cache[35] || (_cache[35] = $event => paramsChanged('gravity'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity,
                      "onUpdate:modelValue": _cache[36] || (_cache[36] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity = $event),
                      min: 0.0,
                      max: 10,
                      step: 0.1,
                      onInput: _cache[37] || (_cache[37] = $event => paramsChanged('gravity')),
                      "controls-position": "right"
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", ParticleEffectvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[38] || (_cache[38] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => add(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).add,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).add), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[39] || (_cache[39] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clear(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/particleeffect/ParticleEffect.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/particleeffect/ParticleEffect.vue



const ParticleEffect_exports_ = ParticleEffectvue_type_script_setup_true_lang_js;

/* harmony default export */ var ParticleEffect = (ParticleEffect_exports_);
;// CONCATENATED MODULE: ./src/webgl/particleeffect/index.js




ParticleEffect.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(ParticleEffect.name, ParticleEffect);
};


;// CONCATENATED MODULE: ./src/webgl/weathereffect/WeatherEffectViewModel.js


let WeatherEffectViewModel_gravityScratch = null;
let _gravityStart = 0.0;

let _gravityEnd = -1.0; //天气特效逻辑类


class WeatherEffectViewModel {
  //三维球场景视图对象
  //粒子系统三维对象
  //绘制管理对象
  //绘制完成监听事件
  //天气特效存储参数对象
  //雨图片url地址
  //雪图片url地址
  constructor(scenceView) {
    _defineProperty(this, "_scene", null);

    _defineProperty(this, "_particleSystem", null);

    _defineProperty(this, "_drawManager", null);

    _defineProperty(this, "_removeEventListener", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_rainImage", const_image_namespaceObject.RAIN_URL);

    _defineProperty(this, "_snowImage", const_image_namespaceObject.SNOW_URL);

    scenceView._viewer.clock.shouldAnimate = true;
    scenceView._viewer.clock.multiplier = 0.6;
    scenceView._viewer.scene.globe.depthTestAgainstTerrain = true;
    this._scene = scenceView._viewer.scene;
    this._drawManager = scenceView._drawManager;
    WeatherEffectViewModel_gravityScratch = new Cesium.Cartesian3();
    var that = this;
    that._removeEventListener = that._drawManager.drawFinishedEvent.addEventListener(shape => {
      if (shape && shape.type === "marker") {
        that._drawManager.clear();

        let position = shape.position;

        if (position) {
          let matrix = new Cesium.Matrix4.fromTranslation(position);

          if (!that._particleSystem) {
            that._particleSystem = new Cesium.ParticleSystem({
              modelMatrix: matrix,
              lifetime: that._options.lifeCycle,
              emitter: new Cesium.BoxEmitter(new Cesium.Cartesian3(that._options.rangeRadius, that._options.rangeRadius, that._options.rangeRadius)),
              startScale: that._options.startScale,
              endScale: that._options.endScale,
              emissionRate: that._options.particleNum,
              startColor: that._options.mode === "rain" ? new Cesium.Color.fromCssColorString("#3c8dbc") : Cesium.Color.WHITE.withAlpha(0.6),
              endColor: that._options.mode === "rain" ? new Cesium.Color.fromCssColorString("#365e76") : Cesium.Color.WHITE.withAlpha(1.0),
              image: that._options.mode === "rain" ? that._rainImage : that._snowImage,
              imageSize: new Cesium.Cartesian2(that._options.particleSize, that._options.particleSize),
              sizeInMeters: true,
              show: true,
              updateCallback: that.applyGravity
            });

            that._scene.primitives.add(that._particleSystem);
          } else {
            that._particleSystem.modelMatrix = matrix;
          }
        }
      }
    });
  }

  applyGravity(particle, dt) {
    WeatherEffectViewModel_gravityScratch = Cesium.Cartesian3.normalize(particle.position, WeatherEffectViewModel_gravityScratch);
    Cesium.Cartesian3.multiplyByScalar(WeatherEffectViewModel_gravityScratch, Cesium.Math.randomBetween(_gravityStart, _gravityEnd), WeatherEffectViewModel_gravityScratch);
    particle.velocity = Cesium.Cartesian3.add(particle.velocity, WeatherEffectViewModel_gravityScratch, particle.velocity);
  } //添加天气特效


  addWeatherEffect(options) {
    let mode = options.mode;

    if (mode !== "rain" && mode !== "snow") {
      console.log("This mode is not supported.");
      return;
    }

    if (options.gravity) this.setGravity(options.gravity);
    this._options = options;

    this._drawManager.startDraw("marker", {
      image: null
    });
  } //清除天气特效


  clear() {
    this._drawManager.stopDraw();

    this._drawManager.clear();

    this._particleSystem && this._scene.primitives.remove(this._particleSystem);
    this._particleSystem = null;
  } //销毁


  destroy() {
    this.clear(); //移除监听事件

    this._removeEventListener && this._removeEventListener();
    this._removeEventListener = null;
  } //设置范围半径


  setRangeRadius(radius) {
    if (this._particleSystem) {
      this._particleSystem.emitter = new Cesium.BoxEmitter(new Cesium.Cartesian3(radius, radius, radius));
    }
  } //设置粒子数量


  setParticleNumber(number) {
    if (this._particleSystem) {
      this._particleSystem.emissionRate = number;
    }
  } //设置粒子大小


  setParticleSize(size) {
    if (this._particleSystem) {
      this._particleSystem.minimumImageSize = new Cesium.Cartesian2(size, size);
      this._particleSystem.maximumImageSize = new Cesium.Cartesian2(size, size);
    }
  } //设置生命周期


  setLifeCycle(lifeCycle) {
    if (this._particleSystem) {
      this._particleSystem.lifetime = lifeCycle;
    }
  } //设置初始比例


  setStartScale(startScale) {
    if (this._particleSystem) {
      this._particleSystem.startScale = startScale;
    }
  } //设置结束比例


  setEndScale(endScale) {
    if (this._particleSystem) {
      this._particleSystem.endScale = endScale;
    }
  } //设置重力


  setGravity(gravity) {
    if (gravity <= 1) {
      _gravityStart = 0.0;
      _gravityEnd = 0 - gravity;
    } else {
      _gravityStart = 0 - (gravity - 1);
      _gravityEnd = 0 - gravity;
    }
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/weathereffect/WeatherEffect.vue?vue&type=script&setup=true&lang=js

const WeatherEffectvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-weather-effect-box"
};
const WeatherEffectvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-weather-effect-footer"
};






const WeatherEffectvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dWeatherEffect"
};
/* harmony default export */ var WeatherEffectvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(WeatherEffectvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    // 是否显示阴影效果
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconWeatherEffect
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)();
    let currentLang = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let collapseValue = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(""); // 获取组件传参

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      mode: props.settingParams && props.settingParams.mode || "rain",
      rangeRadius: props.settingParams && props.settingParams.rangeRadius || 100,
      particleNum: props.settingParams && props.settingParams.particleNum || 800,
      particleSize: props.settingParams && props.settingParams.particleSize || 2.0,
      lifeCycle: props.settingParams && props.settingParams.lifeCycle || 18,
      startScale: props.settingParams && props.settingParams.startScale || 1.1,
      endScale: props.settingParams && props.settingParams.endScale || 1.3,
      gravity: props.settingParams && props.settingParams.gravity || 1
    });
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.weatherEffect;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      currentLang.value = proxy.$i18n.locale; // 获取当前语言

      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new WeatherEffectViewModel(scenceView);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; //切换雨雪天气特效


    function changeMode(mode) {
      if (formItem.mode !== mode) {
        viewModel && viewModel.clear();
        formItem.mode = mode;

        if (mode === "rain") {
          formItem.particleSize = 2.0;
          formItem.startScale = 1.1;
          formItem.endScale = 1.3;
        } else if (mode === "snow") {
          formItem.particleSize = 0.6;
          formItem.startScale = 0.5;
          formItem.endScale = 0.6;
        }
      }
    }

    function paramsChanged(key) {
      switch (key) {
        case "rangeRadius":
          viewModel.setRangeRadius(formItem.rangeRadius);
          break;

        case "particleNum":
          viewModel.setParticleNumber(formItem.particleNum);
          break;

        case "particleSize":
          viewModel.setParticleSize(formItem.particleSize);
          break;

        case "lifeCycle":
          viewModel.setLifeCycle(formItem.lifeCycle);
          break;

        case "startScale":
          viewModel.setStartScale(formItem.startScale);
          break;

        case "endScale":
          viewModel.setEndScale(formItem.endScale);
          break;

        case "gravity":
          viewModel.setGravity(formItem.gravity);
          break;

        default:
          break;
      }
    }

    function add() {
      viewModel && viewModel.addWeatherEffect(formItem);
    }

    function clear() {
      viewModel && viewModel.clear();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      changeMode,
      paramsChanged,
      add,
      clear
    });
    return (_ctx, _cache) => {
      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_slider = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-slider");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_collapse_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse-item");

      const _component_kq_collapse = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-collapse");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-weather-effect", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", WeatherEffectvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        gutter: 20,
        class: "rowclass"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
          icon: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconRain),
          class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(['kq3d-weather-effect-btn', (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 'rain' ? 'kq3d-weather-effect-btn_active' : '']),
          onClick: _cache[0] || (_cache[0] = $event => changeMode('rain')),
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rain
        }, null, 8
        /* PROPS */
        , ["icon", "class", "title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
          icon: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconSnow),
          class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(['kq3d-weather-effect-btn', (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 'snow' ? 'kq3d-weather-effect-btn_active' : '']),
          onClick: _cache[1] || (_cache[1] = $event => changeMode('snow')),
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).snow
        }, null, 8
        /* PROPS */
        , ["icon", "class", "title"])]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        class: "kq3d-weather-effect-tip"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("p", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse, {
        "model-value": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(collapseValue),
        class: "kq3d-weather-effect-collapse"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_collapse_item, {
          title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).analysisSettings,
          name: "setting"
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
            "label-width": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(currentLang) === 'zh' ? '110px' : '160px',
            "label-position": "left"
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rangeRadius
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rangeRadius,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rangeRadius = $event),
                      step: 10,
                      min: 10,
                      max: 1000,
                      onInput: _cache[3] || (_cache[3] = $event => paramsChanged('rangeRadius'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rangeRadius,
                      "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).rangeRadius = $event),
                      step: 10,
                      min: 10,
                      max: 1000,
                      "controls-position": "right",
                      onInput: _cache[5] || (_cache[5] = $event => paramsChanged('rangeRadius'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleNum
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum,
                      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum = $event),
                      step: 100,
                      min: 100,
                      max: 10000,
                      onInput: _cache[7] || (_cache[7] = $event => paramsChanged('particleNum'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum,
                      "onUpdate:modelValue": _cache[8] || (_cache[8] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleNum = $event),
                      step: 100,
                      min: 100,
                      max: 10000,
                      "controls-position": "right",
                      onInput: _cache[9] || (_cache[9] = $event => paramsChanged('particleNum'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).particleSize
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize,
                      "onUpdate:modelValue": _cache[10] || (_cache[10] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[11] || (_cache[11] = $event => paramsChanged('particleSize'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize,
                      "onUpdate:modelValue": _cache[12] || (_cache[12] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).particleSize = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      "controls-position": "right",
                      onInput: _cache[13] || (_cache[13] = $event => paramsChanged('particleSize'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-row>\r\n              <kq-form-item :label=\"language.lifeCycle\">\r\n                <kq-row style=\"display: flex\">\r\n                  <kq-col :span=\"16\">\r\n                    <kq-slider v-model=\"formItem.lifeCycle\" :step=\"1\" :min=\"1\" :max=\"50\" @input=\"paramsChanged('lifeCycle')\"></kq-slider>\r\n                  </kq-col>\r\n                  <kq-col :span=\"8\">\r\n                    <kq-input-number\r\n                      v-model=\"formItem.lifeCycle\"\r\n                      :step=\"1\"\r\n                      :min=\"1\"\r\n                      :max=\"50\"\r\n                      controls-position=\"right\"\r\n                      @input=\"paramsChanged('lifeCycle')\">\r\n                    </kq-input-number>\r\n                  </kq-col>\r\n                </kq-row>\r\n              </kq-form-item>\r\n            </kq-row> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).startScale
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale,
                      "onUpdate:modelValue": _cache[14] || (_cache[14] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale = $event),
                      min: 0.1,
                      max: 5.0,
                      step: 0.1,
                      onInput: _cache[15] || (_cache[15] = $event => paramsChanged('startScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale,
                      "onUpdate:modelValue": _cache[16] || (_cache[16] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).startScale = $event),
                      min: 0.1,
                      max: 5.0,
                      step: 0.1,
                      "controls-position": "right",
                      onInput: _cache[17] || (_cache[17] = $event => paramsChanged('startScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).endScale
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale,
                      "onUpdate:modelValue": _cache[18] || (_cache[18] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale = $event),
                      min: 0.1,
                      max: 5.0,
                      step: 0.1,
                      onInput: _cache[19] || (_cache[19] = $event => paramsChanged('endScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale,
                      "onUpdate:modelValue": _cache[20] || (_cache[20] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).endScale = $event),
                      min: 0.1,
                      max: 5.0,
                      step: 0.1,
                      "controls-position": "right",
                      onInput: _cache[21] || (_cache[21] = $event => paramsChanged('endScale'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "max", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              class: "rowclass"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
                label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).gravity
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
                  style: {
                    "display": "flex"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 16
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_slider, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity,
                      "onUpdate:modelValue": _cache[22] || (_cache[22] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity = $event),
                      step: 0.1,
                      min: 0.1,
                      max: 5,
                      onInput: _cache[23] || (_cache[23] = $event => paramsChanged('gravity'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "step", "min"])]),
                    _: 1
                    /* STABLE */

                  }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                    span: 8
                  }, {
                    default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                      modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity,
                      "onUpdate:modelValue": _cache[24] || (_cache[24] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).gravity = $event),
                      min: 0.1,
                      max: 5,
                      step: 0.1,
                      "controls-position": "right",
                      onInput: _cache[25] || (_cache[25] = $event => paramsChanged('gravity'))
                    }, null, 8
                    /* PROPS */
                    , ["modelValue", "min", "step"])]),
                    _: 1
                    /* STABLE */

                  })]),
                  _: 1
                  /* STABLE */

                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["label"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label-width"])]),
          _: 1
          /* STABLE */

        }, 8
        /* PROPS */
        , ["title"])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["model-value"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", WeatherEffectvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[26] || (_cache[26] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => add(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).add,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).add), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[27] || (_cache[27] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => clear(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).clear), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/weathereffect/WeatherEffect.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/weathereffect/WeatherEffect.vue



const WeatherEffect_exports_ = WeatherEffectvue_type_script_setup_true_lang_js;

/* harmony default export */ var WeatherEffect = (WeatherEffect_exports_);
;// CONCATENATED MODULE: ./src/webgl/weathereffect/index.js




WeatherEffect.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(WeatherEffect.name, WeatherEffect);
};


;// CONCATENATED MODULE: ./src/webgl/comparemap/CompareMapViewModel.js

//多窗口逻辑类
class CompareMapViewModel {
  // 三维视图对象
  //三维viewer对象
  constructor(scenceView) {
    _defineProperty(this, "_scenceView", null);

    _defineProperty(this, "_viewer", null);

    this._scenceView = scenceView;
    this._viewer = scenceView._viewer;
  } //切换窗口模式


  changeMode(mode) {
    let viewMode = Cesium.SplitViewMode.NONE;

    switch (mode) {
      case 1:
        viewMode = Cesium.SplitViewMode.NONE;
        break;

      case 2:
        viewMode = Cesium.SplitViewMode.HORIZONTAL;
        break;
      // case 3:
      //   viewMode = Cesium.SplitViewMode.HORIZONTAL_TRIPLE;
      //   break;

      case 4:
        viewMode = Cesium.SplitViewMode.QUAD;
        break;
      // case 5:
      //   viewMode = [
      //     { index: 0, left: 0, top: 0, width: 1, height: 1 },
      //     { index: 1, left: 0.78, top: 0.06, width: 0.2, height: 0.2 }
      //   ];
      //   break;

      default:
        break;
    }

    this._viewer.scene.splitViewMode = viewMode;
  } //重置窗口模式


  resetMode() {
    this.changeMode();

    let checkedLayerkeys = this._scenceView._layerManager.getLayerCheckedListKey();

    for (let i = 0; i < checkedLayerkeys.length; i++) {
      let layer = this._scenceView._layerManager.getLayerByGuid(checkedLayerkeys[i]);

      let type = this._scenceView._layerManager.getLayerTypeByGuid(checkedLayerkeys[i]);

      layer.showInViews = undefined;

      if (type == 'datasource') {
        layer.entities.values.forEach(entity => {
          entity.showInViews = [0, 1, 2, 3];
        });
      }
    }
  }

  setLayerState(index, guid, visible) {
    let layer = this._scenceView._layerManager.getLayerByGuid(guid);

    let type = this._scenceView._layerManager.getLayerTypeByGuid(guid);

    if (layer) {
      let showInViews = layer.showInViews || [0, 1, 2, 3];

      if (visible) {
        showInViews.push(index);
      } else {
        let num = showInViews.indexOf(index);

        if (num > -1) {
          showInViews.splice(num, 1);
        }
      }

      layer.showInViews = showInViews;

      if (type == 'datasource') {
        layer.entities.values.forEach(entity => {
          if (entity.show) {
            entity.showInViews = showInViews;
          }
        });
      }
    }
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/comparemap/CompareMapTree.vue?vue&type=script&setup=true&lang=js


const CompareMapTreevue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-compare-map-tree"
};



const CompareMapTreevue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dCompareMapTree"
};
/* harmony default export */ var CompareMapTreevue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(CompareMapTreevue_type_script_setup_true_lang_js_default_, {
  props: {
    index: Number,
    setLayerState: {
      type: Function
    }
  },

  setup(__props) {
    const props = __props;
    let layerTreeStyle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 图层树选择框样式

    let selectedLayers = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); // 图层树选中值

    let layerTreeData = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); // 图层树选项数据

    let preCheckedKeys = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)([]); // 记录上次图层树选中值

    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let viewModel = null;
    /**
     * 勾选图层逻辑
     */

    function changeLayer(values) {
      let checkedKeys = preCheckedKeys.value;

      if (checkedKeys.length > values.length) {
        for (let val of checkedKeys.values()) {
          if (!values.includes(val)) {
            props.setLayerState(props.index, val, false);
          }
        }
      } else {
        for (let val of values.values()) {
          if (!checkedKeys.includes(val)) {
            props.setLayerState(props.index, val, true);
          }
        }
      }

      preCheckedKeys.value = values;
    } // 国际化


    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.nextTick)(() => {
        gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
          if (scenceView) {
            layerTreeData.value = gis_utils_namespaceObject.mapLayerUtils.getLayerCheckedList();
            selectedLayers.value = gis_utils_namespaceObject.mapLayerUtils.getLayerCheckedListKey();
            preCheckedKeys.value = selectedLayers.value;
          }
        });
      });
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {});
    return (_ctx, _cache) => {
      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", CompareMapTreevue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
        teleported: true,
        multiple: "",
        "collapse-tags": "",
        onChange: changeLayer,
        modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(selectedLayers),
        "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(selectedLayers) ? selectedLayers.value = $event : selectedLayers = $event),
        "value-key": "id",
        placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).selectLayer,
        style: {
          "width": "220px"
        }
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)(external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.Fragment, null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.renderList)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(layerTreeData), item => {
          return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)(_component_kq_option, {
            key: item.guid,
            label: item.name,
            value: item.guid
          }, null, 8
          /* PROPS */
          , ["label", "value"]);
        }), 128
        /* KEYED_FRAGMENT */
        ))]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["modelValue", "placeholder"])]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/comparemap/CompareMapTree.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/comparemap/CompareMapTree.vue



const CompareMapTree_exports_ = CompareMapTreevue_type_script_setup_true_lang_js;

/* harmony default export */ var CompareMapTree = (CompareMapTree_exports_);
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/comparemap/CompareMap.vue?vue&type=script&setup=true&lang=js

const CompareMapvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-compare-map"
};






const CompareMapvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dCompareMap"
};
/* harmony default export */ var CompareMapvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(CompareMapvue_type_script_setup_true_lang_js_default_, {
  props: {
    showShadow: {
      type: Boolean,
      default: false
    },
    offsetTop: {
      type: String,
      default: "16px"
    }
  },
  emits: ["back"],

  setup(__props, {
    expose,
    emit
  }) {
    const props = __props;
    let offsetTop = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)("auto");
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let btnShow = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 分屏返回按钮

    let viewModel = null;
    let showTree1 = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 图层树1

    let showTree2 = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 图层树2

    let showTree3 = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 图层树3

    let showTree4 = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false); // 图层树4

    let tree1Index = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(0);
    let tree2Index = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(1);
    let tree3Index = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(2);
    let tree4Index = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(3); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      offsetTop.value = props.offsetTop;
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new CompareMapViewModel(scenceView);
        }
      });
    }); //切换窗口模式

    function changeMode(mode) {
      btnShow.value = true;

      if (mode === 2) {
        showTree1.value = true;
        showTree2.value = true;
        tree1Index.value = 0;
        tree2Index.value = 1;
        tree3Index.value = 2;
        tree4Index.value = 3;
      } else if (mode === 4) {
        showTree1.value = true;
        showTree2.value = true;
        showTree3.value = true;
        showTree4.value = true;
        tree1Index.value = 2;
        tree2Index.value = 3;
        tree3Index.value = 0;
        tree4Index.value = 1;
      }

      viewModel && viewModel.changeMode(mode);
    } //返回


    function goBack() {
      btnShow.value = false;
      showTree1.value = false;
      showTree2.value = false;
      showTree3.value = false;
      showTree4.value = false;
      emit("back");
      resetMode();
    } //重置窗口模式


    function resetMode() {
      viewModel && viewModel.resetMode();
    } //设置图层显示状态


    function setLayerState(index, guid, visible) {
      viewModel && viewModel.setLayerState(index, guid, visible);
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      resetMode();
    });
    expose({
      changeMode,
      goBack,
      resetMode,
      setLayerState
    });
    return (_ctx, _cache) => {
      const _component_kq_icon = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-icon");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", CompareMapvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showTree1) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(CompareMapTree), {
        key: 0,
        class: "layer-tree-1",
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
          top: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(offsetTop)
        }),
        index: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tree1Index),
        setLayerState: setLayerState
      }, null, 8
      /* PROPS */
      , ["style", "index"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showTree2) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(CompareMapTree), {
        key: 1,
        class: "layer-tree-2",
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
          top: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(offsetTop)
        }),
        index: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tree2Index),
        setLayerState: setLayerState
      }, null, 8
      /* PROPS */
      , ["style", "index"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showTree3) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(CompareMapTree), {
        key: 2,
        class: "layer-tree-3",
        index: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tree3Index),
        setLayerState: setLayerState
      }, null, 8
      /* PROPS */
      , ["index"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(showTree4) ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(CompareMapTree), {
        key: 3,
        class: "layer-tree-4",
        index: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(tree4Index),
        setLayerState: setLayerState
      }, null, 8
      /* PROPS */
      , ["index"])) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" 返回 "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        circle: "",
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).return,
        class: "close-button",
        style: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeStyle)({
          top: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(offsetTop)
        }),
        onClick: _cache[0] || (_cache[0] = $event => goBack())
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_icon, {
          size: 26
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(client_icons_vue_namespaceObject.IconBack))]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title", "style"]), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(btnShow)]])]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/comparemap/CompareMap.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/comparemap/CompareMap.vue



const CompareMap_exports_ = CompareMapvue_type_script_setup_true_lang_js;

/* harmony default export */ var CompareMap = (CompareMap_exports_);
;// CONCATENATED MODULE: ./src/webgl/comparemap/index.js




CompareMap.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(CompareMap.name, CompareMap);
};


;// CONCATENATED MODULE: ./src/webgl/screenshot/ScreenshotViewModel.js

//截图逻辑类
class ScreenshotViewModel {
  //三维viewer对象
  //截图存储参数对象
  //截图三维对象
  constructor(viewer, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_options", null);

    _defineProperty(this, "_cameraToImage", null);

    this._options = {
      width: options.imgWidth,
      height: options.imgHeight,
      imageType: options.imgFormat,
      fixedRatio: options.lockAspectRatio,
      //锁定宽高比
      style: options.tilesetStyle,
      //倾斜样式
      tilesetName: options.tilesetName //倾斜名称

    };
    this._viewer = viewer;
    this._viewer.enabledFXAA = true; //声明场景出图类

    this._cameraToImage = new Cesium.Kq3dCanvasToImage(viewer._container, {
      viewer: viewer,
      canvas: viewer.scene.canvas
    });
    let that = this;
    setTimeout(() => {
      let tileset = this.findLayerByName(this._options.tilesetName);

      if (tileset) {
        if (tileset instanceof Array && tileset.length > 0) {
          tileset[0].readyPromise.then(function (tileset) {
            tileset.style = new Cesium.Cesium3DTileStyle(that._options.style);
          });
        } else if (tileset instanceof Object) {
          tileset.readyPromise.then(function (tileset) {
            tileset.style = new Cesium.Cesium3DTileStyle(that._options.style);
          });
        }
      }
    }, 800);
  } // 查找所有3dtiles模型对象


  findLayers() {
    let tilesets = [];
    const primitives = this._viewer.scene.primitives._primitives;

    for (let m = 0; m < primitives.length; m++) {
      if (primitives[m] instanceof Cesium.Cesium3DTileset) {
        tilesets.push({
          guid: primitives[m].guid,
          name: primitives[m].name ? primitives[m].name : primitives[m].guid
        });
      }
    }

    return tilesets;
  } // 出图


  sceneFigure() {
    this.saveAsimages();
  } // 返回base64


  saveAsimages() {
    //设置宽、高、图片类型
    var options = {
      width: this._options.width,
      //图片宽度
      height: this._options.height,
      //图片高度
      type: this._options.imageType //图片类型

    }; //返回图片

    var img = this._cameraToImage.saveAsimages(this._viewer.scene.canvas, options);

    return img;
  } // 返回base64


  toDataURL() {
    var base64 = this._cameraToImage.toDataURL({
      width: this._options.width,
      height: this._options.height,
      type: Cesium.Kq3dImageFormatter.JPG
    });

    return base64;
  } //根据id获取tileset对象


  findLayerByName(name) {
    const primitives = this._viewer.scene.primitives._primitives;
    const tileset = primitives.find(function (item) {
      return item.name === name;
    });
    return tileset;
  } //根据宽度计算高度


  calcWidthByWindowRatio(width) {
    var r = this._viewer.scene.canvas.width / this._viewer.scene.canvas.height;
    return parseInt(width * r);
  } //根据高度计算宽度


  calcHeightByWindowRatio(height) {
    var r = this._viewer.scene.canvas.width / this._viewer.scene.canvas.height;
    return parseInt(height / r);
  } // 锁定图片宽高比


  setImgAspectRatio(val) {
    this._options.fixedRatio = val;
  } // 设置图片宽度


  setImgWidth(val) {
    this._options.width = val;
  } // 设置图片高度


  setImgHeight(val) {
    this._options.height = val;
  } // 设置图片类型


  setImgType(val) {
    this._options.imageType = val;
  } // 注销


  destroy() {
    if (this._cameraToImage) this._cameraToImage = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/screenshot/Screenshot.vue?vue&type=script&setup=true&lang=js

const Screenshotvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-screenshot-box"
};
const Screenshotvue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-screenshot-footer"
};





 // 场景宽度

const Screenshotvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dScreenShot"
};
/* harmony default export */ var Screenshotvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Screenshotvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 设置参数
    settingParams: {
      type: Object
    },
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconScreenshot
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let imgWidthMax = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(800); // 场景高度

    let imgHeightMax = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(800);
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); // 分析类

    let viewModel = null; // 获取组件传参
    //设置样式

    var style = {
      color: {
        conditions: [["${height} >= 250", "rgb(255, 0, 0)"], ["${height} >= 200", "rgb(255, 255, 0)"], ["${height} >= 150", "rgb(255, 255, 255)"], ["${height} >= 100", "rgb(0, 0, 255)"], ["${height} >= 80", "rgb(0, 255, 255)"], ["${height} >= 50", "rgb(255, 0, 255)"], ["${height} >= 20", "rgb(0, 255, 0)"], ["true", "rgb(125527, 255, 255)"]]
      }
    };
    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      lockAspectRatio: props.settingParams && props.settingParams.lockAspectRatio || true,
      // 锁定宽高比
      imgWidth: props.settingParams && props.settingParams.imgWidth || 0,
      // 图片宽度
      imgHeight: props.settingParams && props.settingParams.imgHeight || 0,
      // 图片高度
      imgFormat: props.settingParams && props.settingParams.imgFormat || "JPG",
      // 图片格式
      tilesetName: props.settingParams && props.settingParams.tilesetName || "ShangHai-White",
      //倾斜摄影名称
      tilesetStyle: props.settingParams && props.settingParams.tilesetStyle || style // 倾斜摄影样式

    }); // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.screenshot;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          var canvas = scenceView._viewer.scene.canvas;
          imgWidthMax.value = canvas.width;
          imgHeightMax.value = canvas.height;
          formItem.imgWidth = canvas.width;
          formItem.imgHeight = canvas.height;
          viewModel = new ScreenshotViewModel(scenceView._viewer, formItem);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 场景出图


    function sceneFigure() {
      viewModel && viewModel.sceneFigure();
    } // 参数联动


    function paramsChanged(key) {
      if (!viewModel) return;

      switch (key) {
        case "lockAspectRatio":
          viewModel.setImgAspectRatio(formItem.lockAspectRatio);
          break;

        case "imgWidth":
          viewModel.setImgWidth(formItem.imgWidth);
          formItem.imgHeight = formItem.lockAspectRatio ? viewModel.calcHeightByWindowRatio(formItem.imgWidth) : Number(formItem.imgWidth);
          viewModel.setImgHeight(formItem.imgHeight);
          break;

        case "imgHeight":
          viewModel.setImgHeight(formItem.imgHeight);
          formItem.imgWidth = formItem.lockAspectRatio ? viewModel.calcWidthByWindowRatio(formItem.imgHeight) : Number(formItem.imgHeight);
          viewModel.setImgWidth(formItem.imgWidth);
          break;

        case "imgFormat":
          viewModel.setImgType(formItem.imgFormat);
          break;

        default:
          break;
      }
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      paramsChanged,
      sceneFigure
    });
    return (_ctx, _cache) => {
      const _component_kq_checkbox = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-checkbox");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_input_number = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-input-number");

      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_form_item = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form-item");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      const _component_kq_button = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-button");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-screenshot", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Screenshotvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
        "label-width": "120px",
        "label-position": "left"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_checkbox, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).lockAspectRatio,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).lockAspectRatio = $event),
            onChange: _cache[1] || (_cache[1] = $event => paramsChanged('lockAspectRatio'))
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).lockAspectRatio), 1
            /* TEXT */
            )]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).imgWidth + '(px)'
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 24
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgWidth,
                  "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgWidth = $event),
                  step: 1,
                  min: 200,
                  max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(imgWidthMax),
                  "controls-position": "right",
                  onInput: _cache[3] || (_cache[3] = $event => paramsChanged('imgWidth'))
                }, null, 8
                /* PROPS */
                , ["modelValue", "max"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).imgHeight + '(px)'
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
                span: 24
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_input_number, {
                  modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgHeight,
                  "onUpdate:modelValue": _cache[4] || (_cache[4] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgHeight = $event),
                  step: 1,
                  min: 100,
                  max: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(imgHeightMax),
                  "controls-position": "right",
                  onInput: _cache[5] || (_cache[5] = $event => paramsChanged('imgHeight'))
                }, null, 8
                /* PROPS */
                , ["modelValue", "max"])]),
                _: 1
                /* STABLE */

              })]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form_item, {
            label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).imgFormat
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
              style: {
                "display": "flex"
              }
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
                modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgFormat,
                "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).imgFormat = $event),
                onChange: _cache[7] || (_cache[7] = $event => paramsChanged('imgFormat')),
                style: {
                  "width": "100%"
                }
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  label: "JPG",
                  value: "jpg"
                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  label: "PNG",
                  value: "png"
                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  label: "BMP",
                  value: "bmp"
                }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)(" <kq-option label=\"GIF\" value=\"gif\"></kq-option> "), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
                  label: "JPEG",
                  value: "jpeg"
                })]),
                _: 1
                /* STABLE */

              }, 8
              /* PROPS */
              , ["modelValue"])]),
              _: 1
              /* STABLE */

            })]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["label"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Screenshotvue_type_script_setup_true_lang_js_hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_button, {
        onClick: _cache[8] || (_cache[8] = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withModifiers)($event => sceneFigure(), ["stop"])),
        title: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).screenshotTips,
        type: "primary"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).screenshotTips), 1
        /* TEXT */
        )]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["title"])])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/screenshot/Screenshot.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/screenshot/Screenshot.vue



const Screenshot_exports_ = Screenshotvue_type_script_setup_true_lang_js;

/* harmony default export */ var Screenshot = (Screenshot_exports_);
;// CONCATENATED MODULE: ./src/webgl/screenshot/index.js




Screenshot.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Screenshot.name, Screenshot);
};


;// CONCATENATED MODULE: ./src/webgl/hawkeye/HawkeyeViewModel.js

//鹰眼逻辑类
class HawkeyeViewModel {
  //鹰眼三维对象
  constructor(scenceView, options) {
    _defineProperty(this, "_overviewMap", null);

    options.viewer = scenceView._viewer;
    options.centerRectColor = Cesium.Color.fromCssColorString(options.centerColor || "#0000ff").withAlpha(options.centerColorAlpha || 0.5);
    this.init(options);
  }

  init(options) {
    if (!options.layers) {
      // let layers = [];
      // options.viewer.imageryLayers._layers.forEach(function (layer) {
      //   layers.push(layer._imageryProvider);
      // });
      // options.layers = layers;
      options.layers = new Cesium.Kq3dArcGISMapServerImageryProvider({
        url: 'https://services.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer'
      });
    }

    this._overviewMap = new Cesium.Kq3dOverviewMap(options);
  } //显示


  show() {
    this._overviewMap.show = true;
  } //隐藏


  hide() {
    this._overviewMap.show = false;
  } //销毁


  destroy() {
    this._overviewMap.destroy();

    this._overviewMap = null;
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js



const Hawkeyevue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dHawkeye"
};
/* harmony default export */ var Hawkeyevue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Hawkeyevue_type_script_setup_true_lang_js_default_, {
  props: {
    //指定组件绑定的viewer对象的div的id
    mapTarget: String,
    show: {
      type: Boolean,
      default: true
    },
    width: {
      type: Number,
      default: 300
    },
    height: {
      type: Number,
      default: 200
    },
    top: Number,
    left: Number,
    bottom: {
      type: Number,
      default: 16
    },
    right: {
      type: Number,
      default: 16
    },
    centerColor: {
      type: String,
      default: "#0000ff"
    },
    centerColorAlpha: {
      type: Number,
      default: 0.5
    },
    layers: Array
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let viewModel = null; // 获取组件传参

    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      //父组件ScenceView初始化完成后执行
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            show: props.show,
            width: props.width,
            height: props.height,
            bottom: props.bottom,
            right: props.right,
            zIndex: 9999,
            centerColor: props.centerColor,
            centerColorAlpha: props.centerColorAlpha,
            layers: props.layers
          };
          viewModel = new HawkeyeViewModel(scenceView, options);
        }
      });
    });

    function show() {
      viewModel && viewModel.show();
    }

    function hide() {
      viewModel && viewModel.hide();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      show,
      hide
    });
    return (_ctx, _cache) => {
      return null;
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/hawkeye/Hawkeye.vue



const Hawkeye_exports_ = Hawkeyevue_type_script_setup_true_lang_js;

/* harmony default export */ var Hawkeye = (Hawkeye_exports_);
;// CONCATENATED MODULE: ./src/webgl/hawkeye/index.js




Hawkeye.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Hawkeye.name, Hawkeye);
};


;// CONCATENATED MODULE: ./src/webgl/roller/RollerViewModel.js

//卷帘逻辑类
class RollerViewModel {
  //三维viewer对象
  //图层管理对象
  //卷帘的图层数组
  //左右卷帘的线的DOM元素
  //上下卷帘的线的DOM元素
  //左右卷帘三维对象
  //上下卷帘三维对象
  //左右卷帘活动状态
  //上下卷帘活动状态
  constructor(scenceView, options) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_layerManager", null);

    _defineProperty(this, "_layers", []);

    _defineProperty(this, "_lrSlider", null);

    _defineProperty(this, "_tbSlider", null);

    _defineProperty(this, "_lrSliderHandler", null);

    _defineProperty(this, "_tbSliderHandler", null);

    _defineProperty(this, "_lrSliderActive", false);

    _defineProperty(this, "_tbSliderActive", false);

    this._viewer = scenceView._viewer;
    this._layerManager = scenceView._layerManager;
    this._layers = options.layers;
    this._lrSlider = document.createElement("div");
    this._lrSlider.class = "shutter-slider";
    this._lrSlider.id = "lrSlider";
    this._tbSlider = document.createElement("div");
    this._tbSlider.class = "shutter-slider";
    this._tbSlider.id = "tbSlider";

    this._viewer.container.appendChild(this._lrSlider);

    this._viewer.container.appendChild(this._tbSlider);

    setTimeout(() => {
      this.initLayers();
    }, 500);
    this.registerEvents();
  } //注册卷帘拖动事件


  registerEvents() {
    let that = this;
    this._lrSliderHandler = new Cesium.ScreenSpaceEventHandler(this._lrSlider);

    this._lrSliderHandler.setInputAction(function () {
      that._lrSliderActive = true;
    }, Cesium.ScreenSpaceEventType.LEFT_DOWN);

    this._lrSliderHandler.setInputAction(function (movement) {
      if (!that._lrSliderActive) {
        return;
      }

      let relativeOffset = movement.endPosition.x;
      let splitPosition = (that._lrSlider.offsetLeft + relativeOffset) / that._lrSlider.parentElement.parentElement.offsetWidth;
      that._lrSlider.style.left = 100.0 * splitPosition + '%';
      that._viewer.scene.imagerySplitPosition = splitPosition;
    }, Cesium.ScreenSpaceEventType.MOUSE_MOVE);

    this._lrSliderHandler.setInputAction(function () {
      that._lrSliderActive = false;
    }, Cesium.ScreenSpaceEventType.LEFT_UP);

    this._tbSliderHandler = new Cesium.ScreenSpaceEventHandler(this._tbSlider);

    this._tbSliderHandler.setInputAction(function () {
      that._tbSliderActive = true;
    }, Cesium.ScreenSpaceEventType.LEFT_DOWN);

    this._tbSliderHandler.setInputAction(function (movement) {
      if (!that._tbSliderActive) {
        return;
      }

      let relativeOffset = movement.endPosition.y;
      let splitPosition = 1.0 - (that._tbSlider.offsetTop + relativeOffset) / that._tbSlider.parentElement.parentElement.offsetHeight;
      that._tbSlider.style.top = 100.0 * (1.0 - splitPosition) + '%';
      that._viewer.scene.imagerySplitPosition = splitPosition;
    }, Cesium.ScreenSpaceEventType.MOUSE_MOVE);

    this._tbSliderHandler.setInputAction(function () {
      that._tbSliderActive = false;
    }, Cesium.ScreenSpaceEventType.LEFT_UP);
  } //初始化图层数据


  initLayers() {
    let layers = this._layerManager.getLayerCheckedList();

    for (let i = 0; i < layers.length; i++) {
      this._layers.push({
        guid: layers[i].guid,
        name: layers[i].name,
        direction: 0
      });
    }
  } //切换模式


  changeMode(mode) {
    let direction = 0;
    let splitdirection = Cesium.ImagerySplitDirection.NONE;
    let splitPosition = 0.5;
    this._lrSlider.style.display = "none";
    this._tbSlider.style.display = "none";

    switch (mode) {
      case 1:
        direction = 1;
        this._lrSlider.style.display = "block";
        splitdirection = Cesium.ImagerySplitDirection.LEFT;
        splitPosition = this._lrSlider.offsetLeft / this._lrSlider.parentElement.parentElement.offsetWidth;
        break;

      case 2:
        direction = 3;
        this._tbSlider.style.display = "block";
        splitdirection = Cesium.ImagerySplitDirection.TOP;
        splitPosition = 1.0 - this._tbSlider.offsetTop / this._tbSlider.parentElement.parentElement.offsetHeight;
        break;

      default:
        break;
    }

    let that = this;

    this._layers.forEach(layer => {
      layer.direction = direction;

      let layerObj = that._layerManager.getLayerByGuid(layer.guid);

      if (layerObj) layerObj.splitDirection = splitdirection;
    });

    if (mode !== 0) {
      this._viewer.scene.imagerySplitPosition = splitPosition;
    }
  } //改变方向


  changeDirection(index) {
    let direction = this._layers[index].direction;
    let splitdirection = Cesium.ImagerySplitDirection.NONE;

    switch (direction) {
      case 1:
        splitdirection = Cesium.ImagerySplitDirection.LEFT;
        break;

      case 2:
        splitdirection = Cesium.ImagerySplitDirection.RIGHT;
        break;

      case 3:
        splitdirection = Cesium.ImagerySplitDirection.TOP;
        break;

      case 4:
        splitdirection = Cesium.ImagerySplitDirection.BOTTOM;
        break;

      default:
        break;
    }

    let layer = this._layerManager.getLayerByGuid(this._layers[index].guid);

    if (layer) {
      layer.splitDirection = splitdirection;
    }
  } //重置


  reset() {
    this.changeMode(0);
  } // 销毁


  destroy() {
    this.reset(); //移除监听事件

    this._lrSliderHandler && this._lrSliderHandler.destroy();
    this._tbSliderActive && this._tbSliderActive.destroy(); //移除卷帘分割线DOM元素

    this._lrSlider && this._viewer.container.removeChild(this._lrSlider);
    this._tbSlider && this._viewer.container.removeChild(this._tbSlider);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/roller/Roller.vue?vue&type=script&setup=true&lang=js

const Rollervue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-roller-form kq3d-roller-box"
};
const Rollervue_type_script_setup_true_lang_js_hoisted_2 = {
  class: "kq3d-roller-span"
};






const Rollervue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dRoller"
};
/* harmony default export */ var Rollervue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Rollervue_type_script_setup_true_lang_js_default_, {
  props: {
    showShadow: {
      type: Boolean,
      default: true
    },

    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object],
    // 是否生成HeaderTemp
    showHeaderTemp: {
      type: Boolean,
      default: false
    },
    // 是否折叠HeaderTemp，showHeaderTemp为true时生效
    isCollapseHeaderTemp: {
      type: Boolean,
      default: false
    },
    // HeaderTemp标题
    headerTempTitle: {
      type: String
    },
    // HeaderTemp图标
    headerTempIcon: {
      type: [Object, String],
      default: client_icons_vue_namespaceObject.IconRoller
    },
    // HeaderTemp Title&Icon的位置
    isRight: {
      type: Boolean,
      default: true
    }
  },

  setup(__props, {
    expose
  }) {
    const props = __props;
    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({}); //获取组件传参
    // 表格头样式

    let headClass = args => {
      return {
        "background-color": "var(--kq-fill-color-light)",
        color: "var(--kq-color-info)",
        "font-size": "14px"
      };
    };

    let formItem = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)({
      mode: props.settingParams && props.settingParams.mode || null
    });
    let layers = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.reactive)([]);
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 生成组件默认header

    let headerTemp = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)();
    let headerTempRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    let headerTempTitle = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null);
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
      headerTempTitle.value = language.value.roller;
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      watchCreateHeaderTemp();
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.showHeaderTemp, (newVal, oldVal) => {
        watchCreateHeaderTemp();
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          let options = {
            layers: layers
          };
          viewModel = new RollerViewModel(scenceView, options);
        }
      });
    });
    /**
     * @description 监听header生成
     */

    const watchCreateHeaderTemp = () => {
      if (props.showHeaderTemp) {
        // 生成headerTemp
        headerTemp.value = (0,util_namespaceObject.createHeaderTemp)(boxRef.value, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toRefs)(props), headerTempRef, headerTempTitle);
      }
    }; // 切换模式


    function changeMode() {
      let mode = formItem.mode;
      viewModel && viewModel.changeMode(formItem.mode);
    } // 改变方向


    function changeDirection(index) {
      viewModel && viewModel.changeDirection(index);
    } //重置


    function reset() {
      formItem.mode = null;
      viewModel && viewModel.reset();
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      changeMode,
      changeDirection,
      reset
    });
    return (_ctx, _cache) => {
      const _component_kq_col = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-col");

      const _component_kq_option = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-option");

      const _component_kq_select = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-select");

      const _component_kq_row = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-row");

      const _component_kq_table_column = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table-column");

      const _component_kq_radio = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio");

      const _component_kq_radio_group = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-radio-group");

      const _component_kq_table = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-table");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.normalizeClass)(["kq3d-roller", {
          'kq-box-shadow': __props.showShadow
        }]),
        ref_key: "boxRef",
        ref: boxRef
      }, [__props.showHeaderTemp ? ((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createBlock)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveDynamicComponent)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headerTemp)), {
        key: 0,
        ref_key: "headerTempRef",
        ref: headerTempRef
      }, null, 512
      /* NEED_PATCH */
      )) : (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createCommentVNode)("v-if", true), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Rollervue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, {
        style: {
          "margin-bottom": "8px"
        }
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 8,
          style: {
            "line-height": "32px"
          }
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("span", Rollervue_type_script_setup_true_lang_js_hoisted_2, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rollerMode), 1
          /* TEXT */
          )]),
          _: 1
          /* STABLE */

        }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 16
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_select, {
            modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode = $event),
            onChange: changeMode,
            placeholder: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).noRoller + '...',
            clearable: "",
            onClear: reset
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).lrRoller,
              value: 1
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_option, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).tbRoller,
              value: 2
            }, null, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["modelValue", "placeholder"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_row, null, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_col, {
          span: 24
        }, {
          default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table, {
            border: "",
            stripe: "",
            data: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(layers),
            style: {
              "width": "100%",
              "height": "100%"
            },
            "cell-style": {
              padding: '8px 0'
            },
            "header-cell-style": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(headClass)
          }, {
            default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).layer,
              prop: "name",
              align: "center"
            }, null, 8
            /* PROPS */
            , ["label"]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_table_column, {
              label: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).position,
              prop: "direction",
              align: "center"
            }, {
              default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(scope => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio_group, {
                modelValue: scope.row.direction,
                "onUpdate:modelValue": $event => scope.row.direction = $event,
                onChange: $event => changeDirection(scope.$index)
              }, {
                default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                  label: 1,
                  size: "large",
                  style: {
                    "margin-right": "12px"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).leftRoller), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 1]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                  label: 2,
                  size: "large",
                  style: {
                    "margin-right": "0px"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).rightRoller), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 1]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                  label: 3,
                  size: "large",
                  style: {
                    "margin-right": "12px"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).topRoller), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 2]]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withDirectives)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_radio, {
                  label: 4,
                  size: "large",
                  style: {
                    "margin-right": "0px"
                  }
                }, {
                  default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createTextVNode)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).bottomRoller), 1
                  /* TEXT */
                  )]),
                  _: 1
                  /* STABLE */

                }, 512
                /* NEED_PATCH */
                ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode === 2]])]),
                _: 2
                /* DYNAMIC */

              }, 1032
              /* PROPS, DYNAMIC_SLOTS */
              , ["modelValue", "onUpdate:modelValue", "onChange"])]),
              _: 1
              /* STABLE */

            }, 8
            /* PROPS */
            , ["label"])]),
            _: 1
            /* STABLE */

          }, 8
          /* PROPS */
          , ["data", "header-cell-style"])]),
          _: 1
          /* STABLE */

        })]),
        _: 1
        /* STABLE */

      }, 512
      /* NEED_PATCH */
      ), [[external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.vShow, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(formItem).mode !== null]])])], 2
      /* CLASS */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/roller/Roller.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/roller/Roller.vue



const Roller_exports_ = Rollervue_type_script_setup_true_lang_js;

/* harmony default export */ var Roller = (Roller_exports_);
;// CONCATENATED MODULE: ./src/webgl/roller/index.js




Roller.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Roller.name, Roller);
};


;// CONCATENATED MODULE: ./src/webgl/underground/UndergroundViewModel.js

class UndergroundViewModel {
  // 三维viewer对象
  // 地下模式三维管理对象
  constructor(viewer) {
    _defineProperty(this, "_viewer", null);

    _defineProperty(this, "_undergroundManager", null);

    this._viewer = viewer;
    this._undergroundManager = new Cesium.Kq3dUndergroundManager(this._viewer.scene);
  }

  open() {
    this._viewer.scene.skyAtmosphere.show = false; // 关闭碰撞检测

    this._viewer.scene.screenSpaceCameraController.enableCollisionDetection = false; // false;
    // 关闭深度检测

    this._viewer.scene.globe.depthTestAgainstTerrain = false; // false;

    window.Cesium.Kq3dUndergroundMixin(this._viewer.scene); // 开启地下模式

    this._undergroundManager.undergroundEnabled = true; // true;
    // 开启地形透明

    this._undergroundManager.transparentEnabled = true; // true;
    // 设置地形透明度，透明度在0-1之间

    this._undergroundManager.transparent = 0.5;
  }

  close() {
    this._viewer.scene.skyAtmosphere.show = true; // 开启碰撞检测

    this._viewer.scene.screenSpaceCameraController.enableCollisionDetection = true; // true;
    // 开启深度检测

    this._viewer.scene.globe.depthTestAgainstTerrain = true; // true;
    // 关闭地下模式

    this._undergroundManager.undergroundEnabled = false; // false;
    // 关闭地形透明

    this._undergroundManager.transparentEnabled = false; // false;
    // 设置地形透明度，透明度在0-1之间

    this._undergroundManager.transparent = 0;
  }

  destroy() {
    this.close();
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/underground/Underground.vue?vue&type=script&setup=true&lang=js

const Undergroundvue_type_script_setup_true_lang_js_hoisted_1 = {
  class: "kq3d-underground-switch"
};





const Undergroundvue_type_script_setup_true_lang_js_default_ = {
  name: "kq3dUnderground"
};
/* harmony default export */ var Undergroundvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(Undergroundvue_type_script_setup_true_lang_js_default_, {
  props: {
    /**
     * 例："center","topLeft","topRight","bottomLeft","bottomRight", "topCenter", "bottomCenter" {top:'16px',left:'16px'}, {top:16,left:16}
     */
    position: [String, Object]
  },
  emits: ["undergroundChange"],

  setup(__props, {
    expose,
    emit
  }) {
    const props = __props;
    const {
      proxy
    } = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.getCurrentInstance)(); //获取组件传参

    let language = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)({});
    let isUndergroundMode = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(false);
    let viewModel = null; // 组件容器Ref

    let boxRef = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.ref)(null); // 国际化

    let {
      locale,
      messages
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      language.value = messages.value[newVal]["webgl"];
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => props.position, (newVal, oldVal) => {
        (0,util_namespaceObject.updatePosition)(boxRef.value, props);
      });
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new UndergroundViewModel(scenceView._viewer);
        }
      });
    }); // 地下模式点击事件

    function undergroundChange() {
      if (isUndergroundMode.value) {
        viewModel.open();
      } else {
        viewModel.close();
      }

      emit("undergroundChange", isUndergroundMode.value);
    } // 销毁


    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel && viewModel.destroy();
    });
    expose({
      undergroundChange
    });
    return (_ctx, _cache) => {
      const _component_kq_switch = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-switch");

      const _component_kq_form = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.resolveComponent)("kq-form");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementBlock)("section", {
        class: "kq3d-underground",
        ref_key: "boxRef",
        ref: boxRef
      }, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_form, {
        "label-width": "120px",
        "label-position": "left"
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createElementVNode)("div", Undergroundvue_type_script_setup_true_lang_js_hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.createVNode)(_component_kq_switch, {
          modelValue: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(isUndergroundMode),
          "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.isRef)(isUndergroundMode) ? isUndergroundMode.value = $event : isUndergroundMode = $event),
          onChange: undergroundChange,
          width: 30,
          "active-text": (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.unref)(language).undergroundText,
          style: {
            "margin-right": "'5px'"
          }
        }, null, 8
        /* PROPS */
        , ["modelValue", "active-text"])])]),
        _: 1
        /* STABLE */

      })], 512
      /* NEED_PATCH */
      );
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/underground/Underground.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/webgl/underground/Underground.vue



const Underground_exports_ = Undergroundvue_type_script_setup_true_lang_js;

/* harmony default export */ var Underground = (Underground_exports_);
;// CONCATENATED MODULE: ./src/webgl/underground/index.js




Underground.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Underground.name, Underground);
};


;// CONCATENATED MODULE: ./src/webgl/statusbar/StatusBarViewModel.js

// 地图状态栏逻辑类
class StatusBarViewModel {
  constructor(viewer, options) {
    _defineProperty(this, "_viewer", null);

    viewer.statusBar.show = true;
    viewer.statusBar.readyPromise.then(() => {
      // viewer.statusBar.container.style.bottom = "16px";
      //viewer.statusBar.container.parentElement.style.right = "0px!important";
      // console.log(viewer.statusBar.container.parentElement.style.right);
      if (options.hideResolution) {
        viewer.statusBar.hideResolution();
      }

      if (options.hideScale) {
        viewer.statusBar.hideScale();
      }

      if (options.hideLonLat) {
        viewer.statusBar.hideLonLat();
      }

      if (options.hideEyeAlt) {
        viewer.statusBar.hideEyeAlt();
      }

      if (options.hideCopyright) {
        viewer.statusBar.hideCopyright();
      }

      if (options.copyrightText) {
        viewer.statusBar.setCopyrightText(options.copyrightText);
      }
    });
    this._viewer = viewer;
  }

  changeLanguage(lang) {
    var that = this;

    if (that._viewer.statusBar._ready) {
      var originLanguage = that._viewer.statusBar._curLanguage;
      var language = new Cesium.Languages({
        languageStyle: lang == 'zh' ? 'zh-cn' : 'en'
      });
      language.readyPromise.then(function () {
        //loaded success
        that._viewer._language = language;
        var langContent = language.content;

        if (langContent) {
          that._viewer.statusBar._curLanguage = {
            mUnit: langContent.mUnit,
            kmUnit: langContent.kmUnit,
            sqkmUnit: langContent.sqkmUnit,
            sqmUnit: langContent.sqmUnit,
            N: langContent.N,
            S: langContent.S,
            E: langContent.E,
            W: langContent.W,
            du: langContent.du,
            fen: langContent.fen,
            miao: langContent.miao,
            elevation: langContent.elevation,
            eyeAltitude: langContent.eyeAltitude,
            copyright: langContent.copyright,
            scale: langContent.scale
          };
          var id = that._viewer.statusBar._id; // 比例尺控件

          html = document.getElementById(id + '_ScaleBarTxt').innerHTML;
          document.getElementById(id + '_ScaleBarTxt').innerHTML = html.replace(originLanguage.scale, langContent.scale); // 比例尺

          html = document.getElementById(id + '_ScaleTxt').innerHTML;
          document.getElementById(id + '_ScaleTxt').innerHTMLhtml = html.replace(originLanguage.kmUnit, langContent.kmUnit).replace(originLanguage.mUnit, langContent.mUnit); // 视点高

          html = document.getElementById(id + '_CoordEyeAlt').innerHTML;
          document.getElementById(id + '_CoordEyeAlt').innerHTML = html.replace(originLanguage.eyeAltitude, langContent.eyeAltitude).replace(originLanguage.kmUnit, langContent.kmUnit).replace(originLanguage.mUnit, langContent.mUnit); // 高度

          var html = document.getElementById(id + '_CoordHeight').innerHTML;
          document.getElementById(id + '_CoordHeight').innerHTML = html.replace(originLanguage.kmUnit, langContent.kmUnit).replace(originLanguage.mUnit, langContent.mUnit);
        }
      });
    }
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/statusbar/StatusBar.vue?vue&type=script&setup=true&lang=js




/**
 * 支持传入属性：
 *   hideResolution - 隐藏分辨率
 *   hideScale - 隐藏比例尺
 *   hideLonLat - 隐藏经纬度
 *   hideEyeAlt - 隐藏视点高
 *   hideCopyright - 隐藏版权信息
 *   copyrightText - 版权信息文字
 */

const StatusBarvue_type_script_setup_true_lang_js_default_ = {
  name: "Kq3dStatusBar"
};
/* harmony default export */ var StatusBarvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(StatusBarvue_type_script_setup_true_lang_js_default_, {
  props: {
    // 隐藏分辨率
    hideResolution: Boolean,
    // 隐藏比例尺
    hideScale: Boolean,
    // 隐藏经纬度
    hideLonLat: Boolean,
    // 隐藏视点高
    hideEyeAlt: Boolean,
    // 隐藏版权信息
    hideCopyright: {
      type: Boolean,
      default: true
    },
    // 版权信息文字
    copyrightText: String
  },

  setup(__props) {
    const props = __props;
    let viewModel = null; // 国际化

    let {
      locale
    } = (0,vue_i18n_cjs_js_namespaceObject.useI18n)();
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.watch)(() => locale.value, (newVal, oldVal) => {
      viewModel && viewModel.changeLanguage(newVal);
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      gis_utils_namespaceObject.utils.getWebMap(null, scenceView => {
        if (scenceView) {
          viewModel = new StatusBarViewModel(scenceView._viewer, props);
        }
      });
    });
    return (_ctx, _cache) => {
      return null;
    };
  }

}));
;// CONCATENATED MODULE: ./src/webgl/statusbar/StatusBar.vue?vue&type=script&setup=true&lang=js
 
// EXTERNAL MODULE: ./node_modules/css-loader/dist/cjs.js!./node_modules/vue-loader/dist/stylePostLoader.js!./node_modules/sass-loader/dist/cjs.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/statusbar/StatusBar.vue?vue&type=style&index=0&id=f2dabb7e&lang=scss
var StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss = __webpack_require__(854);
;// CONCATENATED MODULE: ./node_modules/style-loader/dist/cjs.js!./node_modules/css-loader/dist/cjs.js!./node_modules/vue-loader/dist/stylePostLoader.js!./node_modules/sass-loader/dist/cjs.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/webgl/statusbar/StatusBar.vue?vue&type=style&index=0&id=f2dabb7e&lang=scss

            

var StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss_options = {};

StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss_options.insert = "head";
StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss_options.singleton = false;

var StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss_update = injectStylesIntoStyleTag_default()(StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss/* default */.Z, StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss_options);



/* harmony default export */ var statusbar_StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss = (StatusBarvue_type_style_index_0_id_f2dabb7e_lang_scss/* default.locals */.Z.locals || {});
;// CONCATENATED MODULE: ./src/webgl/statusbar/StatusBar.vue?vue&type=style&index=0&id=f2dabb7e&lang=scss

;// CONCATENATED MODULE: ./src/webgl/statusbar/StatusBar.vue



;

const StatusBar_exports_ = StatusBarvue_type_script_setup_true_lang_js;

/* harmony default export */ var StatusBar = (StatusBar_exports_);
;// CONCATENATED MODULE: ./src/webgl/statusbar/index.js




StatusBar.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(StatusBar.name, StatusBar);
};


;// CONCATENATED MODULE: ./src/webgl/components.js
/**
 * Author: 朱鹏超
 * Date: 2022-11-23
 * Description: client3d_webgl_vue 组件入口
 * LastEditors: 朱鹏超
 */

 // 三维地图快捷工具








 // 客户端打印

 // 在线地形




 // 飞行


 // gpu空间查询


 // 模型拾取















































const webglComponents = {
  KqScenceView: ScenceView,
  Kq3dMeasure: Measure,
  Kq3dFlight: Flight,
  Kq3dGPUSpatialQuery: GPUSpatialQuery,
  Kq3dModelSelect: ModelSelect,
  Kq3dSightlineAnalysis: SightlineAnalysis,
  Kq3dViewshedAnalysis: ViewshedAnalysis,
  Kq3dShadowAnalysis: ShadowAnalysis,
  Kq3dProfileAnalysis: ProfileAnalysis,
  Kq3dSkylineAnalysis: SkylineAnalysis,
  Kq3dTerrainOperation: TerrainOperation,
  Kq3dBaseterrainGallery: BaseterrainGallery,
  Kq3dExcavateFillAnalysis: ExcavateFillAnalysis,
  Kq3dFloodAnalysis: FloodAnalysis,
  Kq3dSlopeAnalysis: SlopeAnalysis,
  Kq3dAspectAnalysis: AspectAnalysis,
  Kq3dIsolineAnalysis: IsolineAnalysis,
  Kq3dBoxClip: BoxClip,
  Kq3dPlaneClip: PlaneClip,
  Kq3dAddData: AddData,
  Kq3dParticleEffect: ParticleEffect,
  Kq3dWeatherEffect: WeatherEffect,
  Kq3dCompareMap: CompareMap,
  Kq3dHawkeye: Hawkeye,
  Kq3dRoller: Roller,
  Kq3dScreenShot: Screenshot,
  Kq3dFixedZoomout: FixedZoomout,
  Kq3dFixedZoomin: FixedZoomin,
  Kq3dResetView: ResetView,
  Kq3dCompass: Compass,
  Kq3dUnderground: Underground,
  Kq3dStatusBar: StatusBar,
  Kq3dClientPrint: ClientPrint
}; // 全局引入

const install = function (Vue, opts = {}) {
  for (const comp in webglComponents) {
    const com = webglComponents[comp];
    Vue.use(com, opts);
  }
};


/* harmony default export */ var components = ({
  install
});
;// CONCATENATED MODULE: ./src/webgl/index.js
/**
 * Author: 朱鹏超
 * Date: 2022-11-23
 * Description: webgl 组件包的总入口文件
 * LastEditors: 朱鹏超
 */
// import "@/webgl/style.scss";

/* harmony default export */ var webgl = (components);

}();
module.exports = __webpack_exports__;
/******/ })()
;